package appserver.client;

import java.awt.*;
import java.awt.event.*;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import util.*;
import appserver.frontend.Portal;

public class Client extends JApplet implements ActionListener {
    final public static String DEBUG_PARAMETER = "DEBUG";
    final public static String SETUPS_PARAMETER = "SETUPS";
    final public static String TRANSPORTS_PARAMETER = "TRANSPORTS";
    final public static String PORTAL_HOST_PARAMETER = "PORTAL_HOST";
    final public static String PORTAL_PORT_PARAMETER = "PORTAL_PORT";
    final public static String EMAIL_IMAGE_PARAMETER = "EMAIL_IMAGE";
    final public static String CALENDAR_IMAGE_PARAMETER = "CALENDAR_IMAGE";
    final public static String WORD_PROCESSOR_IMAGE_PARAMETER =
      "WORD_PROCESSOR_IMAGE";
    final private static int APPLET_WIDTH = 600;
    final private static int APPLET_HEIGHT = 400;
    final private static int BUTTON_WIDTH = APPLET_WIDTH / 3;
    final private static int BUTTON_HEIGHT = 200;
    final private static int TEXT_AREA_WIDTH = APPLET_WIDTH;
    final private static int TEXT_AREA_HEIGHT = APPLET_HEIGHT - BUTTON_HEIGHT;
    final private static String EMAIL_LABEL = "Web-mail Client";
    final private static String CALENDAR_LABEL = "Calendar";
    final private static String WORD_PROCESSOR_LABEL = "Word Processor";
    final private static String EMAIL_ACTION = "EMAIL";
    final private static String CALENDAR_ACTION = "CALENDAR";
    final private static String WORD_PROCESSOR_ACTION = "WORD_PROCESSOR";
    final private SJProtocol p_cp =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1Sz2sTQRj9khjabRViJUVoxINEg8ouVRShB21KSq1bGrLq" +
       "RTBOJsPuxsnOujup\n2yKe9Z/wKkrBk3hTpDdv9SJ48aAHL/4FenB+pNs2Db" +
       "uwszN8733vzdtv+w8U4wguxCSOfRb0TL4Z\nktiUR71zVpfqxPWDu+LUxqCf" +
       "XB4gieB8BusAqVrCby/Xtrc0qZZBcnRpVCtnQxF7Pu1yqNl7dEuR\nrJRuHa" +
       "IvCKVzI0pyZZ0ewVxqaZHdd6+YUf37Xnsrh4xuupTxIUNjFqsf7tm/P53VmL" +
       "kxmHXVtY3/\nXa+c+br4yyhIy5Mhi30u9DmctvdI1oD71GoOKwtJGCYi/mpm" +
       "JkF3XPjXMjhrYo9cssT6/UHgY8TT\nUN/Ud3L29McfKtTpvsbJEofyvkkdqM" +
       "7xCTyHvHKZ9edaBBN/gxw1KulTin4xg74+4J0IBdgbd9Os\n4awfYD24dMNo" +
       "fnv8cDgwSOA4nLJ7aAPp2FdQ7K2hML1TKFydlGVTls1huTjx/fPO7KPdAuSX" +
       "YYoy\n1F1GmLPoNhjci0jsMdpNwpu3lMXjTyfFWhJvQTQrp05VQ2fVRh1CDw" +
       "1ygaIOhxntiqLAtRwe+YEr\nRoHDhNNo3W+0rsbSoCFSk98T2mhlZO6aFGGy" +
       "IryQqI1f//zyrHHn5QslcSxAfSKZs7JnSV1QKpla\nSVYqqnM5VbxyRFGhxk" +
       "HnM6DJ/vY/rt9E4VkEAAA="));
    private boolean debug = false;
    private String setups = "d";
    private String transports = "d";
    private String host_p;
    private int port_p;
    private String emailImage;
    private String calendarImage;
    private String wordProcessorImage;
    private JPanel panel;
    private JButton emailButton;
    private JButton calendarButton;
    private JButton wordProcessorButton;
    private JTextArea textArea;
    
    public void init() {
        this.parseParameters();
        try {
            SwingUtilities.invokeAndWait(new Runnable() {
                                             
                                             public void run() {
                                                 Client.this.assemble();
                                             }
                                         });
        }
        catch (Exception x) { System.err.println("[Client] GUI failed: " + x); }
    }
    
    public void start() { this.appendText("Portal applet started."); }
    
    public void stop() { this.appendText("Portal applet stopped."); }
    
    public void destroy() {  }
    
    public void actionPerformed(ActionEvent e) {
        String action = e.getActionCommand();
        if (action.equals(EMAIL_ACTION) || action.equals(CALENDAR_ACTION) ||
              action.equals(WORD_PROCESSOR_ACTION)) {
            this.appendText("Initiating action: " + action);
            try {
                this.run(debug, setups, transports, host_p, port_p, action);
            }
            catch (Exception x) {
                this.appendText("Failure: " + x.getMessage());
                x.printStackTrace();
            }
        } else {
            System.err.println("[Client] Shouldn\'t get in here: " + action);
        }
    }
    
    public void run(boolean debug, String setups, String transports,
                    String host_p, int port_p, String action)
          throws Exception {
        final SJService c_cp = SJService.create(p_cp, host_p, port_p);
        SJSocket s_cp = null;
        try {
            this.appendText("Connecting back to Portal: " + host_p + ":" +
                            port_p);
            s_cp =
              c_cp.request(
                TransportUtils.createSJSessionParameters(setups, transports));
            this.appendText("Connected to Portal.");
            SJRuntime.pass(s_cp, "Hello from Applet!");
            this.appendText("Received: " + (String) SJRuntime.receive(s_cp));
            this.appendText("Selecting application: " + action);
            if (action.equals(EMAIL_ACTION)) {
                {
                    SJRuntime.outlabel(s_cp, "SERVER1");
                    SJRuntime.pass(s_cp, "Hello from Applet!");
                    this.appendText("Received: " +
                                    (String) SJRuntime.receive(s_cp));
                }
            } else
                      if (action.equals(CALENDAR_ACTION)) {
                          {
                              SJRuntime.outlabel(s_cp, "SERVER2");
                              SJRuntime.pass(s_cp, "Hello from Applet!");
                              this.appendText("Received: " +
                                              (String) SJRuntime.receive(s_cp));
                          }
                      } else {
                          {
                              SJRuntime.outlabel(s_cp, "SERVER3");
                              SJRuntime.pass(s_cp, "Hello from Applet!");
                              this.appendText("Received: " +
                                              (String) SJRuntime.receive(s_cp));
                          }
                      }
            this.appendText("Done.");
        }
        finally {
            SJRuntime.close(s_cp);
        }
    }
    
    private void appendText(final String text) {
        synchronized (textArea)  {
            textArea.setText(textArea.getText() + "\n" + text);
            System.out.println(text);
            this.moveCaretToEnd();
        }
    }
    
    private ImageIcon createImageIcon(String path) {
        ImageIcon imageIcon = null;
        try {
            URL url = new URL(path);
            if (url != null) {
                imageIcon = new ImageIcon(url);
                if (imageIcon.getIconHeight() == -1) {
                    System.err.println("[Chat] Couldn\'t load image file: " +
                                       path);
                }
            } else {
                System.err.println("[Chat] Couldn\'t load image file: " + path);
            }
        }
        catch (MalformedURLException mue) {
            System.err.println("[Chat] Couldn\'t load image file: " + path);
        }
        return imageIcon;
    }
    
    private void assemble() {
        Border blackLineBorder = BorderFactory.createLineBorder(Color.black);
        this.panel = new JPanel(new BorderLayout());
        JPanel buttonsAndLabels = new JPanel(new BorderLayout());
        ImageIcon emailIcon = this.createImageIcon(emailImage);
        ImageIcon calendarIcon = this.createImageIcon(calendarImage);
        ImageIcon wordProcessorIcon = this.createImageIcon(wordProcessorImage);
        this.emailButton = new JButton(EMAIL_LABEL, emailIcon);
        this.calendarButton = new JButton(CALENDAR_LABEL, calendarIcon);
        this.wordProcessorButton = new JButton(WORD_PROCESSOR_LABEL,
                                               wordProcessorIcon);
        Dimension buttonSize = new Dimension(BUTTON_WIDTH, BUTTON_HEIGHT);
        emailButton.setHorizontalTextPosition(AbstractButton.CENTER);
        emailButton.setVerticalTextPosition(AbstractButton.BOTTOM);
        emailButton.setPreferredSize(buttonSize);
        emailButton.setBorder(blackLineBorder);
        emailButton.setActionCommand(EMAIL_ACTION);
        emailButton.addActionListener(this);
        calendarButton.setHorizontalTextPosition(AbstractButton.CENTER);
        calendarButton.setVerticalTextPosition(AbstractButton.BOTTOM);
        calendarButton.setPreferredSize(buttonSize);
        calendarButton.setBorder(blackLineBorder);
        calendarButton.setActionCommand(CALENDAR_ACTION);
        calendarButton.addActionListener(this);
        wordProcessorButton.setHorizontalTextPosition(AbstractButton.CENTER);
        wordProcessorButton.setVerticalTextPosition(AbstractButton.BOTTOM);
        wordProcessorButton.setPreferredSize(buttonSize);
        wordProcessorButton.setBorder(blackLineBorder);
        wordProcessorButton.setActionCommand(WORD_PROCESSOR_ACTION);
        wordProcessorButton.addActionListener(this);
        buttonsAndLabels.setPreferredSize(new Dimension(APPLET_WIDTH,
                                                        BUTTON_HEIGHT));
        buttonsAndLabels.add(emailButton, BorderLayout.WEST);
        buttonsAndLabels.add(calendarButton, BorderLayout.CENTER);
        buttonsAndLabels.add(wordProcessorButton, BorderLayout.EAST);
        this.textArea = new JTextArea();
        textArea.setLineWrap(true);
        JScrollPane scrollPane = new JScrollPane(textArea);
        scrollPane.setPreferredSize(new Dimension(TEXT_AREA_WIDTH,
                                                  TEXT_AREA_HEIGHT));
        scrollPane.setBorder(blackLineBorder);
        panel.add(buttonsAndLabels, BorderLayout.CENTER);
        panel.add(scrollPane, BorderLayout.SOUTH);
        panel.setPreferredSize(new Dimension(APPLET_WIDTH, APPLET_HEIGHT));
        panel.setBorder(blackLineBorder);
        this.add(panel);
    }
    
    private void parseParameters() {
        this.debug = Boolean.parseBoolean(this.getParameter(DEBUG_PARAMETER));
        this.setups = this.getParameter(SETUPS_PARAMETER);
        this.transports = this.getParameter(TRANSPORTS_PARAMETER);
        this.host_p = this.getParameter(PORTAL_HOST_PARAMETER);
        this.port_p =
          Integer.parseInt(this.getParameter(PORTAL_PORT_PARAMETER));
        this.emailImage = this.getParameter(EMAIL_IMAGE_PARAMETER);
        this.calendarImage = this.getParameter(CALENDAR_IMAGE_PARAMETER);
        this.wordProcessorImage =
          this.getParameter(WORD_PROCESSOR_IMAGE_PARAMETER);
    }
    
    private void moveCaretToEnd() {
        { textArea.setCaretPosition(textArea.getDocument().getLength()); }
    }
    
    public String[][] getParameterInfo() {
        String[][] info = new String[][] { { DEBUG_PARAMETER, "String",
        "Debug mode [true/false]." }, { SETUPS_PARAMETER, "String",
        "Setup flags." }, { TRANSPORTS_PARAMETER, "String",
        "Transport flags." }, { PORTAL_HOST_PARAMETER, "String",
        "Portal host name." }, { PORTAL_PORT_PARAMETER, "int",
        "Portal port." } };
        return info;
    }
    
    public String getAppletInfo() {
        return ("SJ transport-independent Application Server applet example b" +
                "y Raymond Hu.");
    }
    
    public Client() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238678334374L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVae2wcxRmfO79jJ7EdO0SJ7TixkzhNcnmUoBAThfPlHJ9z" +
       "ji93lwcm9LLeG9ub\n7O1ud+fsSxRRaFVCE1TRJgFaUWgrpBYa9QGFqhRBW0" +
       "JLSx+CVgRVBVpABamFlv5REI+q3zz2nnvn\nddRYnt29eXzf73vMt9/MzoW3" +
       "UY1lIp+FLUvRtaM+ctzAFrvq40exTCxfbDgimRZOBlTJsuLQkJCP\n/Fc58I" +
       "OWzw55kWcMtWq6X1UkKz5l6unJqfiUYmVM1G3o6vFJVSeCYgmN7T0fzfzm1P" +
       "CyKrRwDC1U\ntBiRiCIHdI3gDBlDTSmcGsem5U8mcXIMtWgYJ2PYVCRVOQEd" +
       "dQ0YW8qkJpG0ia0otnR1mnZstdIG\nNhlPuzKMmmRds4iZloluWgQ1h49K09" +
       "LGNFHUjWHFIv1hVDuhYDVpfRrdjLxhVDOhSpPQcXHYlmIj\no7hxkNZD93kK" +
       "wDQnJBnbQ6qPKVqSoOXFI7IS9+6BDjC0LoXJlJ5lVa1JUIFaOSRV0iY3xoip" +
       "aJPQ\ntUZPAxeClpYlCp3qDUk+Jk3iBEFLivtFeBP0amBqoUMIai/uxiiBzZ" +
       "YW2SzPWqO1TR+fjrzXDRYH\nzEksqxR/LQzqKhoUxRPYxJqM+cD3075zoRvS" +
       "HV6EoHN7UWfex7/qR/vDbz21nPdZ5tBnlPliQv7o\nmo7OF/xvNFRRGPWGbi" +
       "nUFQokZ1aNiJb+jAHevThLkTb67MafRn9xwy0P4b97UX0I1cq6mk5pIdSA\n" +
       "tWRAPNfBc1jRMK8dnZiwMAmhapVV1ersN6hjQlExVUcNPBsSmWLPGQMhVAfF" +
       "A//3Iv63jF4Iagio\nCtaIzzpKUC/BFrEOW6Z8WDIMC5vT2Dwss/bD2W4ZSn" +
       "LBjMcD0nQUzywV3HBIV5PYTMjfev3XJ4N7\nvnA7txP1LQGGoKuy5H2cvI+T" +
       "Rx4Po7uIeiDXkN80peN0ZmRufaHzK7+Uvgb6Brkt5QRmYnlmqukV\nBm2pGD" +
       "gCuWkXgicJvCIht93y1tKv/uHBZ7yoyjF4hLOVg7qZklRqf3u2tAp2xS3gNr" +
       "3FzuvE+53T\nI4+8+NzLfTk3BgOUzK7SkXR2rCzWu6nLOAnRJ0f+7g+G/nW2" +
       "5tpHvagaphwEHSKBq8AM7irmUTBL\n+u2IQ2WpCqPGiRLB5xFQ0EyewPTaRC" +
       "/N3DfAFm1FAFmwev9ztZsuPdH4DJPYjmsL8wJgDBM+S1py\n9o+bGEP9y/dE" +
       "zp5/+9SNVTAvDYPbnKBaIz2uKnIGhlxVOLEovCR1m3883N/8xQ3WY8zEDUoq" +
       "lSbS\nuIohEEuqqs/gZIKwSNSSF/VYsAFNNI1D0IL4l1CBEJfV8EyDezqEBd" +
       "+StnN3rb33Eg0cBlPMYjrB\nGFKUYRW9HnrtK2mkvzupB7flxIapfowL0LQ2" +
       "dtPwkdtXMsnzya0XPzJZgitZzUqgtL7iXBikL5ic\nqygn/3Prw78/3+RF3j" +
       "FUp1iDiiapVFnWXu78DqG1iMSJJ/ff9/5vySvMtDlvo8A6MqVx4oCUNxG2\n" +
       "vTjdUvv9+1NeVDeGmtnrUdLIAUlNU8OPwQvOCojKMJpf0F74suKRuT87mzqK" +
       "PT2PbbGf5+ITPNPe\n9LmeuzbrsxA02w7lGiidIoSyO21soZfWjAdcsmZXcG" +
       "D/bvp7KxvXxa4ruOWqoH2CapfW9YD/WizT\nyMA0YMMSEX/UPxKMB6Ns1CLI" +
       "D5hLUPF8/F3MZpgHsfZNBci2QekSyLockNXGgvH9kRit2OkAjT5v\nZ7jopR" +
       "8wNfMBOVC0YUd5ANdDWS4ALHcAMC8e9e+NRUajcQYi6ApEW26QayADULoFkG" +
       "4HII2UnD+c\nGBqNxWntHldI2vNGzQnKCgFlRQUo9EZr980JCr3NCcpKAWWl" +
       "E5TgiD8UToRG/LuDtPagOyh5o1xD\nGYLSI6D0OEBZEPCHg3t3+aM5NDe5Qr" +
       "OkcKBrQHEovQJQrwOgtoOj0V2JSHQ0EIzFRvNgya5gdTkN\ndwWOhvUNUFYL" +
       "cKtLwGVflyxIhGAxMInN1te+/sB7t57a5qXJUs00jZUQhvOCyd40XdLcduF8" +
       "Z+O5\nv5xhLy2EvIcoUaWcSATVGaYyLRFsy9Xkj0TCwXjiYGhXfMgqfUtETC" +
       "UF+e20SMC/1PXA3x55PdrG\nUx6+SukpWSjkj+ErFRaGGw36ml9RiQPrfXHd" +
       "igs3R18Z5xl8a2FaENTSqa33v4TXXt8kO+SlVbCW\nYnaAhLLUDj4oa4Qd1p" +
       "TagT4cg7TkTvpwvJJfGLb+5gv9DQVDu4fY/K/AfjuUPsG+ryx79Cx9+Iwr\n" +
       "9k0D++Px0b3cfLNwp8KvFdzXzsL98+6EF9xdCX8tlPWC/foS9vSeopczrjgv" +
       "jAcPxRP+aNDvSvQ9\nQnxk3yuIfqcrAM05AK6k3wFlk0CwySE8LTyIxzekJE" +
       "Xt5uso2nKXKyQi6If9A8HwLGGImmCzALHZ\nAUR9QFJhaSqxrO9eV9xzcd4N" +
       "gCCULQLAFqe3xkHdTHaztZBl6QzGN13BKI7ubsBcLQqy70Vgaphi\n6e9vu5" +
       "uL3BD+QDw0uncW3jQSbBW8tzpaQqiVVn3X3ZTIWsIVgkHEM2Fk30tMUaBR2v" +
       "BDVzjai0wx\nK5oGxJPN7QLN9hI0jPbjpdxZ1DCAZ00Sj6f5SsA0+GoqDe+6" +
       "cV1XsaQ5z0rKlqb/1wm21zmz/Tm9\nPEETfUzSfFnI5UBOcqwQUx3Z91KCzw" +
       "iC84gpaZahm2Q2oldB2SmI7nQm+qyNckq3SMKYhWAb4qk+\nsu+lBJ+zCVKA" +
       "nGCZ6EYJ0p2oAUFwwJng72yxMY1yoZQ0iWdBSVdAAUE04Ez0eUF0viwClxu6" +
       "NF3d\nJejucqb7R0G3dQbiUTYcuSFuTy1k30uJXxLEawxJw6q9TGylmV3GZ8" +
       "3ACtE3HKFN5blQv90tuOx2\n5vJnwaWR6XsgTQgsuwWvRQW8eFt5Zt2Ip/vI" +
       "vpcy+6tgtsC2Q47mq+UJr4ISEoRDzoTfEIQXFRjC\nFfUOKMOC+rAz9TcF9X" +
       "r6lcBvYslWUHuBguKi1eZloqtn35wBsESXdTW3S3LkzEv7Rg4d3MjT2s0V\n" +
       "SeyFnDZZtENzPqTtfLL9Rc1Lt/BqraN5+x1eixDUF7ZJijyc/uRPseEYb+Kb" +
       "80xZhq2Ff5YGVm8u\nrEN0rTYSsmGrZlkWt5nWiJLC9JOOkJXHdxaV/w1aWl" +
       "MkYhYP3cwdwJOKxhcVwkgerpjVFUblDVrV\nLD+0vu/CCT6or8KgPNHzedEd" +
       "THlKUZMU7jtAo6eiRfjw5793n96w6sNHvWLTjy9pVlXkriWdxNxa\nYcwIPE" +
       "OoCeipVFpTZPaFitN4cOBpT7jxyVcZ/MYU7xcv2Ox6j0GqpJAolnF2RZePig" +
       "7/kA3/RIXh\no2kyDq8uecpJrEo2H8gbdeO6bQ2RS8c+JewgQT+Y5Xk7yUOS" +
       "NTUiGf22TEWbyqK5pu5PP3t68ZHn\nq5B3EM1TdSk5KLGtdtRApkxsTelqMm" +
       "Ps5C+7ppl6uDZDqQJi7VmkjGBsOCyNY7XAP6pUaZzNMLqy\nrIsFoweC0U+y" +
       "ifCByDI+BmDZN8IOWuWpyXbd4r7r5gpdM3mPZXKgHrE9zWIc355eL76qiGnb" +
       "yVQn\nzRAfnqZfa/wydSq6O401bFKTd5b7XsfW5KcOvdt0m3TxJttNpgloWD" +
       "c2qECOv8Pom28+YzofqG2o\nOJlG2FfLXGiriu1cu2Z945teVF3mK06LqIxC" +
       "FmZqWY9nn3ekOX/eWV4kazGelull+6qmlGe9bGOZ\n70WXfIwtHNRfuAM9zy" +
       "wEypS2LPuCoo64CEpY+Fu46AXFIil1kVZu2DLfHSo20uHLIXormkKKU+Pq\n" +
       "aV1J0nGe1XneUvRZgvloRwFmmjnaM16+QpjXQWoEOjUJg3cZIKliFQFSuUIg" +
       "rwYdWjABLhcjpacJ\njNoVwrgDwksS4qqpH79cmOugWAKmNTeYnsIAtNQxAA" +
       "Xp8+ySDMLyVmIDItik3zNx0lkiVjGcca4p\nko3u+NwhZLtjbrLVMtK19OdT" +
       "ueicvZC8YD2LWhblNnSDGRkbVEYm8j6CqiDDchbTFWf3XfMU0yCM\nflEo5m" +
       "IZxaAnKklXQf58sx6G5aBkGDRDghS7vEULJfKUBb4RymsC+GtXEjgGf5RhRU" +
       "AwWxOG5Nza\nqmDpkG1lYqmXKdYSduyD/fG7e7FcxwpIcOrhfY9T4+z0iWc1" +
       "mluwEJs4npTAmbpCOI+D5g16+isi\nmfSsEzYtZ7+ZHW4XwDwp4J68QnA/C2" +
       "vilD6NAxLkA3E9qJWJW7NHYlgse04LtKfnFq1coz1DUPMk\nJlnVhrQJ3So9" +
       "ycUO9PA0/uGq3ne9P1ncy86oVI9DGk/p1hcfgSs94VZwcI0JMK9A3AUVxGXa" +
       "+TK9\nnOO5sWHkzmvkx9fNvI+HbU567q60zu2BdW6tirVJfuCKBaOzuXMZXt" +
       "7dIWoHVF3D9DyK3caPgCi6\nL3vAEBozTvg8nVkZPGf/D+b7BiROMoVjQ8n7" +
       "WshPVmSY452dk+PRaXKPsMQ9V8jxvkPQfHA8v2Go\nmFCvY2blEbE8WGoy/r" +
       "WELg6XlJwR5ScZ5ZUvHOl72mj5FfdR+7RhXRjVT6RVNf/USN5zrWHiCYUJ\n" +
       "WMfPkBgM6WOg1eKjbwCDPzDtPco7/hgWSNmOtOJxo8B7srtLXOgM+h/o9aDu" +
       "PSsAAA==");
}
