package benchmarks;

import java.io.*;

public class NoAliasBinaryTree implements Serializable {
    private int value = 0;
    private NoAliasBinaryTree left = null;
    private NoAliasBinaryTree right = null;
    
    public NoAliasBinaryTree(NoAliasBinaryTree left, NoAliasBinaryTree right,
                             int value) {
        super();
        {
            NoAliasBinaryTree _sjtmp_left = null;
            _sjtmp_left = left;
            left = null;
            this.left = _sjtmp_left;
        }
        {
            NoAliasBinaryTree _sjtmp_right = null;
            _sjtmp_right = right;
            right = null;
            this.right = _sjtmp_right;
        }
        this.value = value;
    }
    
    public NoAliasBinaryTree(int value) {
        super();
        this.value = value;
    }
    
    public boolean isLeaf() { return this.left == null && this.right == null; }
    
    public void inc() {
        this.value++;
        if (this.left != null) { this.left.inc(); }
        if (this.right != null) { this.right.inc(); }
    }
    
    public void printNode() {
        if (this.isLeaf()) {
            System.out.print("leaf=" + this.value);
        } else {
            System.out.print("node=<" + this.value + ">");
        }
    }
    
    public void print() {
        if (this.isLeaf()) {
            System.out.print("leaf=" + this.value);
        } else {
            System.out.print("node=<" + this.value + ", left:(");
            this.left.print();
            System.out.print("), right:(");
            this.right.print();
            System.out.print(")>");
        }
    }
    
    public void println() {
        this.print();
        System.out.println();
    }
    
    public static NoAliasBinaryTree createDepth(int depth) {
        NoAliasBinaryTree l = null;
        NoAliasBinaryTree r = null;
        NoAliasBinaryTree res = null;
        if (depth == 0) {
            res = new NoAliasBinaryTree(0);
        } else {
            l = NoAliasBinaryTree.createDepth(depth - 1);
            r = NoAliasBinaryTree.createDepth(depth - 1);
            {
                NoAliasBinaryTree _sjtmp_r = null;
                NoAliasBinaryTree _sjtmp_l = null;
                _sjtmp_r = r;
                _sjtmp_l = l;
                r = (l = null);
                res = new NoAliasBinaryTree(_sjtmp_l, _sjtmp_r, 0);
            }
        }
        {
            NoAliasBinaryTree _sjtmp_res = null;
            _sjtmp_res = res;
            res = null;
            return _sjtmp_res;
        }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238584038422L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVYXWxURRSe3W233Xax3VKg0D9aSqSBbolBFPuAtdBQWGhp" +
       "C5EKaad3Z3dve/fe\n653Z7ZYQBE0EeTBR/pSoJGJiNDwoRH0xaiL4b0wwAV" +
       "/gBaMkitEXIQaNZ2bu/t1dSkrSTe5k7syZ\nM2fO+c435+7Zm6iUWihICaWq" +
       "oU8E2bRJqGiN8QmiMBoc2jyALUrCPRqmdBgmRpWx/9Sd7wee3eRG\nrhFUox" +
       "vdmorpcMwyEtHYcEylKQstNQ1tOqoZzNZYoOOxZXemvju0ud6DqkZQlaoPMc" +
       "xUpcfQGUmx\nEeSPk/g4sWh3OEzCIyigExIeIpaKNXUvCBo6bEzVqI5ZwiJ0" +
       "kFBDS3LBGpowiSX2TA+GkF8xdMqs\nhMIMizJUHZrASdyZYKrWGVIp6wohb0" +
       "QlWpg+jfYjdwiVRjQcBcGFofQpOoXGzl4+DuIVKphpRbBC\n0ktKJlU9zFCz" +
       "c0XmxG1bQACWlsUJixmZrUp0DAOoRpqkYT3aOcQsVY+CaKmRgF0YWnJXpSBU" +
       "bmJl\nEkfJKEN1TrkBOQVSPuEWvoShBU4xoQlitsQRs5xo9Xv9/x4ZuLUUIg" +
       "42h4micfu9sKjJsWiQRIhF\ndIXIhbcTwWN9uxINboRAeIFDWMp0L/9oR+jG" +
       "p81Spr6ITL/A4qhyZ21D46Xun30ebka5aVCVQyHv\n5CKqA/ZMV8oEdC/MaO" +
       "STwfTkZ4Nf7DrwLvnNjcr7kFcxtERc70M+ood77H4Z9EOqTuRofyRCCetD\n" +
       "JZoY8hriHdwRUTXC3VEKfROzmOinTIRQGTwueMJI/vg7Yqh2m0yZJ1QdW9PD" +
       "FiFBOsFQOyOU0d3U\nUnaPgwdjcWxN0t3FZFN8iwemXC44XYMz0zSA5SZDCx" +
       "NrVHn7+jf7Nm554bCMG8eabRxDDdk9ggV7\nIJdLKJ/PYSnd1m1ZeJqnS+rg" +
       "pcZXv8SvQxDAGVTdS8RZ3VMlvIVFD83IJj3ZXOyDHgaojCq1B24s\nOfXjOx" +
       "fdyFOUUUKZwV7DimONgyKdQjX2ds4ZwFKbE9HF9v7jyNbzl7+9uiKLbYbaCl" +
       "KucCVPmVan\n8y1DIWGgpKz6k/9s+vNo6boP3KgE8hCYiGHAD6R1k3OPvNTp" +
       "StMQP4snhCojBQevYOCgqZwD89Yv\n+lUQinIeDnhqbPDN4w2fDPCmRmIIwl" +
       "XrOIMgudvPeVdf+bjyonBKmg+rcohziDCZXYEsRDhyYPzq\nKwNHj9889JQH" +
       "8tk0BSxcDHnNxLimKilYsig/IfkJwhxZv5/rqn6xg34oUOBT4/EEw+MaAQLH" +
       "mmZM\nkfAoEwwWyGFLQVLgLP84kB3w5qgGiqQ7TFcSEFyEToJ1tcdOtL92hR" +
       "OOKfy1EGz0CEs9wi1p3zjZ\nbcBS40AeSZvdXmp665fz1wdrJXTkFbCsgIVz" +
       "18hrQPi+0uS+aJlpByF9YWXL2f2D18YlPdbk+26j\nnog/fPon0v64XymS5B" +
       "64qFLihMtdvG3PnBaJ0yJhSSNP9dpsHIHzJmVE/O1DezaPHW4VoZT+AdE1\n" +
       "jgTXDcxTE5LbJpJeIBLNcRPc2n5iouXUgZdF0VCmShk4UOe9lDn0nHmm/Ehd" +
       "TeqkOK3bErFuEMeo\nMCWmkTjk2vQbbzukE9Y4Q5wzV1eQOIvsxKktlji8aS" +
       "nqWZdEfI7qmXzf5cqxzFVgqz2ScqIUorBq\nRprt5QVNloXUfX8fPPfDcb8b" +
       "ubPe50lGbS8XucodKvZ+suON29+za8LxWSKT/i+8h3biHI599HIy\n4H3vdN" +
       "yNykZQtSjHsM52Yi3BCWMECiraYw+G0Ly8+fziSFYCXRmibnBmW862TgrNpg" +
       "b0uTTvlztY\n02cH3mcH3+cIvstl8k6fWNAs2tYMx5WZlprEvIJFpUluvIie" +
       "hKGM84a8jTrhqbA3qii+UT9vtjCo\nOkiEZYFbVN1qeCptdZXF1Q3a6kotNR" +
       "rL05fKQTTK4tWGoejPZzZLqEYwU4wDQXMea7xb8Sg47NCT\nf/mfxxf2uG3U" +
       "dzLkY4bZoZEk0TLY9oq9vKCtY0ZsbxUldBZdnqH17Q+uqvwVrti7VA8BPc0l" +
       "8L2g\nD6djL8oKPOuyotlxVqc9gWT9dk9M/cotUCeBWvBlkL+oKx+eFVa+oc" +
       "Jp9XkMVQfPYjvYi2fHUGn+\nuSc5jcG1De4jOCKmV5pySRCQPm4YGsG6WBzN" +
       "QQpKFb7syTOc1yNNtuFNc2S4Jq4+xWl1SdJQw2IZ\nnZXJ3Ncdtskdc2QycI" +
       "YP6ENn24ywCDq9D0P5VbXONnTdHBl6ENhDGHq/RnKFfbaRfXNk5BFJxjrT\n" +
       "9Psxkz/r4em3zewvZmbhFeDm/TZIGir+zShu5uzqg6MMVSoWgUtlAzHlt+UD" +
       "ko0fMXPMuFf9AEVz\nwUcer97rCv6nkf8mKK2XxlZ8bga+Fp8tmS/+Mvjsji" +
       "Q0Lfcmzel7TYtEVGFWmbxXpY1vMlSR/dzk\nI2fM9I1SLW4UfrkH5eWecv0P" +
       "rkgbk5YSAAA=");
}
