package benchmarks.benchmark1.a;

import java.io.*;
import java.net.*;
import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import benchmarks.BinaryTree;

public class Client {
    final private SJProtocol p =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9nJ1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGng0BUOk0O1i9GFgTc" +
       "7IzEkpYdDwgWnXB2vSh2vXR9FuDbRJGc0m\nEJmflJWaXAKyC2LJxfXz8jlV" +
       "f2+FuE20ID+nMj0nvwSqA6LGUXV7qM+L/fIQNdJY1PiDTY1P/mMm\nI3vJ8Q" +
       "knM8jJHAX5xZklQPtLGCR8YJr0S0syc/QDoDLWFQUFFcDg18QTJv6lJeVAv6" +
       "diiwBVPPp8\n8vMLIHqYXU4umqF5axs4IFmS8lMqCxnqGJgrQCRTQUVBMX6D" +
       "glPzUrBZbopHjy+QnZie6pyfm1ua\nl5mcWAKP1ZVOhxl9uPfdBzuGOxeiDi" +
       "RVwiCKCCVIjEIiEurMYvxJJyg1OTWzDEsogbTzQnwpgxZ1\nATmJyake+Tkp" +
       "qUXxycsfn6px9e7sgIRSXmIu0EVCPlmJZYn6OYl56frBJUWZeenAGAM6NCk1" +
       "Lzkj\nN7Eou1jPKTMvsagypCg1FWSRCABU8+bUUAMAAA=="));
    
    public void run(boolean debug, String server, int port, int depth, int len,
                    int num)
          throws Exception {
        final SJService c = SJService.create(p, server, port);
        long totalRunTime = 0;
        for (int i = 0; i < num; i++) {
            BinaryTree bt = BinaryTree.createDepth(depth);
            SJSocket ds = null;
            try {
                ds = c.request();
                int k = 0;
                while (SJRuntime.outsync(ds, k < 1)) {
                    SJRuntime.send(ds, bt);
                    bt = (BinaryTree) SJRuntime.receive(ds);
                    k++;
                }
                bt = BinaryTree.createDepth(depth);
                long runTime = 0;
                long timeStarted = 0;
                long timeFinished = 0;
                SJSocket s = null;
                try {
                    s = c.request();
                    timeStarted = System.nanoTime();
                    int j = 0;
                    while (SJRuntime.outsync(s, j < len)) {
                        SJRuntime.send(s, bt);
                        bt = (BinaryTree) SJRuntime.receive(s);
                        if (debug) { bt.println(); }
                        j++;
                    }
                    timeFinished = System.nanoTime();
                }
                finally {
                    SJRuntime.close(s);
                }
                runTime = (timeFinished - timeStarted) / 1000;
                totalRunTime += runTime;
            }
            finally {
                SJRuntime.close(ds);
            }
        }
        System.out.println(totalRunTime);
    }
    
    private static void configureTransports(boolean debug, String transport) {
        List ss = new LinkedList();
        List ts = new LinkedList();
        if (transport.equals("s")) {
            ss.add(new SJStreamTCP());
            ts.add(new SJStreamTCP());
        } else
                  if (transport.equals("m")) {
                      ss.add(new SJManualTCP());
                      ts.add(new SJManualTCP());
                  } else {
                      throw new RuntimeException("Invalid transport [s/m]: " +
                                                 transport);
                  }
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        String server = args[1];
        int port = Integer.parseInt(args[2]);
        String transport = args[3];
        Client.configureTransports(debug, transport);
        int depth = Integer.parseInt(args[4]);
        int len = Integer.parseInt(args[5]);
        int num = Integer.parseInt(args[6]);
        new Client().run(debug, server, port, depth, len, num);
    }
    
    public Client() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238586677899L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVYb2wcRxWfvTuf/x3E59hpiB2niR1iq8mZVi0qGFRskyhO" +
       "z7Xrc0LipnLm9ubO\n4+ztLjtz53VUVSlISQgSEmoCbVVaqSBQokhAqpYPoI" +
       "DUFih/hAhSWiG1fCiCSlBEv0AEBfFm5vZ2\nb299ISft3OzMe2/evPd7b97s" +
       "lfdQG3NQhhHGqGWuZvi6TZhsrfwq0TnL5A7NY4eRwrSBGVuEiWX9\nxH/pke" +
       "+nv3AwhrQl1GtakwbFbHHFsSqllcUVylwH3WlbxnrJsHhNYpOMTw5/sPars4" +
       "cG4mjTEtpE\nzRzHnOrTlsmJy5dQqkzKeeKwyUKBFJZQ2iSkkCMOxQY9BYSW" +
       "CQszWjIxrziELRBmGVVB2MsqNnHk\nmt5gFqV0y2TcqejcchhHPdlVXMXjFU" +
       "6N8SxlfCKLkkVKjAL7PHocxbKorWjgEhBuyXq7GJcSxw+I\ncSDvoqCmU8Q6" +
       "8VgSJ6lZ4GhHmKO+45EHgQBY28uEr1j1pRImhgHUq1QysFkaz3GHmiUgbbMq" +
       "sApH\n2zYUCkQdNtZP4hJZ5mhrmG5eTQFVpzSLYOGoP0wmJYHPtoV8FvDWXD" +
       "L1n/Pz/7wTPA46F4huCP2T\nwDQUYlogReIQUyeK8WYlc2HmWGUwhhAQ94eI" +
       "Fc3k7h8czr774x2KZiCCZk5icVn/4OOD269P/rEz\nLtTosC1GBRQadi69Ol" +
       "+bmXBtQPeWukQxmfEmf7Lw02OnL5O/xFDHDErqllEpmzOok5iF6Vq/HfpZ\n" +
       "ahI1OlcsMsJnUMKQQ0lLvoM5itQgwhxt0LcxX5F910YItcOjwXMRqV+/aDjq" +
       "nDYoMXmGrXJ0FyeM\ns+PM0Y/nwWwrZeycZH737uP4eJ3aFZI/vKZpsKnBcI" +
       "AZgMaDllEgzrL+nXd+8dj+B790TrlLQKym\nE0dD/ioZf5UMzqhVkKZJ8ZsF" +
       "HpW9Jh0Hr4s4cZ+4vv3pn+FvgPXBCoyeInKT2lpCtMB0T8s0Mu0H\n4Qz0MG" +
       "BkWe87/e62Z3536bUYikemkmx98IDllLEh0ODFTm9tufAMgGgkDOWotf92fv" +
       "bFG798a9QH\nNUcjTbHWzCliZVfY/I6lkwLkIl/81/918O9Ptn3ipRhKQABC" +
       "CuIYgAPxPBReoyFmJrz8I/YSz6Lu\nYtPGuzgYaC2wYdGmRNOjIAK+6AspKF" +
       "PXzS8mP/bGj7pfkzv2stymQDrMEa5iJu37f9EhBMbfemr+\nyYvvnX0kDlFq" +
       "28rnHCXtSt6gugssdzSGmVCvIGDz16sTPV/Zx16WLu6k5XKF47xBIC1jw7DW" +
       "SGGZ\ny7yUDuRAmXrAEqk8pDDIhssGCFJ7tbUqwDMiSWS29l342tizb4g0Yk" +
       "vDbBHhJjVFrhwY0UQ72jQp\n3rcLBPf524bAP6k2kBrLPXroxLldcudBcXtr" +
       "L25doB8L97aMhQPiuAHMcAvyjg+ZE19+8+HZo58b\nV5nw7pYiHoKoLkg5Pv" +
       "/FGfOBa/03zJhASZKt1iM/i2KMczSa9UTWkCdeVS93KKemvNNg76034C9M\n" +
       "H/vHE1d/czEFCy+hdsoOUBMbwtvsIRW9ESdFSMSpa4efu/lr/rbEph8uQv1B" +
       "tznfHcGBSL7/RjWd\n/N7z5RhqX0I98rTHJj+CjYpA7hKc12y6NphFH2qYbz" +
       "x71UEzUU8Hg+FQDSwbDtREwNoJQS36HSo2\nbVfTbNG7X1IPyXanAlOMgxxh" +
       "L47abYdWsaiAkKYgvJmjgbojnIrJaZmIkqwGHRntmkT1pwF0e0I+\nq7tXpN" +
       "8pUqKmOnFrx5GmcPbRFlwBpt09+uW9o1dOKabRFkwBJAXXEjlHX6FGQah7D8" +
       "gYbgkxxf7b\n7z5nde7+90uxWph22yLXjLVYfa7C12AVErXV3S34spZlK574" +
       "Z19/4amx37+sDoa8VVhXGot2ypb5\nsZWgHBQLUYvf14JnFvpQqk1bkB5Nqs" +
       "sSV8m4NPWKlu2+9gepTHdZ0S02wGtK2qSVRxaITmg1wiSC\nfcZ262DrD5QH" +
       "UwBKZ12kfzE56zZDVwJvuJZbkZ9bvcQIWm3fqKiUBfHZo++nzuBXH1UG6m08" +
       "Qfab\nlfJ9z79Jxj6T0iMqmU5u2fsMUiVGPf3G5bpxWHZfS2jNyhrczx/x3A" +
       "Nje/Z2/xmO6g2qkHRtcIHA\nhcOsm1+WJ/i2y5MdIaOE9UlXBx6Or9Cfx2Re" +
       "Uamo6WrRyDTRmIC6nEZFpaMHpAKbwEQd8ByGZ7CG\nBfkvJtOi6VVVhGjmIs" +
       "/NpLRzkjUn9XmHlqG69qD21aFv/enFdxb6lPvUHWm46ZoS5FH3pECo72y1\n" +
       "gqR+9a6dVx5feDvv4XkREmnesgyCTQ/WPfJcFyk+o65XcmLZVtDNcxSHG53o" +
       "lvwmumTwTvia4M2+\n4P2uTmwRt1KJR0Am5OvwOomqRQtSpBWIlKToYtGQkB" +
       "IBTW6D9Gjd0T3wzMBj1BxtRDk64kwS/U9B\necfktTzaFDGfVCl06yILapDN" +
       "cPwWaQlK5UUHHGRbDpekVpNVmiRvMOzvVjx74DlT2+2Z29jtsGjc\n1k5vvi" +
       "PLy5HC+tX4yPuxH24ZkfV+Io+ZlyIaPy40fzto+CQgdeyq7+gj8Oy4xY5IJD" +
       "jvFc05V0Oy\n7ji/wa4nVAYHTxvELKm7q0TSWTfs5wjITxuWSUQx782p+pla" +
       "mfq3GphsLo/F+zGln1xr40zzf5fv\nF6CK0oU6ESGvqrrWvhWvhpR0GqK0DL" +
       "VnNCi1gHEaRoQN1R1a1Adbm75/qa80+q7rJ0ZfsdOvK5R4\nX1Las6ijWDGM" +
       "YAkZ6CdthxSp1K7dKyjF3zc5umOD+zxUkFgq+YIi/Xbj2e6TctTlvwQ5LgVn" +
       "5MRl\nCaVnXO1/g7lVjDcUAAA=");
}
