package benchmarks.benchmark1.a;

import java.io.*;
import java.net.*;
import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import benchmarks.*;

public class Server {
    final private SJProtocol p =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9gp1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGvisgkih28Xow8CanJ" +
       "GZk1LCoOED064P1qQP166Pot0aaJMymk0g\nMj8pKzW5BGQXxJKL6+flc6r+" +
       "3gpxm2hBfk5lek5+CVQHRI2j6vZQnxf75SFqpLGo8QebGp/8x0xG\n9pLjE0" +
       "5mkJM5CvKLM0uA9pcwSPjANOmXlmTm6AdAZawrCgoqivGHiWdeOdDrqdjCXx" +
       "WPNp/8/AKI\nHmaXk4tmaN7aBg5HlqT8lMpChjoG5goQyVRQUUDA/qDU5NTM" +
       "Mqz2m+LR5gtkJ6anOufn5pbmZSYn\nlsDjdaXTYUYf7n33we7hzoWoA0mVMI" +
       "giwgkSp5CohLq0GL+Pg1PzUjBdCdLLC/GlDFrMBeQkJqd6\n5OekpBbFJy9/" +
       "fKrG1buzAxJKeYm5QOcI+WQlliXq5yTmpesHlxRl5qUDIwzoyqTUvOSM3MSi" +
       "7GI9\np8y8xKLKkKLUVJBFIgDUelUBTwMAAA=="));
    
    public Server(boolean debug, int port) throws Exception {
        super();
        ServerThread st = this.new ServerThread(debug, port);
        st.start();
    }
    
    private class ServerThread extends Thread {
        private boolean debug;
        private int port;
        
        public ServerThread(boolean debug, int port) {
            super();
            this.debug = debug;
            this.port = port;
        }
        
        public void run() {
            SJServerSocket ss = null;
            try {
                boolean run = true;
                ss = SJServerSocketImpl.create(p, port);
                new KillThread(port + Kill.KILL_PORT_ADJUST,
                               ss.getCloser()).start();
                BinaryTree bt;
                for (int counter = 0; run; counter++) {
                    SJSocket ds = null;
                    try {
                        ds = ss.accept();
                        while (SJRuntime.insync(ds)) {
                            bt = (BinaryTree) SJRuntime.receive(ds);
                            bt.inc();
                            SJRuntime.send(ds, bt);
                        }
                        SJSocket s = null;
                        try {
                            s = ss.accept();
                            while (SJRuntime.insync(s)) {
                                bt = (BinaryTree) SJRuntime.receive(s);
                                bt.inc();
                                SJRuntime.send(s, bt);
                                if (debug) { bt.println(); }
                            }
                        }
                        finally {
                            SJRuntime.close(s);
                        }
                    }
                    catch (Exception x) { run = false; }
                    finally {
                        SJRuntime.close(ds);
                    }
                    System.out.println("Finished run: " + counter);
                    if (debug) { System.out.println(); }
                }
            }
            catch (Exception x) { throw new RuntimeException(x); }
            finally {
                if (ss != null) ss.close();
            }
        }
        
        final public static String jlc$CompilerVersion$jl = "2.3.0";
        final public static long jlc$SourceLastModified$jl = 1238585562032L;
        final public static String jlc$ClassType$jl =
          ("H4sIAAAAAAAAAJVXX2wURRifu2vv+ue0vVKgoS2F0gaa0quSKGofpDQ0FA6p" +
           "bSFSS8rc7tzdtnu7\n687s9SCEgCaCPJgYwH9ReTExGh4Uor4YNRH8b0wwAV" +
           "/gBaMkitEXJQaN38zs3d7tXWu8ZGdnZ75v\nvvm+7/f9Zu7cLVRLbRSnhFLN" +
           "NObi7KBFqGjN5BxRGI1P7hjHNiXqiI4pnYKJWeXAP9red2JPbg+i\nwDRqMc" +
           "xhXcN0KmObTjozldFo3kZrLFM/mNZN5q5YscZD6+4sfH18R3sINU2jJs2YZJ" +
           "hpyohpMJJn\n0yiaJdkksemwqhJ1GsUMQtRJYmtY1w6BoGmAYaqlDcwcm9AJ" +
           "Qk09xwVbqGMRW9gsDCZQVDENymxH\nYaZNGWpOzOEcHnSYpg8mNMqGEiic0o" +
           "iu0ifQERRMoNqUjtMguCJR8GJQrDg4ysdBvEGDbdoprJCC\nSs28ZqgMdfk1" +
           "ih737AQBUI1kCcuYRVM1BoYB1CK3pGMjPTjJbM1Ig2it6YAVhlYtuigI1VlY" +
           "mcdp\nMstQm19uXE6BVL0IC1dhaLlfTKwEOVvly1lJtnaHo3+fHP9zDWQc9q" +
           "wSRef7D4PSap/SBEkRmxgK\nkYq3nfjpsX1ORxAhEF7uE5Yyw73v70nc/KhL" +
           "yrRXkdktsDir3Lm/o/Py8A/1Ib6NOsukGodCmeci\nq+PuzFDeAnSvKK7IJ+" +
           "OFyY8nPt139C3ycxDVjaGwYupO1hhD9cRQR9x+BPoJzSBydHcqRQkbQzW6\n" +
           "GAqb4hvCkdJ0wsNRC30Ls4zo5y2EUD084BU6huSvmzcM1QOSc8SO0zmG+hmh" +
           "jM5QW5lJQtgyWWzP\nU6977wyeKUrn+cp3LwQC4FSHv8B0QON2U1eJPau8ce" +
           "PLw9t2PnNCpotDzN0T2POsxD0rcRyXVnrk\nC4qZYBUFAsLWMg5OGbxh28YH" +
           "edHkj13ufOkz/CqkAkJCtUNEeBxYqOEtKG1aklNGvIocgx4GwMwq\nrUdvrn" +
           "r5uzcvBVGoKq8kioOjpp3FOodGoZBaXHP+GUBUjx/X1Wz/enLXhStfXdvgIZ" +
           "yhnorCq9Tk\nhdPtz4VtKkQFYvKWf+Gv7b+dqn3w3SCqgWoEPmIYUATFvdpv" +
           "o6yAhgpkxH0JJVBjqsLxBgYBWihx\nmLdR0W9yIRiCp9+F4Hre8MkYb1okpC" +
           "BdrT4fBNXdfip8z9UPGi+JoBRYsamEPicJkzUW8yAyZRMC\n49deHD915tbx" +
           "x8F43rIkLBgKW05S15Q8qKwsL0vugcqR9cv5oeZnB+h7AgX1WjbrMJzUCdA4" +
           "1nVz\ngaizTPBYrIQzBVVBsKJJoDxgz1kdFpLhsAI5QHAVUom3tZ5+vu+Vq5" +
           "x2LBGvFbxcxU6DtJLZxm0t\nC8SRc5ntudWv/3jhxkSrBIyk/3UVDFyqI48A" +
           "EfFGi0dg7VIWhPTF/rXnjkxcT0pqbCmP2DbDyd53\n9nvStyWqVKn0SNI0dY" +
           "IN4Vo/GOTvOEMhOLzkR2+At31F35HwHYkddvIabvWyCjw4L/MT7Zvcv+PA\n" +
           "iW6RWBktrjDAm01y4c0Vw/kqAd64JEOM8hPZKyDt8B/Hzn97JhpEwWkU0eio" +
           "ZmCd44M+Iimhylnk\nW+LQh3teu/0Nuy5i5dUg31hHvpJR9+ISenjgSi4Wfv" +
           "tsNogi06hZ3CewwfZi3eFYn4YbAR1xBxPo\nrrL58tNdHmVDRY7p8EOmxKy/" +
           "+r38Qp9L836dr+Ab4GmDp8ct+B5fwQcCFu9sEQpdou0ulmfEsrUc\n5lcwVK" +
           "uSpJMupvBuIHX+HioztAyeXtdQb3VDo7zZyuBoNG1Rkpvc5cS+t0ogIg+Im1" +
           "0QAkA6F7uQ\niNo4/tjv0afxxf1BF7GDwC7urbGANe80GlgSa7vEnczLdmjy" +
           "4b71Gxt/ArZe5CCKuYMTBC6gxlQh\nF+KEwv/7hOryOerfTyzX/mgoo30eFC" +
           "iQwKm4apYrDZXDpcEu36iIWHvZKcFzOeDmcqDaKcGbtUsS\nx3+yygTQj+1U" +
           "UFJNztRUobavHAOlH4DJaOntREwugxN06RsNJL+t4s+IvDIr3ZcPbPjEin0h" +
           "TuXi\ntTYCd8uUo+ul1VbSD1s2SWnCnYisPUu8kgytXGQrDAWw2C6WovwWXl" +
           "WUoQbvo1QjUzojJjSrEIBm\nwdKcXeIyMvnAvz2cGsDYDQAA");
    }
    
    
    private static void configureTransports() {
        List ss = new LinkedList();
        List ts = new LinkedList();
        ss.add(new SJStreamTCP());
        ss.add(new SJManualTCP());
        ts.add(new SJStreamTCP());
        ts.add(new SJManualTCP());
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    public static void main(String[] args) throws Exception {
        Server.configureTransports();
        boolean debug = Boolean.parseBoolean(args[0]);
        int port = Integer.parseInt(args[1]);
        new Server(debug, port);
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238585562032L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJ1Yb2wcRxWfvTuf/x3E5zhpiJ04f2xik+RMIwoUfwiOSRS7" +
       "l9r1uaE1qZy53bnz\nOHu7y87c+RyiKiUSaYOEQE0gRW1TVZWqVpFaUrX9UB" +
       "SQ2gKlRaiplFZILR+KoBIU0S8QQUG8mbm9\n3ds9HyqWdjy78968N29+7zdv" +
       "7vKHqI25KMMIY9S2ljN81SFMtnZ+meicZXLTs9hlxJg0MWPzMLCo\nH/8PPf" +
       "qT9LcPx5C2gHote8KkmM0vuXa5uDS/RFnVRdsc21wtmjavzRiZ4ys7P1554+" +
       "x0fxytW0Dr\nqJXjmFN90rY4qfIFlCqRUp64bMIwiLGA0hYhRo64FJv0JAja" +
       "FhhmtGhhXnYJmyPMNitCsJeVHeJK\nm97HLErptsW4W9a57TKOerLLuILHyp" +
       "yaY1nK+HgWJQuUmAb7JroXxbKorWDiIghuzHqrGJMzjh0S\n30G8i4KbbgHr" +
       "xFNJnKCWwdFgWKO+4qHbQABU20uEL9l1UwkLwwfUq1wysVUcy3GXWkUQbbPL" +
       "YIWj\nzWtOCkIdDtZP4CJZ5GhTWG5WDYFUpwyLUOFoQ1hMzgR7tjm0Z4Hdmk" +
       "mm/n1u9h/bYMfBZ4PopvA/\nCUpbQ0pzpEBcYulEKd4oZ85P3V0eiCEEwhtC" +
       "wkpmYvjFO7Mf/GxQyfQ3kZmRWFzUP/7iwJZrE3/o\njAs3OhybUQGFhpXLXZ" +
       "2tjYxXHUD3xvqMYjDjDf587hd3n36a/DmGOqZQUrfNcsmaQp3EMiZr/Xbo\n" +
       "Z6lF1NeZQoERPoUSpvyUtOU7hKNATSLC0QZ9B/Ml2a86CKF2eDR4HkHqr080" +
       "HHUCkivEzbBljnZz\nwjg7xlz9WB7CtlTC7gnmd28+ho/Vpati5k+vaBosai" +
       "CcYCag8bBtGsRd1J98/9enDt72wP1quwTE\naj5xtNW3kvGtZHBGWUGaJqdf" +
       "L/Co4jXhunhV5En1vmtbHvolfgSiD1Fg9CSRi9RWEqIFpX0taWTS\nT8Ip6G" +
       "HAyKLed/qDzT9+66lXYyjelEqy9Y+HbLeETYEGL3d6a+bCIwCioTCUm9n+67" +
       "kjz11//d0R\nH9QcDUVyLaopcmVHOPyurRMDuMif/kf/PPy3B9tufT6GEpCA" +
       "QEEcA3Agn7eGbTTkzLjHP2It8Szq\nLkQW3sUhQCuBBYs2JfvrYCs64IFcQt" +
       "tqqOsXjRhMi6ZXoQi2qy+0BsluN84kP//2T7tflUHxiHBd\ngDFzhKu0SvsQ" +
       "mXcJge/vXpx98MKHZ78Rh0R2HAULjpJOOW9SvQoqNzVmoliBIZD1lyvjPd/b" +
       "y16Q\nKOikpVKZ47xJgLmxadorxFjkkrrSAZqU7ATBSuWB5YAwF02YSIXD0S" +
       "qA4CY8ktnUd/6How+/LZjG\nkfHaKGIlPY2xKJnNurQEXFGpkdkPtj7xx+fe" +
       "n+tTgFGMvzNCukEdxfoy4t2OiMD2Vhak9Cu7t1++\nd+69vGLD3saIHbTKpV" +
       "suvUNGv5rSmyR3e962TYItubTdYFD8z3AUh/NKvQxroh2tr91LXvG+ntfS\n" +
       "XsQ3c7CqE0fwpPR+i8jvPn/HgRZPqL1LjebumT5+/w656SqSQmGvaPYpo7dG" +
       "PlcjDrjoCy3Z45A4\noCHLuA1M7SfZ8e++c8eRu74+pqJ1c8spbodQGXIeX/" +
       "/ClLX/6obrVkzkVZIt18OZBUBwjkay3pS1\n7RWvqpebzqkh7/zc878X4Bum" +
       "p/5+35XfXkiB4QXUTtkhamFTgJ/drviuydkamuLk1TsfvfEb/p4E\ngk8wwv" +
       "2BavSEOIoD3Pfl65V08tlLpRhqX0A9sj7CFj+KzbJI5AWocNhk7WMWfaphvL" +
       "FaUUfzeJ1A\nB8L5EDAbprZEINoJIS36HYrNnKqmOaJ3UEoPynZHDWAc5hHx" +
       "AsQ7Lq1gUTMizfFQ3F/fCLdscVoi\nooitQUeSnyazYBpAtyu0Z/XtBZXcAV" +
       "Kklkr9GpVqCmefbaEVUBru0Z/eM3L5pFIaaWXKR1LQlqBg\nfYmahnB3P8yx" +
       "syXElPqbzzxqdw7/63lh1SeeVtanrBUwQpqtdLiFWta2HaUT/9prj18c/d0L" +
       "ipLy\ntrGqHBbtjCNPi1b254hO6iTbaP+WFmpHoA/l7aQN54VFdXktUHM8de" +
       "BlLdt99ffSn+6SkptvANiM\njEqr5eWg5ou6JHSPOtU61jYE6qkDgEl3VRyG" +
       "YnBBym5XtIt82lVsiIT5LWtV3PIkOHvXR6nv4Ffu\n8cyOQeXIbWevSSrEbH" +
       "J67W0JjiPy3uEzQDy3f3TXnu4/QXmyRuWVrn2cI3DJsurhkyUZ/sQl2WBo\n" +
       "rWF/0pX+O+JL9FcxyQyKTCLXqUal8UYK6XIbHZVB66+XRT3wfA6eM7XtPNO0" +
       "LIqSjehPQRnD5A21\n+TGKvD1tNSjegT3XA5sWaBFqxXkXjmrHdjkLH9iJik" +
       "0NOY3diJnIS76+PvHsgud8bX3nP8H6hkRD\nW5cI0QuivBmoFLkSH/oo9tLG" +
       "IVnsJvKYeVhpvFlHL84N92HpY1d9RZ+BZ7DFirwc7PGrFnV5blre\nTIjmVF" +
       "VD8lg5vUYkDstwwHGSNIlVVJe5faL5VjWSctGiadK0LSJKV29MlUzUztR/vI" +
       "DBaPUj3nXl\nn7QVYI7/F2nn4JDUhTtNoqQO7WrL/RavX5IzQRmUKEFpIeEY" +
       "AaUWCE7DFxFDdakU/L8p8oOQ+tlC\n33Ht+MjLTvo1hRzvp4V2uN8XyqYZrB" +
       "AC/aTjkgKV3rV79YL49xBHN61xwYUCAUsnLyrRhxu52xfl\nqMt/CWpcCo7I" +
       "gccklL5f1f4L2DLWcUgTAAA=");
}
