package benchmarks.benchmark1.c;

import java.io.*;
import java.rmi.*;
import java.rmi.registry.*;
import benchmarks.BinaryTree;

public class Client {
    
    public void run(boolean debug, String rmiRegHost, String name, int depth,
                    int len, int num)
          throws Exception {
        Registry registry = LocateRegistry.getRegistry(rmiRegHost);
        Server remObj = (Server) registry.lookup(name);
        long totalRunTime = 0;
        {
            BinaryTree bt = remObj.dummy(BinaryTree.createDepth(depth));
            bt = BinaryTree.createDepth(depth);
            long runTime = 0;
            long timeStarted = 0;
            long timeFinished = 0;
            timeStarted = System.nanoTime();
            for (int j = 0; j < len; j++) {
                bt = remObj.inc(bt);
                if (debug) { bt.println(); }
            }
            timeFinished = System.nanoTime();
            remObj.end();
            runTime = (timeFinished - timeStarted) / 1000;
            totalRunTime += runTime;
            System.out.println(totalRunTime);
        }
    }
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        String rmiRegHost = args[1];
        String name = args[2];
        int depth = Integer.parseInt(args[3]);
        int len = Integer.parseInt(args[4]);
        int num = Integer.parseInt(args[5]);
        new Client().run(debug, rmiRegHost, name, depth, len, num);
    }
    
    public Client() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238584038459L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVXXWwUVRS++9Pt32K7pRSkf/zUQANs/YkGLQabTSulS6jd" +
       "QqCWbGdn726nnZ0Z\n597dDmgIqLHog4kBf6PwYmI0PChEfdCoCeC/L5iAL/" +
       "CCURLFyIORGDSee+/s7uzMtsomc/fOveee\nc+455zvnzMlrqIaYKEowIYqu" +
       "zUTpfgMTPuqpGSxTEk1sH5VMgtMxVSJkHDaS8tQ/yu73Ik9u8yPf\nBGrR9A" +
       "FVkcj4tKnns9Pj0wqxTLTK0NX9WVWnNkcPjwfW3pz7dn57ewA1TaAmRUtQiS" +
       "pyTNcotugE\nCudwLoVNMpBO4/QEimgYpxPYVCRVOQCEugaCiZLVJJo3MRnD" +
       "RFcLjLCF5A1scpnFxTgKy7pGqJmX\nqW4SiprjM1JB6stTRe2LK4T2x1Eoo2" +
       "A1TR5DB5E/jmoyqpQFwrZ48RZ9nGPfEFsH8gYF1DQzkoyL\nR4KzipamqNt9" +
       "onTjnhEggKO1OUyn9ZKooCbBAmoRKqmSlu1LUFPRskBao+dBCkUrF2QKRHWG" +
       "JM9K\nWZykaIWbblRsAVU9Nws7QtEyNxnnBD5b6fKZw1s7Q+G/nxv9cxV4HH" +
       "ROY1ll+ofgUJfr0BjOYBNr\nMhYHb+Sjx4b35jv8CAHxMhexoBm448Nd8auf" +
       "dgua9io0O3ksJuWb93V0nh/4sT7A1KgzdKKwUKi4\nOffqqL3TbxkQ3W0ljm" +
       "wzWtz8bOzzvYfewb/4Ud0wCsm6ms9pw6gea+mYPa+FeVzRsFjdmckQTIdR\n" +
       "UOVLIZ2/gzkyioqZOWpgbkh0ms8tAyFUC48PnoeR+C1hA0X1MVXBGo2SGYo2" +
       "UEwomSSmPJkCs03n\nJHOWlKd3TcqTJWqLcb5tzueDS3W4AaZCNG7T1TQ2k/" +
       "JbV75+YnDk2SPCXSzEbJ0o6ipLiZalROWo\nkIJ8Ps5+KYtHYa8B05T2M5xY" +
       "h893vvqF9AZYH6xAlAOYX9I3F2QjHLp70TQSK4NwGGYSxEhSbj10\ndeVr37" +
       "99zo8CVVNJvLQ4pJs5SWXRUMROiy3OvQNB1OMO5Wqyf3tux+kL31xaXw5qin" +
       "o8WPOeZFhZ\n4za/qcs4DbmozP7lv7b9frTm/vf9KAgAhBREJQgcwHOXW0YF" +
       "ZvqL+YfdJRBHjRnPxRsoGGjOcWE2\nhtnQLEIEfNHqUpCnrhtPhe68+HHjOX" +
       "7jYpZrcqTDBKYCM5Gy/8dNjGH90iujR1+8Nv9oAFBqGMLn\nFIWMfEpVZAuO" +
       "LK+EGVMvzcLm11P9zc9vIh9wF9cruVyeSikVQ1qWVFWfw+kk5Xkp4siBPPWA" +
       "JcIp\nSGGQDZMqMBJ3NXwFCM8qSSK6ovXYS72vX2RpxOCGaWNw45oiiy/0+N" +
       "i43rPJ3jtZBLeWrw3AnxUX\nCPcm9m2fOrKG39zJbqP9YjNHBS8sh1hdKcZE" +
       "LvX4H2eON6wqa7jRya6Lj6tt27L52iLnstqlEybq\nXChf81ozv+d6+Bnp7D" +
       "6RVVsqnTOo5XP3nvgB9z4UlqskiXqqG5tUXMBqyVR+LtcPYjctivIdvLyV\n" +
       "URBIbO1dt7HxZ0DBAgCP2ItjGGq5xvRnMus48qVbRn63yyhufSKF9kcC08qX" +
       "foYtG/Seql15qN9p\nHkCfWakoj552rkATmKgOnkl4muycz//ZZoQNLQKgbL" +
       "inakiGuJ1DxFtZR00lB4WrYFfWF7re/On0\nlbFW4T7Rfqz1dADOM6IF4Qo0" +
       "GiyAVi8mgVOf3bD65MGxyym/DZLNFNWmdF3FksY1XgrdFIcMQ21U\ndC5sfZ" +
       "jvxgwRv0MUBaBjYtMRPlRHY7GQ2IyXlhkPWjI2WM3mSmwFdmZec4sIFnQlzV" +
       "kmHEgJsekg\n16k0jLg1uQXSLSVHs2cdPFtsR2+p5mgvsP0c2JA5Ce94FzeF" +
       "tynj1VhEwKlAz3X/R209vMAEUxIp\nAqeym/U2qxU9KNezoXSr2+Hp/o9bDV" +
       "fR0x2tFYkvKR/4ZNfxG9/Ryzxay8WQ8emwvGlzt+So05sv\nFCKhd0/k/Kh2" +
       "AjXzXl7S6G5JzbO6NAEXJDF7MY6WVOxXdtaijewv4b7DDReHWHcZdmaAIK3A" +
       "Pq+8\nkuVDBptkq7icAi9Fk1SR08H3KtayolHksTVlefKsFwQxVdcwq5zFPV" +
       "GsFD1a+jCCTasqnB4UKnJZ\nC+ee/10roYmpkZk6VZKAMLK1aFyz11HOaQ/g" +
       "NgehwGHrAa/PYZyKFWZD0bCyZmWF52NTfBLJa85P\nrT9jRL4SCCl+ttTCt0" +
       "Mmr6pOjzrmIcPEGYVrVyv8a/C/wxQtX6B5hrZZ5koeEqRPw1dWVVKKGsov\n" +
       "zhPzzh2+cYRHk2X5/gVDkXM4pA8AAA==");
}
