package benchmarks.benchmark1.c;

import java.io.*;
import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;
import benchmarks.BinaryTree;

public class ServerImpl extends UnicastRemoteObject implements Server {
    private static Server remObj;
    private boolean debug;
    private int counter = 0;
    
    public ServerImpl(boolean debug) throws RemoteException {
        super();
        this.debug = debug;
    }
    
    public BinaryTree inc(BinaryTree bt) {
        bt.inc();
        if (debug) { bt.println(); }
        return bt;
    }
    
    public BinaryTree dummy(BinaryTree bt) throws RemoteException { return bt; }
    
    public void end() throws RemoteException {
        System.out.println("Finished run: " + counter++);
        if (debug) { System.out.println(); }
    }
    
    public void reset() throws RemoteException { counter = 0; }
    
    public void shutdown() throws RemoteException {
        UnicastRemoteObject.unexportObject(remObj, true);
        System.exit(0);
    }
    
    public static void main(String[] args) throws IOException {
        boolean debug = Boolean.parseBoolean(args[0]);
        String name = args[1];
        remObj = new ServerImpl(debug);
        System.setSecurityManager(new RMISecurityManager());
        Registry registry = LocateRegistry.getRegistry();
        registry.rebind(name, remObj);
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238584715165L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVYWWxbxRoe24mz1JA4SRfaNKFpKhpBHEDsQYLg26gpLg1J" +
       "WtEQlIyPx85pz8aZ\nOY5TVYhFUOAB6QrKJpYXEALxAEWAEKt04bILqVeC+w" +
       "IvXF2QWAQv91YIEP/MnOOz+NSCIiyd8Xjm\nn/mX+f5v/uNnv0Ot1EY5SihV" +
       "TeNAjq1ahIrWLB4gCqO52V3T2KaklNcwpXMwsags/aruez57684k\nSsyjHs" +
       "Oc0FRM55Zt06kszy2rtGajMy1TW61oJnN3bNjjsq0/r3x0ZNemFOqaR12qMc" +
       "swU5W8aTBS\nY/MooxO9SGw6USqR0jzKGoSUZomtYk09BIKmAYqpWjEwc2xC" +
       "Zwg1tSoX7KGORWyh0xssoIxiGpTZ\njsJMmzLUXTiAq3jMYao2VlApGy+gdF" +
       "klWoneiG5CyQJqLWu4AoLrCp4XY2LHsUk+DuKdKphpl7FC\nvCUtB1WjxNBg" +
       "dEXd4+GrQQCWtumELZt1VS0GhgHUI03SsFEZm2W2alRAtNV0QAtDG0+6KQi1" +
       "W1g5\niCtkkaENUblpOQVSHSIsfAlDa6NiYic4s42RMwuc1p505pe7p/9/Jp" +
       "w42FwiisbtT8OigciiGVIm\nNjEUIheecHL3Te13+pMIgfDaiLCUmdj28t7C" +
       "128OSplNMTJ7BBYXlZ8v6t98fOI/HSluRrtlUpVD\nIeS5ONVpd2a8ZgG619" +
       "V35JM5b/KtmX/uv/kZ8k0StU+htGJqjm5MoQ5ilPJuvw36BdUgcnRPuUwJ\n" +
       "m0ItmhhKm+I3hKOsaoSHoxX6FmbLol+zEEJt8CTgmUbyczpvGDoNkFwl9pRu" +
       "aTl6gKExRiijC9RW\nFooQumUd2wep3z1vQVkIrahxDaevJBLgXH800TRA5U" +
       "5TKxF7UXnqyw8O77j6rjvlsXGoubYxNORr\nyvmackrO14QSCaGil2NTxm7C" +
       "tvEqz5naLcc3P/QufhROAiJC1UNEOJxYaeEtLDq/KaXk/YScgh4G\nvCwqfT" +
       "d/vfHhfz39ThKlYmmlUB+cNG0daxwZXh71uOqiMwCo4Sis43R/f/fuFz798P" +
       "PtPsAZGm7I\nu8aVPG+GokdgmwopAS/52z/w084f7m299MUkaoFkBDpiGEAE" +
       "uT0Q1RHKn3GPi7gvqQJaU25wvJNB\ngFYCDvM2I/pdcBTt8EBeoY0uAtfyhk" +
       "9medMjkQTH1RfxQTDdidvS53722pp3RFA8UuwKsOcsYTLF\nsj5E5mxCYPzz" +
       "B6fvPfrdketTkNSWJWHBUNpyipqq1GDJ+nBWcg9KHFnfHhvvvmeUviRQ0KHq" +
       "usNw\nUSPA4ljTzBVSWmSCxrIByhRMBcHKFIHxgDwXNdhIhsNKVAHBMZyS29" +
       "B33/0jj3zGWccS8VoXAnCU\n2KZtVQfeqLrE9veBJ/77wpczfRIwkv23NhBw" +
       "cI28AUTE11g8AluaaRDSb5+95dmbZr4oSmbsCUds\nh+HoFz7+bzJyZUaJSf" +
       "C2omlqBBs14du2BG9HGvzkv3uBQMX52boK/K2bjOyoKcTiJCnM3czj0ecf\n" +
       "MXDiQXlYmZHZG3Yt3TkkTlluyReMSqUXBUdqdd0pMZyCPc9pShKT/E72c0g9" +
       "/L9bjn1yNJNEyXnU\nptJJ1cAahwi9RrJCzG0U2eLQG3sfO/Ex+0KEy09Dbl" +
       "h/rZFL9+EAQ1zyaTWbfu5xPYna5lG3qCiw\nwfZhzeFwn4eagObdwQI6LTQf" +
       "vt/lZTZep5n+KGoCaqME4B8x9Lk077dHcr4bngH3G3nfgZxPJCze\nuUIsGB" +
       "TtkDy8JMDGstUqZmBzmoqSrAY9m+hgtQeWgeZXh6AUhIT0ZXWjOuBZD0+Pa1" +
       "RPvFE7G40S\n+MmDGa0lUnQqAk1SRyJGxxnw9Lo6euN17ObNLnBVMR1ex4n1" +
       "Z1sSoDmGUlDduQpEZLfIDEJ+BgWA\nPckzefPJKieRxUeu+zFzB377Bp7FfM" +
       "kYQx3MtEY1UiVaPSvSYs807DbaNCt2i/rRx2Vq9oqRs85Z\n8xVcLSe5NbPu" +
       "4AyBYtmY81AjrlP8h6/TwYivUXuy1U3XppbV95ICrxLiDWVxeNF4GNiddthQ" +
       "EbRN\noSttGzz97in3x11pgXNrznxrA2C+ChjFXuUXWDxpIrFUHuKCwInCu0" +
       "tCbCmKjKUGEnRH9odcOQue\n7a4r20/JlcDWTSQuELtVeBo5ur765w3nGTzq" +
       "Gj76xwz3Avn7bIbLLAX1dzRNW6qmWhJiKwF7Ua3x\nR9juPngudu2++K+0+z" +
       "DEGl5OiSCTlVOwlPPl5a6ll/+Vlt7OUDtddljJXDFOxdguF8d519h8nLEx\n" +
       "1w3vD/Pmb82rlMZ3U/EiIiuxY6nhH5OvrhsWtXVLEVOP3sIv9Y3v7KFXcWFj" +
       "Z90jfo0MNvHIo49u\nURXxez0n39tjeWacN/fXEkjcPw/HXrytZV7PiIjwK1" +
       "cjRkW+Sk7z5qhfPiXlCs+CXt+CvGYahBfL\n3pys2VQzV//rBCZrsSbOSxOF" +
       "rlOEVZAenwSHFG5OTKBkAVT7XYVpr+fB1J5wTXoPEIAO1Vs8XBOB\nmIVGIL" +
       "Sd/hsuf3XZ0PBPlfw/RRk6vrT9H1b2fYkr7z+PtgJqLzuaFizEAv20ZZOyKi" +
       "xsk2WZJb5e\nYmj9ScomhhKKMPRFKfpK+FLyRcF0/0dwxWvBGTHxuuUFcGu9" +
       "sqfC7dxeQ1UwZbLOd48C/QZ9mJ+y\nCBQAAA==");
}
