package benchmarks.benchmark1.d;

import java.io.*;
import java.net.*;
import java.util.Arrays;
import benchmarks.BinaryTree;

public class Client {
    
    public void run(boolean debug, String server, int port, int depth, int len,
                    int num)
          throws Exception {
        long totalRunTime = 0;
        for (int i = 0; i < num; i++) {
            BinaryTree bt = BinaryTree.createDepth(depth);
            Socket ds = null;
            ObjectOutputStream doos = null;
            ObjectInputStream dois = null;
            try {
                ds = new Socket(server, port);
                ds.setTcpNoDelay(true);
                doos = new ObjectOutputStream(ds.getOutputStream());
                dois = new ObjectInputStream(ds.getInputStream());
                int k = 0;
                while (k < 1) {
                    doos.writeBoolean(true);
                    doos.flush();
                    doos.writeObject(bt);
                    bt = (BinaryTree) dois.readObject();
                    k++;
                }
                doos.writeBoolean(false);
                doos.flush();
                bt = BinaryTree.createDepth(depth);
                long runTime = 0;
                long timeStarted = 0;
                long timeFinished = 0;
                Socket s = null;
                ObjectOutputStream oos = null;
                ObjectInputStream ois = null;
                try {
                    s = new Socket(server, port);
                    s.setTcpNoDelay(true);
                    oos = new ObjectOutputStream(s.getOutputStream());
                    ois = new ObjectInputStream(s.getInputStream());
                    timeStarted = System.nanoTime();
                    int j = 0;
                    while (j < len) {
                        oos.writeBoolean(true);
                        oos.flush();
                        oos.writeObject(bt);
                        bt = (BinaryTree) ois.readObject();
                        if (debug) { bt.println(); }
                        j++;
                    }
                    oos.writeBoolean(false);
                    oos.flush();
                    timeFinished = System.nanoTime();
                }
                finally {
                    this.closeUp(ds, dois, doos);
                }
                runTime = (timeFinished - timeStarted) / 1000;
                totalRunTime += runTime;
            }
            finally {
                this.closeUp(ds, dois, doos);
            }
        }
        System.out.println(totalRunTime);
    }
    
    private void closeUp(Socket s, ObjectInputStream ois,
                         ObjectOutputStream oos)
          throws IOException {
        if (ois != null) { ois.close(); }
        if (oos != null) {
            oos.flush();
            oos.close();
        }
        if (s != null) { s.close(); }
    }
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        String server = args[1];
        int port = Integer.parseInt(args[2]);
        int depth = Integer.parseInt(args[3]);
        int len = Integer.parseInt(args[4]);
        int num = Integer.parseInt(args[5]);
        new Client().run(debug, server, port, depth, len, num);
    }
    
    public Client() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238584038477L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVXW2xURRievXR7odpuKfdSbjVAhK2XaNBqsGloWFht7QLB" +
       "illmz862h86eczwz\nZ7uAIagJqDEmBFBUxBcTo/HBS9QHjZoI3n3BRH3RF4" +
       "2SKEYejMSg8Z+Zc3bPnj0tsMnMzpn555//\n9v3zz2vnUROzUYoRxnTT2JPi" +
       "ey3CZG/m9xCNs1R2yyi2GSkMUczYNljIabv/03e8kXxkcxRFxlGX\nYQ5SHb" +
       "Ntk7bpTExum9RZxUbLLZPunaAmdzk28Lh91aXprw5vWRJDHeOoQzeyHHNdGz" +
       "INTip8HLWX\nSClPbDZYKJDCOEoahBSyxNYx1fcBoWnAwUyfMDB3bMLGCDNp" +
       "WRB2MccitjzTm8ygds00GLcdjZs2\n46gzsweXcb/Dddqf0RkfyKBEUSe0wB" +
       "5EB1A0g5qKFE8A4fyMp0W/5Ng/LOaBvE0HMe0i1oi3JT6l\nGwWOlgV3VDXu" +
       "2woEsLW5RPikWT0qbmCYQF1KJIqNif4st3VjAkibTAdO4WjxjEyBqMXC2hSe" +
       "IDmO\nFgbpRtUSULVKs4gtHM0LkklO4LPFAZ/5vDWSaP/3idG/l4PHQeYC0a" +
       "iQPwGbegObxkiR2MTQiNp4\n0UkdS9/n9EQRAuJ5AWJFM3jdu9sz5z5cpmiW" +
       "hNCMyFjMaZdu7Vl6dvDn1pgQo8UymS5CoU5z6dVR\nd2WgYkF0z69yFIspb/" +
       "GjsU/uO/gq+S2KWtIooZnUKRlp1EqMwpA7boZxRjeImh0pFhnhaRSnciph\n" +
       "ym8wR1GnRJijCcYW5pNyXLEQQs3QItBOIvXrFB1HrUNUJwZPsT0cXc8J42wX" +
       "s7VdeTDbZAnbU6w2\nvHFXYVeVuiI4XzsdiYBSPUGAUYjGzSYtEDunvfzTFw" +
       "9t2vr4Y8pdIsRcmTjqrZ2Sqp2SKqTUKSgS\nkezninhU9hq0bbxX4KTy8Nml" +
       "z36KXwDrgxWYvo9IJSPTcdHDpptmTSNDNRCmYYQhRnJa98Fzi5/7\n5pUzUR" +
       "QLTSWZ6uSwaZcwFdHgYafLPS64AkHUFwzlsLP/eOLut7798oc1taDmqK8Ba4" +
       "07BVZWBs1v\nmxopQC6qsX/mn81/Hm267e0oigMAIQVxDIEDeO4NnlGHmQEv" +
       "/whdYhk0p9igeBsHA037FBZ9u+g6\nVYiAL7oDAsrUdfHRxA3fvT/njNTYy3" +
       "IdvnSYJVxhJlnz/zabEJj/4cTo0ePnD98fA5RalvI5RwnL\nyVNdq8CWBfUw" +
       "E+IVRNj8/uZA51Pr2TvSxa16qeRwnKcE0jKm1JwmhRyXeSnpy4Ey9YAl2vOQ" +
       "wiAb\n5igwUrpakTKEZ0iSSC3sPvb02pPfiTRiScPMF3CTkqKKnOiLiH5Nw6" +
       "L4XioiuLumNgB/SinQvjb7\nwJbdj62UmvvZrXM/XOao3AjLYXGveDFRyu//" +
       "6+NTbctrEq7zs+uV/QrXtmK8yuNcE7u6w0ZLZ8rX\n8q45vPNC+yF8+gGVVb" +
       "vqnbPJcEq3vPg9WXtXuxaSJFq5aa2npExo1VQxeW4Mjl0/K8rvltdbDQWx\n" +
       "7Ma1q9fN+RVQMAPAk+7kGIG73BDyizNbJPLxVSN/WcAoQXmS5SX3xib1z6IC" +
       "Wy7oG27t+k0DfvMA\n+ux6QWX0LJECdICJWqBth9bl5nz5LxaToutSABXdza" +
       "EhmZB2TrDGm3XU1ktwcZXdm/VI70u/vPXT\nWLdynyo/VjVUAP49qgSRAsyx" +
       "RACtmO0ESX36+hWvHRj7MR91QbKBo+a8aVKCDSnxXKimJGQEalOq\ncpELQ5" +
       "YK3WGOYlAsieHWWheORu8icRnPrTHeVNGIJe5sKcRG4Gk7RvCceNnUC5Jl1o" +
       "eUhBhuEl06\nIIRPkqsgvaPq6FZo90A74Dr6QJijQ4ANJrRsvYyh0A01g4c0" +
       "1wwd0gwG4amsqU0R7s0vkvO6mVLF\nUdqwHA4OILjkUSyupxhxeJXkKhwA+9" +
       "Mj9Q7YCSpo1GRkuyXN3WD0mBjmRIdFp1Uuu1Yzq2iroR1x\nzXrkyswalfkS" +
       "LiQmHxKzK9hY68oiRwHrzVjfheh78/vkvR3PY+blo/pHQuMboK60l3K2VbVa" +
       "BG3Z\nZbRKh8gZTAJ190lO2/fB9lMXv+Y/yiRQqzEEn55K4220A/vKnw3flp" +
       "OJ118sRVHzOOqUTyRs8B2Y\nOuK6HwcF2ZA7mUHX1K3XP1hUeA1U02lPMAv5" +
       "jg1WN/7EGud1KVUWNE4lgmSQ7Q9xOQdeuoGpuirB\n95QYE6r+lpDllapFo2" +
       "pHSG4ZoqZBREHirXV7YV99b8JiJRQkdyoR5Vkzp/QrLkEOgUKaECcktyoj\n" +
       "V2aNa/E5KjmBF+IlCIVweEZ8xqmbETZU7wBRAy5seMOrl6a28uzuNR9byc8V" +
       "QrzXYDM8yYoOpX6P\n+sYJyyZFXUrXrPxryb/jHC2Y4U0CrxGFpmOK9AQ8Xk" +
       "NJOWqrffh3PO9fkQsnZTQ9WYn8D1ls3637\nEAAA");
}
