package benchmarks.benchmark1.d;

import java.io.*;
import java.net.*;
import benchmarks.BinaryTree;

public class Server {
    
    public Server(boolean debug, int port) throws Exception {
        super();
        ServerThread st = this.new ServerThread(debug, port);
        st.start();
    }
    
    private class ServerThread extends Thread {
        private boolean debug;
        private int port;
        
        public ServerThread(boolean debug, int port) {
            super();
            this.debug = debug;
            this.port = port;
        }
        
        public void run() {
            ServerSocket ss = null;
            try {
                boolean run = true;
                ss = new ServerSocket(port);
                Server.this.new KillThread(port + Kill.KILL_PORT_ADJUST,
                                           ss).start();
                BinaryTree bt;
                for (int counter = 0; run; counter++) {
                    Socket ds = null;
                    ObjectInputStream dois = null;
                    ObjectOutputStream doos = null;
                    try {
                        ds = ss.accept();
                        ds.setTcpNoDelay(true);
                        dois = new ObjectInputStream(ds.getInputStream());
                        doos = new ObjectOutputStream(ds.getOutputStream());
                        for (boolean b = dois.readBoolean(); b;
                             b = dois.readBoolean()) {
                            bt = (BinaryTree) dois.readObject();
                            bt.inc();
                            doos.writeObject(bt);
                        }
                        Socket s = null;
                        ObjectInputStream ois = null;
                        ObjectOutputStream oos = null;
                        try {
                            s = ss.accept();
                            s.setTcpNoDelay(true);
                            ois = new ObjectInputStream(s.getInputStream());
                            oos = new ObjectOutputStream(s.getOutputStream());
                            for (boolean b = ois.readBoolean(); b;
                                 b = ois.readBoolean()) {
                                bt = (BinaryTree) ois.readObject();
                                bt.inc();
                                oos.writeObject(bt);
                                if (debug) { bt.println(); }
                            }
                        }
                        finally {
                            Server.this.closeUp(s, ois, oos);
                        }
                    }
                    catch (Exception x) { run = false; }
                    finally {
                        Server.this.closeUp(ds, dois, doos);
                    }
                    System.out.println("Finished run: " + counter);
                    if (debug) { System.out.println(); }
                }
            }
            catch (Exception x) { throw new RuntimeException(x); }
            finally {
                if (ss != null) {
                    try {
                        ss.close();
                    }
                    catch (IOException x) {  }
                }
            }
        }
        
        final public static String jlc$CompilerVersion$jl = "2.3.0";
        final public static long jlc$SourceLastModified$jl = 1238585382507L;
        final public static String jlc$ClassType$jl =
          ("H4sIAAAAAAAAAJVXXWxURRSe3W13+7PSbilQ+kOhlEgDbJVEUfsgpaGhsEht" +
           "C5FaUmbvnd297d17\nr3fmbhdCCGgiyAOJ4cefqLyYGA0PClFfjJoI/hsTTM" +
           "AXeMEoiWL0RYlB45mZu3t3725r3OTOnTtz\nzpw553znm9nzt1EttVGcEko1" +
           "05iJswMWoaI1kzNEYTQ+vn0U25SoQzqmdAImppX9/2h73ok9vS2I\nApOoxT" +
           "AHdQ3TiYxtOunMREajeRuttEz9QFo3mbtixRqPrL479/Wx7R0h1DSJmjRjnG" +
           "GmKUOmwUie\nTaJolmSTxKaDqkrUSRQzCFHHia1hXTsIgqYBhqmWNjBzbELH" +
           "CDX1HBdsoY5FbGGzMJhAUcU0KLMd\nhZk2Zag5MYNzuN9hmt6f0CgbSKBwSi" +
           "O6Sp9Ch1EwgWpTOk6D4NJEwYt+sWL/MB8H8QYNtmmnsEIK\nKjWzmqEy1O3X" +
           "KHrcuwMEQDWSJSxjFk3VGBgGUIvcko6NdP84szUjDaK1pgNWGGqfd1EQqrOw" +
           "MovT\nZJqhNr/cqJwCqXoRFq7C0BK/mFgJctbuy1lJtnaFo3+fGP1zJWQc9q" +
           "wSRef7D4PSCp/SGEkRmxgK\nkYp3nPjpkb1OZxAhEF7iE5Yyg2ve35249VG3" +
           "lOmoIrNLYHFauftgZ9eVwR/qQ3wbdZZJNQ6FMs9F\nVkfdmYG8BeheWlyRT8" +
           "YLkx+Pfbr3yFvk5yCqG0FhxdSdrDGC6omhDrn9CPQTmkHk6K5UihI2gmp0\n" +
           "MRQ2xTeEI6XphIejFvoWZhnRz1sIoXp4wCt0EsnfMt4wVA9IzhE7TmcYWscI" +
           "ZXSK2spUEsKWyWJ7\nlnrd+6fUqaJ0nq+8aC4QAKc6/QWmAxq3mbpK7GnljZ" +
           "tfHtq647njMl0cYu6ewJ5nJe5ZiatxaaVX\nvqCYCVZRICBsLebglMEbtG18" +
           "gBdN/uiVrpc+w69CKiAkVDtIhMeBuRregtLGBTllyKvIEehhAMy0\n0nrkVv" +
           "vL3715OYhCVXklURwcNu0s1jk0CoXU4przzwCiev24rmb71xM7L1796vpaD+" +
           "EM9VYUXqUm\nL5wefy5sUyEqEJO3/At/bfvtVO3D7wZRDVQj8BHDgCIo7hV+" +
           "G2UFNFAgI+5LKIEaUxWONzAI0FyJ\nw7yNin6TC8EQPCtdCHbyhk/GeNMiIQ" +
           "XpavX5IKjuzjPh+6590HhZBKXAik0l9DlOmKyxmAeRCZsQ\nGL/+4uipM7eP" +
           "PQnG85YlYcFQ2HKSuqbkQWVZeVlyD1SOrF8uDDSf3EDfEyio17JZh+GkToDG" +
           "sa6b\nc0SdZoLHYiWcKagKghVNAuUBe07rsJAMhxXIAYKrkEq8rfX02b5Xrn" +
           "HasUS8lvJyFTsN0kpmG7W1\nLBBHzmW251e8/uPFm2OtEjCS/ldXMHCpjjwC" +
           "RMQbLR6BVQtZENKX1q06f3jsRlJSY0t5xLYaTvaB\nc9+Tvs1RpUqlR5KmqR" +
           "NsCNfWgUH+jjMUgsNLfqwJ8Lav6DsSviOxwy5ew61eVoEHZ2V+on3j+7bv\n" +
           "P94jEiujxRU28GajXHhTxXC+SoDXL8gQw/xE9gpIO/TH0QvfnokGUXASRTQ6" +
           "rBlY5/igj0lKqHIW\n+ZY4+OHu1+58w26IWHk1yDfWma9k1D24hB4eupqLhd" +
           "8+lw2iyCRqFvcJbLA9WHc41ifhRkCH3MEE\nuqdsvvx0l0fZQJFjOv2QKTHr" +
           "r34vv9Dn0rxf5yv4Bnja4FnuFvxyX8EHAhbvbBYK3aLtKZZnxLK1\nHOZXMF" +
           "SrkqSTLqZwEZA6fw+UGVoMT7trqL26oWHebGFwNJq2KMmN7nJi31skEJEHxE" +
           "0uCAEgXfNd\nSERtHHvi9+iz+NK+oIvYfmAX99ZYwJp3Gm1YEGs7xZ3My3Zo" +
           "/NG+e9c3/gRsPc9BFHMHxwhcQI2J\nQi7ECYX/9wnV7XPUv59YruPxUEb7PC" +
           "hQIIFTcdUsVxooh0uDXb5REbGOslOC57LHzWVPtVOCN6sW\nJI7/ZJUxoB/b" +
           "qaCkmpypqUJtbzkGSj8Ak9HS24mYXAwn6MI3Gkh+W8WfEXllVnqu7F/7iRX7" +
           "QpzK\nxWttBO6WKUfXS6utpB+2bJLShDsRWXuWeCUZWjbPVhgKyO1iKcpv4V" +
           "VFGWrwPko1MqUzYkKzCgFo\nFizN2SUuI5MP/Avd5/q72A0AAA==");
    }
    
    
    private void closeUp(Socket s, ObjectInputStream ois,
                         ObjectOutputStream oos)
          throws IOException {
        if (ois != null) { ois.close(); }
        if (oos != null) {
            oos.flush();
            oos.close();
        }
        if (s != null) { s.close(); }
    }
    
    private class KillThread extends Thread {
        private int port;
        private ServerSocket server;
        
        public KillThread(int port, ServerSocket server) {
            super();
            this.port = port;
            this.server = server;
        }
        
        public void run() {
            ServerSocket ss = null;
            try {
                ss = new ServerSocket(port);
                Socket s = null;
                try {
                    s = ss.accept();
                }
                finally {
                    if (s != null) { s.close(); }
                }
            }
            catch (Exception x) { x.printStackTrace(); }
            finally {
                try {
                    server.close();
                }
                catch (IOException x) {  }
                if (ss != null) {
                    try {
                        ss.close();
                    }
                    catch (IOException x) {  }
                }
            }
        }
        
        final public static String jlc$CompilerVersion$jl = "2.3.0";
        final public static long jlc$SourceLastModified$jl = 1238585382507L;
        final public static String jlc$ClassType$jl =
          ("H4sIAAAAAAAAAJVXXWxURRSe3W23fyvtlvIT+gcFIg2wVRKJ0gdsGhoKi5Ru" +
           "IVBL2um9s7u3vXvv\n9c7c7UIIAU0EeTAxgKJReVDwJ4QoRH0xaiL4b0wwAV" +
           "8gJhglUYy+KDFoPDNzd+/u3W2NJHc6O3PO\nnDnnfOc7w7nbqJraKEYJpZpp" +
           "TMXYPotQMZqTU0RhNJbYMoRtStR+HVM6AhvjysQ/2q63o49vDqLA\nKGo2zD" +
           "5dw3QkbZtOKj2S1mjORkstU9+X0k3mnlh2xobld2e+OrKlNYQaR1GjZiQYZp" +
           "rSbxqM5Ngo\nimRIZpLYtE9ViTqKogYhaoLYGta1/SBoGmCYaikDM8cmdJhQ" +
           "U89ywWbqWMQWNvOLcRRRTIMy21GY\naVOGmuJTOIt7HKbpPXGNst44Cic1oq" +
           "v0MXQQBeOoOqnjFAgujOe96BEn9gzwdRCv1+CadhIrJK9S\nNa0ZKkOdfo2C" +
           "xyu2ggCo1mQIS5sFU1UGhgXULK+kYyPVk2C2ZqRAtNp0wApDS2Y9FIRqLaxM" +
           "4xQZ\nZ2ixX25IboFUnQgLV2FogV9MnAQ5W+LLWVG2tocjfx8b+nMpZBzurB" +
           "JF5/cPg1KHT2mYJIlNDIVI\nxTtO7MTgHqctiBAIL/AJS5m+le/tjN/6sFPK" +
           "tFaQ2S6wOK7cXd/WfqXvh7oQv0atZVKNQ6HEc5HV\nIXenN2cBuhcWTuSbsf" +
           "zmR8Of7Dn0Jvk5iGoHUVgxdSdjDKI6Yqj97rwG5nHNIHJ1ezJJCRtEVbpY\n" +
           "CpviN4QjqemEh6Ma5hZmaTHPWQihOvjAK/Q9kv9e4QNDdYDkLLFjdIqh1YxQ" +
           "RseorYxNQtjSGWxP\nU296/5g6VpDO8ZPnzQQC4FSbv8B0QONmU1eJPa68dv" +
           "OLA5u2PnVUpotDzL0TQ92elZhnJabGpBWA\nqa5DKROsokBAWJrPoSlD12fb" +
           "eB8vmdzhK+3Pf4pfgkRAQKi2nwh/AzNVfASldXMySr9Xj4MwwwCX\ncaXl0K" +
           "0lL3z7xuUgClVklXhhccC0M1jnwMiXUbNrzr8DeFrhR3Ul278e23bx6pfXV3" +
           "n4ZmhFWdmV\na/Ky6fJnwjYVogItecc/99fm345XP/ROEFVBLQIbMQwYgtLu" +
           "8NsoKZ/ePBVxX0Jx1JAsc7yeQYBm\nihzmY0TMG10AhuA75wLwdT7wzSgfmi" +
           "WgIF0tPh8E0d15InzftfcbLoug5DmxsYg8E4TJCot6EBmx\nCYH166eGjp+8" +
           "feRRMJ6zLAkLhsKWM6lrSg5UFpUWJfdA5cj65UJv09Nr6bsCBXVaJuMwPKkT" +
           "IHGs\n6+YMUceZYLFoEWMKooJgRSaB8IA7x3U4SIbDCmQBwRUoJba45cSz3S" +
           "9e46RjiXgt5MUqbhqk5bw2\nZGsZoI2sy2vPdLz648Wbwy0SMJL8l5fxb7GO" +
           "bAAi4g0Wj8CyuSwI6Uurl507OHxjUhJjc2nENhlO\n5oHT35HuhyNKhToPQY" +
           "sSbs0HxhfpMQhzizxhKtOE5cT2ygAfuwsRQCICSNyznVdyi5db4MJpmaVI\n" +
           "d2LvlomjXSK9MmZcYS0f1smD15ct5yqEec2cPDHAu7JXRtqBPw5f+OZkJIiC" +
           "o6hGowOagXWOEvqI\nJIYK/ch3xP4Pdr5852t2Q0TMq0R+sbZcOavuwkUk8e" +
           "DVbDT81ulMENWMoibxpsAG24V1hyN+FF4F\ntN9djKN7SvZLO7xsZ70Fpmnz" +
           "A6fIrJ8DvCzDnEvzea2v7Ovhmw/fGbfsz/jKPhCw+GSjUOgUY1eh\nSGssW8" +
           "ti/gyDdmbarJDBecDs/O+GEjsd8J117ZytbGcTH/qg/KmAn0CDPFDirE8iEX" +
           "lIXO+iEBDS\nPturRJTIkd2/R57El/YG3aN6wIr7dMyDzWtKa+cE2zbxMPPS" +
           "HUps7L53TcNPQNqz9KOouzhM4BVq\njOSTIRoV/t+NqtPnqP8+0WzrjlBa+y" +
           "woYCCRU/beLFXqLcVLvV16URGx1pJmwVFz3s3m+UrNgg/L\n5mSO/6SVHcBO" +
           "tmOIvdWWlI8B2LKmpgq13aUYKP4BoKz3nih5guuY+1EDqV9c9v8R+WpWuq5M" +
           "rPrY\nin4uWnPhZVsDz8uko+vFxVY0D1s2SWrCmRpZepb4gxlaNMtVGArI60" +
           "5IUVhYUFEUHPR+FGukinfE\nRtrKB6BJkDQnl5iMTA79C51kkZbbDQAA");
    }
    
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        int port = Integer.parseInt(args[1]);
        new Server(debug, port);
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238585382507L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVXXWxURRSe3W13+7PSbikF+gulBBrsVkn8wT5o01BZWGxt" +
       "C5FS0s7enW1ve/fe\ny53Z7QUJQUwEMSEg+BuFFxOj4UEh6oNGTQD/fcEEfI" +
       "EHMIpRjDwYiUHjmZm9+3N3W2WTOzt35syZ\nc85855tzT91A5dRCYUooVQ19" +
       "Osx2mYSK1ohNE4XR8PDGQWxREu/TMKUjMDGuTPyjbn03tH+DF3lG\nUZ1u9G" +
       "oqpiNTlpGanBqZUqltoWWmoe2a1AyW0Vik46EVt2e/ObCxyYdqRlGNqg8zzF" +
       "Slz9AZsdko\nCiZJMkYs2huPk/goCumExIeJpWJN3Q2Chg4bU3VSxyxlETpE" +
       "qKGluWAdTZnEEns6g1EUVAydMiul\nMMOiDNVGp3Ead6eYqnVHVcp6osifUI" +
       "kWpzvRXuSNovKEhidBsCHqeNEtNHb383EQr1LBTCuBFeIs\nKZtR9ThDbe4V" +
       "WY87NoEALA0kCZsysluV6RgGUJ00ScP6ZPcws1R9EkTLjRTswlDjnEpBqMLE" +
       "ygye\nJOMMLXHLDcopkKoUYeFLGFrkFhOa4MwaXWeWd1oD/uDfhwb/XAYnDj" +
       "bHiaJx+/2wqNW1aIgkiEV0\nhciFt1Lh45FtqWYvQiC8yCUsZXpXfrAlev2T" +
       "NinTVEJmQGBxXLl9f3PLhd4fKn3cjArToCqHQoHn\n4lQHMzM9tgnobshq5J" +
       "NhZ/LToc+27Xub/OJFFRHkVwwtldQjqJLo8b5MPwD9qKoTOTqQSFDCIqhM\n" +
       "E0N+Q7xDOBKqRng4yqFvYjYl+raJEArA44HnZyR/C3jDUCUgOU2sMJ1maA0j" +
       "lNExailjMQjbVBJb\nMzTXvXcsPpaVtrnmBbMeDzjV7E4wDdC4wdDixBpX3r" +
       "z21Z71m549KI+LQyxjE0OtuV3CuV3C8bDc\nBXk8Qv1CjkcZr17Lwrt4nthP" +
       "XWh55XP8OkQfokDV3UQ46Zkt4y0sWjsvjfTlkjACPQwYGVfq911v\nfPW7t8" +
       "57ka8klUSzg/2GlcQaR4OTO3WZ7dwzAKION5RL7f3boc1nLn59eXUO1Ax1FO" +
       "Va8UqeK+3u\n8FuGQuLARTn1L/214fdj5eve86IySECgIIYBOJDPre49CnKm" +
       "x+Ef7osviqoTRY5XMQjQbJ7DvA2K\nfg0cRQU8kEtoUQZ1tbzhkyHe1EkUwX" +
       "HVu3wQ7Hbraf89lz6qPi+C4hBhTR5jDhMm0yqUg8iIRQiM\nX3558NgLNw5s" +
       "90Eim6aEBUN+MxXTVMWGJYsLM5F7EOfI+vV0T+3hLvq+QEGlmkymGI5pBJgb" +
       "a5ox\nS+LjTFBXKI8mBTtBsIIxYDkgzHENFMlwmJ40ILgEj4SX1B9/sfO1S5" +
       "xpTBGvBh4rYamXFpPZoKUm\ngSvSGTI72vrGj2euDdVLwEjGX1FEuvlrJOuL" +
       "iFebPALL59tBSJ9bs/zU3qErMcmGdYURW6+nkved\n/J50PhJUSiR3IGYYGs" +
       "G6cG0NbMj/wwz54L6SLys9vO3M+u4kL39fyDJpz+MbXm8rxOQ8Kaxv4fld\n" +
       "nztxoMUZeXbBzuEdGycOtotDl5HkC7p4s1Zuuq5oOGMMShcTWT+/iZ0sSsae" +
       "/OPsiapluQOTupAw\nanlGS84lZxaMbZnrNhNRPvDEzeAz+NwOb0ZVN7AyM8" +
       "wujaSJVgIZXfNS22Zxp+dS3zf8cOequ6t/\ngtSfg9VCmcEhAgWMzs3ie1YI" +
       "usN3THdtLl/d9oTSTY/7ptQvvJxQMkxXVKoULurJxxZQjlVoqAha\nU5ZyKu" +
       "F5DJ4jGco5UpJyeNsm2vYsOwRMS01jKPpKwtMnxHwOPGsEAHXCwsOGMkOYM7" +
       "5UjKtGWBYK\nEd1MMSijCE46Eo2FEgMplhW5g8SA9ZGBwsSIgAuKZlCyxXRn" +
       "XVnaUONC7fY8cPp4d5A3Q7wZsf9z\nrj8bZv6sgudqJsxX/1+YReZ1ABNTUW" +
       "TP73BxHSgKAMmAp30dN70fNnSIO60shqkD28ICurg+Lih7\nhZ1VWa+WwtM2" +
       "j1fOGdTmyEnWyCVsdzN4AZuMK7s/3nLi1rfsiuDO3J3M9TTbxVy0FeeVCw9e" +
       "TIf8\n75xMelFgFNWKTwqss61YS/G7bxScpn2ZwSi6q2C+sMCXEOzJZmKzOx" +
       "PztnVXA/k5WcYKsjHIG9X2\nIJN3dpaAAQNdqo5F7d5hAx40ok/KenUtb6bs" +
       "IuYrvhf6NEMn/HZ25uqd1Mh+n8GkXTKRHpUmir3y\nCNyFROSQ+HyT/H0POK" +
       "Rwc0ogRAbZnhfr/PUBoWkCsjUJUBDJWpSynrzgFIzwGMq6mRdES4q+eeWX\n" +
       "mdJ+YWL1WTP0pcwa5+spAJ8wiZSm5Z9oXt9vWiQhYxWQ52uKv+cYWjxHDc+Q" +
       "R2bYISl6GD72Sooy\nVJV7yV9xNH9GTDwv0LTf9vwLZ5lgEysQAAA=");
}
