package benchmarks.benchmark1.e;

import java.io.*;
import java.net.*;
import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import benchmarks.benchmark1.e.BigObject;

public class Client {
    final private SJProtocol p =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9nJ1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGng0BUOk0O1i9GFgTc" +
       "7IzEkpYdDwgWnXB2vSh2vXR9FuDbRJGc0m\nEJmflJWaXAKyC2LJxfXz8jlV" +
       "f2+FuE20ID+nMj0nvwSqA6LGUXV7qM+L/fIQNdJY1PiDTY1P/mMm\nI3vJ8Q" +
       "knM8jJHAX5xZklQPtLGCR8YJr0S0syc/QDoDLWFQUFFcDg18QTJv6lJeVAv6" +
       "diiwBVPPp8\n8vMLIHqYXU4umqF5axs4IFmS8lMqCxnqGJgrQCRTQUVBMX6D" +
       "glPzUrBZbopHjy+QnZie6pyfm1ua\nl5mcWAKP1ZVOhxl9uPfdBzuGOxeiDi" +
       "RVwiCKCCVIjEIiEurMYvxJJyg1OTWzDEsogbTzQnwpgxZ1\nATmJyake+Tkp" +
       "qUXxycsfn6px9e7sgIRSXmIu0EVCPlmJZYn6OYl56frBJUWZeenAGCthUExK" +
       "zUvO\nyE0syi7WgzMN9VL1nDLTIUkBZKkIAPmtX+BcAwAA"));
    
    public void run(boolean debug, String server, int port, int size, int len,
                    int num)
          throws Exception {
        final SJService c = SJService.create(p, server, port);
        long totalRunTime = 0;
        for (int i = 0; i < num; i++) {
            BigObject bo = new BigObject(i, size);
            SJSocket ds = null;
            try {
                ds = c.request();
                int k = 0;
                while (SJRuntime.outsync(ds, k < 1)) {
                    SJRuntime.send(ds, bo);
                    bo = (BigObject) SJRuntime.receive(ds);
                    k++;
                }
                bo = new BigObject(i, size);
                long runTime = 0;
                long timeStarted = 0;
                long timeFinished = 0;
                SJSocket s = null;
                try {
                    s = c.request();
                    timeStarted = System.nanoTime();
                    int j = 0;
                    while (SJRuntime.outsync(s, j < len)) {
                        SJRuntime.send(s, bo);
                        bo = (BigObject) SJRuntime.receive(s);
                        if (debug) { bo.println(); }
                        j++;
                    }
                    timeFinished = System.nanoTime();
                }
                finally {
                    SJRuntime.close(s);
                }
                runTime = (timeFinished - timeStarted) / 1000;
                totalRunTime += runTime;
            }
            finally {
                SJRuntime.close(ds);
            }
        }
        System.out.println(totalRunTime);
    }
    
    private static void configureTransports(boolean debug, String transport) {
        List ss = new LinkedList();
        List ts = new LinkedList();
        if (transport.equals("s")) {
            ss.add(new SJStreamTCP());
            ts.add(new SJStreamTCP());
        } else
                  if (transport.equals("m")) {
                      ss.add(new SJManualTCP());
                      ts.add(new SJManualTCP());
                  } else {
                      throw new RuntimeException("Invalid transport [s/m]: " +
                                                 transport);
                  }
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
        if (debug) { System.out.println("Transport flag: " + transport); }
    }
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        String server = args[1];
        int port = Integer.parseInt(args[2]);
        String transport = args[3];
        Client.configureTransports(debug, transport);
        int size = Integer.parseInt(args[4]);
        int len = Integer.parseInt(args[5]);
        int num = Integer.parseInt(args[6]);
        new Client().run(debug, server, port, size, len, num);
    }
    
    public Client() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238586444412L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVYb2wcRxWfvTuf/x3E59hpiB2niR1iq8mZVi0qGFRskyhO" +
       "zrXrc0PipnL29ubO\n48ztLjtz501UVSlIJIQKCTWBEqCVCgIligSkavkACk" +
       "htgfJHiCClFVLLhyKoBK3aLxC1BfFm5vZ2\nb299ISft3OzMe2/evPd7b97s" +
       "5bdQG3NQhmHGiGWuZvgJGzPZWvlVbHCWyR2Y1x2GC9NUZ2wRJpaN\nY/8lh3" +
       "6c/sL+GNKWUK9pTVKis8UVx6qUVhZXCHMddLtt0RMlavGaxCYZnxz+YO13pw" +
       "8MxNGGJbSB\nmDmuc2JMWybHLl9CqTIu57HDJgsFXFhCaRPjQg47RKfkJBBa" +
       "JizMSMnUecXBbAEzi1YFYS+r2NiR\na3qDWZQyLJNxp2Jwy2Ec9WRX9ao+Xu" +
       "GEjmcJ4xNZlCwSTAvs8+hRFMuitiLVS0C4KevtYlxKHN8n\nxoG8i4CaTlE3" +
       "sMeSOE7MAkfbwhz1HY8cBAJgbS9jvmLVl0qYOgygXqUS1c3SeI47xCwBaZtV" +
       "gVU4\n2rKuUCDqsHXjuF7CyxxtDtPNqymg6pRmESwc9YfJpCTw2ZaQzwLemk" +
       "um/nN2/t+3g8dB5wI2qNA/\nCUxDIaYFXMQONg2sGG9UMudmjlQGYwgBcX+I" +
       "WNFM7vzJg9k3f75N0QxE0MxJLC4bH3x8cOu1yb92\nxoUaHbbFiIBCw86lV+" +
       "drMxOuDejeVJcoJjPe5C8Wfnnk1CX8jxjqmEFJw6KVsjmDOrFZmK7126Gf\n" +
       "JSZWo3PFIsN8BiWoHEpa8h3MUSQUC3O0Qd/W+YrsuzZCqB0eDZ5vIfXrFw1H" +
       "ndOUYJNn2CpHd3DM\nODvKHONoHsy2Utad48zv3nkUH61Tu0Lyh9c0DTY1GA" +
       "4wCmjcb9ECdpaNH7zxm0f2HvzyGeUuAbGa\nThwN+atk/FUyOKNWQZomxW8U" +
       "eFT2mnQc/YSIE/exa1u/+Sv9O2B9sAIjJ7HcpLaWEC0w3dUyjUz7\nQTgDPR" +
       "0wsmz0nXpzy4U/XXwphuKRqSRbH9xnOWWdCjR4sdNbWy48AyAaCUM5au23z8" +
       "4+e/23r436\noOZopCnWmjlFrOwIm9+xDFyAXOSL/8Z7+995ou0Tz8VQAgIQ" +
       "UhDXATgQz0PhNRpiZsLLP2Iv8Szq\nLjZtvIuDgdYCGxZtSjQ9CiLgi76Qgj" +
       "J13fhi8mOv/Kz7JbljL8ttCKTDHOYqZtK+/xcdjGH8tSfn\nnzj/1umH4hCl" +
       "tq18zlHSruQpMVxgua0xzIR6BQGbf16Z6PnqHva8dHEnKZcrXM9TDGlZp9Ra" +
       "w4Vl\nLvNSOpADZeoBS6TykMIgGy5TEKT2amtVgGdEkshs7jv39bFvvyLSiC" +
       "0Ns0mEm9QUuXJgRBPtaNOk\neN8qENznbxsC/7jaQGos9/CBY2d2yJ0Hxe2u" +
       "vbh1gX4s3N0yFvaJ4wYwwy3IOz5kjn3l1QdmD39u\nXGXCO1uKuB+iuiDl+P" +
       "znZ8z7rvZfN2MCJUm2Wo/8LIoxztFo1hNZQ554Vb3cgZya8k6D3TffgL8w\n" +
       "eeRfj135w/kULLyE2gnbR0ydCm+z+1X0RpwUIREnrz741I3f89clNv1wEeoP" +
       "us357pAeiOR7r1fT\nyR89XY6h9iXUI0973eSHdFoRyF2C85pN1waz6EMN84" +
       "1nrzpoJurpYDAcqoFlw4GaCFg7IahFv0PF\npu1qmi1690rqIdluV2CKcZAj" +
       "7MVRu+2Qqi4qIKQpCG/kaKDuCKdiclLGoiSrQUdGuyZR/WkA3a6Q\nz+ruFe" +
       "l3CpeIqU7c2nGkKZx9tAVXgGlnj3Fp9+jlk4pptAVTAEnBtUTOMVYILQh17w" +
       "IZwy0hptj/\n+MOnrM6d7z8Xq4Vpty1yzViL1ecqfA1WwVFb3dmCL2tZtuKJ" +
       "f/blZ54c+/Pz6mDIW4UTSmPRTtky\nP7YSlINiIWrxe1rwzEIfSrVpC9KjSQ" +
       "xZ4ioZF6de0LLdV/8ilekuK7rFBnhNSZu08sgCNjCpRphE\nsM/Ybh1s29cr" +
       "D6ZISQWHIJx1m2EsQThcy7PIz7NekgQNt65XYMri+PThd1Nf0l98WBmrt/E0" +
       "2WtW\nyvc8/Soe+0zKiKhqOrll76G4imk9FcflunFYdk9LmM3KetzPJfHcfW" +
       "O7dnf/HY7tdSqSdG1wAcPl\nw6y7QpYq+i2XKttCRgnrk64OPBBfIb+OyRyj" +
       "0lLTNaORaaIxGXU5jYpKpw9IBTaAiTrgWYRnsIYL\n+S8m06LpVRWFaOYiz9" +
       "CktHOSNSf4eYeUodL2YPe1oe/97dk3FvqU+9R9abjpyhLkUXemQNhvb7WC\n" +
       "pH7xju2XH114Pe9hexGSat6yKNZND+I98owX6T6jrlpyYtlW0M1zFIfbneiW" +
       "/Ca6fPBO+5rgjb7g\nva6BbRHDUomHQCbk7vA6iapFClKkFYiUpOjqosEhJQ" +
       "Ka3ALp4bqje+CZgYfWHE2jHB1xPon+p6DU\nY/KKHm2KmE+qFLp5wQX1yEY4" +
       "ioukBGXzogMOsi2HS1KrySpNktcZ9ncrnl3wPF7b7eO3sNth0bit\nnd58X5" +
       "YXJYX1K/GRd2M/3TQia/9EXmdeimj80ND8HaHh84DUsau+o4/As+0mO8KR4L" +
       "xbNGdcDcka\n5Ow6u55QGRw8TbFZUvdYiaTTbtjPEZCfppaJRWHvzalamliZ" +
       "+ncbmGwulcX7EaWfXGv9TPN/l/Ln\noKIyhDoRIa8Osda+Fa9USjoFUVqGOj" +
       "QalFrAOA0jwobqPi1qhc1N38LUFxtjx7Vjoy/Y6ZcVSryv\nKu1Z1FGsUBos" +
       "JwP9pO3gIpHatXvFpfj7Lke3rXN4QzWpTPGMIv0+R/2RpBx1+S9BjovBGTlx" +
       "SULp\ngqv9D+77xJpDFAAA");
}
