package benchmarks.benchmark1.e;

import java.io.*;
import java.net.*;
import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import benchmarks.*;

public class Server {
    final private SJProtocol p =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9gp1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGvisgkih28Xow8CanJ" +
       "GZk1LCoOED064P1qQP166Pot0aaJMymk0g\nMj8pKzW5BGQXxJKL6+flc6r+" +
       "3gpxm2hBfk5lek5+CVQHRI2j6vZQnxf75SFqpLGo8QebGp/8x0xG\n9pLjE0" +
       "5mkJM5CvKLM0uA9pcwSPjANOmXlmTm6AdAZawrCgoqivGHiWdeOdDrqdjCXx" +
       "WPNp/8/AKI\nHmaXk4tmaN7aBg5HlqT8lMpChjoG5goQyVRQUUDA/qDU5NTM" +
       "Mqz2m+LR5gtkJ6anOufn5pbmZSYn\nlsDjdaXTYUYf7n33we7hzoWoA0mVMI" +
       "giwgkSp5CohLq0GL+Pg1PzUjBdCdLLC/GlDFrMBeQkJqd6\n5OekpBbFJy9/" +
       "fKrG1buzAxJKeYm5QOcI+WQlliXq5yTmpesHlxRl5qUDI6yEQTEpNS85Izex" +
       "KLtY\nD8401EvVc8pMh6QEkKUiAE/9ZbdbAwAA"));
    
    public Server(boolean debug, int port) throws Exception {
        super();
        ServerThread st = this.new ServerThread(debug, port);
        st.start();
    }
    
    private class ServerThread extends Thread {
        private boolean debug;
        private int port;
        
        public ServerThread(boolean debug, int port) {
            super();
            this.debug = debug;
            this.port = port;
        }
        
        public void run() {
            SJServerSocket ss = null;
            try {
                boolean run = true;
                ss = SJServerSocketImpl.create(p, port);
                new KillThread(port + Kill.KILL_PORT_ADJUST,
                               ss.getCloser()).start();
                BigObject bo;
                for (int counter = 0; run; counter++) {
                    SJSocket ds = null;
                    try {
                        ds = ss.accept();
                        while (SJRuntime.insync(ds)) {
                            bo = (BigObject) SJRuntime.receive(ds);
                            bo.inc();
                            SJRuntime.send(ds, bo);
                        }
                        SJSocket s = null;
                        try {
                            s = ss.accept();
                            while (SJRuntime.insync(s)) {
                                bo = (BigObject) SJRuntime.receive(s);
                                bo.inc();
                                SJRuntime.send(s, bo);
                                if (debug) { bo.println(); }
                            }
                        }
                        finally {
                            SJRuntime.close(s);
                        }
                    }
                    catch (Exception x) { run = false; }
                    finally {
                        SJRuntime.close(ds);
                    }
                    System.out.println("Finished run: " + counter);
                    if (debug) { System.out.println(); }
                }
            }
            catch (Exception x) { throw new RuntimeException(x); }
            finally {
                if (ss != null) ss.close();
            }
        }
        
        final public static String jlc$CompilerVersion$jl = "2.3.0";
        final public static long jlc$SourceLastModified$jl = 1238585956137L;
        final public static String jlc$ClassType$jl =
          ("H4sIAAAAAAAAAJVXX2wURRifu2vv+uekvVKgoS2F0iINcFUSRe2DlIamhUNq" +
           "W4jUkjK3O3e37d7u\nujN7PQghoIkgDyYG8F9UXkyMhgeFqC9GTQT/GxNMwB" +
           "d4wSiJYvRFiUHjNzN7t3d71xov2dnZme+b\nb77v+32/mTt3C9VSG8UpoVQz" +
           "jdk4O2gRKlozOUsURuMTO8awTYk6pGNKJ2FiRjnwj7b3ndiTI0EU\nmEIthj" +
           "moa5hOZmzTSWcmMxrN22i1ZeoH07rJ3BUr1nho7Z35r4/vaA+hpinUpBkTDD" +
           "NNGTINRvJs\nCkWzJJskNh1UVaJOoZhBiDpBbA3r2iEQNA0wTLW0gZljEzpO" +
           "qKnnuGALdSxiC5uFwQSKKqZBme0o\nzLQpQ82JWZzD/Q7T9P6ERtlAAoVTGt" +
           "FV+gQ6goIJVJvScRoElycKXvSLFfuH+TiIN2iwTTuFFVJQ\nqZnTDJWhLr9G" +
           "0eOenSAAqpEsYRmzaKrGwDCAWuSWdGyk+yeYrRlpEK01HbDC0MoFFwWhOgsr" +
           "czhN\nZhhq88uNySmQqhdh4SoMLfOLiZUgZyt9OSvJ1u5w9O+TY3+uhozDnl" +
           "Wi6Hz/YVBa5VMaJyliE0Mh\nUvG2Ez89us/pCCIEwst8wlJmsPf9PYmbH3VJ" +
           "mfYqMrsFFmeUO/d3dF4e/KE+xLdRZ5lU41Ao81xk\ndcydGchbgO7lxRX5ZL" +
           "ww+fH4p/uOvkV+DqK6URRWTN3JGqOonhjqkNuPQD+hGUSO7k6lKGGjqEYX\n" +
           "Q2FTfEM4UppOeDhqoW9hlhH9vIUQqocHvEInkPyt5Q1D9YDkHLHjdJahDYxQ" +
           "RqeprUwnIWyZLLbn\nqNe9d5pMF6XzfOUl84EAONXhLzAd0Dhi6iqxZ5Q3bn" +
           "x5ePvOZ07IdHGIuXsCe56VuGclTuLSSo98\nQTETrKJAQNhaysEpgzdo2/gg" +
           "L5r8scudL32GX4VUQEiodogIjwPzNbwFpc2LcsqQV5Gj0MMAmBml\n9ejNlS" +
           "9/9+alIApV5ZVEcXDYtLNY59AoFFKLa84/A4jq8eO6mu1fT+66cOWra+s9hD" +
           "PUU1F4lZq8\ncLr9ubBNhahATN7yL/w18tup2gffDaIaqEbgI4YBRVDcq/w2" +
           "ygpooEBG3JdQAjWmKhxvYBCg+RKH\neRsV/SYXgiF4NroQXM8bPhnjTYuEFK" +
           "Sr1eeDoLrbT4XvufpB4yURlAIrNpXQ5wRhssZiHkQmbUJg\n/NqLY6fO3Dr+" +
           "OBjPW5aEBUNhy0nqmpIHlRXlZck9UDmyfjk/0PzsJvqeQEG9ls06DCd1AjSO" +
           "dd2c\nJ+oMEzwWK+FMQVUQrGgSKA/Yc0aHhWQ4rEAOEFyFVOJtraef73vlKq" +
           "cdS8RrOS9XsdMgrWS2MVvL\nAnHkXGZ7btXrP164Md4qASPpf20FA5fqyCNA" +
           "RLzR4hFYs5gFIX1xw5pzR8avJyU1tpRHbLvhZO87\n+z3p2xpVqlR6JGmaOs" +
           "GGcG0DGOTvOEMhOLzkR2+At31F35HwHYkddvIabvWyCjw4J/MT7ZvYv+PA\n" +
           "iW6RWBktrrCJN5vlwlsqhvNVArxxUYYY5ieyV0Da4T+Onf/2TDSIglMootFh" +
           "zcA6xwd9RFJClbPI\nt8ShD/e8dvsbdl3EyqtBvrGOfCWj7sUl9PDAlVws/P" +
           "bZbBBFplCzuE9gg+3FusOxPgU3AjrkDibQ\nXWXz5ae7PMoGihzT4YdMiVl/" +
           "9Xv5hT6X5v06X8E3wNMGT69b8L2+gg8ELN7ZKhS6RNtdLM+IZWs5\nzK9gqF" +
           "YlSSddTOESIHX+HigztBSeda6hddUNDfNmG4Oj0bRFSW52lxP73iaBiDwgbn" +
           "FBCADpXOhC\nImrj+GO/R5/GF/cHXcT2A7u4t8YC1rzTaNOiWNsl7mRetkMT" +
           "D/fdvbHxJ2DrBQ6imDs4TuACakwW\nciFOKPy/T6gun6P+/cRy7Y+GMtrnQY" +
           "ECCZyKq2a50kA5XBrs8o2KiLWXnRI8l3E3l/FqpwRv1ixK\nHP/JKuNAP7ZT" +
           "QUk1OVNThdq+cgyUfgAmo6W3EzG5FE7QxW80kPy2ij8j8sqsdF8+sP4TK/aF" +
           "OJWL\n19oI3C1Tjq6XVltJP2zZJKUJdyKy9izxSjK0YoGtMBSQycZSlN/Cq4" +
           "oy1OB9lGpkSmfEhGYVAtAs\nWJqzS1xGJh/4FwJoeaHYDQAA");
    }
    
    
    private static void configureTransports() {
        List ss = new LinkedList();
        List ts = new LinkedList();
        ss.add(new SJStreamTCP());
        ss.add(new SJManualTCP());
        ts.add(new SJStreamTCP());
        ts.add(new SJManualTCP());
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    public static void main(String[] args) throws Exception {
        Server.configureTransports();
        boolean debug = Boolean.parseBoolean(args[0]);
        int port = Integer.parseInt(args[1]);
        new Server(debug, port);
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238585956137L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJ1Yb2wcxRWfvTuf/10bn+OENHZinNiNTZJziUpb6g+pYxLF" +
       "5oKNz6Rggpy93bnz\nOHs725258yWNUGilhroSagWBUCipKqQKFKltEPQDKC" +
       "ABbWlBiFQKqBL0A1WL1FKVL23U0qpvZm53\n73bPV1FLO57deW/emze/95s3" +
       "d/FD1MZclGGYMULtlQw/6WAmW5pfwQZnmdzMnO4ybE5ZOmMLMLBk\nHP8POf" +
       "qz9DcOx5C2iHptOmkRnS0su7RcXF5YJqzqousdap0sWpTXZozM8eWdH6++fn" +
       "amP442LKIN\nxM5xnRNjitocV/kiSpVwKY9dNmma2FxEaRtjM4ddolvkFAhS" +
       "GwwzUrR1XnYxm8eMWhUh2MvKDnal\nTe9jFqUMajPulg1OXcZRT3ZFr+jjZU" +
       "6s8SxhfCKLkgWCLZN9Dd2LYlnUVrD0IghuznqrGJczjh8S\n30G8i4CbbkE3" +
       "sKeSOEFsk6PBsIa/4uFbQQBU20uYL1PfVMLW4QPqVS5Zul0cz3GX2EUQbaNl" +
       "sMLR\n1nUnBaEORzdO6EW8xNGWsNycGgKpThkWocLRprCYnAn2bGtoz+p2az" +
       "aZ+vfa3D+uhx0Hn01sWML/\nJChtDynN4wJ2sW1gpXitnHlo+q7yQAwhEN4U" +
       "ElYykyM/vyP7wYuDSqa/icysxOKS8fEXBrZdmfxD\nZ1y40eFQRgQUGlYud3" +
       "WuNjJRdQDdm/0ZxWDGG3xp/hd3nXka/zmGOqZR0qBWuWRPo05sm1O1fjv0\n" +
       "s8TG6utsocAwn0YJS35KUvkO4SgQC4twtEHf0fmy7FcdhFA7PBo8TyL11yca" +
       "jjoByRXsZtgKR7s5\nZpwdY65xLA9hWy7p7gkWdG88ho/50lUx86dXNQ0WNR" +
       "BOMAvQeJhaJnaXjB+//+vTB2/99v1quwTE\naj5xtD2wkgmsZHBGWUGaJqff" +
       "KPCo4jXpuvpJkSfV+65se/SX+g8g+hAFRk5huUhtNSFaUNrXkkam\ngiSchp" +
       "4OGFky+s58sPX7v33q1RiKN6WSrP/xEHVLuiXQ4OVOb81ceARANByGcjPbf1" +
       "078szV37w7\nGoCao+FIrkU1Ra7sCIffpQY2gYuC6R/55+G/Pdh287MxlIAE" +
       "BAriOgAH8nl72EZDzkx4/CPWEs+i\n7kJk4V0cArRat2DRpmR/A2xFBzyQS2" +
       "iohroB0YjBtGh6FYpgu/pCa5Dsdu2byc+9/UL3qzIoHhFu\nqGPMHOYqrdIB" +
       "RBZcjOH7u+fnHjz34dm745DIjqNgwVHSKectYlRB5brGTBQrMAWy/nJpoueB" +
       "vew5\niYJOUiqVuZ63MDC3bll0FZtLXFJXuo4mJTtBsFJ5YDkgzCULJlLhcL" +
       "QKILgJj2S29D308Njjbwum\ncWS8NotYSU9jLEpmcy4pAVdUamT2ve1P/vGZ" +
       "9+f7FGAU4++MkG69jmJ9GfFuR0RgqJUFKf3K7qGL\n986/l1ds2NsYsYN2uX" +
       "TThXfw2FdSRpPkbs9TamHdlkvbDQbF/wxHcTiv1MuIJtoxf+1e8or3jbyW\n" +
       "9iK+mYNVAzuCJ6X320R+9wU7DrR4Qu1daix3z8zx+3fITVeRFAp7RbNPGb05" +
       "8rkaccBFn2/JHofE\nAQ1ZxikwdZBkx7/zzu1H7vzquIrWjS2nuA1CZcp5Av" +
       "1z0/b+y5uu2jGRV0m24oczC4DgHI1mvSlr\n2yteVS83k1ND3vm5538vIDBM" +
       "Tv/9vktvnkuB4UXUTtghYuuWAD+7TfFdk7M1NMWpy3c8ce0N/p4E\nQkAwwv" +
       "2BavSEOKrXcd+XrlbSyZ9eKMVQ+yLqkfWRbvOjulUWibwIFQ6bqn3Mok81jD" +
       "dWK+ponvAJ\ndCCcD3Vmw9SWqIt2QkiLfodiM6eqaY7oHZTSg7LdUQMYh3lE" +
       "vADxjksquqgZkeZ4KO73N8It25yU\nsChia9CR5KfJLJgB0O0K7Zm/vaCSO4" +
       "CLxFapX6NSTeHssy206pRGeoyn94xePKWURluZCpBUb0tQ\nsLFMLFO4ux/m" +
       "2NkSYkr9rZ88QTtH/vWssBoQTyvr0/YqGMHNVjrSQi1LqaN04re89qPzY797" +
       "TlFS\nnponlcOinXXkadHK/jw2sE+yjfZvaqF2BPpQ3k5ROC9sYshrgZrjqQ" +
       "Mva9nuy7+X/nSXlNxCA8Bm\nZVRaLS8HNV/UJaF71Kn6WBtar546QIoqN4Tg" +
       "otQbUhSMAgpWzIiEK9vWq77lqXD2zo9S39Jfucdz\nYRyqSE6dvRauYKvJSb" +
       "a3JVCOyDtIwAbx3P6xXXu6/wSlyjpVWLr2cR7Dhcv2QynLM/0Tl2eDobWG\n" +
       "/UlX+m+PL5NfxSRLKGKJXK0alSYa6aTLbXRUBq3fL5F64LkBnrXa1q41LZGi" +
       "xCP601DSMHlbbX6k\nIm9PWw2Kd2DSjcCsBVKEunHBhWPboS5n4cM7UaHElN" +
       "PQRsxEXvL++sSzC57Haut77BOsb1g0pHW5\nEL0syluCSpdL8eGPYs9vHpaF" +
       "byKvMw8rjbfs6CW64W4sfezyV/QZeAZbrMjLx56gglEX6aalzqRo\nTlc1JI" +
       "+YM+tE4rAMBxwtSQvbRXWx2year1cjKRctoKYsamNRxnpjqnwiNOP/kAGD0U" +
       "pIvBvKP2mr\njjn+X6StwYFpCHeaREmRVLXlfovXL8qZoCRKlKDMkHCMgFKr" +
       "C07DFxFDdcEUZ8GWyI9D6icMY8eV\n46MvO+nXFHK8nxna4a5fKFtWfbVQ10" +
       "86Li4Q6V27VzuIf49ydN065AzFggrFeSX6OEebmopy1BW8\n1GtcqB+RAz+U" +
       "UPpuVfsv5w0hvlQTAAA=");
}
