package benchmarks.benchmark2.a;

import java.util.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.sharedmem.*;
import benchmarks.*;
import benchmarks.benchmark2.c.*;

public class NoAlias {
    final private static int[] lens = { 0, 1, 10, 100, 1000 };
    
    private void run(final boolean debug, final int port, final int depth,
                     final int repeat)
          throws Exception {
        new Thread() {
            
            public void run() {
                try {
                    new Server(port);
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
        Thread.sleep(1000);
        for (int i = 0; i < repeat; i++) {
            for (int li = 0; li < lens.length; li++) {
                final int len = lens[li];
                Thread t =
                  new Thread() {
                    
                    public void run() {
                        try {
                            new Client().run(debug, "localhost", port, depth,
                                             len, 1);
                        }
                        catch (Exception x) { throw new RuntimeException(x); }
                    }
                };
                t.start();
                t.join();
            }
        }
        Kill.main(new String[] { "localhost", new Integer(port).toString() });
    }
    
    private static void configureTransports() {
        List ss = new LinkedList();
        List ts = new LinkedList();
        ss.add(new SJFifoPair());
        ss.add(new SJStreamTCP());
        ts.add(new SJFifoPair());
        ts.add(new SJStreamTCP());
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    public static void main(String[] args) throws Exception {
        NoAlias.configureTransports();
        boolean debug = Boolean.parseBoolean(args[0]);
        int port = Integer.parseInt(args[1]);
        int depth = Integer.parseInt(args[2]);
        int repeat = Integer.parseInt(args[3]);
        new NoAlias().run(debug, port, depth, repeat);
    }
    
    public NoAlias() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238669451427L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAKVYe2wURRife/SOllN6pbzLuwZQuCoJRmgEa0OlcEBpC5FS" +
       "Uub25q5b9nbXnbnr\nQQgBTOSRaKKArwjEBGM0/KEQ9Q+Nmgi+jQkm4D/wD0" +
       "ZJFCP/KDFo/GZm73Zv9zhEm8zcPL6Zb77X\n7/u2p66hOmqhBCWUqoY+kmA7" +
       "TEJFb6RGiMJoom91D7YoSXdqmNJ+2BhStv2tbno7vm9VEAUGUJNu\ndGgqpv" +
       "3DlpHPDvcPq7RooVmmoe3Iagazb/TdsWzuzdGv96+eFkLjBtA4Ve9jmKlKp6" +
       "EzUmQDKJYj\nuRSxaEc6TdIDKK4Tku4jloo1dScQGjowpmpWxyxvEdpLqKEV" +
       "OGETzZvEEjxLi0kUUwydMiuvMMOi\nDDUmR3ABt+WZqrUlVcrakyiSUYmWpk" +
       "+g3SiYRHUZDWeBcGKyJEWbuLGti68DeYMKz7QyWCGlI+Ht\nqp5maKb3RFni" +
       "1jVAAEejOcKGjTKrsI5hATXJJ2lYz7b1MUvVs0BaZ+SBC0NTb3kpEI0xsbId" +
       "Z8kQ\nQ5O9dD1yC6jqhVr4EYYmeMnETWCzqR6buay1PhL761DPH7PA4vDmNF" +
       "E0/v4IHJrhOdRLMsQiukLk\nwRv5xJHuzfmWIEJAPMFDLGk67nlvY/LqRzMl" +
       "zbQqNOuFLw4pNx9smX6+44f6EH/GGNOgKneFCsmF\nVXvsnfaiCd49sXwj30" +
       "yUNj/u/XTznjfJz0E0phtFFEPL5/RuVE/0dKc9jsI4qepErq7PZChh3Sis\n" +
       "iaWIIeagjoyqEa6OOhibmA2LcdFECEWhBaBlkfybwDuGGtbJkEnQEYYWMkIZ" +
       "HaSWMpgCvQ3nsLWd\nOsPFg3jQIS/yu+8eDQRArBZviGngj6sMLU2sIeX1K1" +
       "/uWrnm4AFpMO5k9qvARx02CYdNAidsNigQ\nEPeP5y4pVdZhWXgHD5Xi3vPT" +
       "X/oMHwMDgCKoupMIOQOjYd7DocU1kaTTicNuGGFwkyGlec/VqS9/\n98a5IA" +
       "pVRZNkebHLsHJY4w5RCp8mm513B/yo1evN1Xj/emjtmQtfXZrv+DVDrb5w85" +
       "/k4TLHq3/L\nUEga4Mi5/oU/V/12uG7pO0EUhhgEFGIYfAdCeoaXR0XYtJcg" +
       "iMsSSqKxGZ/gDQwUNOoSmPcx3jVK\nHwFbNHseKNDrxpOR+y9+MPackLgEdO" +
       "NciNhHmAybuGP/fosQWL/0Ys/ho9f2bwlBoJqmtDlDETOf\n0lSlCEcmVUYa" +
       "f16au80vp9sbn1lE3xUmrldzuTzDKY0AMmNNM0ZJeogJaIq7YFCgD2gilgIU" +
       "A0Ac\n0uAiKasZKIB7VsGJxOTmI88veOUiRxJTKGYijzjxUlQUC60B3s/3bf" +
       "L5dO7BzY7YEPvbpQCxBX1b\nV287MEdI7r5uoT0pli90YmFhzVjo4hnHcRV1" +
       "1+97T397NBZEwQEUVWmXqmONK4vaYVkFaz1X7Pxw\n4/Eb37DLwrSOt/GHtR" +
       "T9eLEJuwLhoQuFeOStE7kgig6gRpEvsc42YS3PDT8AGY922otJdFfFfmX2\n" +
       "klDdXo6mFq+nu9h6/dzBKRhzaj4eI11b0IwDzXIdt0ObZGOq+OWbcd41FQMB" +
       "kw+WiAMzRD9bmizE\ngB1XK0NR01ILmMHbI1QUHkUGuE50Sv1pUICfzFSnQ6" +
       "3Xg+9PbBXxHE5hKl/orR/85UFF1hcCNZg8\nYLwW7bHUHCSngp09n51x8scz" +
       "V3qbJTzJEmOuL8u7z8gyQ3AYKzjMrsVBUJ+9b/ap3b2XUzL9NlWG\n8Eo9n1" +
       "ty4nuy4JGYUiWXhEBSn+fz+QNmMYCEIR7zGyLIx0t5Nxf0HgG9Z2XW7ODdci" +
       "eWgpJczMcz\nOyNxN4PaxNAJx5DSngxb1UiUq0TYrBaVMz0KWSss40RCvDBt" +
       "Q2hY/TwoPFI6sa+sqzzUXum6DRaB\nqlTvr3Dgaab4We7XRkAqoiY63Ra6+s" +
       "C3Fa6Tkj4aHV3JkJRpISDJ++WFyLmwBGSgoem3qgOFu+x/\n/HrsKXx2a9Dm" +
       "3MlQPTPMRRopEK38tpCMOLhtUU0U9Go/1LdiwbyFY3+CCLtFMRC3F3srlSyq" +
       "BHyH\nVQLvN5SRpR7aZmhTbGSZ4kEWmVer229ZdROFBUVYzFeYkuZRgJ+UYW" +
       "gE62Wfl131O9xhVRkEK4sK\nMXkpK54G2BCy8rqXV7hgqGlxpeUydJgPR6ry" +
       "vy2BUtZYI7R7oXXbGuv+dxoT8b+Md+3/0+1HQR+Q\njDJqFuqufgvr1DQsiU" +
       "iWT2ZPyvbIwts8aIO2LIN3IMvcGrK4zfdwmRv3rZk1uFUJY/ldWB1teXew\n" +
       "hLhP10Zc3q8u2/SAD235NMm7dX74FAEjmYnDLiz5ryZ8jncDvNtSrKlBPjXE" +
       "kX3g1TmobaqbOeAS\nq2IFck3ULqZ4fTvZ9y8K+SGtzDm/bf4nZvwLmeVLH7" +
       "tR+OLM5DXNXaO4xhHTIhlVPC8qKxYJ+McZ\nmnSLDy6GAli88pgkfRW+zauS" +
       "whejM3GfOOneERuvmVKT6B/A3i2y2hEAAA==");
}
