package benchmarks.benchmark2.b;

import java.util.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.sharedmem.*;
import benchmarks.*;
import benchmarks.benchmark1.a.*;
import benchmarks.benchmark2.d.*;

public class Ordinary {
    final private static int[] lens = { 0, 1, 10, 100, 1000 };
    
    private void run(final boolean debug, final int port, final int depth,
                     final int repeat)
          throws Exception {
        new Thread() {
            
            public void run() {
                try {
                    new benchmarks.benchmark2.d.Server(port);
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
        Thread.sleep(1000);
        for (int i = 0; i < repeat; i++) {
            for (int li = 0; li < lens.length; li++) {
                final int len = lens[li];
                Thread t =
                  new Thread() {
                    
                    public void run() {
                        try {
                            new Client().run(debug, "localhost", port, depth,
                                             len, 1);
                        }
                        catch (Exception x) { throw new RuntimeException(x); }
                    }
                };
                t.start();
                t.join();
            }
        }
        Kill.main(new String[] { "localhost", new Integer(port).toString() });
    }
    
    private static void configureTransports() {
        List ss = new LinkedList();
        List ts = new LinkedList();
        ss.add(new SJFifoPair());
        ss.add(new SJStreamTCP());
        ts.add(new SJFifoPair());
        ts.add(new SJStreamTCP());
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    public static void main(String[] args) throws Exception {
        Ordinary.configureTransports();
        boolean debug = Boolean.parseBoolean(args[0]);
        int port = Integer.parseInt(args[1]);
        int depth = Integer.parseInt(args[2]);
        int repeat = Integer.parseInt(args[3]);
        new Ordinary().run(debug, port, depth, repeat);
    }
    
    public Ordinary() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238669512448L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAKVYa2xURRSefXT7WqVbSsFSKI8aQGGrJBihEawNlZYFSluI" +
       "FJoye3d2e9u7917v\nzG4XQghgImCiiQK+IhATjNHwQyHqD42aCL6NCSbgH/" +
       "iDURLFyB8lBo1nZnb33r13WUSbzOw8zsyZ\n8/rOuT15FVVRC0UpoVQ19PEo" +
       "22ESKnojPk4URqODff3YoiTRrWFKh2BjVNn+t7r57ci+NX7kG0aN\nutGlqZ" +
       "gOjVlGJjU2NKbSnIXmmIa2I6UZLH+j544V829Mfr2/b2YATRlGU1R9kGGmKt" +
       "2GzkiODaNw\nmqTjxKJdiQRJDKOITkhikFgq1tSdQGjowJiqKR2zjEXoAKGG" +
       "luWEjTRjEkvwLCzGUFgxdMqsjMIM\nizLUEBvHWdyRYarWEVMp64yhUFIlWo" +
       "I+jnYjfwxVJTWcAsLmWEGKDnFjRw9fB/I6FZ5pJbFCCkeC\nE6qeYKjNfaIo" +
       "cftaIICj1WnCxowiq6COYQE1yidpWE91DDJL1VNAWmVkgAtDLTe9FIhqTKxM" +
       "4BQZ\nZWiGm65fbgFVrVALP8LQNDeZuAls1uKymcNaG0Lhv57q/2MOWBzenC" +
       "CKxt8fgkOzXYcGSJJYRFeI\nPHg9Ez3cuyXT6kcIiKe5iCVN193vbYpd+ahN" +
       "0swsQ7NB+OKocuOB1lnnun6oDfBn1JgGVbkrlEgu\nrNqf3+nMmeDdzcUb+W" +
       "a0sPnxwKdb9rxJfvajml4UUgwtk9Z7US3RE935cTWMY6pO5OqGZJIS1ouC\n" +
       "mlgKGWIO6kiqGuHqqIKxidmYGOdMhFA1NB+0MST/mnnHUP0GK6Hq2NoRpeMM" +
       "LWGEMrqNWsq2OChu\nLI2tCWoPl26Lb3PQ5/jtd076fCBYqzvINPDINYaWIN" +
       "ao8vrlL3etXnvwgDQZd7P8uxiaY/OJ2nyi\n8WiBD/L5BIOp3Cul1rosC+/g" +
       "0ZLbe27WS5/ho2AD0AVVdxIhqm8yyHs4tLQimHTbodgLIwyeMqo0\n7bnS8v" +
       "J3b5z1o0BZQIkVF3sMK4017hOFCGrMs3PvgCu1ux26HO9fn1p3+vxXFxfars" +
       "1QuyfivCd5\nxMxzG8AyFJIARLKvf+HPNb8dqlr+jh8FIQwBiBgG94Gonu3m" +
       "URI5nQUU4rIEYqg+6RG8joGCJh0C\n8z7MuwbpJGCLJtcDBYBdfyJ034UP6s" +
       "8KiQtYN8UBioOEyciJ2PYfsgiB9Ysv9h86cnX/1gDEqmlK\nmzMUMjNxTVVy" +
       "cGR6abDx5yW42/xyqrPhmSX0XWHiWjWdzjAc1wiAM9Y0Y5IkRplAp4gDCQUA" +
       "gSbC\ncQAywMRRDS6Sspq+LLhnGaiIzmg6/PyiVy5wMDGFYkTQiZeinFho9/" +
       "F+oWeTz2dxD26yxYbwn5AC\nhBcNjvRtPzBPSO68bnF+kiteaMfC4oqx0MOT" +
       "ju0q6q7f95769kjYj/zDqFqlPRCLGlcWXS+dvwzc\nuq7Y+eGmY9e/YZeEaW" +
       "1v4w9rzXkBYzN2BMKD57OR0FvH035UPYwaRMrEOtuMtQw3/DAkPdqdX4yh\n" +
       "O0r2SxOYROvOYjS1uj3dwdbt5zZQwZhT83GNdG1BMyUPo53QZuRhVfzyzQjv" +
       "GnM+n8kHy8SB2aKf\nK00WYMCOq5WhatNSs5jB20NU1B45BtBOdEq9mVCAn0" +
       "xWpwLt1/zvN7eLeA7GMZUvdJcQ3gqhJPEL\ngepMHjBui/ZbahryUzafQJ+d" +
       "feLH05cHmiQ8ySpjvifRO8/ISkNwqBcc5lbiIKjP3Dv35O6BS3GZ\ngRtLQ3" +
       "i1nkkvO/49WfRwWCmTTAIgqcfz+fx+M+dDwhCPeg3h5+PlvJsPeg+B3lMycX" +
       "bxbqUdS35J\nLuZTWT4jcTeD8sTQCceQwp4MW9WIFgtF2CwXlW0uhawTlrEj" +
       "IZKduTEwpn7uFx4pndhT2ZUe6ix1\n3TqLQGGqD5U48ExT/Kz0asMnFVERnW" +
       "4JXYPg2wrXSUEfDbauZEjKtOCT5EPyQmRfWAAy0NCsm5WC\nwl32P3Yt/CQ+" +
       "M+LPc+5mqJYZ5hKNZIlWfFtARhzctqQiCrq1HxhctWjB4vqfIMJuUgxE8osD" +
       "pUoW\nVQK+zSqB9xuLyFILbQu0ljyytLiQRebV8vZbUd5EQUERFPNVpqR5BO" +
       "AnbhgawXrR52VX/g5nWJUG\nweqcQkxezYqnATYErIzu5hXMGmpCXGk5DB3k" +
       "w/Gy/G9JoBQ11gDtHmh9eY31/TuNifhfwbvO/+n2\nk6APSEZJNQV115CFdW" +
       "oalkQkyyOzK2W7ZOFtAbSRvCwjtyHL/AqyOM33UJHbXdDaKnArE8by07A8\n" +
       "2vLuYAFxn66MuLzvK9r0gAdt+TTGu/Ve+BQBI5mJww4s+a8mfI53w7zbmquo" +
       "QT41xJF94NVpqG3K\nm9nnEKtkBXJNTeEjhxe4Mzz/ppAf08q8c9sXfmJGvp" +
       "BpvvDBWw1fncmMpjmLFMc4ZFokqYr3VcuS\nRSL+MYam3+STiyFfXDzzqCR9" +
       "Fb7Py5IyVGdPnCdOOHfExmumVCX6B7FtTgneEQAA");
}
