package benchmarks.benchmark2.c;

import java.io.*;
import java.net.*;
import java.util.Arrays;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import benchmarks.NoAliasBinaryTree;

public class Client {
    final private SJProtocol p =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9nJ1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGng0BUOk0O1i9GFgTc" +
       "7IzEkpYdDwgWnXB2vSh2vXR9FuDbRJGc0m\nEJmflJWaXAKyC2LJxfXz8jlV" +
       "f2+FuE20ID+nMj0nvwSqA6LGUXV7qM+L/fIQNdJY1PiDTY1P/mMm\nI3vJ8Q" +
       "knM8jJHAX5xZklQPtLGCR8YJr0S0syc/QDoDLWFQUFFcDg18QTJv6lJeVAv6" +
       "diiwBVPPp8\n8vMLIHqYXU4umqF5axs4IFmS8lMqCxnqGJgrQCRTQUVBMX6D" +
       "glPzUrBZbopHjy+QnZie6pyfm1ua\nl5mcWAKP1ZVOhxl9uPfdBzuGOxeiDi" +
       "RVwiCKCCVIjEIiEurMYvxJJyg1OTWzDEsogbTzQnwpgxZ1\nATmJyake+Tkp" +
       "qUXxycsfn6px9e7sgIRSXmIu0EVCPlmJZYn6OYl56frBJUWZeenAGCthkElK" +
       "zUvO\nyE0syi7W88t3zMlMLHbKzEssqgwpSk0F2ScCAAhPTPdXAwAA"));
    
    public void run(boolean debug, String server, int port, int depth, int len,
                    int num)
          throws Exception {
        final SJService c = SJService.create(p, server, port);
        long totalRunTime = 0;
        for (int i = 0; i < num; i++) {
            NoAliasBinaryTree bt = NoAliasBinaryTree.createDepth(depth);
            SJSocket ds = null;
            try {
                ds = c.request();
                int k = 0;
                while (SJRuntime.outsync(ds, k < 1)) {
                    {
                        NoAliasBinaryTree _sjtmp_bt = null;
                        _sjtmp_bt = bt;
                        bt = null;
                        SJRuntime.pass(ds, _sjtmp_bt);
                    }
                    bt = (NoAliasBinaryTree) SJRuntime.receive(ds);
                    k++;
                }
                bt = NoAliasBinaryTree.createDepth(depth);
                long runTime = 0;
                long timeStarted = 0;
                long timeFinished = 0;
                SJSocket s = null;
                try {
                    s = c.request();
                    timeStarted = System.nanoTime();
                    int j = 0;
                    while (SJRuntime.outsync(s, j < len)) {
                        {
                            NoAliasBinaryTree _sjtmp_bt = null;
                            _sjtmp_bt = bt;
                            bt = null;
                            SJRuntime.pass(s, _sjtmp_bt);
                        }
                        bt = (NoAliasBinaryTree) SJRuntime.receive(s);
                        if (debug) { bt.println(); }
                        j++;
                    }
                    timeFinished = System.nanoTime();
                }
                finally {
                    SJRuntime.close(s);
                }
                runTime = (timeFinished - timeStarted) / 1000;
                totalRunTime += runTime;
            }
            finally {
                SJRuntime.close(ds);
            }
        }
        System.out.println(totalRunTime);
    }
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        String server = args[1];
        int port = Integer.parseInt(args[2]);
        int depth = Integer.parseInt(args[3]);
        int len = Integer.parseInt(args[4]);
        int num = Integer.parseInt(args[5]);
        new Client().run(debug, server, port, depth, len, num);
    }
    
    public Client() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238670740171L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVYfWwcRxWfvTufvw7ic5w0xB9pEofYanKGqEUFCxXbTRSn" +
       "59r1OWnipnL2dufO\n4+ztLjtz53UUSgsSaYsEQm3aFNpEQkhVq0htU7X8AQ" +
       "pI/W5BiCClFVLLH0VQCYroPxBBQbyZ2b3d\n2z1fqaUdz+68r3nv9968uYsf" +
       "ojbqoBzFlBLLXMmxNRtTMVrFFawxmiscmlMdivUpQ6V0ARaWtBP/\nJUeey3" +
       "7rYAIpi6jXtCYMotKFZceqlpcXlgl1HXS9bRlrZcNinsSYjK/s/Hj1V2cO9S" +
       "fRhkW0gZgF\npjKiTVkmwy5bRJkKrhSxQyd0HeuLKGtirBewQ1SDnAJCywTF" +
       "lJRNlVUdTOcxtYwaJ+ylVRs7Qqf/\nMY8ymmVS5lQ1ZjmUoZ78ilpTx6qMGG" +
       "N5Qtl4HqVLBBs6/Tq6ByXyqK1kqGUg3Jz3dzEmJI4d4N+B\nvIuAmU5J1bDP" +
       "kjpJTJ2hbVGO+o6HbwMCYG2vYLZs1VWlTBU+oF5pkqGa5bECc4hZBtI2qwpa" +
       "GNq6\nrlAg6rBV7aRaxksMbYnSzckloOoUbuEsDG2KkglJELOtkZiFojWbzv" +
       "znwbl/Xg8RB5t1rBnc/jQw\nDUWY5nEJO9jUsGS8Vs09PH2sOpBACIg3RYgl" +
       "zcSunx7Of/CLbZKmvwnNrMDikvbxlwYGr0z8sTPJ\nzeiwLUo4FBp2LqI656" +
       "2Muzage3NdIl/M+Yu/nH/12L1P478kUMc0SmuWUa2Y06gTm/qUN2+HeZ6Y\n" +
       "WH6dLZUoZtMoZYhPaUu8gztKxMDcHW0wt1W2LOaujRBqh0eBx0XybzMfGOqc" +
       "Mgg2WY6uMHQDw5TR\n49TRjhfBbcsV1TlJg+m+49rxOrXLJX92VVFgUwPRBD" +
       "MAjQctQ8fOkvbk+2+e3n/bA/fLcHGIeTYx\nNBRoyQVaclpOakGKIsRv5HiU" +
       "/ppwHHWN54l735XBx15TnwDvgxcoOYXFJpXVFB+BaV/LMjIVJOE0\nzFTAyJ" +
       "LWd+8HW3/4u6deSaBk01KSr388YDkV1eBo8HOn11MXXQEQDUeh3Ez33x6cef" +
       "7qW++OBKBm\naDiWa3FOnis7ou53LA3rUIsC8Y/+6+DfH2r78gsJlIIEhBLE" +
       "VAAO5PNQVEdDzoz79YfvJZlH3aXY\nxrsYOGg1tGE+ZvjQIyECseiLGChK17" +
       "Vvp7/w9s+7XxE79qvchlA5LGAmcyYbxH/BwRi+v3tu7qGz\nH565Kwlwtm0Z" +
       "c4bSdrVoEM0Flusa04ybp3PY/PXSeM/39tIXRYg7SaVSZWrRwFCWVcOwVrG+" +
       "xERd\nyoZqoCg94IlMEUoYVMMlAwTJvdpKDeDZpEjktvQ9/Mjo42/zMmILx4" +
       "h0E5YiV3wYVvg4Elvk74Mc\nwX3BtiHxT8oNZEYLdx86cf8OsfOwuD3ei1sX" +
       "GOTCjS1z4QA/bgAzzIK6E0DmxHffuWPm6J1jshJ+\nsaWI2yGrdSEn4D87bd" +
       "5yedNVM8FRkqYr9czPowRlDI3kfZEe8virnBUOFeSSfxrs+eQNBIrJ6X/c\n" +
       "d+k3ZzOgeBG1E3qAmKrBo01vl9nb5KSIiDh1+fD5a79m7wlsBunCzR9w4/Xu" +
       "iBrK5Juv1rLpZy9U\nEqh9EfWI01412RHVqHLkLsJ5Tae8j3n0mYb1xrNXHj" +
       "Tj9XIwEE3VkNpooqZC3k5xaj7vkLlpu4pi\n89nNgnpIjNslmBIM5HB/MdRu" +
       "O6Sm8g4IKRLCGxnqrwfCqZqMVDBvyTzoiGxXBKq/CqDbHYlZPby8\n/E7iMj" +
       "HliesdR4rE2edbcIWYdvVoT+8ZuXhKMo20YAohKayL1xxtmRg6N3cfyNjZEm" +
       "KS/bfPnLc6\nd/37hYSXpt02rzWjLbTPVtkqaMHNtrqrBV/esmzJk7z1jR+f" +
       "G/39i/JgKFr6mrSYj5O2qI+tBBWg\nWWim/KYWPDMwh1ZtyoLyaBJNtLhSxl" +
       "OTLyn57st/EMZ0VyTdQgO8JoVPWkVkHmuY1Jq4hLNP224d\nbAOh9sBL3UnA" +
       "prPGTwFOM+PGESzwt9MrsSgosX59BOMG1+stRV985uhHme+oL98t/dTbeJDs" +
       "N6uV\nmy68g0e/ltGaNDSdzLL3GriGjXoVTsi8ArV7WyJsRrTiQRlJFm4Z3b" +
       "2n+89wYq/TjGS9j/MY7h1m\nPQqiS1E/dZeyLeKUqD3ZWv8dyWXyekKUF1mR" +
       "YjeMRqbxxjrU5TQaKuLdLwzYAC7qgOcwPIMeJMR/\nvpjlQ69sJvgw2/T4TA" +
       "s/p2m8ts85pAJNto+4Hwz95E/Pvz/fJ8Mnr0o7Y7eVMI+8LoUyfnsrDYL6\n" +
       "5Ru2X7xn/r2iD+sFqKdFyzKwavro7hHHO6/0OXnLEgtLtoRukaEkXOz4tBwM" +
       "zTsH/6D3BG8MBO93\nNWzz9BVG3AUyoWxH9aRqFtGFSCuUKWk+VfmAI0aELP" +
       "kUpEfrgebPbngqXqArzQLd5GgSiQ1dHhW3\n89auiF8gxc1BIuBScvijxM82" +
       "D4tmOFVUqZ84jTfv+MW64b4s7Oyq7+pz8Gz7hF3hpiG7kQ/fcBUk\nDuVvrr" +
       "PzcVnXYP8GNsvyYif8e9qN1Zo4EKYMy8S80/XXZHNJrFz9hwxYjPeO/P2YtE" +
       "/oWj///u/e\n9gFoMTRuTpNEkC2P2zK2/NUQkqCJTFWgMRPQjQFYCTmn4Qv3" +
       "obxg8sNzS+zHIfkThrbjyomRl+zs\nGxIl/s8M7XDXL1UNI9xfheZp28ElIq" +
       "xr97st/u8cQ9etc9mF9koTRj4qSX/E0KampAx1BS9hjvPh\nFbFwQUDp+67y" +
       "P2EDQkVUEwAA");
}
