package benchmarks.benchmark2.d;

import java.io.*;
import java.net.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import benchmarks.*;

public class Server {
    final private SJProtocol p =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9gp1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGvisgkih28Xow8CanJ" +
       "GZk1LCoOED064P1qQP166Pot0aaJMymk0g\nMj8pKzW5BGQXxJKL6+flc6r+" +
       "3gpxm2hBfk5lek5+CVQHRI2j6vZQnxf75SFqpLGo8QebGp/8x0xG\n9pLjE0" +
       "5mkJM5CvKLM0uA9pcwSPjANOmXlmTm6AdAZawrCgoqivGHiWdeOdDrqdjCXx" +
       "WPNp/8/AKI\nHmaXk4tmaN7aBg5HlqT8lMpChjoG5goQyVRQUUDA/qDU5NTM" +
       "Mqz2m+LR5gtkJ6anOufn5pbmZSYn\nlsDjdaXTYUYf7n33we7hzoWoA0mVMI" +
       "giwgkSp5CohLq0GL+Pg1PzUjBdCdLLC/GlDFrMBeQkJqd6\n5OekpBbFJy9/" +
       "fKrG1buzAxJKeYm5QOcI+WQlliXq5yTmpesHlxRl5qUDIwzoyqTUvOSM3MSi" +
       "7GI9\np8y8xKLKkKLUVJBFIgDUelUBTwMAAA=="));
    
    public Server(int port) throws Exception {
        super();
        ServerThread st = this.new ServerThread(port);
        st.start();
    }
    
    private class ServerThread extends Thread {
        private int port;
        
        public ServerThread(int port) {
            super();
            this.port = port;
        }
        
        public void run() {
            SJServerSocket ss = null;
            try {
                boolean run = true;
                ss = SJServerSocketImpl.create(p, port);
                new KillThread(port + Kill.KILL_PORT_ADJUST,
                               ss.getCloser()).start();
                BinaryTree bt;
                for (int counter = 0; run; counter++) {
                    SJSocket ds = null;
                    try {
                        ds = ss.accept();
                        while (SJRuntime.insync(ds)) {
                            bt = (BinaryTree) SJRuntime.receive(ds);
                            bt.inc();
                            SJRuntime.send(ds, bt);
                        }
                        SJSocket s = null;
                        try {
                            s = ss.accept();
                            while (SJRuntime.insync(s)) {
                                bt = (BinaryTree) SJRuntime.receive(s);
                                bt.inc();
                                SJRuntime.send(s, bt);
                            }
                        }
                        finally {
                            SJRuntime.close(s);
                        }
                    }
                    catch (Exception x) { run = false; }
                    finally {
                        SJRuntime.close(ds);
                    }
                }
            }
            catch (Exception x) { throw new RuntimeException(x); }
            finally {
                if (ss != null) ss.close();
            }
        }
        
        final public static String jlc$CompilerVersion$jl = "2.3.0";
        final public static long jlc$SourceLastModified$jl = 1238669068569L;
        final public static String jlc$ClassType$jl =
          ("H4sIAAAAAAAAAJVXXWxURRSe3W13+7Pabik/oS2lpWgb6NYQNGpjsGloKCxS" +
           "u4VIKSmz98620969\n93pn7nYhhIAmgjyYGPA3Ki8mRsODQtQXoyaC/8YEE/" +
           "AFXjBKohh9UWLQeGbm7t/dbY1NdnZ25pw5\nc875zjenZ2+iWuagOCOMUcuc" +
           "i/ODNmFytFJzROMsntw+hh1G9GEDMzYBG9PagX/onndiT2wLosAk\najGtIY" +
           "NiNjHrWO7M7MQsZTkHrbUt4+CMYXHvxIozHlx3e+Hr49vbQqhpEjVRM8kxp9" +
           "qwZXKS45Mo\nmiGZFHHYkK4TfRLFTEL0JHEoNughELRMMMzojIm56xA2Tphl" +
           "ZIVgC3Nt4kib+cUEimqWybjjatxy\nGEfNiTmcxQMup8ZAgjI+mEDhNCWGzh" +
           "5HR1AwgWrTBp4BwRWJvBcD8sSBEbEO4g0UrumksUbyKjXz\n1NQ56vRrFDzu" +
           "2QECoBrJED5rFUzVmBgWUIu6koHNmYEkd6g5A6K1lgtWOFq96KEgVGdjbR7P" +
           "kGmO\nVvnlxtQWSNXLsAgVjpb7xeRJkLPVvpyVZGtXOPr3ybE/10LG4c460Q" +
           "xx/zAorfEpjZM0cYipEaV4\ny42fHt3rtgcRAuHlPmElM7T+/d2JGx91Kpm2" +
           "KjK7JBantdv3tXdcGvqhPiSuUWdbjAoolHkuszrm\n7QzmbED3isKJYjOe3/" +
           "x4/NO9R98iPwdR3SgKa5bhZsxRVE9MfdibR2CeoCZRq7vSaUb4KKox5FLY\n" +
           "kr8hHGlqEBGOWpjbmM/Kec5GCNXDB7xCJlJ/nWLgqB6QnCVOnM1xtIETxtkU" +
           "c7SpFIRtNoOdeVac\nbprSpwrSOXHynQuBADjV7i8wA9C4zTJ04kxrb1z/8v" +
           "DWHU+fUOkSEPPuBPaKVuJFK3E9rqz0qC8o\nZoJ1FAhIW8sEOFXwhhwHHxRF" +
           "kzt2qeOlz/CrkAoICaOHiPQ4sFAjRlDatCSnDBcrchRmGAAzrbUe\nvbH65e" +
           "/evBhEoaq8kigsjlhOBhsCGvlCavHM+XcAUT1+XFez/evJnecvf3W1t4hwjn" +
           "oqCq9SUxRO\ntz8XjqURHYipePwLf2377VTtA+8GUQ1UI/ARx4AiKO41fhtl" +
           "BTSYJyPhSyiBGtMVjjdwCNBCicNi\njMp5kwfBEHzu8iC4TgxiMyaGFgUpSF" +
           "erzwdJdbeeDN9z5YPGizIoeVZsKqHPJOGqxmJFiEw4hMD6\n1RfHTj138/g+" +
           "MJ6zbQULjsK2mzKolgOVleVlKTzQBbJ+OTfY/Ew/e0+ioJ5mMi7HKYMAjWPD" +
           "sBaI\nPs0lj8VKOFNSFQQrmgLKA/acNuAgFQ47kAUEVyGV+KrW08/3vXJF0I" +
           "4t47WiDMB+ZhtzaAaII+sx\n27NrXv/x/PXxVgUYRf/rKhi4VEc9ATLijbaI" +
           "QNdSFqT0hQ1dZ4+MX0spamwpj9hW083ce+Z70vdw\nVKtS6SF4pHLSr/UBMf" +
           "YVfETSRyRv0iFcbS1mD/huXuUh2pfcv/3AiW6ZQBUVodCvztxcupKrEr6N\n" +
           "S9b/iHhvi+VBD/9x7Ny3z0WDKDiJIpSNUBMbIvvsEVXwVV4a3xGHPtz92q1v" +
           "+DUZiWKFiYu15yr5\ncg8uKf77L2dj4bfPZIIoMomaZbeATb4HG65A8iS892" +
           "zYW0ygO8r2y99u9VANFhik3Q+IErP+2i5m\nD+ZCWszrfOXcAJ9l8OnyyrnL" +
           "V86BgC0mD0mFTjl2F4ovYjs0i0WDBQ+V5cgC6ZcEgALSzhYFF1SE\ny2YPKp" +
           "DQjsXaA4nU44/9Hn0KX9gf9HA1ALXu9XCV2OhfEhs7ZYdUzE4ouaXv7o2NPw" +
           "F3LvIsxLzF\ncQLtoDmRj518L/D/fi86fY767xPLtj0amqWfB2XWVKIrGr9y" +
           "pcHy9DY45ReVEWsr42yR5F4vyb3V\nOFsMXUuW93/WfgJIwnFNubfBVvJxwE" +
           "bWorpUS5ZjoPQHYCha2ivIzWXwni3dX0DyV1X8a6AaWK37\n0oHeT+zYF/KN" +
           "LDSZEej00q5hlFZHyTxsOyRNpTsRVSu2/JriaOUiV+EooK67T4lC67y8qihH" +
           "DcUf\npRqp0h25odn5ADRLLhVsEFeRyQX+BSDG38tmDQAA");
    }
    
    
    public static void main(String[] args) throws Exception {
        int port = Integer.parseInt(args[0]);
        new Server(port);
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238669068569L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVYb2wcxRWfvTuf/10bn3FCGtsxSezGVuJzQYDauip1TNI4" +
       "bIjxmQAmyN7bnTuP\nvbe73Zk7ryNEoaAmBAmJQlpALUhVpQoUqW0Q9EOrgA" +
       "S0pYAQQQoICfgAAiSggi9t1NKqb2Zub/f2\nzls10o1nZ96bN/Pe7/3mTc58" +
       "htqoi3IUU0psayXH1h1MRWsXVrDOaC5/aFZzKTamTY3SeZhY1Jf+\nQ47+Lv" +
       "ujgwmkLKBey54yiUbnl127UlqeXybUc9Fljm2ul0yb1VZsWuPbu75ce+XEof" +
       "4k2rSANhEr\nzzRG9GnbYthjCyhTxuUCdumUYWBjAWUtjI08dolmkuMgaFtg" +
       "mJKSpbGKi+kcprZZ5YK9tOJgV9j0\nB1WU0W2LMreiM9ulDPWoK1pVm6gwYk" +
       "6ohLJJFaWLBJsG/QG6AyVU1FY0tRIIblH9U0yIFScO8HEQ\n7yKwTbeo6dhX" +
       "Sa0Sy2BoKKpRP/HwdSAAqu1lzJbtuqmUpcEA6pVbMjWrNJFnLrFKINpmV8AK" +
       "Q9s2\nXBSEOhxNX9VKeJGhrVG5WTkFUp3CLVyFoc1RMbESxGxbJGahaB1JZ/" +
       "59avYfl0HEYc8G1k2+/zQo\nbY8ozeEidrGlY6l4sZJ7aOaWykACIRDeHBGW" +
       "MlMjv79R/fjZISnT30LmiMDiov7l1QOD56c+6Ezy\nbXQ4NiUcCg0nF1Gdrc" +
       "1Meg6ge0t9RT6Z8yefm/vTLXc+iT9JoI4ZlNZts1K2ZlAntozpWr8d+iqx\n" +
       "sBw9UixSzGZQyhRDaVt8gzuKxMTcHW3QdzS2LPqegxBqh58CvyqS/7K8YagT" +
       "kFzFbo6uMLSHYcro\nMerqxwrgtuWy5q7SoHvFMeNYXdrjK391TVHgUAPRBD" +
       "MBjQdt08Duov7r9/96+/7r7j0pw8UhVtsT\nQ9sDK7nASs7ISStIUcTyl3A8" +
       "Sn9Nua62zvPEu+v84CN/1n4B3gcvUHIci0MqaynegtIVsTQyHSTh\nDPQ0wM" +
       "ii3nfnx9sefeOJFxMo2ZJK1PrgAdstayZHg587vTVz0RkA0XAUyq1s/+3U4a" +
       "cuvPzOaABq\nhoabcq1Zk+fKzqj7XVvHBnBRsPzP/nnw8wfbvvV0AqUgAYGC" +
       "mAbAgXzeHrXRkDOTPv/wsyRV1F1s\nOngXAwethQ7M24zob4JQdMAPcgkN1l" +
       "C3lTd8MsubXokiCFdf5AyC3S7enf7Gm3/sflE4xSfCTSHG\nzGMm0yobQGTe" +
       "xRjG33l49sHTn524NQmJ7DgSFgylnUrBJLoHKpc2ZiI/gcGR9enZyZ77x+kz" +
       "AgWd\npFyuMK1gYmBuzTTtNWwsMkFd2RBNCnYCZ2UKwHJAmIsmLCTd4ShVQH" +
       "ALHslt7Xvop2M/f5MzjSP8\ntaUBwFEym3VJGbiiWiOzB7b/6sOn3p/rk4CR" +
       "jL+riXTDOpL1hce7He6BHXEWhPQLe3acuWPu3YJk\nw95Gj+23KuWrHn8Lj3" +
       "0vo7dI7iTcS54414jC27GmM/LvS1gtvbkfc/s9HTucD8UuB7kb+oLIAv2t\n" +
       "yhhlxvK3HVo6uVMEV67GFcalvavDI14L114Zyw0H+PULOcRs4OEghZbue+uG" +
       "wzffNCF9cXnsEteD\nIwyxTqB/esa65tzmC1aCZ02artSdpaIEZQyNqv6Ste" +
       "DxT9nLH8rLKf923Pu/DxAYJrf//a6zr53O\ngOEF1E7oAWJpJoc2vV6yWYub" +
       "M7LE8XM3PnbxVfauCHNAH3z7A14z/x/VQsz2zQvVbPq3j5cTqH0B\n9YjqR7" +
       "PYUc2s8DRdgPqFTtcGVfSVhvnGWkRevJN1ehyIoj1kNkpcqZC3U1ya9zskVz" +
       "meoji8t09I\nD4l2p4RVgsE63F8MtTsuqWq8IkSK42O3vx4It2IxUsa8RK1B" +
       "R1CbImD4fQDd7kjM6uEFlfw+XCKW\nTOwaUSoSZ1+P0QopjfToT+4dPXNcKo" +
       "3GmQqQFLbFCVZfJqbBt/sdWGNXLMSk+uu/eczuHPnX09xq\nQCtx1mesNTCC" +
       "W510JEZNtW1H6iSvfemXD4+9/YwknIJtrMsN81Z1xF0QZ38O67hOoY32r4pR" +
       "Owx9\nKF6nbbgNLKKLol+u8cS+5xW1+9x7Yj/dZSk33wAwVXgl7nh5qOiat8" +
       "R1845Xx9rmULW0DzDprvOr\njk/eJGR3SLJFAdlKIkTc/OBG9bTg+RM3f5H5" +
       "sfbCbb7ZCagLme2Mm7iKzRYEOh4LjsPiVREwQDJ/\nzdjuvd0fQfGxQV2VrQ" +
       "3OYXhCWXX3iYJL+78LrqHIWaP7yVb7b0guk78kBDNIMml6LDUqTTZSSJfb\n" +
       "uFHhtP560cN/u+Hn1MLptCx6msmG94ehSKHi/Rl/eTY/kURtLGF0Njn8ReIP" +
       "W4ZFuZcqaNT3Z+Pb\nsvnp2PAiFPvsqp/qa/AbijmVj9Oe4D6Xz8eWF/93eb" +
       "PqKUhQr72BN/YLlwDlpk1sleRzZpw3K8G9\nnpDiLcqJadO2MC/e/DlZTBA7" +
       "V3++w2RzhcC/l+T+hK1QdkWigfwMi5vk3+twkeh8Oy28JC82Lzbe\n/PNKsV" +
       "KBoVQZrl8hsceRWjkYrNrEEHL3RKuglaa6aMXjPpXPLM6ZW5v+i0Q+5PWd55" +
       "dGn3eyL0kk\n+Y/tdnjxFiumGb5VQ/204+IiEbtt9+9Y/uc+hi7d4MkHl6pE" +
       "3Skpen8j3wWiDHUFH2GNB8IzYuIn\nAlo/9JT/Ao1RjRhaEgAA");
}
