package benchmarks.benchmark3.a;

import sessionj.runtime.*;
import sessionj.runtime.net.*;
import benchmarks.NoAliasBinaryTree;

public class Alice {
    final private SJProtocol p_bob =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9nJ1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGng0BUOk0O1i9GFgTc" +
       "7IzEkpYdDwgWnXB2vSh2vXR9FuDbRJGc0m\nEJmflJWaXAKyC2LJxfXz8jlV" +
       "f2+FuE20ID+nMj0nvwSqA6LGUXV7qM+L/fIQNdJY1PiDTY1P/mMm\nI3vJ8Q" +
       "knM8jJHAX5xZklQPtLGCR8YJr0S0syc/QDoDLWFQUFFcDg18QTJv6lJeVAv6" +
       "diiwBVPPp8\n8vMLIHqYXU4umqF5axs4IFmS8lMqCxnqGJgrQCRTQUVBMX6D" +
       "glPzUrBZbopHjy+QnZie6pyfm1ua\nl5mcWAKP1ZVOhxl9uPfdBzuGOxeiDi" +
       "RVwiCKCCVIjEIiEurMYvxJJyg1OTWzDEsogbTzQnwpgxZ1\nATmJyake+Tkp" +
       "qUXxycsfn6px9e7sgIRSXmIu0EVCPlmJZYn6OYl56frBJUWZeenAGCthkElK" +
       "zUvO\nyE0syi7W88t3zMlMLHbKzEssqgwpSk0F2ScCAAhPTPdXAwAA"));
    
    public void run(boolean debug, String bob, int bob_port, int depth,
                    int len)
          throws Exception {
        final SJService c = SJService.create(p_bob, bob, bob_port);
        NoAliasBinaryTree bt = NoAliasBinaryTree.createDepth(depth);
        SJSocket ds = null;
        try {
            ds = c.request();
            int k = 0;
            while (SJRuntime.outsync(ds, k < 1)) {
                {
                    NoAliasBinaryTree _sjtmp_bt = null;
                    _sjtmp_bt = bt;
                    bt = null;
                    SJRuntime.pass(ds, _sjtmp_bt);
                }
                bt = (NoAliasBinaryTree) SJRuntime.receive(ds);
                k++;
            }
            bt = NoAliasBinaryTree.createDepth(depth);
            long runTime = 0;
            long timeStarted = 0;
            long timeFinished = 0;
            SJSocket s = null;
            try {
                s = c.request();
                timeStarted = System.nanoTime();
                int j = 0;
                while (SJRuntime.outsync(s, j < len)) {
                    {
                        NoAliasBinaryTree _sjtmp_bt = null;
                        _sjtmp_bt = bt;
                        bt = null;
                        SJRuntime.pass(s, _sjtmp_bt);
                    }
                    bt = (NoAliasBinaryTree) SJRuntime.receive(s);
                    if (debug) { bt.println(); }
                    j++;
                }
                timeFinished = System.nanoTime();
            }
            finally {
                SJRuntime.close(s);
            }
            runTime = (timeFinished - timeStarted) / 1000;
            System.out.println(runTime);
        }
        finally {
            SJRuntime.close(ds);
        }
    }
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        String bob = args[1];
        int bob_port = Integer.parseInt(args[2]);
        int depth = Integer.parseInt(args[3]);
        int len = Integer.parseInt(args[4]);
        new Alice().run(debug, bob, bob_port, depth, len);
    }
    
    public Alice() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238584038579L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVYfWwcRxWfvTufvw7ic5w0je2kSRxiQ3KGfqCChYptEsXp" +
       "uXZ9bojdVJe53bnz\nOns7y87c+RyF0oJE2iKBUBsaaEkkhIRaRQJStfwBCk" +
       "htgUIr1FRKq0pt/yiCSlBE/4EICuLNzO7t\n3t75WizteHbnfc17v/fmzV18" +
       "F3UwF2UYYcyk9mqGrzuEyZEWVonOWSZ3ZB67jBjTFmZsERby+on/\nmkd/mv" +
       "7q4RjSllG/TSctE7PFFZdWSiuLKyaruegGh1rrJYtyT2KTjM/ueX/txTNHBu" +
       "No0zLaZNo5\njrmpT1ObkxpfRqkyKReIyyYNgxjLKG0TYuSIa2LLPAWE1AbF" +
       "zCzZmFdcwhYIo1ZVEPazikNcqdP/\nmEUpndqMuxWdU5dx1JddxVU8XuGmNZ" +
       "41GZ/IomTRJJbBvoTuRbEs6ihauASEW7P+LsalxPFD4juQ\n95hgplvEOvFZ" +
       "EidN2+BoZ5SjvuOR24EAWDvLhK/QuqqEjeED6lcmWdgujee4a9olIO2gFdDC" +
       "0fYN\nhQJRl4P1k7hE8hxti9LNqyWg6pZuESwcbYmSSUkQs+2RmIWiNZdM/e" +
       "eh+X/eABEHmw2iW8L+JDDt\niDAtkCJxia0TxXitknlkZqkyFEMIiLdEiBXN" +
       "5N6f3ZV955c7Fc1gC5o5icW8/v6nh4avTP6xOy7M\n6HIoMwUUGnYuozrvrU" +
       "zUHED31rpEsZjxF3+18Oul+54kf4mhrhmU1KlVKdszqJvYxrQ374R51rSJ\n" +
       "+jpXLDLCZ1DCkp+SVL6DO4qmRYQ7OmDuYL4i5zUHIdQJjwaPjtRfrxg46oKE" +
       "0UmGrXL0cU4YZ8eZ\nqx8vgNdWytg9yYLpTcfxcZ+4JuR+dE3TYEtD0fSyAI" +
       "uHqWUQN6//6O3fnT54+4MPqGAJgHkWcTQc\nKMkESjI4I5UgTZPSNwswKmdN" +
       "ui5eF0lSu//K8Hd/g78PrgcXMPMUkTvU1hJiBKYb29aQ6SADZ2CG\nASB5fe" +
       "C+d7Z/75Unno+heMs6kq1/PETdMrYEFPzE6ffURVcAQSNRHLfS/beHZp+6+v" +
       "s3RgNEczTS\nlGjNnCJRdke971KdGFCIAvGP/uvw3x/u+MzTMZSA7IP6wzGg" +
       "BpJ5R1RHQ8JM+MVH7CWeRb3Fpo33\ncHDQWmjDYkyJoU8hBGIxEDFQ1q1rX0" +
       "t+8tVf9D4vd+yXuE2hWpgjXCVMOoj/oksIfH/j3PzDZ989\nc3ccUtRxVMw5" +
       "SjqVAuCmBizXNeaYMM8QsPnrpYm+bx5gz8gQd5vlcoXjgkWgJmPLomvEyHNZ" +
       "lNKh\nAijrDngiVYD6BaUwb4EgtVdHqwI8W1SIzLaBR74z9virooY40jFbRa" +
       "5JS1FNfhjRxDjatCjehwWC\nB4JtQ9afVBtIjeXuOXLigd1y52Fx+72XWl1g" +
       "kAs3t82FQ+KsAcxwCkUngMyJb7x25+yxL46rMvip\ntiLugKQ2pJyA/+yMfd" +
       "vlLVftmEBJkq3WEz+LYoxzNJr1RXrIE69qljuSU0v+UbD/gzcQKDZP/+P+\n" +
       "S384mwLFy6jTZIdMG1si2uwOlb0tjomIiFOX7zp/7SX+psRmkC7C/KFac7k7" +
       "ikOZfOvVajr5kwvl\nGOpcRn3yqMc2P4qtikDuMhzWbNr7mEUfaVhvPHjVKT" +
       "NRLwdD0VQNqY0maiLk7YSgFvMulZtOTdMc\nMbtVUu+Q4y4FphgHOcJfHHU6" +
       "rlnFov1BHU6+QAuSbjNHg/VguBWbm2UiejIPPjLjNYnszwHw9kXi\nVg+xKM" +
       "FTpGTa6sj1ziNNYe1jbbhCTHv79Cf3j148pZhG2zCF0BTWJeqOvmJahjD3Rp" +
       "Cxpy3MFPvL\nPz5Pu/f+++mYl6q9jqg3Y220z1X4Gmghrba6tw1fllJH8cS/" +
       "8MIPzo29/ow6HArUWFcWi3HKkTWy\nnaAcdAutlN/ShmcW5tCrTVMokbapyx" +
       "5XyXhi6lkt23v5LWlMb1nRLTZAbEr6pF1EFohOzGoLlwj2\nGcermQC2oVCH" +
       "4KXvFODTXRcngaCZrTWjWOJvj1dmUVBm/RoJxg1v1FzKxvjMsfdSX8fP3aP8" +
       "1N94\nmBy0K+VbLrxGxj6f0lv0NN2cOgcsUiVWvRLHVG6B2gNtETYre/GglM" +
       "Rzt43t29/7Zzi1N2hI0t7H\nBQIXD7seBdmp4P+7U9kZcUrUnnR18M74ivnb" +
       "mCwxqio1XTEamSYaa1GP22iojPegNGATuKgLnll4\n+j1IyP9iMS2GftVQiG" +
       "Gu5RHaIf0sbpDR+j7vmmXosn3EfXvHD//01NsLAyp86q60p+m6EuZR96VQ\n" +
       "xu9qp0FSP/eJXRfvXXiz4MN6EWpqgVKLYNtHd5884kW1z6hrllzIOwq6BY7i" +
       "cLMT05IcWjcO/jnv\nydwcyDxY04kjMlfqvxvEQcWOqkhUqWlIkTSUJB1iis" +
       "VAAv0hIz4c1bF6ZMWzD54lL7JLrSLb4jyS\nmQytHZP38fYOaL4yyuuCCvml" +
       "+Mh7sZ9vHZEdcKKAmZ8pjXft5qt0ww1Z2tlT39X18Oz8gF2RloG6\nWQxfrm" +
       "lInsRf2WDnE6qQwf4tYpfUVU7693Stqbg0h3/aojYR7a2/pjpKk2bqP13AYn" +
       "PDKN6XlH1S\n18YJ96Eb2gehidCFOS2Qr/qcWtvYildLSoLOMVGGbkwCtgm2" +
       "Wsg5DV9EFyMvleKw3Nb0a5D6zULf\nfeXE6LNO+gUFEv93hU643BcrlhXuqU" +
       "LzpOOSoimN6/Q7LPHvHEfXbXC/5UjD0sZHFeljHG1pScpR\nT/AS5jgfXpEL" +
       "FySSvlXT/ge6xRrjRRMAAA==");
}
