package benchmarks.benchmark3.a;

import java.util.*;
import benchmarks.benchmark1.a.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.sharedmem.*;

public class AliceCarol {
    final private static int[] lens = { 0, 1, 10, 100, 1000 };
    
    private void run(final boolean debug, final int carol_port,
                     final String bob, final int bob_port, final int depth,
                     final int repeat)
          throws Exception {
        new Thread() {
            
            public void run() {
                try {
                    new Carol(carol_port);
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
        Thread.sleep(500);
        for (int i = 0; i < repeat; i++) {
            for (int li = 0; li < lens.length; li++) {
                Thread.sleep(100);
                final int len = lens[li];
                Thread t =
                  new Thread() {
                    
                    public void run() {
                        try {
                            Alice a = new Alice();
                            a.run(debug, bob, bob_port, depth, len);
                        }
                        catch (Exception x) { throw new RuntimeException(x); }
                    }
                };
                t.start();
                t.join();
            }
        }
        KillBobCarol.main(new String[] { bob, new Integer(bob_port).toString(),
                          "localhost", new Integer(carol_port).toString() });
    }
    
    private static void configureTransports(String transports) {
        List ss = new LinkedList();
        List ts = new LinkedList();
        if (!transports.contains("d")) {
            if (transports.contains("f")) {
                ss.add(new SJFifoPair());
                ts.add(new SJFifoPair());
            }
            if (transports.contains("s")) {
                ss.add(new SJStreamTCP());
                ts.add(new SJStreamTCP());
            }
        }
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    public static void main(String[] args) throws Exception {
        String transports = args[0];
        AliceCarol.configureTransports(transports);
        boolean debug = Boolean.parseBoolean(args[1]);
        int carol_port = Integer.parseInt(args[2]);
        String bob = args[3];
        int bob_port = Integer.parseInt(args[4]);
        int depth = Integer.parseInt(args[5]);
        int repeat = Integer.parseInt(args[6]);
        new AliceCarol().run(debug, carol_port, bob, bob_port, depth, repeat);
    }
    
    public AliceCarol() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238673513972L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJ1Ya2wURRyfu2uvDw7bK4Ui9MGjBhrh6iMYoRGsDZWWA0qv" +
       "ECmQMrc3d912b3fZ\nmbsehBDwBdZoooCvCMQEYzR8UIj6QaMmgm9jggn4Bb" +
       "5glEQx8kWJQeN/Zu5u73aPq9hk52Zn/jP/\n9+//3568iiqphUKUUKoa+liI" +
       "7TIJFaMRHSMKo6FI/wC2KIn1aJjSIdgYUXb8o25+J/joGi/yDKMG\n3ejWVE" +
       "yHRi0jlRgdGlVpxkLzTEPbldAMlr3RdceKhTcmvjnQP9eH6oZRnapHGGaq0m" +
       "PojGTYMAok\nSTJKLNodi5HYMArqhMQixFKxpu4GQkMHxlRN6JilLEIHCTW0" +
       "NCdsoCmTWIJnbjGMAoqhU2alFGZY\nlKH68BhO484UU7XOsEpZVxj54yrRYn" +
       "Qn2ou8YVQZ13ACCGeFc1p0ihs7e/k6kNeqIKYVxwrJHakY\nV/UYQ23OE3mN" +
       "29cCARytShI2auRZVegYFlCDFEnDeqIzwixVTwBppZECLgzNuemlQFRtYmUc" +
       "J8gI\nQ7OddANyC6hqhFn4EYZmOsnETeCzOQ6fFXhrgz/w9+TAn/PA4yBzjC" +
       "gal98Ph1odhwZJnFhEV4g8\neD0VOty3JdXsRQiIZzqIJU33He9vCl/5uE3S" +
       "zC1Bs0HE4ohy477mlnPdP9b4uBjVpkFVHgpFmguv\nDmR3ujImRPes/I18M5" +
       "Tb/GTwsy373iK/eFF1H/IrhpZK6n2ohuixnuy8CuZhVSdydUM8TgnrQxWa\n" +
       "WPIb4h3MEVc1ws1RCXMTs1Exz5gIoSp4PPCkkPybwQeGpkPCKKQHW4YWomMM" +
       "dTJCGd1GLWVbFEw3\nmsTWOLWn927D24pOZDiH2yY8HlCu2ZloGkTlGkOLEW" +
       "tEeePyV3tWr33qoHQbD7WsbAwtsDmFbE4h\nHLI5IY9HsJjBY1Partuy8C6e" +
       "M5n951pe/hwfBU+ARai6mwiFPRMVfIRD95SFlB47IftghiFeRpTG\nfVfmvP" +
       "L9m2e9yFcSVsL5xV7DSmKNR0Yujxqy7Jw7EFDtzrAuxfu3yXWnz399cbEd4A" +
       "y1u/LOfZLn\nzQKnCyxDITHAJfv6F/9a8/uhyuXvelEFJCPAEcMQRJDbrU4e" +
       "RfnTlcMirosvjKbFXYrXMjDQRIHC\nfAzwoV6GCfii0SGggLHrj/nvuvDhtL" +
       "NC4xzi1RVAY4QwmT9B2/9DFiGwfvGlgUNHrh7Y6oOMNU3p\nc4b8ZioKwZOB" +
       "I03FKcfFi/Gw+fVUV/2zS+l7wsU1ajKZYjiqEYBorGnGBImNMIFRwQI8FDAE" +
       "lghE\nAc4AGUc0uEjqanrSEJ4lACM0u/HwCx2vXuCQYgrDzOKpJyRFGbHQ7u" +
       "HjYtcmf2/hEdxoqw0gMC4V\nCHREtvfvOLhAaF543ZLsSyZ/oZ0LS8rmQi8v" +
       "PXaoqHv+2H/quyMBL/IOoyqV9qo61rix6HoZ/CVA\n13HF7o82Hbv+LbskXG" +
       "tHGxesOeOGjM24IBHuP58O+t8+nvSiqmFULwon1tlmrKW444eh9NGe7GIY\n" +
       "TS/aLy5jErO78tnU7Iz0ArbOOLehCuacms+rZWgLmjqwLLdxFzwzs+Aqfvlm" +
       "kA8NGY/H5JNl4kCr\nGOdLl/kYsONmZajKtNQ0ZiC7n4oOJMMA4IlOqbseCv" +
       "CTJeuUr/2a94NZ7SKfK6KYSgmdjYS7Tygq\n/0KhWpMnjNOjA5aahCqVzpbR" +
       "51pP/HT68mCjhCfZayx0lfvCM7LfEBymCQ7zy3EQ1GfunH9y7+Cl\nqKzDDc" +
       "UpvFpPJZcd/4F0PBhQSpQTH2jqinz+freZ8SDhiIfdjvDy+XI+LAS7+8HuCV" +
       "k+u/mw0s4l\nryQX7zNYtiLxMIMmxdAJx5Dcnkxb1Qjl20XYLJWVbQ6DrBOe" +
       "sTMhmJ670TeqfuEVESmD2NXfFR/q\nKg7dWotAe6oPFQXwXFP8rHRbwyMNUR" +
       "adpoSuCMS2wm2Ss0e9bSuZkrIseCT5kLwQ2RfmgAws1HKz\nhlCEy4FHrgWe" +
       "xGe2e7OcexiqYYa5VCNpouVl88mMg9uWlkVBp/V9kVUdi5ZM+xky7CbNQDC7" +
       "OFhs\nZNEl4FvsEvi4MY8sNfA8AU9TFlmaHMgi62pp/60o7SK/oPCL91WmpH" +
       "kI4CdqGBrBuoj5Eh6T3wL5\njJBDaQ6FSVecIqszCjF5xysEB+TwWSndKUlF" +
       "2lBj4kpWEAZ+Ph3Ls06WlOQWSJW8jeuz6B3O2jj8\n32wsEGMFH7rKmkGIMH" +
       "W27AJDQQ2Lqwlo14YsrFPTsKQBmMsYhZe6V2zV+LMInnhWtfgtqLZwatXE\n" +
       "+wN5brfD0zYFt2RpaObD0zl4fqY8PPOxP+/OSRc089cwH9a7sVZkl2QmDhcA" +
       "z/+Fuef5MMyHrZkp\nA2GnOPI4BHkSGqEyzp10OXcyA4Wp1v4m4v3wbNf/Nu" +
       "QXuLLg3I7Fn5rBL2VXkPtKroJP1XhK0wp7\nmoK537RIXBUSVskORxaIYww1" +
       "3eQbjSEPFoIelaSvwUd9SVIQ3X4pPHGicEdsvG5KY6J/AZ8SxcoT\nEgAA");
}
