package benchmarks.benchmark3.c;

import sessionj.runtime.*;
import sessionj.runtime.net.*;
import benchmarks.BinaryTree;

public class Alice {
    final private SJProtocol p_bob =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9nJ1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGng0BUOk0O1i9GFgTc" +
       "7IzEkpYdDwgWnXB2vSh2vXR9FuDbRJGc0m\nEJmflJWaXAKyC2LJxfXz8jlV" +
       "f2+FuE20ID+nMj0nvwSqA6LGUXV7qM+L/fIQNdJY1PiDTY1P/mMm\nI3vJ8Q" +
       "knM8jJHAX5xZklQPtLGCR8YJr0S0syc/QDoDLWFQUFFcDg18QTJv6lJeVAv6" +
       "diiwBVPPp8\n8vMLIHqYXU4umqF5axs4IFmS8lMqCxnqGJgrQCRTQUVBMX6D" +
       "glPzUrBZbopHjy+QnZie6pyfm1ua\nl5mcWAKP1ZVOhxl9uPfdBzuGOxeiDi" +
       "RVwiCKCCVIjEIiEurMYvxJJyg1OTWzDEsogbTzQnwpgxZ1\nATmJyake+Tkp" +
       "qUXxycsfn6px9e7sgIRSXmIu0EVCPlmJZYn6OYl56frBJUWZeenAGAM6NCk1" +
       "Lzkj\nN7Eou1jPKTMvsagypCg1FWSRCABU8+bUUAMAAA=="));
    
    public void run(boolean debug, String bob, int bob_port, int depth,
                    int len)
          throws Exception {
        final SJService c = SJService.create(p_bob, bob, bob_port);
        BinaryTree bt = BinaryTree.createDepth(depth);
        SJSocket ds = null;
        try {
            ds = c.request();
            int k = 0;
            while (SJRuntime.outsync(ds, k < 1)) {
                SJRuntime.send(ds, bt);
                bt = (BinaryTree) SJRuntime.receive(ds);
                k++;
            }
            bt = BinaryTree.createDepth(depth);
            long runTime = 0;
            long timeStarted = 0;
            long timeFinished = 0;
            SJSocket s = null;
            try {
                s = c.request();
                timeStarted = System.nanoTime();
                int j = 0;
                while (SJRuntime.outsync(s, j < len)) {
                    SJRuntime.send(s, bt);
                    bt = (BinaryTree) SJRuntime.receive(s);
                    if (debug) { bt.println(); }
                    j++;
                }
                timeFinished = System.nanoTime();
            }
            finally {
                SJRuntime.close(s);
            }
            runTime = (timeFinished - timeStarted) / 1000;
            System.out.println(runTime);
        }
        finally {
            SJRuntime.close(ds);
        }
    }
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        String bob = args[1];
        int bob_port = Integer.parseInt(args[2]);
        int depth = Integer.parseInt(args[3]);
        int len = Integer.parseInt(args[4]);
        new Alice().run(debug, bob, bob_port, depth, len);
    }
    
    public Alice() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238584038537L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVYfWwcRxWfvTufvw7ic5w0xHbSJE5jQ3KG0qKChYptEsXp" +
       "uXZ9bkiuqS57u3Pn\ncfZ2lp258zkKpQWJtEUCoTY00JJIqFLVKhI0VcsfoI" +
       "DUFigfQgQprZBa/iiCSlBE/4EICuLNzO7t\n3t75WizteHbnfc17v/fmzV16" +
       "G3UxF2UYZoxQezXD1x3M5EiLq9jgLJM7sqi7DJuzls7YMiwUjJP/\nJUefTX" +
       "/pcAxpeTRo02mL6Gx5xaXV8sryCmF1F93oUGu9bFHuSWyR8ak976796uyR4T" +
       "jalEebiJ3j\nOifGLLU5rvM8SlVwpYhdNm2a2MyjtI2xmcMu0S1yGgipDYoZ" +
       "Kds6r7qYLWFGrZogHGRVB7tSp/8x\ni1IGtRl3qwanLuNoILuq1/TJKifWZJ" +
       "YwPpVFyRLBlsk+j+5DsSzqKll6GQi3Zv1dTEqJk4fEdyDv\nI2CmW9IN7LMk" +
       "ThHb5GhnlKOx47E7gABYuyuYr9CGqoStwwc0qEyydLs8meMusctA2kWroIWj" +
       "7RsK\nBaIeRzdO6WVc4GhblG5RLQFVr3SLYOFoS5RMSoKYbY/ELBSthWTqPw" +
       "8v/vNGiDjYbGLDEvYngWlH\nhGkJl7CLbQMrxuvVzKNzx6sjMYSAeEuEWNFM" +
       "7/3B3dm3frxT0Qy3oVmQWCwY735iZPTq9B9748KM\nHocyIqDQtHMZ1UVvZa" +
       "ruALq3NiSKxYy/+JOlnx6//xn8lxjqmUNJg1rVij2HerFtznrzbphniY3V\n" +
       "14VSiWE+hxKW/JSk8h3cUSIWFu7ogrmj8xU5rzsIoW54NHhMpP5SYuCoBxLG" +
       "wBm2ytGHOWacnWCu\ncaIIXlup6O4pFkw/fsI44RPXhdwPrmkabGkkml4WYP" +
       "EwtUzsFoyn3vzFmYN3PPSgCpYAmGcRR6OB\nkkygJGNkpBKkaVL6ZgFG5axp" +
       "19XXRZLUH7g6+q2f6d8B14MLGDmN5Q61tYQYgenmjjVkNsjAOZjp\nAJCCMX" +
       "T/W9u//bunX46heNs6km18PETdim4JKPiJM+ipi64AgsaiOG6n+28Pzz937Z" +
       "evjweI5mis\nJdFaOUWi7I5636UGNqEQBeIf+9fhvz/S9cnnYygB2Qf1h+uA" +
       "GkjmHVEdTQkz5RcfsZd4FvWXWjbe\nx8FBa6ENizElhgGFEIjFUMRAWbeufz" +
       "n50Vd/1P+y3LFf4jaFamEOc5Uw6SD+yy7G8P3184uPnHv7\n7D1xSFHHUTHn" +
       "KOlUi4CbOrDc0JxjwjxTwOavl6cGvnaAvSBD3EsqlSrXixaGmqxbFl3DZoHL" +
       "opQO\nFUBZd8ATqSLULyiFBQsEqb06Wg3g2aZCZLYNPfrNiSdeFTXEkY7ZKn" +
       "JNWorq8sOYJsbxlkXxPioQ\nPBRsG7L+lNpAaiJ375GTD+6WOw+L2++91BsC" +
       "g1y4pWMuHBJnDWCGUyg6AWROfvW1u+aPfW5SlcGP\ndRRxJyS1KeUE/Ofm7N" +
       "uvbLlmxwRKkmy1kfhZFGOco/GsL9JDnnhVs9yRnFryj4L9772BQDE5848H\n" +
       "Lv/mXAoU51E3YYeIrVsi2uxOlb1tjomIiNNX7r5w/df8DYnNIF2E+SP11nJ3" +
       "VA9l8m3Xaunk9y9W\nYqg7jwbkUa/b/KhuVQVy83BYs1nvYxZ9oGm9+eBVp8" +
       "xUoxyMRFM1pDaaqImQtxOCWsx7VG46dU1z\nxOw2Sb1DjrsUmGIc5Ah/cdTt" +
       "uKSmi/YHdTmFIi1Kus0cDTeC4VZtTipY9GQefGTGaxLZnwbg7YvE\nrRFiUY" +
       "JncJnY6sj1ziNNYe2mDlwhpr0DxjP7xy+dVkzjHZhCaArrEnXHWCGWKcy9GW" +
       "Ts6Qgzxf7b\n712gvXv//XzMS9V+R9SbiQ7aF6p8DbTgdlvd24EvS6mjeOKf" +
       "feW75yd+/4I6HIrUXFcWi3HGkTWy\nk6AcdAvtlN/agWce5tCrzVIokTYxZI" +
       "+rZDw986KW7b/yB2lMf0XRLTdBbEb6pFNElrCBSa2NSwT7\nnOPVTADbllCH" +
       "MAPAdNfFESAW5+ut8JXA2+PVVxTUV784glWjG3WVsiM+e+yd1Ff0l+5VDhps" +
       "PkUO\n2tXKrRdfwxOfSRltmpleTp0DFq5hq1GCYyqpQO2BjtCal014UEPiud" +
       "sn9u3v/zMc1xt0Imnv4xKG\nG4fdcL9sUfT/u0XZGXFK1J50bfiu+Ar5eUzW" +
       "FlWOWu4WzUxTzUWoz202VAZ6WBqwCVzUA888PJs9\nLMj/YjEthkHVSYhhoe" +
       "3Z2SX9LK6O0cK+6JIKtNc+1L6x48k/Pffm0pAKn7ok7Wm5p4R51EUplOq7\n" +
       "OmmQ1C99ZNel+5beKPp4XoZiWqTUwrrtw3pAnu2izGfU/UouFBwF3SJHcbjS" +
       "iWlZDu07Bv+A92Ru\nDmQerBvYESkr9d8D4qBUR1UkapSYUiQNJUmXmOpiwI" +
       "H+kBHvj+pYI7Li2QdP3otsvl1k2xxEMpOh\np2PyIt7ZAa13RXlPUCG/HB97" +
       "J/bDrWOy9U0UdeZnSvMlu/UO3XQ1lnb2NXb1IXh2vseucNtA3SKG\nL9Q1JI" +
       "/gL26w8ylVyGD/FrbL6g4n/Xum3lJcWsM/a1Ebi77WX1OtJKGZxm8WsNjaKY" +
       "r348o+qWvj\nhHvfnexD0D0Ywpw2yFcNTr1jbMWrJSVBy5ioQBsmAdsCWy3k" +
       "nKYvon2Rt0lxSm5r+RlI/Vhh7L56\ncvxFJ/2KAon/g0I33OpLVcsKN1Ohed" +
       "JxcYlI47r91kr8O8/RDRtcbDnSDGnjY4r08eYTLiDlqC94\nCXNcCK/IhYsS" +
       "SV+va/8Dsl160z4TAAA=");
}
