package benchmarks.benchmark3.c;

import sessionj.runtime.*;
import sessionj.runtime.net.*;
import benchmarks.*;

public class Bob {
    final private SJProtocol p_alice =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9gp1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGvisgkih28Xow8CanJ" +
       "GZk1LCoOED064P1qQP166Pot0aaJMymk0g\nMj8pKzW5BGQXxJKL6+flc6r+" +
       "3gpxm2hBfk5lek5+CVQHRI2j6vZQnxf75SFqpLGo8QebGp/8x0xG\n9pLjE0" +
       "5mkJM5CvKLM0uA9pcwSPjANOmXlmTm6AdAZawrCgoqivGHiWdeOdDrqdjCXx" +
       "WPNp/8/AKI\nHmaXk4tmaN7aBg5HlqT8lMpChjoG5goQyVRQUUDA/qDU5NTM" +
       "Mqz2m+LR5gtkJ6anOufn5pbmZSYn\nlsDjdaXTYUYf7n33we7hzoWoA0mVMI" +
       "giwgkSp5CohLq0GL+Pg1PzUjBdCdLLC/GlDFrMBeQkJqd6\n5OekpBbFJy9/" +
       "fKrG1buzAxJKeYm5QOcI+WQlliXq5yTmpesHlxRl5qUDIwzoyqTUvOSM3MSi" +
       "7GI9\np8y8xKLKkKLUVJBFIgDUelUBTwMAAA=="));
    final private SJProtocol p_carol =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9nJ1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGng0BUOk0O1i9GFgTc" +
       "7IzEkpYdDwgWnXB2vSh2vXR9FuDbRJGc0m\nEJmflJWaXAKyC2LJxfXz8jlV" +
       "f2+FuE20ID+nMj0nvwSqA6LGUXV7qM+L/fIQNdJY1PiDTY1P/mMm\nI3vJ8Q" +
       "knM8jJHAX5xZklQPtLGCR8YJr0S0syc/QDoDLWFQUFFcDg18QTJv6lJeVAv6" +
       "diiwBVPPp8\n8vMLIHqYXU4umqF5axs4IFmS8lMqCxnqGJgrQCRTQUVBMX6D" +
       "glPzUrBZbopHjy+QnZie6pyfm1ua\nl5mcWAKP1ZVOhxl9uPfdBzuGOxeiDi" +
       "RVwiCKCCVIjEIiEurMYvxJJyg1OTWzDEsogbTzQnwpgxZ1\nATmJyake+Tkp" +
       "qUXxycsfn6px9e7sgIRSXmIu0EVCPlmJZYn6OYl56frBJUWZeenAGAM6NCk1" +
       "Lzkj\nN7Eou1jPKTMvsagypCg1FWSRCABU8+bUUAMAAA=="));
    
    public Bob(boolean debug, int port, String carol, int carol_port)
          throws Exception {
        super();
        ServerThread st = this.new ServerThread(debug, port, carol, carol_port);
        st.start();
    }
    
    private class ServerThread extends Thread {
        private boolean debug;
        private int port;
        private String carol;
        private int carol_port;
        
        public ServerThread(boolean debug, int port, String carol,
                            int carol_port) {
            super();
            this.debug = debug;
            this.port = port;
            this.carol = carol;
            this.carol_port = carol_port;
        }
        
        public void run() {
            SJServerSocket ss = null;
            try {
                boolean run = true;
                ss = SJServerSocketImpl.create(p_alice, port);
                new KillThread(port + Kill.KILL_PORT_ADJUST,
                               ss.getCloser()).start();
                final SJService c =
                  SJService.create(p_carol, carol, carol_port);
                BinaryTree bt = null;
                for (int counter = 0; run; counter++) {
                    SJSocket ds1 = null;
                    SJSocket ds2 = null;
                    try {
                        ds1 = ss.accept();
                        ds2 = c.request();
                        while (SJRuntime.outsync(ds2, SJRuntime.insync(ds1))) {
                            bt = (BinaryTree) SJRuntime.receive(ds1);
                            SJRuntime.send(ds2, bt);
                            bt = (BinaryTree) SJRuntime.receive(ds2);
                            SJRuntime.send(ds1, bt);
                        }
                        SJSocket alice = null;
                        SJSocket bob = null;
                        try {
                            alice = ss.accept();
                            bob = c.request();
                            while (SJRuntime.outsync(bob,
                                                     SJRuntime.insync(alice))) {
                                bt = (BinaryTree) SJRuntime.receive(alice);
                                SJRuntime.send(bob, bt);
                                if (debug) { bt.println(); }
                                bt = (BinaryTree) SJRuntime.receive(bob);
                                SJRuntime.send(alice, bt);
                            }
                            if (debug) { bt.println(); }
                        }
                        finally {
                            SJRuntime.close(new SJSocket[] { alice, bob });
                        }
                    }
                    catch (Exception x) { run = false; }
                    finally {
                        SJRuntime.close(new SJSocket[] { ds1, ds2 });
                    }
                    System.out.println("Finished run: " + counter);
                    if (debug) { System.out.println(); }
                }
            }
            catch (Exception x) { throw new RuntimeException(x); }
            finally {
                if (ss != null) ss.close();
            }
        }
        
        final public static String jlc$CompilerVersion$jl = "2.3.0";
        final public static long jlc$SourceLastModified$jl = 1238671680714L;
        final public static String jlc$ClassType$jl =
          ("H4sIAAAAAAAAAJVXW2xURRievXS3l5WypUCl9wuRBro1GIzYGC2Fpi0L1LYQ" +
           "WUuW2XNmd0979pzD\nmTnbhRACmgjyQGIAb1F5MTEaHhSivhg1EbwbE0zAF3" +
           "jBKIli9EWJQeM/c87ezm5r3GRmZ2f+y8z/\nf/83s+dvoxpqoggllCq6Nhdh" +
           "Bw1CRa8n5ojEaGR6YhKblMgjKqZ0Bhbi0v5/lD3vhJ8a8yJPDDVp\n+rCqYD" +
           "qTNnUrlZ5JKzRnoi5DVw+mVJ05FitsPNx7d+Hr4xOtPtQYQ42KNs0wU6QRXW" +
           "Mkx2IolCGZ\nBDHpsCwTOYbCGiHyNDEVrCqHQFDXwDFVUhpmlknoFKG6muWC" +
           "TdQyiCl85iejKCTpGmWmJTHdpAwt\nj87hLB60mKIORhXKhqIokFSIKtMD6A" +
           "jyRlFNUsUpEFwVzZ9iUFgcHOXzIF6vwDbNJJZIXsU/r2gy\nQ51ujcKJ+7aD" +
           "AKgGM4Sl9YIrv4ZhAjXZW1KxlhqcZqaipUC0RrfAC0NrFjUKQrUGluZxisQZ" +
           "anHL\nTdpLIFUnwsJVGFrpFhOWIGdrXDkrydauQOjvk5N/dkHGYc8ykVS+/w" +
           "AodbiUpkiSmESTiK14x4qc\nGd9rtXkRAuGVLmFbZnjt+7ujtz7qtGVaq8js" +
           "EliMS3cfbGu/MvxDnY9vo9bQqcKhUHZykdVJZ2Uo\nZwC6VxUs8sVIfvHjqU" +
           "/3Hn2L/OxFteMoIOmqldHGUR3R5BFnHIRxVNGIPbsrmaSEjSO/KqYCuvgN\n" +
           "4UgqKuHhqIGxgVlajHMGQqgOGpwKnUL2p4N3DAW26IkInWNoHSOU0VlqSrMJ" +
           "iFk6g815Whw+MCvN\n2qI5bnPZgscDx2lzl5YKOBzTVZmYcemNm18e3rb92R" +
           "N2oji4nN2As6KLSNFFRIqAiz6orSwAJG0S\nLCOPRzhawTFpx2zYNPFBXiu5" +
           "Y1faX/oMvwoZgEhQ5RARB/Us+HkPShuXpJKRYiGOwwgDTuJS89Fb\na17+7s" +
           "3LXuSrSifRwuSobmawyhGRr58mx517BYDU54ZzNd+/ntxx8epX19cVgc1QX0" +
           "W9VWryeulx\nJ8LUJSIDHxXNv/DX2G+naza/60V+KEKgIYYBPFDTHW4fZXUz" +
           "lOcgfhZfFDUkKw5ezyBACyUH5n1I\njBsd5PmgrXeQt5Z3fDHMuyYbT5CuZt" +
           "cZBMPdeTpw/7UPGi6LoOTJsLGENacJs0srXITIjEkIzF9/\ncfL02dvHnwTn" +
           "OcOwYQGIN6yEqkg5UFldXo38BDJH1i8XhpafGqDvCRTUKZmMxXBCJcDeWFX1" +
           "BSLH\nmaCvcAlVCoaCYIUSwHRAmnEVDNnhMDxZQHAVLom0NJ95vv+Va5xtDB" +
           "GvVbBHv9ipn1YS2qSpZIAv\nsg6hPdfx+o8Xb04124CxWb+3gnhLdWzmFxFv" +
           "MHgEupfyIKQvre8+f2TqRsJmxKbyiG3TrMymc9+T\n/sdCUpUyDyZ0XSVYE0" +
           "dbDw75d4QhH9xZYrwCbkCRNh7CiH3b8PmNtuhaD+/7C5FBIjJI7L+dV3hz\n" +
           "MedAjvN29kL90/sm9p/oEWm3Y8kVBoRh3m0qcbF5CYFclZRsWJJTRvnVXSw5" +
           "5fAfxy58ezbkRd4Y\nCip0VNGwyhFFd9okUuXScpk49OHu1+58w26I6Barlm" +
           "+sLVdJwHtwCaE8dDUbDrx9LuNFwRhaLh4e\nWGN7sGrx6ojB04GOOJNRdE/Z" +
           "evkzwL7zhgqs1OYGWYlbN18UEQFjLs3HtS6KqIfWAq3LoYguF0V4\nPAYfbB" +
           "EKnaLvKRR00DCVLOZvNVQjk4SVKiRzGVwD/PuRMkcroHU7jrqrOxrj3VYGd6" +
           "husgIsqptb\nDa3HMddT3dx2x1yNhE1dLSBsGUJV7N0Lrdex11vd3k7HXr2w" +
           "F3dvUgR3q11BqFhBm53qARS3L/a8\nEiV//InfQ8/gS/u8TqkNAmk6b+B8QR" +
           "Qv2YElC2KHeGEWIembfrT/vg0NP8EltMj9GnYmpwg8p7WZ\nPGDExYv/98Xb" +
           "6Tqoez/hbOvjvrTyuVdA1UZ3xcO5XGmoHNP1ZvlGRcRayy4/DrgBJ6MD1S4/" +
           "3nUv\nyXj/SYcxYFXTqmBaf1ZXZKGGyzFQ+gMKJ1T66MpTc+sSrzTIfEvF/y" +
           "r79S/1XNm/7hMj/IV4aRRe\n6EF4JictVS3lg5JxwDBJUhFnCdrsYIgveJqu" +
           "XmQfDHkksVfFFs3AH4qqolApxR+lGkbpilg4YFS5\nmOyw5NC/ZkOvFqMOAA" +
           "A=");
    }
    
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        int port = Integer.parseInt(args[1]);
        String carol = args[2];
        int carol_port = Integer.parseInt(args[3]);
        new Bob(debug, port, carol, carol_port);
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238671680714L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVYb2wcxRWfvTuf/12bnOP8aezEJLGJLZJzS5uq1B9S55o0" +
       "dtbE8TkhGFNnbm/u\nvM7e7rIzdz5bEYJWIkCrCgQpoX8SqapUgSIVgoAPrQ" +
       "IS0JbSqmoqBYQEfABRpJaqfGmjllZ9M7N7\nu7d33qiWbjw38968N29+7zdv" +
       "7tLHqI06KEMJpbplLmXYik2oaK38EtEYzeQmp7FDSSFrYEpnYWJB\nO/Vf/c" +
       "Sz6W8djiFlDvWY1rihYzq76FiV0uLsok5rDrrJtoyVkmExd8WmNb6669Pl35" +
       "2d7IujdXNo\nnW7mGGa6lrVMRmpsDqXKpJwnDh0vFEhhDqVNQgo54ujY0FdB" +
       "0DLBMNVLJmYVh9AZQi2jygV7aMUm\njrDpDaoopVkmZU5FY5ZDGVqvLuEqHq" +
       "0w3RhVdcrGVJQs6sQo0HvQvSimoraigUsguEn1djEqVhw9\nxMdBvEsHN50i" +
       "1oinkjitmwWGBsIa9R0PHgEBUG0vE7Zo1U0lTAwDqEe6ZGCzNJpjjm6WQLTN" +
       "qoAV\nhrauuSgIddhYO41LZIGhLWG5aTkFUp0iLFyFoY1hMbESnNnW0JkFTu" +
       "toMvWfh6f/eROcOPhcIJrB\n/U+C0vaQ0gwpEoeYGpGK1yuZxyfurPTHEALh" +
       "jSFhKTM+9OJx9aOXBqRMXwuZowKLC9qnX+7fdnX8\ng844d6PDtqjOodCwc3" +
       "Gq0+7MWM0GdG+qr8gnM97kyzO/uvO+p8lfYqhjAiU1y6iUzQnUScxC1u23\n" +
       "Q1/VTSJHjxaLlLAJlDDEUNIS3yEcRd0gPBxt0LcxWxT9mo0QaoePAp8nkfzr" +
       "5g1DyQNWPkOXGBpm\nhDI6Tx1tPg8xWyxj5zT1u1+c1+alaI2v+dllRYHt9I" +
       "dTywAcHraMAnEWtJ+9/9szB4889KA8KA4u\n1xuG+nwTGd9ERsuACaQoYu0N" +
       "HIYyTOOOg1d4etTuv7rtyV/jH0PQYfNUXyVib8pygregdGske2T9\n3JuAHg" +
       "ZoLGi993209Qd/euq1GIq3ZBC1PnjIcsrY4CDwUqbHNReeAewMhhHcyvbfHp" +
       "567tob7wz7\nWGZosCnFmjV5iuwMx96xNFIACvKXf+Jfh//+WNttz8dQAvIO" +
       "mIdhwAuk8fawjYZUGfNoh+8lrqLu\nYtPGuxgEaDmwYd6mRH8dHEUHfCCFUL" +
       "8Lts284ZNp3vRICMFx9Yb2IEjt+reTn3/zl92viaB4/Lcu\nQJQ5wmQ2pX2I" +
       "zDqEwPg756cfO/fx2bvikL+2LWEBILcreUPXaqCyuTEB+Q4KHFl/vTy2/nt7" +
       "6QsC\nBZ16uVxhOG8QIGxsGNYyKSwwwVjpADsKUoJgpfJAbsCTCwYsJMNhK1" +
       "VAcAv6yGzpffz7Iz96kxOM\nLeK1CXxMCE8TtJnDph29DBRRdTns0e0//fC5" +
       "92d6JWAk0e9q4tqgjiR7EfFum0dgR5QFIf3qLTsu\n3Tvzbl6SYE9jxA6alf" +
       "K+i2+Rka+ltBaZ3Z63LINgU2ztFjDI/2cYisM1Jfob4NITx8ZDmJEXDB+/\n" +
       "VYoOKbwdqUfGS21XdYOverCmEZuTp9jbNp79vT4egCtPy5NNjeTunjz14E4B" +
       "CRlnrrBXGOXNvoD5\nsQiBWt2pmJCKgcUvRfLNIX6TQ14yCyjdT8tT33nr2N" +
       "TJO0ZlfL8QucTtENyCWMfXPzdh7r+y8ZoZ\n45mYpEv1A1DBJwZUrnpLuoDg" +
       "X2UvN5mTU95Fu+fGG/AN62f+cf/lP5xLgeE51K7TQ7qJDZ4u9HbJ\nkC0u4d" +
       "ASq1eOX7j+e/augI5PSdz9/lrzhXICB9jyK9eq6eQzF8sx1D6H1otCCpvsBD" +
       "YqPPXnoBSi\nWXdQRZ9pmG8sa+QdPlan3P5wBgXMhskwEYh2gkvzfofkP7um" +
       "KDbvfUNID4h2pwRdjME6PF6QI7aj\nVzEvLqG7AGWkW7sBvvvqx+FUTKaXCa" +
       "95XQAJ0lREfqgAvd2hk6sfMqjkDpCSbkrKcClYkWi7OUIr\noDS0Xnt6z/Cl" +
       "Vak0HGXKx1PQFqdubVE3CtzdcVhjVyTQpPoff37B6hz69/Pcqk9YUdYnzGUw" +
       "Qlrt\ndChCTbUsW+rEv/76T86PvP2CpLK8VViRDvP2mC1umSj7M0QjdXJutL" +
       "8vQm0K+lANZy24Z0xdE68I\nucZTB15R1O4r7wl/ustSbrYBZsdEVKK2l4MS" +
       "sdklrnvSdm8dwNrGQBF2AJDprPBLlE/OC5H9dTh/\nswWceX+SN0ckjDXsSI" +
       "hOBXCKb4DT7Bo45brTYpsjEdpHK2yN0+f6x72tzrm30B0wIHYnGiGzQ945\n" +
       "yL9z5AWAuOlta71BxCV59uQnqQfwq3d75kYZ6mSWvdcgVWI0XV8O2huJ/ynx" +
       "EvOpLp7bP7J7T/ef\noXJboyhNu4MzBJ6dZh0holrF/3e1OhDaa9ifdLXvWH" +
       "xR/01MUKBkzaYHZqPSWCNXdjmNjoqg9dUr\nRv7ZDZ9H3GN8pGXF2BqGg1Dh" +
       "UfFmj64hmp+V4mEh4XM5PvhJ7BebBkWtnMhj6sWz8T3e/NxueEUL\nP7vqu/" +
       "ocfAZusKt9LWudLG9WawoSkD0TlYCDkIBJg5gl+dwTJctKc7HSXEFlDcskvM" +
       "r15mT9pFuZ\n+s8bMFlr6Z8l/RO2ApkUijzysilqkn9/AG5HjbvTokaUt3Ut" +
       "8mz519vESvcwlChDTREuQBNVSy8I\nuUcDia4EgtUwAjGNw2OU8/+Wpt+P5K" +
       "8c2s6rp4ZfsdOvS8h4v0S0q6ijWDGMYJ0Q6CdthxR14Wq7\nVzXwf+cZ2rzG" +
       "q5ghRRMePiFFf9jI3b4oQ13+l6DGheCMmLgocPXdmvI/kxdtVncTAAA=");
}
