package benchmarks.benchmark3.c;

import sessionj.runtime.*;
import sessionj.runtime.net.*;
import benchmarks.*;

public class Carol {
    final private SJProtocol p_bob =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9gp1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGvisgkih28Xow8CanJ" +
       "GZk1LCoOED064P1qQP166Pot0aaJMymk0g\nMj8pKzW5BGQXxJKL6+flc6r+" +
       "3gpxm2hBfk5lek5+CVQHRI2j6vZQnxf75SFqpLGo8QebGp/8x0xG\n9pLjE0" +
       "5mkJM5CvKLM0uA9pcwSPjANOmXlmTm6AdAZawrCgoqivGHiWdeOdDrqdjCXx" +
       "WPNp/8/AKI\nHmaXk4tmaN7aBg5HlqT8lMpChjoG5goQyVRQUUDA/qDU5NTM" +
       "Mqz2m+LR5gtkJ6anOufn5pbmZSYn\nlsDjdaXTYUYf7n33we7hzoWoA0mVMI" +
       "giwgkSp5CohLq0GL+Pg1PzUjBdCdLLC/GlDFrMBeQkJqd6\n5OekpBbFJy9/" +
       "fKrG1buzAxJKeYm5QOcI+WQlliXq5yTmpesHlxRl5qUDIwzoyqTUvOSM3MSi" +
       "7GI9\np8y8xKLKkKLUVJBFIgDUelUBTwMAAA=="));
    
    public Carol(boolean debug, int port) throws Exception {
        super();
        ServerThread st = this.new ServerThread(debug, port);
        st.start();
    }
    
    private class ServerThread extends Thread {
        private boolean debug;
        private int port;
        
        public ServerThread(boolean debug, int port) {
            super();
            this.debug = debug;
            this.port = port;
        }
        
        public void run() {
            SJServerSocket ss = null;
            try {
                boolean run = true;
                ss = SJServerSocketImpl.create(p_bob, port);
                new KillThread(port + Kill.KILL_PORT_ADJUST,
                               ss.getCloser()).start();
                BinaryTree bt;
                for (int counter = 0; run; counter++) {
                    SJSocket ds = null;
                    try {
                        ds = ss.accept();
                        while (SJRuntime.insync(ds)) {
                            bt = (BinaryTree) SJRuntime.receive(ds);
                            bt.inc();
                            SJRuntime.send(ds, bt);
                        }
                        SJSocket bob = null;
                        try {
                            bob = ss.accept();
                            while (SJRuntime.insync(bob)) {
                                bt = (BinaryTree) SJRuntime.receive(bob);
                                bt.inc();
                                SJRuntime.send(bob, bt);
                                if (debug) { bt.println(); }
                            }
                        }
                        finally {
                            SJRuntime.close(bob);
                        }
                    }
                    catch (Exception x) { run = false; }
                    finally {
                        SJRuntime.close(ds);
                    }
                    System.out.println("Finished run: " + counter);
                    if (debug) { System.out.println(); }
                }
            }
            catch (Exception x) { throw new RuntimeException(x); }
            finally {
                if (ss != null) ss.close();
            }
        }
        
        final public static String jlc$CompilerVersion$jl = "2.3.0";
        final public static long jlc$SourceLastModified$jl = 1238671639887L;
        final public static String jlc$ClassType$jl =
          ("H4sIAAAAAAAAAJVXX2wURRifu2vv+uekvVKg0n9QSqQCV4NR1D5IaWhaOKS2" +
           "hUgtKXO7c3fT7u2u\nO7PXgxACmgjyYGIA/0XlxcRoeFCI+mLURPC/McEEfI" +
           "EXjJIoRl+UGDR+M7t3e7d3rfGSnZ2d+b75\n5vu+3/ebubM3US2zUJwRxqih" +
           "z8b5AZMw2RrJWaJwFp/YPoYtRtQhDTM2CRMzyv5/6J53Yk+OBFFg\nCrXoxq" +
           "BGMZvMWIadzkxmKMtbaJVpaAfSmsHdFSvWeGjN7fmvj21vD6GmKdRE9QmOOV" +
           "WGDJ2TPJ9C\n0SzJJonFBlWVqFMophOiThCLYo0eBEFDB8OMpnXMbYuwccIM" +
           "LScEW5htEkvaLAwmUFQxdMYtW+GG\nxThqTsziHO63OdX6E5TxgQQKpyjRVP" +
           "YEOoyCCVSb0nAaBJcnCl70yxX7h8U4iDdQ2KaVwgopqNTM\nUV3lqNuvUfS4" +
           "dwcIgGokS3jGKJqq0TEMoBZnSxrW0/0T3KJ6GkRrDRuscLRywUVBqM7EyhxO" +
           "kxmO\n2vxyY84USNXLsAgVjpb5xeRKkLOVvpyVZGtXOPr3ibE/V0HGYc8qUT" +
           "Sx/zAodfmUxkmKWERXiKN4\ny46fGt1rdwQRAuFlPmFHZnDt+7sTNz7qdmTa" +
           "q8jsklicUW7f39F5afCH+pDYRp1pMCqgUOa5zOqY\nOzOQNwHdy4srisl4Yf" +
           "Lj8U/3HnmL/BxEdaMorBiandVHUT3R1SG3H4F+gurEGd2VSjHCR1GNJofC\n" +
           "hvyGcKSoRkQ4aqFvYp6R/byJEKqHB7xCOeT87hQNR3VD2DK0OJvl6G5OGGfT" +
           "zFKmkxC1TBZbc8zr\n3jutTBeE82LdJfOBALjU4S8vDbA4YmgqsWaUN65/eW" +
           "jbjmeOO8kSAHN3BOY8I3HPSFyJSyO9UGE5\ngEnGIlhFgYA0tVQg04ncoGXh" +
           "A6Ji8kcvdb70GX4V8gDxYPQgke4G5mtEC0qbFiWUIa8cR6GHAS0z\nSuuRGy" +
           "tf/u7Ni0EUqkoqieLgsGFlsSZwUaiiFtecfwbg1OsHdTXbv57Yef7yV1fXef" +
           "DmqLei6io1\nRdX0+FNhGQpRgZW85V/4a+S3k7UPvhtENVCKQEYcA4Sgsrv8" +
           "NsqqZ6DARMKXUAI1piocb+AQoPkS\nh0Ublf0mF38heHpc/HWJRkzGRNPiIA" +
           "rS1erzQfLcrafC91z5oPGiDEqBEptKuHOCcKfAYh5EJi1C\nYPzqi2MnT988" +
           "9jgYz5umAwuOwqad1KiSB5UV5TUpPFAFsn45N9D87Eb2nkRBPc1mbY6TGgEO" +
           "x5pm\nzBN1hksSi5UQpuQpCFY0CXwH1DmjwUJOOMxADhBchVHiba2nnu975Y" +
           "rgHFPGa7moVbnTIKuktTGL\nZoE1ci6tPdf1+o/nr4+3OoBxuH9NBf2W6jj8" +
           "LyPeaIoIrF7MgpS+sH712cPj15IOL7aUR2ybbmfv\nO/M96dsSVaoUeiRpGB" +
           "rBunRtPRgU7zhHITi5nI+1AdH2FX1H0nckd9gparjVyyqQ4JyTn2jfxL7t\n" +
           "+4/3yMQ60RIKG0WzyVl4c8VwvkqANyzKEMPiOPYKiB764+i5b09Hgyg4hSKU" +
           "DVMdawIf7BGHEqoc\nRL4lDn64+7Vb3/BrMlZeDYqNdeQrCXUPLqGHBy7nYu" +
           "G3z2SDKDKFmuVlAut8D9ZsgfUpuA6wIXcw\nge4omy8/2p1zbKDIMR1+yJSY" +
           "9Ve/l1/oC2nRr/MVfAM8bfC0uwXf7iv4QMAUnS1SoVu2PcXyjJgW\nzWFx/0" +
           "K1Kkna6WIKlwCpi/dAmaGl8HS4hjqqGxoWzVYO56JhyZLc5C4n973VASLygL" +
           "jZBSEApHOh\n24isjWOP/R59Gl/YF3QR2w/s4l4ZC1jzTqONi2Jtp7yQedkO" +
           "TTzcd9eGxp+ArRc4iGLu4DiB26c+\nWciFPKHw/z6hun2O+vcTy7U/GsrQz4" +
           "MSBQ5wKu6Z5UoD5XBpsMo3KiPWXnZKiFz2urnsrXZKiGb1\nosTxn6wyDvRj" +
           "2RWUVJMzqCrV9pZjoPQDMBktvZ3IyaUcdS56oYHct1X8EXGuy0rPpf3rPjFj" +
           "X8hD\nuXiljcC9MmVrWmmxlfTDpkVSVHoTcUrPlK8kRysW2AlHAUXuFjui4g" +
           "ZeVZSjBu+jVCNTOiMnqFnw\nv1mStCCXuBOYfOBfrixm5dQNAAA=");
    }
    
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        int port = Integer.parseInt(args[1]);
        new Carol(debug, port);
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238671639887L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVYb2wcRxWfvTuf/x3E5zp/iO24SWxit8kZAgWKPwTHJIrd" +
       "S+363NCaVM7e7tx5\nnL2dZWfufI6i0haJtEVUqprQFkErISTUKhKQquUDKC" +
       "C1BUpboaZSWlVq+6EIKkER/QIRFMSbmdvb\nvd3zIiLdeHbmvXlv3vzeb97k" +
       "4geog7koxzBjhNprOb7hYCZbWlzDBme5wtyC7jJszlg6Y0swsWKc\n+g858d" +
       "PsfccSSFtG/TadtojOllZdWi2vLq0SVnfR9Q61NsoW5Y0VI2t8ce9H66+cmx" +
       "tMoi3LaAux\nC1znxJihNsd1vowyFVwpYpdNmyY2l1HWxtgsYJfoFjkDgtQG" +
       "w4yUbZ1XXcwWMaNWTQj2s6qDXWnT\nG8yjjEFtxt2qwanLOOrLr+k1fbLKiT" +
       "WZJ4xP5VG6RLBlsq+hu1EijzpKll4GwW15bxeTcsXJo2Ic\nxHsIuOmWdAN7" +
       "KqnTxDY5GglrNHc8egsIgGpnBfNV2jSVsnUYQP3KJUu3y5MF7hK7DKIdtApW" +
       "ONq5\n6aIg1OXoxmm9jFc42hGWW1BTINUtwyJUONoaFpMrwZntDJ1Z4LTm05" +
       "l/P7jwj+vhxMFnExuW8D8N\nSrtCSou4hF1sG1gpXqvmzs/eWR1KIATCW0PC" +
       "SmZ67Ge359//5YiSGWwjMy+xuGJ89Lmh4SvTf+hO\nCje6HMqIgELLzuWpLj" +
       "RmpuoOoHtbc0UxmfMmf7X46zvveRr/OYG6ZlHaoFa1Ys+ibmybM41+J/Tz\n" +
       "xMZqdL5UYpjPopQlh9JUfkM4SsTCIhwd0Hd0vir7dQch1Ak/DX5fR+pfr2g4" +
       "6prRXWrl2BpHN3DM\nODvJXONkEaK2WtHd08zvfuakcdITrot1P76uabCloX" +
       "B6WYDFY9Qysbti/Oi93509cssD96vDEgBr\neMTRsG8k5xvJGTlpBGmaXP06" +
       "AUYVrGnX1TdEktTvvTL8+G/070PoIQSMnMFyh9p6SrSgdDCWQ2b8\nDJyFng" +
       "4AWTEG7nl/53dff+rFBEq25ZF8c/AodSu6JaDgJU5/w1x4BhA0GsZxO9t/ff" +
       "D4M1dffnvc\nRzRHo5FEi2qKRNkTjr5LDWwCEfnLP/rPY397pOPmZxMoBdkH" +
       "/MN1QA0k866wjZaEmfLIR+wlmUe9\npcjGezgEaD2wYdFmZH8LHEUX/CCR0P" +
       "YG5PpFIyazoulXIILjGgjtQVLbtW+kP/XGL3pflEHxWHBL\ngC4LmKucyvoQ" +
       "WXIxhvG3H1t45MIH576ahCx2HAULjtJOtWgRow4q21vTUOzAFMj6y6WpvocO" +
       "sOck\nCrpJpVLletHCQNu6ZdF1bK5wyVvZAEdKaoJgZYpAccCWKxYspMLhaD" +
       "VAcBsSye0YOP+die+9IWjG\nkfHaJmIlPU2wKJMtuKQCRFFrMNnDu374x2fe" +
       "WxxQgFF0vzfCuEEdRfky4r2OiMDuOAtS+oUbd1+8\ne/GdoqLC/taIHbGrlZ" +
       "uefBNPfCljtMntziKlFtZtubUbwaD4m+MoCZeV+hjTRDvR3LuXvOL7Ot5I\n" +
       "exHf3JG6gR1BktL7YZHfA/6JAyeeVmeXmSjcNXfq/j3y0FUkhcIB0RxURm+O" +
       "DNcjDrjos7HscVTc\nzpBlnAJN+0l26ltv3nb8jq9Mqmh9OnaJWyFUplzH17" +
       "8wax+6vPWqnRB5lWZrzXDmARCco/G8t2Tj\neMWn6hXmCmrKuzz3/+8N+IbJ" +
       "2b/fe+n3FzJgeBl1EnaU2LolwM9uVXzX5mINLXHm8u1PXHuVvyOB\n4BOMcH" +
       "+oHr0gTugB7vvC1Vo2/ZMnKwnUuYz6ZHGk2/yEblVFIi9DecNmGoN59LGW+d" +
       "ZSRd3LU00C\nHQrnQ8BsmNpSgWinhLTodyk2c+qa5ojeESk9Its9DYBxWEfE" +
       "CxDvuKSmi4IRdTgrRVr0kDzYPAy3\nanNSwaKKbcBHEqAmM2EOgLcvdG7NIw" +
       "aVwmFcJrZK/wadagprn4zRCiiN9RlP7x+/eEYpjceZ8tEU\ntCVo2Fgllinc" +
       "PQRr7I2FmVJ/7cdP0O6xfz0rrPrkE2d91l4HI7jdTsdi1PKUOkon+eWXfvDY" +
       "xFvP\nKVoqUnNDOSzaeUfeGHH2F7GBm0Tbav+mGLXj0If6dobCnWETQ74L1B" +
       "pPHX5ey/deflf601tRckst\nIJuXUYnbXgGKvqhLQveE07hBAGtbAyXVYcCl" +
       "uyEuRDG5LGV3K+pFPvUqRkTC/PBmJbe8Dc7d8WHm\nm/oLd3lmJznq5tQ5YO" +
       "EattqQ6IFYcByXDw+fBZKFQxP79vf+CUqUTaqvbGNwEcMry26GT5Zl+v9d\n" +
       "lo2E9hr2J1sbvC25Sn6bkOygCCXynmpVmmqlkR631VEZtMFmaSR++0TgG8dZ" +
       "b1saRQlH9EehlGHy\niRp/lUZfUbKCVjC6lBz9MPHzbaOyKEwVdebFs/X5GX" +
       "1dtjwapZ89zV19An4jMbvycNrn3+7qhdm2\nDJgWjV3XkKRfd5NoHJMhAdpN" +
       "W9guqxfPQdFU6pHCKlpczFjUxqLE8+ZUaUForvnCh8lolSC+DeWf\ntBXIrt" +
       "BpIC/D4ibF91m4OQzhTpsoqcutHnve4vPzciW4GVMVuILD1VeqRokp5c4Fkl" +
       "8LBKtlRFxl\n8i0mKHNH5D9R1FPf2HPl1PjzTvYlBSTvOd4Jb+JS1bKCF2ug" +
       "n3ZcXCLS2U7vmhV/HuJo+ybPQo40\nQ/r4bSX6cCvd+aIc9fgfQY3zwRk5cU" +
       "Ei67669l8AuqRVfBIAAA==");
}
