package nbody.noaliaz;

import java.util.Arrays;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import nbody.Particle;
import nbody.ParticleV;

public class FirstWorker {
    final private static int MAX_PARTICLES = 4000;
    final private static int MAX_PROCESSORS = 128;
    final private SJProtocol pc_nbody =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1WXWhcRRSe3U02zU91U9MYbZrQNkkTqrsqVJR9abo2NvaW" +
       "xGxbaQwss3dndyed\nvfc6MzfZBCmKD+qLIK1aQVsQQS0BpVJ9UKrgv+CDfb" +
       "AiWB8qImhB34L64JmZ3ezuzbKB3MzMmfP3\nne+cydpN1C442iuIENR1FuNy" +
       "xSMirrZmlX4kdZAUqHMMdhkbmZ9QGKEyR2MttOqURmP2xbvG11aN\n0ngLpb" +
       "QRBX2FLNRuFynLSTRuVdUTWimxoZ5oUE+Cpz0BT+rrZheJLZUv4+T7d8+7na" +
       "P/Xjaxbfdc\ntlJgrqxomDuTox8et37/ZNjc2dHkzoy2mrH/u39w59XJXzsj" +
       "KuQtniuoBP8SDVhVpYQvKUvMViTJ\nsueVRWtM5ohN6BJphv/+FmpHYY0LJO" +
       "WWSr5DbSw3cH3n4Gchq/vKLxrX7pK5p0QSba/FaTA1UD6B\nTqOwDnSihccZ" +
       "Xy5DkZpGOtpCz3Jdz+hEHvrmjXMTP32gI2vLurkV5TlS9e8JtdiqFq0tpomT" +
       "2xyF\nUu4yyncGajjJOV4xGpciI3+HP+ofCaM2FQMWROl1Wyiap4TlhEQxax" +
       "EvYVNIiwqZtFAXdSTheWwT\nHWKfhTpKRBbdnNkCAEMBj3MkTzhx7Apa6378" +
       "7PRJf7Aap+rJ/g0V5Spe5cync1+efOoi+SOMtkyj\nqO0yv+RMo05IOVVZd8" +
       "Daog4xpzP5vCByGrUxfRR19R5yy0OtJNpmsmHYKSTSklOnAPm0eVgWVRwD\n" +
       "ZQ/guxd+J+H37Qqc+q9Et0xRLuRjLj9FeFwsSjQmiZBiQXB7wVHVW3BczChe" +
       "XWi8qIg0GMBjlgF4\nh12WIzxjv3Xj2ycPHXn+OcMDB5dIJRbwqQ3HZzGX1G" +
       "YELN2m4jcQ6TKqkpSfvrrz1a/w69CHkLig\nq0TnEVpuU1+xuRxTqrbTjpAY" +
       "SpKxV68cP7/+nbyuA+i0oYUxgMclGgo2SEMd1dAJJnYC85rdB35Y\n6o2+d6" +
       "EURh3zKAZ2lUCewMwnaSLngUciVTm00NYGeWOlzMBRlcoRm0k0GIyrzi3cas" +
       "8zXADq9gev\nTanzZD3IsFYiTXpNxaj63FEOIU8t9gJ4fUHwlJH1Z6L3XPu4" +
       "+wszrSv+bq1rFUgwqZuvt1awY5yo\nxH8+N3vmpZvPPh4B9nueLlJYghHqYM" +
       "gt6vlZRu0yrBhxCrLYpH6znJagO6pj8sWhN397/8ZcnyHQ\nKerAy7EnmHuD" +
       "zsgRuGQmXbuedLtaedC3P9+3a+303PWsmXDbGrv1kOOX9l/4kUwc6LGb0DgC" +
       "A0Nt\n+st6QgyrjE3eej8oK7RWxY6nmOsQnGWkKuvTMurG04RT6LBVJaxZqt" +
       "F8OJDEUT2UanzsXdrxaKRI\nvw6jyAaVhoM4NSoFyNLFifS5flkMZTjavQk5" +
       "1yY5n5Oa31f+OfzXmfYHL+shW+svZWF3lT1qMwYP\nVN7lJcyUg+ps7ZJF7i" +
       "7XTuppqkHVx+P6u8/QKaTWcVXX2xvrpKzk1Mj481Iy9sLdAt6eyDzqpPBq\n" +
       "SoWqhXowY+4yyWWkfiJ767owxbBQ3dOTxTaQrJBhYMiE5IWWYDQ1+VchPtB3" +
       "9uWJ164p1ngbJUM6\nSmRqmNLRPrxJqPYHoC9sxYcqF2I1npihoK/d9z9a5Y" +
       "Lq2AkAAA=="));
    final private SJProtocol ps_ring =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1VXWhcRRSe/cmm+bFu0jRWmzamTWqKuqsPFXURTENDY29p" +
       "TNpKY2CZvTu7O+ns\nvdeZ2WQTpCg+qC+CtP6Bti+CWgJKpfqgVMFfBB/sg/" +
       "XF+lARQQv6FtQHz5nZze7ehCzcuzNz5vx9\n5zvnrtwkbUqSuxRTivvefEov" +
       "BUylcGtXM4/NHGRF7h2HXdYl9heJElKVZN8mWk1KI0n34j2jK8tW\naXQzV1" +
       "YU9hVxSJtb4iKvyahTV08bpfSaerpFPQOe9oY84dvPzTNXoy/r5If3z/sdI/" +
       "9etrFtD3yx\nVBS+rmnYO2MjH59wfv9s0N7ZucGdY8Zq1v3vgYFdV8d+7Yhh" +
       "yFsCX3EN/jXZ4dSV0hXNRXqqJslU\ng6CqNsdkmrmML7CN8D+widpRWNMiG/" +
       "fL5YrHXarXcH3v4BcRp+vKLwbXrrK9hyJNtjfitJhaKJ8i\nZ0g0qAYQ6R2h" +
       "7MekpEvW7qXY8N/RT/qHoyTukHiOKoZ6XQ5JFDgTeaVJ0pmnC9RC4HClMw7p" +
       "5J5m\nskBdpvD2Voe0l5ku+Xm7hSR3hzxOswKTzHNriKxWUucmT1UGEBFUQT" +
       "b3r6mgq1Qd7c+nvz71zEX2\nR5RsmSQJ1xeVsjdJOpiXH6+t22HtcI/Z02OF" +
       "gmJ6ksSFOUr4Zg+5FbgAsHptNoJ6xfSMltwrQj7x\ngOoSxtFbDaBQ98MzBs" +
       "+7tcKZf022TnCp9BO+PM1kSs1rsk8zpdWcku6cl/PzS3OeTwWny3OtF5Er\n" +
       "AyE8pgSAd9gXeSaz7js3vnv60JEXXzC1jXu0zGqxgE9jODVFpeauYGBpG8Zv" +
       "ITJlxJJUn726641v\n6FvAYEhc8WVm8ogsxvGt1pdjAms76SlNoSRZd/nKif" +
       "Or3+vrJoAOF8hPATypye4wtVrqiO0aTuwk\nlQ27D/640JP44EI5StpnSRLs" +
       "okCfpKLCZpieBR6p8dqhQ25pkbdWyrYqVirPXKHJQDiuJrdwq60g\naBGo2x" +
       "++NoHnmWaQYY0iQ3pDxQS+tlUjJMDFEIDXFwYPjaw+l7jv2qddX9k5V/N3a1" +
       "OrQIIZ03w9\njYIdlwwT//n1qbOv3Hz+yRiwPwhMkaIajHCPQm6JoJIT3K3C" +
       "SjCvqEsb1G9K8jJ0R33AvLz77d8+\nvDHdZwl0mnswc/eGc2/RGT4Cl+yMaD" +
       "PDbGgzD+b2l3cPrZyZvp6zU6y3tVsPeZXygQs/sf2Pdrsb\n0DgGAwM3yaqZ" +
       "ELdjxjZvs+/XNVpjsVPjwvcYzQlWl/UZGfdTM0xy6LBlFDYsNWg+GEriqBlK" +
       "DT72\nLOx8PFbi30ZJbI1Kg2GcWpVCZOmUTFekmcmWMpLsWYec77J8RbKG39" +
       "f+OfzX2baHLpsh2+gvtDBQ\nZw9u7oTRXvBlmQp0UJ+tnbok/cXGSTNNDajm" +
       "eI95j1g6RXA9inW9rbVOaCWPI+PPS5nkS/eqjwCK\nWdLB4XujEVWHdFMh/E" +
       "WWz2rzcelp6sJxQRV2T3eOukCyYlaAIRtSEFmA0bTBRza1o+/cq/vfvIas\n" +
       "CdZKRkyUxNbwERPt2Doh7h+GvnCRD3UuJBs8sUOh+j8O5p30DQkAAA=="));
    
    public void run(boolean debug, int port_l, String host_r, int port_r,
                    int numParticles, int reps) {
        final Particle[] particles = new Particle[numParticles];
        ParticleV[] pvs = new ParticleV[numParticles];
        int numProcessors = 0;
        final SJService c_r = SJService.create(pc_nbody, host_r, port_r);
        SJSocket s_r = null;
        SJServerSocket ss_l = null;
        try {
            ss_l = SJServerSocketImpl.create(ps_ring, port_l);
            try {
                long timeStarted = 0;
                long timeFinished = 0;
                s_r = c_r.request();
                timeStarted = System.nanoTime();
                numProcessors = SJRuntime.receiveInt(s_r) + 1;
                if (debug) {
                    System.out.println("Number of processors: " +
                                       numProcessors);
                }
                this.initParticles(debug, particles, pvs);
                int i = 0;
                while (SJRuntime.outsync(s_r, i < reps)) {
                    if (debug) {
                        System.out.println("\nIteration: " + i);
                        System.out.println(
                          "Particles: " +
                          Worker.noaliasArrayToString(particles));
                    }
                    Particle[] current = new Particle[numParticles];
                    Worker.noaliasArrayCopy(particles, current);
                    int j = 0;
                    while (SJRuntime.outsync(s_r, j < numProcessors - 1)) {
                        Worker.computeForces(particles, current, pvs);
                        {
                            Particle[] _sjtmp_current = null;
                            _sjtmp_current = current;
                            current = null;
                            SJRuntime.pass(s_r, _sjtmp_current);
                        }
                        SJSocket s_l = null;
                        try {
                            s_l = ss_l.accept();
                            current = (Particle[]) SJRuntime.receive(s_l);
                        }
                        finally {
                            SJRuntime.close(s_l);
                        }
                        j++;
                    }
                    Worker.computeForces(particles, current, pvs);
                    Worker.computeNewPos(particles, pvs, i);
                    i++;
                }
                timeFinished = System.nanoTime();
                System.out.println("time = " + (timeFinished - timeStarted) /
                                     1000 + " micros");
                if (debug) {
                    System.out.println("\nIteration: " + i);
                    System.out.println("Particles: " +
                                       Worker.noaliasArrayToString(particles));
                }
            }
            finally {
                SJRuntime.close(s_r);
            }
        }
        catch (SJIncompatibleSessionException ise) {
            System.err.println("[FirstWorker] Non-dual behavior: " + ise);
        }
        catch (SJIOException sioe) {
            System.err.println("[FirstWorker] Communication error: " + sioe);
        }
        catch (ClassNotFoundException cnfe) {
            System.err.println("[FirstWorker] Class error: " + cnfe);
        }
        finally {
            if (ss_l != null) ss_l.close();
        }
    }
    
    public static void main(String[] args) {
        boolean debug = Boolean.parseBoolean(args[0]);
        int port_l = Integer.parseInt(args[1]);
        String host_r = args[2];
        int port_r = Integer.parseInt(args[3]);
        int numParticles = Integer.parseInt(args[4]);
        int reps = Integer.parseInt(args[5]);
        if (numParticles <= MAX_PARTICLES) {
            FirstWorker fw = new FirstWorker();
            fw.run(debug, port_l, host_r, port_r, numParticles, reps);
        } else {
            System.out.println("Too many particles: " + numParticles);
        }
    }
    
    private void initParticles(boolean debug, final Particle[] particles,
                               ParticleV[] pvs) {
        for (int i = 0; i < particles.length; i++) {
            Particle p = new Particle();
            if (debug) {
                p.x = i;
                p.y = i;
                p.m = 1.0;
            } else {
                p.x = 10.0 * Math.random();
                p.y = 10.0 * Math.random();
                p.m = 10.0 * Math.random();
            }
            {
                Particle _sjtmp_p = null;
                _sjtmp_p = p;
                p = null;
                particles[i] = _sjtmp_p;
            }
            ParticleV pv = new ParticleV();
            pv.vi_old = 0;
            pv.vj_old = 0;
            pv.ai_old = 0;
            pv.aj_old = 0;
            pv.ai = 0;
            pv.aj = 0;
            pvs[i] = pv;
        }
    }
    
    public FirstWorker() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238689875225L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAK1Yf3AcVR1/d5dckiY0uTStpUla2qQ0GdMLdayiUSENjU25" +
       "NOldaEMIXjd775JN\n93aX3XeXawZrCjMUy8hMoQHsAGUUtTB11DLAH0p0BE" +
       "RUxrGOBZkBHXGUGcWRf2xH0fH7fW/3bm/3\ncqGOmdmXd/u+3/d931+f7/ft" +
       "ufdItWWSqEUtS9G12Sg7YlCLj/rULJWZFU3sHZVMi6YGVMmyxmAh\nKR/6j3" +
       "Lge5G79gRJYII0a3q/qkjW2IypZ6dnxmYUK2+SawxdPTKt6sze0bfHpzs+mP" +
       "vF8b2tIdI4\nQRoVLcEkpsgDusZonk2QhgzNTFHT6k+laGqCRDRKUwlqKpKq" +
       "zAOhroFgS5nWJJY1qRWnlq7mkLDZ\nyhrU5DKdlzHSIOuaxcyszHTTYqQpNi" +
       "vlpN4sU9TemGKxvhgJpxWqpqw7yFESjJHqtCpNA+G6mKNF\nL9+xdxDfA/kq" +
       "BY5ppiWZOixVhxUtxcgmL0dB486bgQBYazKUzegFUVWaBC9IsziSKmnTvQlm" +
       "Kto0\nkFbrWZDCyIZlNwWiWkOSD0vTNMnIei/dqFgCqjpuFmRhZK2XjO8EPt" +
       "vg8ZnLWyPhhn+fGL10DXgc\nzpyisornDwPTRg9TnKapSTWZCsbL2eipoVuz" +
       "bUFCgHith1jQ9G99/pbYuz/cJGhay9CM8FhMyh98\noq39Qv8f60J4jFpDtx" +
       "QMhRLNuVdH7ZW+vAHRva6wIy5GncUfxX9y68LT9C9BUjtEwrKuZjPaEKmj\n" +
       "WmrAntfAPKZoVLwdSactyoZIlcpfhXX+G8yRVlSK5qiGuSGxGT7PG4SQGngC" +
       "8LxGxN9qHBhZPahA\nHB7UzcPUjFqzjFzLqMWsScuUJ7UpPXVkUtMh0KX5yV" +
       "LCPO68ei4QAKXavAmmQjTu0dUUNZPyt975\n2Z27b/7yvcJdGGL2mRi5mguI" +
       "2gKiLgEkEOA7r8FQFKbqN03pCKZI/tiF9q++Ij0GhgcDWMo85foF\n5qpwBK" +
       "aPVUSQgWL+DcFMgvBIyi0L7244/eunXg6SUFkUiRVeDupmRlIxEJy0abbFeV" +
       "cgfjq9UVxO\n9t9ODD9z8edvdRXjmZFOX5r5OTFNtngtb+oyTQEMFbd/+J97" +
       "/v5g9aeeDZIqyD1AHyZBzEAqb/TK\nKEmXPgd6UJdQjNSnfYqvYmCgOZfCOD" +
       "bg0CSiA3zR4jkgR63Ld4eve/0H9S9zjR2Aa3QhYYIykS6R\nov/HTErh/VuP" +
       "jD64+N7x20KQoIYhfM5I2MhOqYqcB5aPlGYYHi+FYfPX831N92+3nuMurlMy" +
       "mSyT\nplQKiCypqj5HU0nGISnigj+OOmCJhilALwDCpAobCV2NQA7Csww+RN" +
       "e3nHqo+9HXEUEMbph1mGn8\npCTPX3QGcOzyLeLvdozglqLakPOHhQIN3Ynb" +
       "9x66dwvX3L1dj/0jX9iwir+pgp16KubCIFaaYqgo\nd/7j2PlfLjYESXCC1C" +
       "jWoKJJKhrL2ieCvwzGeraYX7rl8cuvsbe5a4vRhgdry/uR4oDkSoTrL+Yi\n" +
       "4e+eyQRJzQRp4nVS0tgBSc2i4yeg0lkD9ssYuapkvbRqCYjuK2RTmzfSXWK9" +
       "cV5EKJgjNc5rRWhz\nmkawLNq4F54mG0v5f1yM4NCc59glYhcPFB2CEj1Nze" +
       "Y/PPHkpWPHrw8iclXn8OBgk6Yi3b4sNhr3\nnFtsrz/1+/t4BBHS+ARuupML" +
       "38jHzcL9IQZHRxcxUmOYSk5iYIewxZuXPCNXDfePJ0f742NDA7Hd\nCcvvul" +
       "FTyUD1ydnl8eTGJ//0zDvxFoFDoofo8JVxN4/oI7ht6g3Mvc2VJHDqlz66+d" +
       "zR+NtTor42\nl+bqbi2b2XnmDdp9Y4NcplyEoNPhuAIoj/+v8/kjYvsj4vcH" +
       "Tj4Jbxdw8vkyxsT5Z3D4LA6fAwOu\n5gaMjwzsTiRG4gl8vcuRb5KPr5xZgM" +
       "ZMh2JeDPFD972xf3j8YK9Qf0fFLfaB7ilPei0OaTcsrb2o\nBRF/w9asK1iD" +
       "FmOkK+ZsafsLf4pZYm9CLIkWixvQAMsYOBv1GyRYNAjYotaQk7xac5I1jLQW" +
       "zm5m\nNaZkKDbntr7cSAEOchh32zxqFs6E1XgXnVY0EYC28wLCONdW4HIxbW" +
       "2Sn+7pOjcvmLoqMLnUd8vC\nEiTPKGoKjzsCe3RU9Ipg/9V3Htfrtv7r2aCN" +
       "2iL8K0mPU5kWUq1U050V2IZhDm3zgA71SlNkft0Q\nezy168VArH7pd1yD+o" +
       "ygGysBrHF+qu4K249k2RzoXvZYWyvwxXTdEDyhm1792iPdbz4n8hUjRNjR\n" +
       "li8q4BcMXs0r7ZiArtZ/CmSeFMzeGwHvBwXH+VDn+8Hvr+vkLU7VlGQJG3iv" +
       "Uv6bUskFiAtbVcCU\nHfD0w3PWPs9ZD6Y4ibBaNLFwqQTYVWmhBjv9KP7egU" +
       "M6HyA82WYrJVsHJFtYpdq06N054NBiZQ8K\nckf4mmLtGFB1jWJH46yJJkLR" +
       "o4W7KizmfeczySaPZYe5UYqgE8m17g/NKD8N8vooSqrvclnK1Fda\nSFeZFO" +
       "7GWml0tgqjcAX9FgkIY1Tsl1ZspnJQIWW0i2MTV60VTQIn28WXhwtouLASGt" +
       "YYVhIvxvh7\nzIV2d6+Adoll0A55DxpCn9sg3IXTcZwTOpKijk63B6Lal7sk" +
       "81J7fPz9hnukl253BNzESB3Tje0q\nzVG1YK6QqH6w2/aKuOcNilDihu5tPf" +
       "V/hpxb5sYUsV/GS33Pr1LSFV6lcGSF1KxF/eFpt23Y7klN\n7hGX9TwREuYq" +
       "h/nvG22rD4BTp3RdpZJWjIjSgBHfQgpJKYaVY/B+aFygRHqlVeV0JcXZTrvc" +
       "Gsbp\nA4XtF8tKuwLSrxRshs82eE7aNjtZzmbLxH2H6IjKquqGuVRB2tXwbF" +
       "pB2uLyUPlNByrPVoZKHDMF\nnb/hg0n8qeNwhx/3eEgJYZx5+Xj50HDzbRy+" +
       "iMPR/MrUZyAIMnA74jHgi4SASyP/m6Jf6+BJVihT\ny/g1IKCs7CFDxYaYxx" +
       "f1OHcEnvEPURkbSyvjgeX9veT4+8dX4u8X/jd/L/FtXvg/+PuVK/L383Al\n" +
       "UzSFlXQKfscLu5e5YNioiTcD+1MU3v083zgv7X9odvPphQf453DnCg/NXO9K" +
       "m3n2+fqXak+sb84/\nzNu6oMkN1yY6JEOU7IDLBT3eiBFrUCnrXR/1sItb7/" +
       "sWL74Yy1suHOp60Yi8Kno456tuTYzUprOq\n6r6Uu+Zhw6RphZ+nRlzRxeEu" +
       "gqlLvi0Cutszft7fCLLfQnugOS3rm4ZwZOC/q7Eg64gYAAA=");
}
