package nbody.noaliaz;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import nbody.Particle;
import nbody.ParticleV;

public class LastWorker {
    final private static int MAX_PARTICLES = 4000;
    final private SJProtocol ps_nbody =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1WXWhcRRSe3U02zZ8mNY3RpgltkzahuqtCRdmXpmtr197S" +
       "mLSVxsAye3d2d9LZ\ne69zZ5NNkKL4oL4IpVUraAsiiCWgVKoPShX8F3ywD1" +
       "YE60NFBC3oW1AfPGdmN7t7s2wgNzNz5vx+\n3zmT1Vuk3Zdkt898n7vOQkwt" +
       "e8yP4dasZh+b3c/y3DkGu7RNzE8oTEhZkl0ttOqUxvvsS/dMrK4Y\npYlWro" +
       "wo6CtkkXa7wEVWkQmrqh7XSvF19XiDegI87Qx4wq+bWWC2Ql/GyffvXnA7x/" +
       "+9YmLb4rli\nOS9cVdEwd6bGPzxu/f7JqLmztcmdo9pq2v7vweFt16Z+7Yxg" +
       "yJs81+cK/CsyZFWV4iXFRXy6IkmU\nPa8M5R9vWRMn26z4e1voHIE1zbOkWy" +
       "yWHG5TtV7Ud/Z/FrK6r/6ii9pdNPdQpMiWWpCmoKaOT5HT\nJKyjbIVcylkC" +
       "gFizQFslZ7muZ3Qij3zz5vnJnz7QgbVl3OwyOo5U3Xs+Lnpx0TqQGWYzvtgk" +
       "ENTv\nMvp3ByCckpIuG43LkbG/wx8NjoVJG4ZBfYZ63RaJ5jgTWV+RPmuBLl" +
       "KDo8V9lbBIF3cUkzlqMx3l\ngEU6ikwV3KzZQg1GAh5nWI5J5tiVONdKsXOp" +
       "k6XhapzYkoPrKugqVqXMpzNfnnzmEvsjTDalSNR2\nRanopEgnkCRZWXfA2u" +
       "IOM6dHczmfqRRpE/oo6uo95JYDuBTZbLIR1MnHZ5XkTh7yafOoKmAcQ2UP\n" +
       "ync//E7B75lKOfVfRXot6qsnXHmKyZi/oMi4Yr7y531pzzuI37zjUsHpynzD" +
       "PSTScKAa0wJKd8gV\nWSbT9ts3v336wOEXXzBEcGiRVSJR5DZtNzZNpeK2YG" +
       "DpDozeFEiDiICUn7227bWv6BvQhJC2z1eY\nziK01IZffyMYBxHZlOMrCoCk" +
       "7ZWrxy+sfadu6AA6behfCqWTiowEG6QBRZw4wcROUFmz+9APi/3R\n9y4Ww6" +
       "RjjvSBXRSoE1SU2CxTc8AiP1k5tEhvg7wRJzNtEKcss4Uiw8G46tzCrfacoH" +
       "kg7mDw2kE8\nT9QXGdYo0pTXRIzi565yiHi42A3FGwgWD42sPRe97/rH3V+Y" +
       "UV3xd3tdo0CCCd16/TXAjkmGif98\nfvrsy7eefzIC3Pc8DVJYgRHuUMgt6p" +
       "UygttlWAnm5FWhCX7TkhehN6pNf2bkrd/evzkzYAh0ijvw\nbOwM5t6gM3YY" +
       "LplJ164n3fZWHvTtz/dsXz09cyNjRtzmxl494JSKey/+yCb39dhNaByBcYGb" +
       "wbKe\nD6OYsclb74dVhdYIdiwpXIfRjGBV2YCWcTc2yySHBltBYc1SjeajgS" +
       "SO6JFU42P/4tbHIwX+dZhE\n1qk0GqxTo1KALF2SqZLUL4uhjCQ7NlTOtVm2" +
       "JFnN76v/HPrrbPvDV/SIrfUXWthRZQ9udsEDlXNl\nkQp0UJ2sXaog3aXaST" +
       "1NdVH18YT+7jF0CuE6hrje2YgTWsniyPjzcqLvpXt9eHwic6STw6upsKoW\n" +
       "6aFCuEssm1b6ieyv68KkoD52T0+G2kCyfFqAIROSF1qE0dTk/4TY0MC5VyZf" +
       "v46s8dYhIzpKYjBM\n6mgf3SDE/T7oCxv5UOVCX40nZijoaw/8D8XwrDnVCQ" + "AA"));
    final private SJProtocol pc_ring =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1VW2hcRRievaa5tG7SNFa7TUyb1RR1Vx8q6iKYLi1de0pj" +
       "0lYaA8vs2dndSWfP\nOc7MbjaLFMUH9UUorTfQ9kUQS0CpVB+UKnhF8ME+WF" +
       "+sDxURtKBvQX3wn5m9noQsnLMz889/+/7v\n/8/qLRQRHN0jiBDUdZaScsUj" +
       "Iqm2ZjX/ROYAKVHnOOxyNjK/QBChOkd3b6LVpZSI2Zfum15tGKXp\nTZTmjc" +
       "jvK2ChiF2mrCDRtNVST2mlVFs91aOeBk97fZ7U280vEVsqX8bJD+9fcPsT/1" +
       "4xse3wXLZS\nYq5sapg7M4mPT1i/fzZh7uza4M4xbTVn//dQfPe1mV/7Qyrk" +
       "LZ4rqAT/Eu20WkqpqqQsNduUpOue\nVwf4E5ti4hQ2An//JjpHYY1LJONWKl" +
       "WH2li2QX3vwBcBa/DqLxrUwYq5p0QS7egEaQA1OD6DzqCg\nV/cgzDt9qc9w" +
       "jleM3cuhqb+Dn4xNBVHYQuE8FkTpDVooWqSEFYREMWsJ17DJ36JCpi00QB1J" +
       "eBHb\nRKjb2yzUVyGy7BbMFpIc93mcI0XCiWMT43WtmjyfPVWNK0SUiqLyWF" +
       "tFuUq2oP587utTz10ifwTR\nliyK2i6rVpws6gdwM811H6wt6hBzeqxYFERm" +
       "UZjpo6ir95BbkTIAa8Rkw7BTSs1LTp0S5BP2sCyr\nOEbqHhTqQXhm4DnbLJ" +
       "z+l2irhYV8yuWnCU+KJYkSkggpFgW3F528W1hZdFzMKG4s9txTNIn70Jhl\n" +
       "AN1hlxUIz9nv3vzu2YNHXn5JVzbs4AppRiLRNm03OYu5pDYjYGm7it4ApIuo" +
       "ClJ//truN7/BbwN5\nIW1BG0RnEVgOq7dYX4xDqrJZR0gMBcnZjasnLqx9L2" +
       "/oAPpt4D0G6LhE435i9VRRdao/sZOYd+w+\n/GNtOPrBxUoQ9S2gGNhVAnkS" +
       "syqZJ3IBWCQyzUMLbe2R99bJdKmqU4HYTKK4P64ut3ArUmS4BMQd\n8187pM" +
       "7T3SDDWok05TURo+q1vR5AnlpMAnijfvCUkbUXog9c/3TwKzPimv5u62oUSD" +
       "CtW2+4U7Dj\nnKjEf35j9tyrt158OgTc9zxdpKAEI9TBkFvUq+YZteuwYsQp" +
       "yfIG9ZvltAK9UWs209nxd3778Obc\nqCHQaerAuN3rz71HZ+oIXDITIqLn2O" +
       "RmHvTtL++dXD0zdyNvZthIb68edKqV/Rd/IvseH7I3oHEI\nxoXaxOp6Ptyh" +
       "MjZ56/2YbNJaFTuZYa5DcJ6RlmxUy6ibnCecQoM1lLBjqUPzCV8SR/VI6vBx" +
       "uLbr\nyVCZfhtEoTaVJvw49Sr5yDLAiaxyPZENZTjasw451yaFKicdv6//c/" +
       "ivc5FHrugR2+kvZSHeYo/a\n3AWDvejyCmbKQWuyDsgyd5c7J9001aDq4z36" +
       "nTB0Cqj1tKrr7b11UlYKamT8eTkde+V+8RFAsYD6\nKXxtpELVQkOYMXeZFH" +
       "JSf1qGu7oww7BQ3TOUxzaQrJRjYMiE5AVqMJo2+L4md46ef23fW9cVa7x2\n" +
       "yZCOEpkaPqajnVknVPtHoS9sxYcWF2IdnpihUP8ff36IZQgJAAA="));
    
    public void run(boolean debug, int port_l, String host_r, int port_r,
                    int numParticles) {
        final Particle[] particles = new Particle[numParticles];
        ParticleV[] pvs = new ParticleV[numParticles];
        final SJService right_c = SJService.create(pc_ring, host_r, port_r);
        SJServerSocket ss_l = null;
        try {
            ss_l = SJServerSocketImpl.create(ps_nbody, port_l);
            SJSocket s_l = null;
            try {
                s_l = ss_l.accept();
                SJRuntime.send(s_l, 1);
                this.initParticles(debug, particles, pvs);
                int i = 0;
                while (SJRuntime.insync(s_l)) {
                    if (debug) {
                        System.out.println("\nIteration: " + i);
                        System.out.println(
                          "Particles: " +
                          Worker.noaliasArrayToString(particles));
                    }
                    Particle[] current = new Particle[numParticles];
                    Worker.noaliasArrayCopy(particles, current);
                    Worker.computeForces(particles, current, pvs);
                    while (SJRuntime.insync(s_l)) {
                        SJSocket s_r = null;
                        try {
                            s_r = right_c.request();
                            {
                                Particle[] _sjtmp_current = null;
                                _sjtmp_current = current;
                                current = null;
                                SJRuntime.pass(s_r, _sjtmp_current);
                            }
                        }
                        finally {
                            SJRuntime.close(s_r);
                        }
                        current = (Particle[]) SJRuntime.receive(s_l);
                    }
                    Worker.computeForces(particles, current, pvs);
                    Worker.computeNewPos(particles, pvs, i);
                    i++;
                }
                if (debug) {
                    System.out.println("\nIteration: " + i);
                    System.out.println("Particles: " +
                                       Worker.noaliasArrayToString(particles));
                }
            }
            finally {
                SJRuntime.close(s_l);
            }
        }
        catch (SJIncompatibleSessionException ise) {
            System.err.println("[Client] Non dual-behavior: " + ise);
        }
        catch (SJIOException sioe) {
            System.err.println("[Client] Communication error: " + sioe);
        }
        catch (ClassNotFoundException cnfe) {
            System.err.println("[Client] Class error: " + cnfe);
        }
        finally {
            if (ss_l != null) ss_l.close();
        }
    }
    
    public static void main(String[] args) {
        boolean debug = Boolean.parseBoolean(args[0]);
        int port_l = Integer.parseInt(args[1]);
        String host_r = args[2];
        int port_r = Integer.parseInt(args[3]);
        int numParticles = Integer.parseInt(args[4]);
        if (numParticles <= MAX_PARTICLES) {
            LastWorker lw = new LastWorker();
            lw.run(debug, port_l, host_r, port_r, numParticles);
        } else {
            System.out.println("Too many particles.");
        }
    }
    
    private void initParticles(boolean debug, final Particle[] particles,
                               ParticleV[] pvs) {
        for (int i = 0; i < particles.length; i++) {
            Particle p = new Particle();
            if (debug) {
                p.x = particles.length + i;
                p.y = particles.length + i;
                p.m = 1.0;
            } else {
                p.x = 10.0 * Math.random();
                p.y = 10.0 * Math.random();
                p.m = 10.0 * Math.random();
            }
            {
                Particle _sjtmp_p = null;
                _sjtmp_p = p;
                p = null;
                particles[i] = _sjtmp_p;
            }
            ParticleV pv = new ParticleV();
            pv.vi_old = 0;
            pv.vj_old = 0;
            pv.ai_old = 0;
            pv.aj_old = 0;
            pv.ai = 0;
            pv.aj = 0;
            pvs[i] = pv;
        }
    }
    
    public LastWorker() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238689834623L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAK1Ye2wcRxmfu/Odn40fcUKI7aSJbWIL59wgggoGWvuakHPP" +
       "ieNzXNeknNe7c+d1\n9na3u3PnixVKQqU6pIgqNOlL0ESlUtUqEjRVk0pUAd" +
       "QWKA8VUpRWSC2IIqgERfQfEkFBfDOzr9s9\nnxuEpR3P7XzfzPf8fd/sufdQ" +
       "1DRQ3MSmKWvqQpwc1rHJRm1uAYvEjKdHxwXDxFJCEUxzEhYy4ux/\n5KlnW7" +
       "+6J4xCM6hN1YYVWTAn5w2tkJufnJfNkoFu1DXlcE7RiLVjYI/PdH+w+Ivl0Y" +
       "4Iap5BzbKa\nJgKRxYSmElwiM6gpj/Nz2DCHJQlLM6hVxVhKY0MWFHkJCDUV" +
       "DjblnCqQgoHNCWxqSpEStpkFHRvs\nTPtlCjWJmmoSoyASzTAJakktCEVhsE" +
       "BkZTAlm2QohWJZGSuSeTe6B4VTKJpVhBwQrk/ZWgyyHQd3\n0/dA3iCDmEZW" +
       "ELHNUnNIViWCNvs5HI17bgcCYK3NYzKvOUfVqAK8QG1cJEVQc4NpYshqDkij" +
       "WgFO\nIWjjipsCUZ0uiIeEHM4QtMFPN86XgKqemYWyELTOT8Z2Ap9t9PnM46" +
       "19saZ/nxi/eiN4HGSWsKhQ\n+WPAtMnHNIGz2MCqiDnjtUL8VPLOQmcYISBe" +
       "5yPmNMO9Fw+k3v3BZk7TUYFmH4vFjPjBpzq7Lg//\nsT5CxajTNVOmoVCmOf" +
       "PquLUyVNIhutc7O9LFuL34w4kf33n0GfyXMKpLopioKYW8mkT1WJUS1rwW\n" +
       "5ilZxfztvmzWxCSJahT2Kqax32COrKxgao4ozHWBzLN5SUcI1cITgucC4n9r" +
       "6EDQDSnBJHdoxiFs\nxM0FgnoJNol50DTEg+qcJh0+qGoQ58LSwTK6Et13zW" +
       "IoBCp1+tNLgVjcoykSNjLiU+/87Miu2792\nnDuLBpglERiK7R+39o+7+6NQ" +
       "iG28lsYht9OwYQiHaX6Ujl3uevQnwrfB6qC9KS9hplxosYaOwPSJ\nqvCRcJ" +
       "MvCTMBYiMjth99d+Njrz/9ShhFKkJIynm5WzPygkKjwM6ZNus4/woET48/hC" +
       "ud/bcTY89d\n+flbfW4wE9QTyLEgJ82RrX7DG5qIJcAgd/uH/7nn7w9GP/18" +
       "GNVA4gH0EAECBvJ4k/+MslwZsnGH\n6hJJocZsQPEGAgZa9ChMxyY6tPDgAF" +
       "+0+wRkkHXt3thNb7zY+ArT2Ea3Zg8MpjHhudLq+n/SwBje\nv/XI+IOn31v+" +
       "YgSyU9e5zwmK6YU5RRZLwPKR8vSi4kk0bP56fqjlG9vNC8zF9XI+XyDCnIIB" +
       "jgVF\n0RaxlCEMj1o92McgByzRNAfQBSiYUWAjrqseKkJ4VgCH+Ib2Uw/1f+" +
       "sNCh86M8x6mmZMUlRiL3pC\ndOwLLNLfXTSC2121IeEPcQWa+tN3jc4e38o0" +
       "9243YP0oORtG2JsI7DRQNRd20zLjhop85B/Hzr92\nuimMwjOoVjZ3y6qgUG" +
       "OZe3nwVwBY3xZLlw48fu2X5G3mWjfaqGCdpSBQTAmeRLj5SrE19r0z+TCq\n" +
       "nUEtrEgKKpkSlAJ1/AyUOTNhvUyhG8rWy0sWx+chJ5s6/ZHuOdYf5y5AwZxS" +
       "03kdD21G0wyWpTYe\nhKfFAlL2ny620qGtxLCLxy4VKJ6E+pzDRtsfzj559d" +
       "jyzWGKXNEiFRxs0uLS7S3QLuO+c6e7Gk/9\n/n4WQQg1n6Wb7mSHb2LjFu7+" +
       "CAHRqYsIqtUNuSgQsEPMZJ1LCWB9bHg6Mz48MZlMpHalzaDrxg05\nD6WnaN" +
       "XGk5ue/NNz70y0cxziDUR3oIZ7eXgTwWzTqNPc21LtBEb98se3nLtn4u05Xl" +
       "zbynN1l1rI\n7zzzJu6/tUmsUC0i0OYwXGEo/8nVIxvQkGhQSd0Qm73/zf1j" +
       "03cM8uN3VN1iL5wt+cL7dFK95dK6\nK2qY4l/MXPAES9gkBPWl7C0te9GffJ" +
       "YeTfMl3t9Qrpt0iBSdzkaD3g3T+Wfp8DlwZp1uZlixZCRr\nCepwZDcKKpHz" +
       "mHbGlr7MSCEGMmNgqW0+NR2ZgCU9gnOyygPACuYQN87HqnB5mHpbxGcG+s4t" +
       "caa+\nake56nvPoiVAnJcViYqbhD26q3qFs//6u49r9b3/ej5soSYPv96qp6" +
       "tSJTV3VuEZgzk0rAkNioUq\ni6zR53s8PfJSKNV46XdM/MY8p5ssQ4sJJlI1" +
       "gyTVRdAbV5KqmiYpTdM5T+S2V594pP+3F3iu0Ojg\nNrSO59VnWmeVtJogE1" +
       "jEDgx4BaH8U5zf342zdoxznI/0vB/+/voe1mHUzAkmt4L/GhO8pZRdPthh\n" +
       "DQ7E7oBnGJ6TljwnfRBr58Ea3kLChQ5QT8FOCbTbQfp7Bx1mSyHEck2qlmvd" +
       "kGsxBas53jeP0CHj\nFtYwJ7cPX+tCd0LRVEwbCnuN13BZizv3RFgsBeQz0G" +
       "afZceYUVzMaS127I/Myz8Ns/LEK1rgYlfO\nNFRexxoMDPdStTw+O7hRmIJB" +
       "i4S4Maq2K6v2MoDZUZHaxbaJp9TxGs3IRtjyFxwwXFoNDGt1MUMv\npfT3Xg" +
       "/YfXkVsEusAHaUd7/O9TkA4c6dTse7uY7I1dFutuCorpUuqKzSLU+/33Sf8P" +
       "Jd9gG3EVRP\nNH27gotYqdCpba8Ke/6giKRv6d820PhnyLkVLiyt1suJct+z" +
       "m4xwnTcZOqpOatbBMw1Pp2XDTl9q\nMo94rOeLkChTOcp+32pZPQFOndM0BQ" +
       "uqGxHlAcO/QzhJObJ6+B2HlgGKo/+gmqImS4ztlMejUTr9\nurP9A/6DPhzV" +
       "smMk+myD54hlpCOVjLRCoHfT4fOVFfTi2pec0z4Kz+ZVTntgZWw8a2PjE9Wx" +
       "kY6u\nC84EcJH+lOlwKAh0LIb4YYx55QD50PjyFB0W6VAqrU79KLg+D7cR5v" +
       "mA/0MejYJvXL/Ww5OpUpdW\n8GuIY1dFIS0McEIr43PuPivfViuFzeWlcGpl" +
       "f79g+/vF6/H3xf/N3y+wbS7+H/z9o+vy97NwBZJV\nmZS1BkHHc7tXuFBYME" +
       "lvAtanH3rX8n1QvLr/oYUtjx39Jvv2bF+ZoYEbXG0z3z7f+UrdiQ1tpYdZ\n" +
       "Kxc22D2nk7dEOq/RIY8LBvwRw9egNDa439Bo17Yh8N2bf50Vt16e7XtJb32V" +
       "92z2F9TaFKrLFhTF\newf2zGO6gbMyE6eW34i5bL8CS5d9yQM0t2ZM3Nc42e" +
       "vQDqh2l/obnfsx9F/AVh+X9BcAAA==");
}
