package nbody.noaliaz;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.sharedmem.*;

public class LocalRun {
    
    private static void configureTransports(String transports) {
        List ss = new LinkedList();
        List ts = new LinkedList();
        if (transports.contains("f")) {
            ss.add(new SJFifoPair());
            ts.add(new SJFifoPair());
        }
        if (transports.contains("s")) {
            ss.add(new SJStreamTCP());
            ts.add(new SJStreamTCP());
        }
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    public static void main(final String[] args) throws Exception {
        final String transports = args[0];
        LocalRun.configureTransports(transports);
        final String debug = args[1];
        final String numParticlesLast = args[2];
        final String numParticlesFirst = args[3];
        final String reps = args[4];
        new Thread() {
            
            public void run() {
                try {
                    LastWorker.main(new String[] { debug, "4444", "localhost",
                                    "4442", numParticlesLast });
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
        Thread.sleep(500);
        new Thread() {
            
            public void run() {
                try {
                    FirstWorker.main(new String[] { debug, "4442", "localhost",
                                     "4444", numParticlesFirst, reps });
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
    }
    
    public LocalRun() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238690306491L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVXW2wUVRg+e+n2tthuWyqhN6Al0Ei3RqNBq8Gmcikstm4L" +
       "kbZkOTt7djtldmac\nc3Y7rYaAN5AHEwNeo/BiYjQ8KER90KgJ4N0XTMAXeM" +
       "EoiWLkwUgMGv9zZmYvM9uCm8zZM+f85z//\n7fv/f05cRVXUQFFKKJU1dSbK" +
       "5nRCxaglZ4jEaHRs6yg2KEkNKZjScdhISHv+lXe+H3lqix/5JlCT\nqg0qMq" +
       "bj04aWy0yPT8vUNNAKXVPmMorGbI4eHvd335j97uDWtgBqmEANsjrGMJOlIU" +
       "1lxGQTKJwl\n2SQx6GAqRVITKKISkhojhowVeR4INRUupnJGxSxnEBonVFPy" +
       "nLCJ5nRiiDudxRgKS5pKmZGTmGZQ\nhhpjMziP+3NMVvpjMmUDMRRKy0RJ0c" +
       "fRPuSPoaq0gjNA2BpztOgXHPs38XUgr5NBTCONJeIcCe6V\n1RRDXe4TBY17" +
       "tgEBHK3OEjatFa4KqhgWUJMlkoLVTP8YM2Q1A6RVWg5uYWj5gkyBqEbH0l6c" +
       "IQmG\nlrnpRq0toKoVZuFHGFrqJhOcwGfLXT4r8dZIKPzP4dG/VoDHQeYUkR" +
       "QufwgOdboOxUmaGESViHXw\nei56dHhXrt2PEBAvdRFbNIOrP9oRu/JZl0XT" +
       "VoFmRMRiQrpxb3vHucGfagNcjBpdozIPhTLNhVdH\n7Z0BU4fobi1w5JtRZ/" +
       "Pz+Be79r9LfvWjmmEUkjQll1WHUS1RU0P2vBrmMVkl1upIOk0JG0ZBRSyF\n" +
       "NPEO5kjLCuHmqIK5jtm0mJs6QqgaHh88cWT9buMDQ/UxTcJKPKdG6QxD3YxQ" +
       "RqeoIU2pSS01N6Vq\nEOV4fqqEyuQ8b5v1+UCddje0FIjDLZqSIkZCevvyN0" +
       "9u3Pb8IctRPLhsaSCaBfeozT3qcEc+n2Db\nzCPQstCgYeA5jgzzwLmO177E" +
       "b4K9QW8qzxOhlm82yEc4dNeiiWOoCLthmGGIioTUsv/K8td/eOes\nHwUqJo" +
       "9YYXGTZmSxwv3voKXJvs69A2HT4w7eSnf/fnj7qfPfXlxbDGOGejzo8p7k6F" +
       "jlNruhSSQF\n2afI/pW/t/xxpOq+D/woCJCDpMMwhAoguNN9RxlKBpyMw3UJ" +
       "xFB92qN4HQMDzZYozMcwHxqt0ABf\ntLgEFMnq+tOhOy98Un9WaOzktYaSBD" +
       "hGmIWSSNH/4wYhsH7x1dEjL109OBkAXOq65XOGQnouqciS\nCUduLwcWFy/F" +
       "w+a3kwONL/TRD4WLa+VsNsdwUiGQiLGiaLMklWAiE0VKsp5INmCJcBKSFuS/" +
       "hAKM\nLF11Xx7Cs0JaiC5rOfpy7xsXeOLQhWFaOcCEpMgUCz0+Pq71bPL3Dh" +
       "7BLUW1Aep7LQXCvWO7t+45\ntEpoXspunf1iM0d5Lxw38UrixEQ2+cSfp4/V" +
       "rShKuK6UXacYV9q25fNuh3NR7MIJA3UslKFFdTn4\n2LXwc/jMbiuPNpU7Z6" +
       "Oay95z/EfS+1BYqpAcapmm9ykkT5SCqfziXj9c27coyreLglZEQWBsQ++a\n" +
       "dfW/AAoWAHjEXowTqN4ql5/fWSOQj/838rtcRnHLE8m3PRqYlr/yc2zZoPfU" +
       "6fJDA6XmAfQZ5YKK\n6GkTAjSAiRrhGbD/kfPPNyN8aLIB6vG3n6Fq3ZDzmA" +
       "EUQlT0P5WD1sm3/L0Z+hcRshw1UatXuHmo\nb2CoGfJRWs5Awho3sEp1zWCU" +
       "euv3qCFnoTzm7fr9YudbP5+6HG+xQsZqcro9fUbpGavREbfW6zxo\nVy52g6" +
       "A+c8fKE/vil5J+W9r1DAXzmpwSCj1SAgKxsNlcYOWBgkf40wfPGtsja27RIw" +
       "KBfHh4cUd4\neyVRMi2TnQz0XPN/3NojqkAwiakT3eVNpreHLGsNhYx1BY26" +
       "4Fl9E402V5DT7d6y7JSQ5j/dcez6\n9+yScG+xYnE+7aY3t+3EJcV0/fl8JP" +
       "Te8awfVU+gRtFiY5XtxEqOF48JUJAO2YsxtKRsv7zhtbq7\ngQI4293xVXKt" +
       "u1aWwjTIygAqyuOU6UM6nyQrArAqLatYsRIvgFAhaoZNC5qYboXACEMB8BSf" +
       "Tpqe\n3GgjsrmIyCFFUwmvds6eVWBkLVr4fIFNsyK2H7QkFnfx4e5FcX1T0E" +
       "Nar5K4OBUSh2Vz85byTYl2\nG02J6Lx5FheMA06zEDACppXBOukB66QJlq5x" +
       "uk/eeSzzfCtaXzTSqnN71p7WI19bSHK+Oqqh9U/n\nFKXU8yXzkG6QtCzkq7" +
       "biQBd/BxhaUtYBQ/q1Z0LE/RbZM2A0QcZfnhWhkzd9/wHsJeNIKA8AAA==");
}
