package nbody.noaliaz;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import nbody.Particle;
import nbody.ParticleV;

public class Worker {
    final private static int MAX_PARTICLES = 4000;
    final private static double G = 1.0;
    final private SJProtocol ps_nbody =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1WXWhcRRSe3U023STVpKYx2rQhadImVHelUFH2pena2thb" +
       "GpO20hgIs3dndyed\nvfc6dzbZBCmKD+pLQVq1grYgglgCSqX6oFTBf8EH+2" +
       "BFsD5URNCCvgX1wXNm9vdm2UBuZubM+f2+\ncyZrt0m7L8lun/k+d53FuFrx" +
       "mB/HrVnNPjZ7gOW4cxx2CzYxP6EwISVJdrXQqlMa67Ev3ze+tmqU\nxlu5Mq" +
       "Kgr5BF2u08FxlFxq2KekIrJarqiQb1JHjaGfCEXze9yGyFvoyT79+96MbG/r" +
       "1qYtvquWIl\nJ1xV1jB3Jsc+PGH9/smQubOtyZ1j2uqC/d+Dg9uvT/4ai2DI" +
       "mzzX5wr8KzJgVZQSRcVFYrosSZY8\nrwTlH2tZEyfTrPj7WugchTXNsZRbKB" +
       "QdblNVLeo7Bz4LWV3XftFF7SqYeyhSZGstSFNQU8enyBkS\n1lG2Qm7KWQaA" +
       "WLNAWyVnua5ndCKPfPPmhYmfPtCBtaXdzAo6jlTcez4uNuOidSAzzGZ8qUkg" +
       "qN9p\n9O8NQDgpJV0xGlcio3+HP+ofDZM2DIP6DPW6LBLNciYyviI91iJdog" +
       "ZHi/sqaZFO7igms9RmOso+\ni3QUmMq7GbOFGuwIeJxhWSaZY5fjXC/Gz0+d" +
       "Kg5W4sSW7K+qoKt4hTKfznx56pnL7I8w2TRForYr\nigVnisSAJKnyugPWFn" +
       "eYOT2WzfpMTZE2oY+irt5DblmAS5EtJhtBnVxiVknu5CCfNo+qPMYxUPKg\n" +
       "fCPwuxd+z5bLqf8qEnvClaeZjPuLigwr5it/3pf2vIPYzTsuFZyuzlfvIIEG" +
       "A1WYFlCyw67IMLlg\nv33r26cPHnnxBUMAhxZYOQJF7tA249NUKm4LBpbuwq" +
       "hNYTR4CETp2evbX/uKvgHNB+n6fJXp6EPL\nbfj1N4JwCBGdcnxFAYgFe/Xa" +
       "iYvr36mbOoCYDX1LoWRSkR3BxmhADydNMLGTVNbsPvTDUm/0vUuF\nMOmYIz" +
       "1gFwXqJBVFNsvUHLDHT5UPLbK5Qd6Ij5kyiE+G2UKRwWBcdW7hVntW0BwQtj" +
       "947RCeJ+uL\nDGsUaaprAkbxc08pRDxc7Ibi9QWLh0bWn4s+cOPjri/MiC77" +
       "u7OuQSDBpG653hpgxyXDxH++MH3u\n5dvPPxkBznueBimswAh3KOQW9Yppwe" +
       "0SrARzcirfBL9pyQvQE5Vmf2nHW7+9f2umzxDoNHfgudgZ\nzL1BZ/QIXDIT" +
       "rl1PuOFWHvTtz/cMr52ZuZk2o21LY48edIqFfZd+ZBP7u+0mNI7AmMBNf0nP" +
       "hSHM\n2OSt94OqTGsEO54SrsNoWrCKrE/LuBufZZJDc62isGapRvOhQBJH9S" +
       "iq8bF3advjkTz/OkwiVSoN\nBevUqBQgS6dkqij1i2IoI8nIhsq5NssUJav5" +
       "ffWfw3+da3/4qh6ttf5CCyMV9uBmFzxMWVcWqEAH\nlYnaqfLSXa6d1NNUF1" +
       "Ufj+vvHkOnEK7jiOvdjTihlQyOjD+vJHvO3u/DoxOZIzEOr6XCqlqkmwrh\n" +
       "LrPMgtJPY29dF6YE9bF7utPUBpLlFgQYMiF5oSUYTU3+P4gP9J1/ZeL1G8ga" +
       "rwoZ0VESg2FKR/vo\nBiHu90Nf2MiHChd6ajwxQ0Ff2/s/z9RSc80JAAA="));
    final private SJProtocol pc_nbody =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1WXWhcRRSe3U023STVpKYx2jQhadImVHelUFH2pena2thb" +
       "smbbSmNgmb07uzvp\n7L3XmdlkE6QoPqgvBWnVCtqCCGIJKJXqg1IF/wUf7I" +
       "MVwfpQEUEL+hbUB+fM7O/NsoHczMyZ8/t9\n50zWb6NOwdEeQYSgrrMUlase" +
       "EVHYmlXqscRBkqfOcbVL28j8BIIIlTna3UarQWmyz75839T6mlGa\naqOUMi" +
       "K/r4CFOu0CZVmJpqyqekwrxWrqsSb1uPK0y+cJvm5midgSfBkn37970Y1M/n" +
       "vVxLbdc9lq\nnrmyomHuzEx+eML6/ZNRc2dHiztz2mra/u/B4Z3XZ36NhCDk" +
       "LZ4rqFT+JRqyqkqxkqQslqxI4mXP\nK4v2NZknNqHLpFX997dRO6bWOE8Sbr" +
       "FYcqiNZa2u7xz8LGD1XPtF17WnaO6BSKLt9ThNTU0pn0Jn\nUFAHOt3G41xJ" +
       "riiQWkY62UbPcl3P6IQe+ebNC9M/faAj68i42VXwHKr69wQstsKivcUUcbKb" +
       "owDl\nbqN8rw/DGc7xqtG4Epr4O/jR4EQQdUAMWBDQ67FQOEcJywqJ+qwlvI" +
       "wNkBYVMm6hbupIwnPYJjrE\nAQt1FYksuFmzVQUY8XmcJznCiWNXqrVRip6f" +
       "PVUarsYJPTlYUwFX0SpnPp3/8tQzl8kfQbRlFoVt\nl5WKziyKqJQTlXWXWl" +
       "vUIeZ0LpcTRM6iDqaPwq7eq9xyCiuJtplsGHbysZTk1MmrfDo8LAsQx1DZ\n" +
       "U+UbV7/71O/ZSjn1X4kiT7j8NOFRsSTRmCRCikXB7UUHgFt0XMwoXlus3QH6" +
       "DPuqkGSqZEdcliU8\nbb9969unDx198QWDvoOLpBKBRHdom9Ek5pLajChLd0" +
       "HUpjAaPACi/Oz1na99hd9Q3afSFXSN6OgD\nKx3wFZtBOAyIzjpCYgVE2l67" +
       "duLixnfypg4gYqvGxapkXKIRf1s0oQejxp/YSczrdh/6Ybk//N6l\nYhB1La" +
       "A+ZRcE8iRmJZIickGxRyQqhxba2iRvxseMGcAnS2wm0bA/rga36lZnjuG8Iu" +
       "yg/9phOI83\nFlmtQaSprgkYhs895QDyYLFHFW/AXzwwsvFc+IEbH/d8YWZ0" +
       "xd+dDQ2iEozrluuvA3acE0j85wvJ\ncy/ffv7JkOK852mQglIZoQ5WuYW9Uo" +
       "ZRu6xWjDh5WWiBX5LTouqJ6nB8aeSt396/NT9gCHSaOuq9\n2OXPvUln4qi6" +
       "ZOZbp55vY+086Nuf7x1bPzN/M2Pm2rbmHj3klIr7L/1Ipg/02i1oHFJjAjaD" +
       "ZT0X\nRiFjk7feD8sKrQHsaIK5DsEZRqqyAS2jbjRFOFXNtQbCuqU6zUd9SR" +
       "zTo6jOx/7lHY+HCvTrIArV\nqDTqr1Ozko8s3ZzIEtfviaEMR+ObKufaJFvi" +
       "pO731X+O/HWu8+GrerTW+wssjFfZA5vd6lnKubyI\nGTioTtRuWeDuSv2kka" +
       "a6qPp4Sn/3GjoFYB0FXO9uxgmsZGFk/Hkl3nf2fqFenNACilD1VkqoqoV6\n" +
       "MWPuCsmmpX4Y+xu6MMGwgO7pzWBbkSyfZsqQCckLLKvR1OIfhOjQwPlXpl+/" +
       "AazxapAhHSUyGCZ0\ntI9uEsL+gOoLG/hQ5UJfnSdmKOhr+/4HAX2pQs4JAA" + "A="));
    
    public void run(boolean debug, int port_l, String host_r, int port_r,
                    int numParticles) {
        final Particle[] particles = new Particle[numParticles];
        ParticleV[] pvs = new ParticleV[numParticles];
        SJServerSocket ss_l = null;
        final SJService c_r = SJService.create(pc_nbody, host_r, port_r);
        SJSocket s_r = null;
        try {
            ss_l = SJServerSocketImpl.create(ps_nbody, port_l);
            SJSocket s_l = null;
            try {
                s_l = ss_l.accept();
                s_r = c_r.request();
                SJRuntime.send(s_l, SJRuntime.receiveInt(s_r) + 1);
                this.initParticles(particles, pvs);
                int i = 0;
                while (SJRuntime.outsync(s_r, SJRuntime.insync(s_l))) {
                    if (debug) {
                        System.out.println("\nIteration: " + i);
                        System.out.println(
                          "Particles: " +
                          Worker.noaliasArrayToString(particles));
                    }
                    Particle[] current = new Particle[numParticles];
                    Worker.noaliasArrayCopy(particles, current);
                    while (SJRuntime.outsync(s_r, SJRuntime.insync(s_l))) {
                        Worker.computeForces(particles, current, pvs);
                        {
                            Particle[] _sjtmp_current = null;
                            _sjtmp_current = current;
                            current = null;
                            SJRuntime.pass(s_r, _sjtmp_current);
                        }
                        current = (Particle[]) SJRuntime.receive(s_l);
                    }
                    Worker.computeForces(particles, current, pvs);
                    Worker.computeNewPos(particles, pvs, i);
                    i++;
                }
                if (debug) {
                    System.out.println("\nIteration: " + i);
                    System.out.println("Particles: " +
                                       Worker.noaliasArrayToString(particles));
                }
            }
            finally {
                SJRuntime.close(new SJSocket[] { s_l, s_r });
            }
        }
        catch (SJIncompatibleSessionException ise) {
            System.err.println("[Worker] Non-dual behavior: " + ise);
        }
        catch (SJIOException sioe) {
            System.err.println("[Worker] Communication error: " + sioe);
        }
        catch (ClassNotFoundException cnfe) {
            System.err.println("[Worker] Class error: " + cnfe);
        }
        finally {
            if (ss_l != null) ss_l.close();
        }
    }
    
    public static void main(String[] args) {
        boolean debug = Boolean.parseBoolean(args[0]);
        int port_l = Integer.parseInt(args[1]);
        String host_r = args[2];
        int port_r = Integer.parseInt(args[3]);
        int numParticles = Integer.parseInt(args[4]);
        if (numParticles <= MAX_PARTICLES) {
            Worker w = new Worker();
            w.run(debug, port_l, host_r, port_r, numParticles);
        } else {
            System.out.println("Too many particles: " + numParticles);
        }
    }
    
    private void initParticles(final Particle[] particles, ParticleV[] pvs) {
        for (int i = 0; i < particles.length; i++) {
            Particle p = new Particle();
            p.x = 10.0 * Math.random();
            p.y = 10.0 * Math.random();
            p.m = 10.0 * Math.random();
            {
                Particle _sjtmp_p = null;
                _sjtmp_p = p;
                p = null;
                particles[i] = _sjtmp_p;
            }
            ParticleV pv = new ParticleV();
            pv.vi_old = 0;
            pv.vj_old = 0;
            pv.ai_old = 0;
            pv.aj_old = 0;
            pv.ai = 0;
            pv.aj = 0;
            pvs[i] = pv;
        }
    }
    
    protected static void computeForces(final Particle[] particles,
                                        final Particle[] current,
                                        ParticleV[] pvs) {
        for (int ours = 0; ours < particles.length; ours++) {
            double x = particles[ours].x;
            double y = particles[ours].y;
            double ai = 0.0;
            double aj = 0.0;
            for (int theirs = 0; theirs < current.length; theirs++) {
                double ri = current[theirs].x - x;
                double rj = current[theirs].y - y;
                double m = current[theirs].m;
                if (ri != 0) { ai += (ri < 0 ? -1 : 1) * G * m / (ri * ri); }
                if (rj != 0) { aj += (rj < 0 ? -1 : 1) * G * m / (rj * rj); }
            }
            pvs[ours].ai += ai;
            pvs[ours].aj += aj;
        }
    }
    
    protected static void computeNewPos(final Particle[] particles,
                                        ParticleV[] pvs, int step) {
        double dt = 1.0;
        for (int i = 0; i < particles.length; i++) {
            ParticleV pv = pvs[i];
            double x = particles[i].x;
            double y = particles[i].y;
            double ai_old = pv.ai_old;
            double aj_old = pv.aj_old;
            double ai = pv.ai;
            double aj = pv.aj;
            double vi_old = pv.vi_old;
            double vj_old = pv.vj_old;
            double vi;
            double vj;
            if (step == 0) {
                vi = vi_old;
                vj = vj_old;
            } else {
                vi = vi_old + (ai + ai_old) * dt / 2;
                vj = vj_old + (aj + aj_old) * dt / 2;
            }
            particles[i].x = x + vi * dt + ai * dt * dt / 2;
            particles[i].y = y + vj * dt + aj * dt * dt / 2;
            pv.vi_old = vi;
            pv.vj_old = vj;
            pv.ai_old = ai;
            pv.aj_old = aj;
            pv.ai = 0.0;
            pv.aj = 0.0;
        }
    }
    
    protected static void noaliasArrayCopy(final Particle[] src,
                                           final Particle[] dest) {
        for (int i = 0; i < src.length; i++) {
            Particle p = new Particle();
            p.x = src[i].x;
            p.y = src[i].y;
            p.m = src[i].m;
            {
                Particle _sjtmp_p = null;
                _sjtmp_p = p;
                p = null;
                dest[i] = _sjtmp_p;
            }
        }
    }
    
    protected static String noaliasArrayToString(final Particle[] ps) {
        String m = "[";
        for (int i = 0; i < ps.length; i++) {
            m += ps[i].toString();
            if (i < ps.length - 1) { m += ", "; }
        }
        m += "]";
        return m;
    }
    
    public Worker() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238689142915L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAK1ZfWwUxxWfvbPvbOzgTyjFBgKYYqtwTqJS0boNmAOKnQOM" +
       "zwHHITLr3Tl77b3d\nze6cfXaiFGgVUpCQ2gBJUUmiNFKUhLYpiPSPVqRqAm" +
       "1Cq6hUIqhq0qip2qhtquSfgEha9c3Mft3e\n3dpUIHY8O/Nm5n3+3pu90x+i" +
       "SstECQtblqJr4wkybWCLtfrIOJaIlUj39ommheWkKlrWAEwMS/v+\nq+z+ac" +
       "PBbREkDKFGTe9WFdEaGDP13OjYwJhi5U10u6Gr06OqTuwdi/b46srPpn57qL" +
       "cliuqGUJ2i\npYlIFCmpawTnyRCqzeLsCDatblnG8hBq0DCW09hURFWZAUJd" +
       "g4MtZVQTSc7EVj+2dHWSEjZaOQOb\n7ExnMIVqJV2ziJmTiG5aBNWnxsVJsT" +
       "NHFLUzpVikK4ViGQWrsvUgegRFUqgyo4qjQLgw5UjRyXbs\n3ErHgXyeAmya" +
       "GVHCzpKKCUWTCVoWXOFK3HYPEMDSeBaTMd09qkITYQA1cpZUURvtTBNT0UaB" +
       "tFLP\nwSkELS67KRBVGaI0IY7iYYIWBen6+BRQVTO10CUELQiSsZ3AZosDNv" +
       "NZa2es9j+H+67dDhYHnmUs\nqZT/GCxaGljUjzPYxJqE+cLrucSxnvtyrRGE" +
       "gHhBgJjTdK/62b2pD15dxmlaStDsZL44LH325dYl\nl7v/Wh2lbFQZuqVQVy" +
       "iQnFm1z57pyhvg3QvdHelkwpn8Zf/F+/a/iP8ZQVU9KCbpai6r9aBqrMlJ\n" +
       "ux+HfkrRMB/dmclYmPSgCpUNxXT2DurIKCqm6qiEviGSMdbPGwihODwC/F+M" +
       "+L/5tCGoeo9uTmAz\nYY0TtJxgi1h7LVPaq43o8vReTQcfF2f2ujR5ut/8KU" +
       "EAUVqDYaWCD27TVRmbw9Lz77/58JZ7vvMY\nNxJ1LJsTgprZ3gl77wTfGwkC" +
       "27SJ+h7XTbdpitM0JvIHLi/5/q/FU6BpkNhSZjATSJiqoC0suisU\nMpJewP" +
       "VATwR/GJaa93+w+OQfXrgQQdGSsJFyB7fqZlZUqeWdOGm0jwvOgMO0Bd221N" +
       "n/Prz97JVL\n77R7DkxQW1FcFa+kcbEiqHRTl7AMuONt/8SNbR89XvmVcxFU" +
       "AcEGcENEcBKI3aXBMwrio8vBGipL\nNIVqMkWCzyOgoCmfwLStpU09dwywRX" +
       "OAQQZT178Vu+PtX9RcYBI7iFbng740Jjw+Gjz7D5gYw/g7\nT/Y9fvzDQ/dH" +
       "ISINg9ucoJiRG1EVKQ9LPlcYUpQ9mbrNv8501R9da73CTFytZLM5Io6oGCBY" +
       "VFV9\nCsvDhGFQgw/vGMyAJmpHAK4A+YZV2IjLagiT4J4lACGxqPnYiY4fvE" +
       "0hw2CKWUhDi3GK8mygTaBt\ne9EkfV9CPbjZExuCfIILUNuRfqB332MrmOT+" +
       "7dbYL3l3wwo2UgE7rQmNha00tXiuojz8yYEzbx2v\njaDIEIor1lZFE1WqLG" +
       "sHd/4SoBrYYub8vU9d/x15l5nW8zbKWGu+GCR2i75AWH9lsiH28tPZCIoP\n" +
       "oXqWGEWN7BbVHDX8EKQ2K2kPptBtBfOFaYpjcpcbTa1BT/cdG/RzD5ygT6lp" +
       "v4q7NqOpA81SHXfC\nU2+DJ/tLJxto05hn2MV9lzKU6IGcPIrNxr8889y1A4" +
       "fWRyhyVU5SxkEn9R7djhytLB49fXxJzbH3\njjAPQqjuGbrpOnb4UtYu5+aP" +
       "EmCdmoiguGEqkyIBPcQsVq3kCbpte/fgcF93/0BPMrUlbRWbrs9U\nspBuJu" +
       "18+N2lz/3t7Pv9zRyHeNGwsihv+9fwwoHppsagsbc87ARG/foXl59+pP/dEZ" +
       "5QGwtjdYuW\ny657+iru2FgrlcgUUShtGK4AytO/dxTYYxU8TbY9mkrZw6fn" +
       "zTrABd5/9le9HROfVsBRmx1zUPr1\nGz7i29CXb5TQO+1/jTZfp83doGuBk2" +
       "00eAwmwQ4yO8Ph10Rfmj0SAb2JDtneC4l9R67u2j64p5Or\n687QLXaAruRA" +
       "OB7v0TacX3BFi1C8jlnjPueOWISg9pSzpW1f+sp76d40n+I1GFO4AZo0aG+g" +
       "WCsR\nTyugkCrDGmaJnZE0EdTi8m7mNKJkMa3ebXmZkgQGintAU6sDYro8wZ" +
       "L0JjyqaNxhbWMLXDlfCFnl\nW7SqXnpxTfvpGb6oPewoT3z/WTRlSWOKKlN2" +
       "07DHylCr8OW//8lTevWqT89FbJTn4bIq9HRNLiXm\nupA126EPRXVSh+SmKR" +
       "K7jPA9Xtj0mpCqOf9nxn5NltMNFKDbXsZSmEJ6tCmQG5fiKkySlK4bfE10\n" +
       "8xvPPtnxx1d4bFPv4Dq0j+fZcsRgmT+MkX4sYRe2/IzQ9fv4+uCNgZWPfMWZ" +
       "aNvHkZ8vbGMVUcWI\naHEtBK9axTepggsSO2yeC0Er4LkLnqM2P0cDEOTEwX" +
       "xe7sKlE1BaxW7KdspX+n4nbcbzAmKxpoXF\n2kqItZiKtVFe22+ijeIVAhFO" +
       "7hze5EFgUtU1TAsgZ47XHIqecO+yMJkv4s9EywKa3c6U4mFOw2TL\nruiY8p" +
       "sIS6c8AxddPgsXdRXm3XkmhruzVuifLVwpTMBijQhcGaHl1ay11wwkVInqxd" +
       "GJL2XwmoKR\nbWLTu1ww/PbsYChxMKQDgz60OzQL2iXLoB1de7+dazIsbjtC" +
       "dtmZI2UCl66XnMA74nSGocPUzIRl\nRA9x3SFPd07RCWcvKXc5Zxn/0ODHtY" +
       "+Krz/gnLcZLplEN9aqeBKrrhnibLs47LY2FE6DzhZNb+hY\nvabm7xDLZS5u" +
       "DfZgf6FPsRudeJM3Otrm3ZCvgmcQnmW2SpcFQp4Z2qe9gOdVMpErg4VDfETX" +
       "VSxq\nnqcVOiL/BuMG+6bZ3foElE6QdIMHVUzqisyWPeuzaCXtnnS3PxU8aG" +
       "5Ux10l0Wc1PNO2kqZLKalM\nAK2kzd2lBfTj5Zh72udtM4Sddqo85v7YwdyX" +
       "wzGXtg+6Mv+oCG/pKxvLFQMo8yF+GFtc3kHmjFvn\naHOANgfzs1M/D6bPwq" +
       "2MWb7I/oJPouIRz67V8PSF5LsydhU4JpZk0qc8JWDXjfD0zCG71hVm193l\n" +
       "TX3RMfWbN2PqC/+fqS+y9sItMPVbN2XqV+EWqGgKKag2im0eKXE9scGR3ivs" +
       "D1/0phn4hHpt14nx\n5Sf3f499bXc+GEA52DnbZoF9fvjNqsOLGvNPsMIwYr" +
       "JbXisvsAye8QWf9tf4/MQ37PlmIzwPwfOS\n7S0vzRFzIDMZcCWBVIPlEOiJ" +
       "erdAJchEmDX+ROhXi6yRIxgyi1TOGlHWv+oIXvhWpIbSbBTqgub8\nS7YuLt" +
       "0E/r53E0pgzj2HZPQPTwk78FSfPjclBE8Iyu6fK5RdhueGLfuNWyR7JOCAyu" +
       "xifwI53I4C\ndhNJ6sZ0uWAMMX/pAFBKCd4LCFTF5eZ/b4Hggofhs8ssROnH" +
       "fZ/MA7pXu5xi607500x5Se0D6VWH\n/zxAL3iLin7G4z82SSsu72t/zWh4g1" +
       "/vnB+E4ilUlcmpqv/znq8fM0ycUdjZcf6xjzEiNIC7FvxA\nAQWa3aMMCvWc" +
       "rBluDk6FLyxgeeVgXvgf1vwqIcMcAAA=");
}
