package nbody.ordinary;

import java.util.Arrays;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import nbody.Particle;
import nbody.ParticleV;

public class FirstWorker {
    final private static int MAX_PARTICLES = 4000;
    final private static int MAX_PROCESSORS = 128;
    final private SJProtocol pc_nbody =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1WXWhcRRSe3U02zU9tUtMYbZrQNmkSoruiVJR9abo2NvaW" +
       "xGxbaQwss/fO7k46\ne+91ZjbZBCmKD+qLIK1aQVsQQS2BSqX6oFTBf8EH+2" +
       "BFsD5URNCCvgX1wTkzu9ndm2UDuZmZM+fv\nO985k7VbqFVwNCqIENRzF2Ny" +
       "xSciBluzSj2aPEhy1D2mdmkbmZ9QGKESR/uaaNUojXTbF+8eW1s1\nSmNNlF" +
       "JGFPQVslCrnafMkWjMqqjHtVJ8Qz1ep55QnvYGPMHXyywSW4Iv4+T7S+e99p" +
       "F/r5jYdvge\nW8kxT5Y1zJ3JkQ+PW79/MmTu7GxwZ0ZbTdv/PTCw69rkr+0R" +
       "CHmL7wkqlX+J+q2KUrwoKYvPliWJ\nku+XRHNM5ohN6BJphP/+JmpH1RrnSN" +
       "IrFIoutbHcwPXdg5+FrM6rv2hcOwvmHogk2lGN02BqoHwS\nnUZhHeh4E48z" +
       "RbmsitQw0pEmepbn+UYn8vA3b54b/+kDHVlLxnNWwHOk4t8XsNgKi+YWU8R1" +
       "NkcB\nyh1G+a5ADSc5xytG43Jk+O/wR33DYdQCMWBBQK/TQtEsJcwREnVbi3" +
       "gJm0JaVMiEhTqoKwnPYpvo\nEHst1FYgMu85ZqsAGAx4nCNZwolrl9FaL8bO" +
       "Tp8sDlTihJ7s21ABV7EKZz6d+/Lk0xfJH2G0ZRpF\nbY8VC+40alcpJ8vrNr" +
       "W2qEvM6Uw2K4icRi1MH0U9vVe5ZVWtJNpusmHYzcVTklM3p/Jp8bHMQxz9\n" +
       "JV/BN6F+71e/75Th1H8lum2KciEf9/gpwmNiUaJRSYQUC4LbCy5Ub8HjDnUx" +
       "X1movwlMGggAMssU\neoc95hCett+++e1Th4688LwhgosLpByMcqotx2Yxl9" +
       "RmRFm6HRIwGOk6Qk1Kz1zb9dpX+A3ViCpz\nQVeJTiS03AJfsbkeU1DcaVdI" +
       "rGqStlevHj+//p28oQNot1UPY4Uel2gw2CF1hYSpE0zsBOZVuw/+\nsNQTfe" +
       "9CIYza5lG3sgsCeQKzIkkROa+IJJLlQwttrZPXl8pMHCiVQ2wm0UAwrhq36l" +
       "ZrluGc4m5f\n8NoUnCdqQVZrEGnWay5G4XNnKYR8WIwq8HqD4IGR9Wej917/" +
       "uPMLM67L/rbV9IpKMKG7r6dasGOc\nQOI/n5s98/Kt556IKPr7vi5SWCojij" +
       "wqt6hfzDBql9SKETcn8w3qN8tpQbVHZU6+NPjWb+/fnOs1\nBDpFXfV07A3m" +
       "XqczfERdMqOuVY+63c086NufT+xeOz13I2NG3Pb6dj3kFgv7L/xIxg902Q1o" +
       "HFET\nAzZ9JT0ihiBjk7feD8gyraHYsSTzXIIzjFRkvVpGvViKcIoZXQVh1V" +
       "KV5kOBJI7qqVTlY8/Szsci\nefp1GEU2qDQUxKleKUCWDk5kkeunxVCGoz2b" +
       "kPNs4hQ5qfp99Z/Df51pfeiKnrLV/gILeyrsgc0+\n9UJlPV7ADBxUhmuHzH" +
       "NvuXpSS1MNqj4e098JQ6cQrGNQ1zvq6wRWHBgZf15OdL94j1CPT2QetVP1\n" +
       "bEpA1UJdmDFvmThpqd/InpouTDIsoHu6MthWJMulmTJkQvJDS2o0NfhfIdbf" +
       "e/aV8devA2v8jZIh\nHSUyNUzqaB/ZJIT9AdUXNvChwoXuKk/MUNDX7vsfUq" +
       "asetkJAAA="));
    final private SJProtocol ps_ring =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1VXWhcRRSe/cmm+bFu0jRWu01Mm9iU6q4gFXURTENDY29p" +
       "TNpKY2CZnTu7O+ns\nvdeZ2WQTpCg+qC+CtP6Bti8FtQSUSvVBqYK/CD7YB+" +
       "uL9aEighb0LagPnpnZze7ehCzcuzNz5vx9\n5zvnrtxCbVKgvZJKyXxvPq2W" +
       "AirTemtXM4/PHKRF5h2HXY4g+4tEEaoKdM8mWk1KI0ly6d7RlWWr\nNLqZKy" +
       "sK+4o4qI2UGHcVGnXq6hmjlFlTz7SoZ8HTnpAn/fbz85Qo7cs6+eH9837HyL" +
       "9XbGzbA58v\nFbmvahr2ztjIxyec3z8btHd2bnDnmLGaI/89mNp1bezXjpgO" +
       "eUvgS6bAv0I7nLpSpqIYz0zVJNlq\nEFTl5phMU0LZAt0I/wObqB2FNS7Scb" +
       "9crniMYLWG63sHv4g4XVd/Mbh2le09LVJoeyNOi6mF8ml0\nBkWDagCR3hXK" +
       "fkwIvGTtXo4N/x39pH84iuIOiuexpFqvy0GJAqPclQolnXm8gC0EDpMq66BO" +
       "5ikq\nCphQqW9vdVB7maqS79otJDkQ8jhNC1RQj9QQWa2kz02eqqQ0IlpFs7" +
       "l/TUW7StfR/nz661PPXqJ/\nRNGWSZQgPq+UvUnUQT13vLZuh7XDPGpPjxUK" +
       "kqpJFOfmKOGbPeRWYBzA6rXZcOwVMzNKMK8I+cQD\nrEo6jt5qAIXaD88D8L" +
       "xbK5z5V2jrBBNSPemL01Sk5bxCexWVSs5JQea8vO8uzfnCZR4WS3OtNzVZ\n" +
       "UiFApjigd9jnLhU58s7N7545dOSlF01x4x4u01ow4NRYTk9hoRjhFCxt0wlY" +
       "jEwddU2qz13b9eY3\n+G2gMGQu2TI1iUQW4/ot19djQhd30pMKQ01yZPnqif" +
       "Or36sbJoAOAuzHgJ5QaCDMrZZC6n4NJ3YS\ni4bdh35c6El8cKEcRe2zKAl2" +
       "tUCdxLxCZ6iaBSLJ8dqhg25rkbeWyvaqLpVLCVcoFY6ryS3caitw\nXATu9o" +
       "evTejzbDPIsNYiw3rDxYR+batGUKAXQwBeXxg8bWT1+cT91z/t+soOupq/25" +
       "t6BRLMmu7r\naRTsuKA68Z/fmDr76q0XnooB/YPAFCmqwAiQB3JLBJU8Z6QK" +
       "K069oiptUL8pwcrQHvUJ88rAxd8+\nvDndZwl0mnkwdPeEc2/RGT4Cl+yQaD" +
       "PTbGgzD+b2l/uHVs5M38jbMdbb2q6HvEr5wIWf6L7HuskG\nNI7BxNCbZNWM" +
       "iDt1xjZvs+9XNVrrYqfHue9RnOe0LuszMuanZ6hgmLNlLWxYatB8MJTEUTOV" +
       "Gnzs\nWdj5RKzEvo2i2BqVBsM4tSqFyNIpqKoIM5QtZQTavQ45n1C3ImjD7+" +
       "v/HP7rbNvDV8yUbfSXtpCq\ns0dv7obZXvBFGXPtoD5cO1VJ+IuNk2aaGlDN" +
       "8W7zHrF0iuj1qK7rHa110lZcPTL+vJxNvnyf/Aig\nmEUdDD44SqPqoG7Mub" +
       "9I3ZwyX5eepi4c51jq7unOYwIkK+Y4GLIhBZEFGE0bfGXTO/rOvbbvreua\n" +
       "NcFayZCJEtkaPmqiHVsn1PtHoC+I5kOdC8kGT+xQqP4PYj8Daw4JAAA="));
    
    public void run(boolean debug, int port_l, String host_r, int port_r,
                    int numParticles, int reps) {
        Particle[] particles = new Particle[numParticles];
        ParticleV[] pvs = new ParticleV[numParticles];
        int numProcessors = 0;
        final SJService c_r = SJService.create(pc_nbody, host_r, port_r);
        SJSocket s_r = null;
        SJServerSocket ss_l = null;
        try {
            ss_l = SJServerSocketImpl.create(ps_ring, port_l);
            try {
                long timeStarted = 0;
                long timeFinished = 0;
                s_r = c_r.request();
                timeStarted = System.nanoTime();
                numProcessors = SJRuntime.receiveInt(s_r) + 1;
                if (debug) {
                    System.out.println("Number of processors: " +
                                       numProcessors);
                }
                this.initParticles(debug, particles, pvs);
                int i = 0;
                while (SJRuntime.outsync(s_r, i < reps)) {
                    if (debug) {
                        System.out.println("\nIteration: " + i);
                        System.out.println("Particles: " +
                                           Arrays.toString(particles));
                    }
                    Particle[] current = new Particle[numParticles];
                    System.arraycopy(particles, 0, current, 0, numParticles);
                    int j = 0;
                    while (SJRuntime.outsync(s_r, j < numProcessors - 1)) {
                        SJRuntime.send(s_r, current);
                        Worker.computeForces(particles, current, pvs);
                        SJSocket s_l = null;
                        try {
                            s_l = ss_l.accept();
                            current = (Particle[]) SJRuntime.receive(s_l);
                        }
                        finally {
                            SJRuntime.close(s_l);
                        }
                        j++;
                    }
                    Worker.computeForces(particles, current, pvs);
                    Worker.computeNewPos(particles, pvs, i);
                    i++;
                }
                timeFinished = System.nanoTime();
                System.out.println("time = " + (timeFinished - timeStarted) /
                                     1000 + " micros");
                if (debug) {
                    System.out.println("\nIteration: " + i);
                    System.out.println("Particles: " +
                                       Arrays.toString(particles));
                }
            }
            finally {
                SJRuntime.close(s_r);
            }
        }
        catch (SJIncompatibleSessionException ise) {
            System.err.println("[FirstWorker] Non-dual behavior: " + ise);
        }
        catch (SJIOException sioe) {
            System.err.println("[FirstWorker] Communication error: " + sioe);
        }
        catch (ClassNotFoundException cnfe) {
            System.err.println("[FirstWorker] Class error: " + cnfe);
        }
        finally {
            if (ss_l != null) ss_l.close();
        }
    }
    
    public static void main(String[] args) {
        boolean debug = Boolean.parseBoolean(args[0]);
        int port_l = Integer.parseInt(args[1]);
        String host_r = args[2];
        int port_r = Integer.parseInt(args[3]);
        int numParticles = Integer.parseInt(args[4]);
        int reps = Integer.parseInt(args[5]);
        if (numParticles <= MAX_PARTICLES) {
            FirstWorker fw = new FirstWorker();
            fw.run(debug, port_l, host_r, port_r, numParticles, reps);
        } else {
            System.out.println("Too many particles: " + numParticles);
        }
    }
    
    private void initParticles(boolean debug, Particle[] particles,
                               ParticleV[] pvs) {
        for (int i = 0; i < particles.length; i++) {
            Particle p = new Particle();
            if (debug) {
                p.x = i;
                p.y = i;
                p.m = 1.0;
            } else {
                p.x = 10.0 * Math.random();
                p.y = 10.0 * Math.random();
                p.m = 10.0 * Math.random();
            }
            particles[i] = p;
            ParticleV pv = new ParticleV();
            pv.vi_old = 0;
            pv.vj_old = 0;
            pv.ai_old = 0;
            pv.aj_old = 0;
            pv.ai = 0;
            pv.aj = 0;
            pvs[i] = pv;
        }
    }
    
    public FirstWorker() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238689511981L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAK1Yf2wbVx1/thMnabImTtNSmqRdm5QmWutsQGEQYEu9hiZz" +
       "mtTO2i7LcC/nZ+fS\n893t7tlxqlG1TFrHJiaVNTAmWCc0oJuKgE7b/oAFxD" +
       "bGgAnRSe2EtIEYgkkwxP5hFQzE9/ue73y+\ns50VEele3t37ft/3fX99vt/n" +
       "82+TRsskUYtalqJrC1G2ZFCLj/rcApWZFU2OT0mmRdMxVbKsaVhI\nyUf+ox" +
       "z8QeQL+4IkMEM6NX1EVSRret7U89n56XnFKprkWkNXl7Kqzko7+vb4ZN97i7" +
       "86Nd4dIu0z\npF3RkkxiihzTNUaLbIa05WhujprWSDpN0zMkolGaTlJTkVTl" +
       "GBDqGgi2lKwmsbxJrQS1dLWAhJ1W\n3qAml2l/jJM2WdcsZuZlppsWIx3xBa" +
       "kgDeWZog7FFYsNx0k4o1A1bd1FjpNgnDRmVCkLhBvithZD\nfMehUfwO5GsU" +
       "OKaZkWRqszQcVbQ0I1u8HI7G/bcCAbA25Sib1x1RDZoEH0inOJIqadmhJDMV" +
       "LQuk\njXoepDCyqeamQNRsSPJRKUtTjGz00k2JJaBq4WZBFkbWe8n4TuCzTR" +
       "6fubw1GW779/1T714LHocz\np6ms4vnDwLTZw5SgGWpSTaaC8Uo+embs9nxP" +
       "kBAgXu8hFjQj25+9Lf7Wj7cImu4qNJM8FlPyex/r\n6b048seWEB6j2dAtBU" +
       "OhQnPu1anSynDRgOje4OyIi1F78SeJn91+4kn6lyBpHiNhWVfzOW2MtFAt\n" +
       "HSvNm2AeVzQqvk5mMhZlY6RB5Z/COn8Hc2QUlaI5GmFuSGyez4sGIaQJngA8" +
       "rxDxtxYHRtaOKhCH\nh3TzKDWj1gIjOxi1mDVrmfKsNqenl2Z1M61okrk0W0" +
       "lZxK3XLgYCoFWPN8NUCMd9upqmZkr+zpu/\nuHvvrV+8T/gLY6x0KIgmLiFq" +
       "S4i6JJBAgG+9DoNRGGvENKUlTJLiyYu9X3tJ+gaYHkxgKcco1zCw\n2IAjMH" +
       "24LobEyhk4BjMJAiQld514a9Mjrz7xYpCEquJI3Pk4qps5ScVQsBOnsyTOuw" +
       "IR1O+N42qy\n/3b/xFOXfvn6QDmiGen3JZqfExNlm9f0pi7TNABRefuv/nPf" +
       "3x9q/MTTQdIA2Qf4wySIGkjmzV4Z\nFQkzbIMP6hKKk9aMT/E1DAy06FIYxz" +
       "YcOkR4gC+6PAfkuHXlnvD1l3/U+iLX2Ia4dhcWJikTCRMp\n+3/apBS+v/7w" +
       "1EPLb5+6IwQpahjC54yEjfycqshFYPlAZY7h8dIYNn+9MNzx4C7rGe7iFiWX" +
       "yzNp\nTqWAyZKq6os0nWIclCIuAOS4A5ZomwP8AihMqbCR0NUIFCA8qyBEdG" +
       "PXma8Mfv0yYojBDbMBc42f\nlBT5h/4AjgO+RXzvxQjuKqsNWX9UKNA2mLxz" +
       "/Mh927jm7u12ll6KzoYN/EsD7LSzbi6MYq0ph4py\n9z9OXvj1cluQBGdIk2" +
       "KNQl6qaCxrvwj+Kijr2eLYym2PXnmFvcFdW442PFhP0Q8VByVXItx4qRAJ\n" +
       "f/9sLkiaZkgHr5SSxg5Kah4dPwO1zoqVPsbJNRXrlXVLgPSwk0093kh3ifXG" +
       "eRmiYI7UOG8Woc1p\n2sGyaOMheDpKaMr/42IEh84ixy4Ru3ig6BgU6Sw1O/" +
       "/w2OPvnjx1YxCRq7GABwebdJTp9uex1bj3\n/HJv65nfP8AjiJD2x3DT3Vz4" +
       "Zj5uFe4PMTg6uoiRJsNUChIDO4Qt3r4UGblmYuRwamokMT0Wi+9N\nWn7XTZ" +
       "lKDupPoVQgT29+/E9PvZnoEjgkuog+XyF384hOgtum1cDc21pPAqd+4bqt54" +
       "8n3pgTFbaz\nMlf3avnc7rOv0cGb2+Qq9SIEvQ7HFUB5/H+9zx+Rkj8ifn/g" +
       "5OPw9QROPlvFmDj/FA6fxuEzYMC1\n3ICJydjeZHIykcTPe2z5Jvno6pkFaM" +
       "x0KOflED/ywGsHJg4fGhLq31B3i/2ge9qTXstj2k0r6y9p\nQcTfsLXgCtag" +
       "xRgZiNtblvyFr2KWHE+KJdFkcQMaYBkDZ1N+gwTLBgFbNBtyipdrTrKOkW7n" +
       "7GZe\nY0qOYnte0pcbKcBBDuNuh0dN50xYjffQrKKJACw5LyCM86E6XC6m7R" +
       "3ykzsHzh8TTAN1mFzqu2Vh\nCZLnFTWNx52EPfrqekWw/+Z7j+ot2//1dLCE" +
       "2iL860lPUJk6qVap6e46bBMwh8Y5pkO90hSZXzjE\nHk/seT4Qb135HdegNS" +
       "fopisA6zA/1WCd7SfzbBF0r3qs7XX44rpuCJ7QLS9/8+HB3z4j8hUjRNix\n" +
       "JF9UwM8ZvJrX2zEJfa3/FMg8K5i9dwLeDwqOC6H+d4I/3NDPW5yGOckSNvBe" +
       "pvx3pYorEBe2xsGU\n6+D5CDznSuc558EUOxHWii4WrpUAuyp1arDdj+L7DT" +
       "hkigHCk22hXrL1QbKFVaplRffOAYeWK3tQ\nkNvC15VrR0zVNYodjb0mmghF" +
       "jzq3VVgs+s5nki0ey05wo5RBJ1LoPhCaV34e5PVRlFTf9bKSabiy\nkK4xKd" +
       "yOtcro7BZG4Qr6LRIQxqjbL63aTBWgQspoF9smrlormgROtocvTzhoeGI1NG" +
       "wyrBRejfF9\n2oV296yCdskaaIe8hwyhzx0Q7sLpOC4KHUlZR7vbA1G9ta7J" +
       "vNSeOvxO273SC3faAm5hpIXpxi6V\nFqjqmCskqh/stqsu7nmDIpS8aXDHzt" +
       "Y/Q87VuDFFSh8Tlb7nVynpKq9SODInNZtRf3h6Szbs9aQm\n94jLep4ICXOV" +
       "w/z95pLVY+DUOV1XqaSVI6IyYMSvIU5SimH1GHwQGhcokV5pDQVdSXO2R1xu" +
       "DeP0\ny872y1WlXQXplxyb4bMDntMlm52uZrMacd8nOqKqqrphLu1I+yA8W1" +
       "aRtlwbKr9tQ+W5+lCJY87R\n+Vs+mMRXHYe7/LjHQ0oI48y14+V9w813cfg8" +
       "DseLq1OfhSDIwe2Ix4AvEgIujfxfyn5tgedAnTJV\nw68BAWVVDxkqN8Q8vq" +
       "jHuSPwjL+PytheWRkP1vb3iu3vn16Nv5/73/y9wrd57v/g75euyt/PwpVM\n" +
       "0RRW0Sn4He+yu0vJGmtQi1pdP5thn7TR93u3+FVW3nbxyMDzRuRl0SXZv5w2" +
       "xUlzJq+q7muvax42\nTJpR+PmbxCXY4P9edRof++c7uCPYU37ii4LwEpRgzW" +
       "4LLxvCWIH/Art3v3fuFwAA");
}
