package nbody.ordinary;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import nbody.Particle;
import nbody.ParticleV;

public class LastWorker {
    final private static int MAX_PARTICLES = 4000;
    final private SJProtocol ps_nbody =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1WXWhcRRSe3U02zZ8mNY3RpgltkzQhuitKRdmXpmtr197S" +
       "mLSVxsAyuTu7O+ns\nvde5s8kmSFF8UF+E0qoVtAURxBJQKtUHpQr+Cz7YBy" +
       "uC9aEighb0LagPnjOzm929WTaQm5k5c36/\n75zJ2i3S6kuyx2e+z11nMaZW" +
       "PObHcGtWs4/N7mc57hyDXdom5icUJqQkyVgTrRql0R770j3ja6tG\nabyZKy" +
       "MK+gpZpNXOc5FRZNyqqMe1UnxDPV6nngBPuwOe8OsuLDJboS/j5Pt3L7jto/" +
       "9eMbFt81yx\nkhOuKmuYO1OjHx63fv9k2NzZ3uDOUW01bf/34OCOa1O/tkcw" +
       "5C2e63MF/hUZsCpK8aLiIj5dliRK\nnleC8o82rYmTaVT8vU10jsCa5ljSLR" +
       "SKDrep2ijqO/s/C1mdV3/RRe0smHsoUmRbNUhTUFPHp8hp\nEtZRNkMu5SwD" +
       "QKxRoM2Ss1zXMzqRR7558/zETx/owFoW3MwKOo5U3Hs+Lrpx0TyQGWYzvtQg" +
       "ENTv\nMPp3ByCckpKuGI3LkZG/wx/1j4RJC4ZBfYZ6nRaJZjkTGV+RHmuRLl" +
       "GDo8V9lbBIB3cUk1lqMx1l\nn0XaCkzl3YzZQg2GAh5nWJZJ5tjlONeLsXOp" +
       "k8XBSpzYkv0bKugqVqHMpzNfnnzmEvsjTLakSNR2\nRbHgpEg7kCRZXrfB2u" +
       "IOM6dHs1mfqRRpEfoo6uo95JYFuBTZarIR1MnFZ5XkTg7yafGoymMcAyUP\n" +
       "yjcJvw/A75lyOfVfRbot6qsnXHmKyZi/qMiYYr7y531pzzuI37wrM9yhcmW+" +
       "7iIyaTBQjmkBtTvk\nigyTafvtm98+feDwiy8YJji0wMqhKHKbNhybplJxWz" +
       "CwdAeGbyqkUURESs9e2/HaV/QN6ELI2+er\nTKcRWm7Br78ZjYMIbcrxFQVE" +
       "0vbq1eMX1r9TN3QA7TY0MIXaSUWGgh1SByOOnGBiJ6is2n3oh6Xe\n6HsXC2" +
       "HSNkd6wC4K1AkqimyWqTmgkZ8sH1qku05eD5QZNwhUhtlCkcFgXDVu4VZrVt" +
       "AcMLc/eO0g\nnidqiwxrFGnOayZG8XNXKUQ8XOyB4vUFi4dG1p+L3nf9484v" +
       "zKwu+7u9plMgwYTuvd4qYMckw8R/\nPj999uVbzz8ZAfJ7ngYprMAIcAdyi3" +
       "rFBcHtEqwEc3Iq3wC/ackL0ByVrj8z9NZv79+c6TMEOsUd\neDd2B3Ov0xk5" +
       "DJfMqGvVo25nMw/69ueTO9dOz9xYMDNua32zHnCKhb0Xf2QT+7rsBjSOwLzA" +
       "TX9J\nD4hhzNjkrfeDqkxrBDuWFK7D6IJgFVmflnE3Nsskp4KvorBqqUrz4U" +
       "ASR/RMqvKxd2n745E8/zpM\nIhtUGg7WqV4pQJYOyVRR6qfFUEaSXZsq59os" +
       "U5Ss6vfVfw79dbb14St6xlb7Cy3sqrAHN2PwQmVd\nWaACHVRGa4fKS3e5el" +
       "JLU11UfTyuv5OGTiFcxxDXO+txQisZHBl/Xk70vHSvD69PZI60c3g2FVbV\n" +
       "Il1UCHeZZdJKv5G9NV2YFNTH7ulaoDaQLJcWYMiE5IWWYDQ1+EchNtB37pWJ" +
       "168ja7wNyIiOkhgM\nkzraRzcJcb8P+sJGPlS40FPliRkK+tr9/wMTbwB61g" +
       "kAAA=="));
    final private SJProtocol pc_ring =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1VXWhcRRSe/U3z03aTprHabWLapKZUdwWpqItgurR07S2N" +
       "SVtpDCyz987uTjp7\n73VmNtkNUhQf1BehtP6Bti+CWAKWSvVBqYK/CD7YB+" +
       "uL9aEighb0LagPnpnZze7ehCzcuzNz5vx9\n5zvnLt9BMcHRfYIIQT13PiXr" +
       "PhEptTWrmSezB0mJuidgl7eR+YXCCNU42ruBVpvSeMK+fP/E8pJR\nmthAac" +
       "aIgr5CForZZcociSaspnpaK6VX1dMd6hnwtCfgSb29wjyxpfJlnPzwwUWve/" +
       "zfaya27b7H\n6iXmyYaGuTM5/vFJ6/fPRsydnevcOa6t5u3/Hk7uujH5a3dE" +
       "hbzJ9wSV4F+iHVZTKV2VlKWnGpJM\nzfdrAP/4hpi4znrgH9hA5xiscYlkvU" +
       "ql6lIby1VQ3z/4Rcjqvf6LBrW3Yu4pkUTbW0EaQA2Oz6Kz\nKOzXfAjznkDq" +
       "k5zjurF7NTL2d/iTobEwilooWsCCKL1eC8WLlDBHSJSw5vECNvlbVMiMhXqo" +
       "Kwkv\nYpsIdXuLhboqRJY9x2whyeGAx2lSJJy4NjFeV6qpC7nT1aRCRKkoKg" +
       "+tqihXqSbUn09/ffr5y+SP\nMNqUQ3HbY9WKm0PdAG62se6CtUVdYk6PF4uC" +
       "yByKMn0U9/QecitSBmANmGwYdkvpGcmpW4J8oj6W\nZRXHQM2HQu2H5yF4zj" +
       "UKp/8l2mxhIZ/2+BnCU2Jeor2SCCnmBLfn3ILn1Oc87lAX8/pcx0XFk2QA\n" +
       "jikG2B3xmEN43n7v9nfPHTr6ysu6tFEXV0gjFIm2aMOpKcwltRkBS9tU+AYh" +
       "XUVVkdoLN3a99Q1+\nB9gLeQu6RHQaocWoeou11TisSptzhcRQkby9dP3kxZ" +
       "Xv5S0dQLcNxMeAHZdoOMisjjKqVg0mdgrz\nlt1Hflzoj1+5VAmjrlmUALtK" +
       "IE9hViUzRM4CjUS2cWihzR3yzkKZNlWFcojNJEoG42pzC7diRYZL\nwNyh4L" +
       "XD6jzTDjKslUhzXjMxrl7baiHkq8UogDcYBE8ZWXkx/uDNT3u/MjOu4W9rW6" +
       "dAghnde/2t\ngp3gRCX+85tT51+789IzESC/7+sihSUYAe5AbnG/WmDUrsGK" +
       "Ebcky+vUb4rTCjTHQqObzg2/+9uH\nt6cHDYHOUBfm7Z5g7h06Y0fhkhkRMT" +
       "3IRjfyoG9/uX90+ez0rYIZYgOdzXrIrVYOXPqJ7Huiz16H\nxhGYF2qTqOkB" +
       "cbfK2OSt90OyQWtV7FSWeS7BBUaaskEto15qhnCKGV1SwpalFs1HAkkc0zOp" +
       "xcf+\nhZ1PRcr02zCKrFJpJIhTp1KALD2cyCrXI9lQhqPda5DzbOJUOWn5fe" +
       "OfI3+djz16Tc/YVn8pC8km\ne9TmXpjsRY9XMFMOmqO1R5a5t9g6aaepBlUf" +
       "79bvcUOnkFpPqLre1VknZcVRI+PPq5nEqw+IjwCK\nWdRN4XMjFaoW6sOMeY" +
       "vEyUv9belv68Isw0J1T18B20CyUp6BIROSH1qA0bTOBza1Y/DC6/vevqlY\n" +
       "46+WDOkokanh4zrayTVCtX8M+sJWfGhyIdHiiRkKtf8BxAfilwkJAAA="));
    
    public void run(boolean debug, int port_l, String host_r, int port_r,
                    int numParticles) {
        Particle[] particles = new Particle[numParticles];
        ParticleV[] pvs = new ParticleV[numParticles];
        final SJService right_c = SJService.create(pc_ring, host_r, port_r);
        SJServerSocket ss_l = null;
        try {
            ss_l = SJServerSocketImpl.create(ps_nbody, port_l);
            SJSocket s_l = null;
            try {
                s_l = ss_l.accept();
                SJRuntime.send(s_l, 1);
                this.initParticles(debug, particles, pvs);
                int i = 0;
                while (SJRuntime.insync(s_l)) {
                    if (debug) {
                        System.out.println("\nIteration: " + i);
                        System.out.println("Particles: " +
                                           Arrays.toString(particles));
                    }
                    Particle[] current = new Particle[numParticles];
                    System.arraycopy(particles, 0, current, 0, numParticles);
                    while (SJRuntime.insync(s_l)) {
                        SJSocket s_r = null;
                        try {
                            s_r = right_c.request();
                            SJRuntime.send(s_r, current);
                        }
                        finally {
                            SJRuntime.close(s_r);
                        }
                        Worker.computeForces(particles, current, pvs);
                        current = (Particle[]) SJRuntime.receive(s_l);
                    }
                    Worker.computeForces(particles, current, pvs);
                    Worker.computeNewPos(particles, pvs, i);
                    i++;
                }
                if (debug) {
                    System.out.println("\nIteration: " + i);
                    System.out.println("Particles: " +
                                       Arrays.toString(particles));
                }
            }
            finally {
                SJRuntime.close(s_l);
            }
        }
        catch (SJIncompatibleSessionException ise) {
            System.err.println("[Client] Non dual-behavior: " + ise);
        }
        catch (SJIOException sioe) {
            System.err.println("[Client] Communication error: " + sioe);
        }
        catch (ClassNotFoundException cnfe) {
            System.err.println("[Client] Class error: " + cnfe);
        }
        finally {
            if (ss_l != null) ss_l.close();
        }
    }
    
    public static void main(String[] args) {
        boolean debug = Boolean.parseBoolean(args[0]);
        int port_l = Integer.parseInt(args[1]);
        String host_r = args[2];
        int port_r = Integer.parseInt(args[3]);
        int numParticles = Integer.parseInt(args[4]);
        if (numParticles <= MAX_PARTICLES) {
            LastWorker lw = new LastWorker();
            lw.run(debug, port_l, host_r, port_r, numParticles);
        } else {
            System.out.println("Too many particles.");
        }
    }
    
    private void initParticles(boolean debug, Particle[] particles,
                               ParticleV[] pvs) {
        for (int i = 0; i < particles.length; i++) {
            Particle p = new Particle();
            if (debug) {
                p.x = particles.length + i;
                p.y = particles.length + i;
                p.m = 1.0;
            } else {
                p.x = 10.0 * Math.random();
                p.y = 10.0 * Math.random();
                p.m = 10.0 * Math.random();
            }
            particles[i] = p;
            ParticleV pv = new ParticleV();
            pv.vi_old = 0;
            pv.vj_old = 0;
            pv.ai_old = 0;
            pv.aj_old = 0;
            pv.ai = 0;
            pv.aj = 0;
            pvs[i] = pv;
        }
    }
    
    public LastWorker() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238689595183L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAK1YfWwcRxWfu/OdPxt/xAlpbCdN7DS2mpxbIKhgoLWvCTn3" +
       "nDg+x3VNynm9O3de\ne293uzt3PluhaqhUhxZRRU2gRdBEVaWqVSRoqiaVqA" +
       "KoLVBoBQ1SWiG1IIqgEhTRf2gEBfFmZr9u\n9+6cICzteHbnvXnfvzdzZz9A" +
       "UdNAcRObpqypC3GyrGOTjdrcAhaJGU+PjguGiaWEIpjmJCxkxNn/\nyFPPtX" +
       "9tfxiFZlCHqg0rsmBOzhtaITc/OS+bJQPdoGvKck7RiLVjYI/P9X689PrqaF" +
       "cEtc6gVllN\nE4HIYkJTCS6RGdSSx/k5bJjDkoSlGdSuYiylsSELirwChJoK" +
       "gk05pwqkYGBzApuaUqSEHWZBxwaT\naX9MoRZRU01iFESiGSZBbakFoSgMFo" +
       "isDKZkkwylUCwrY0Uy70X3oXAKRbOKkAPCjSnbikG24+A+\n+h3Im2RQ08gK" +
       "IrZZ6hZlVSJoq5/DsbjvTiAA1vo8JvOaI6pOFeAD6uAqKYKaG0wTQ1ZzQBrV" +
       "CiCF\noM1VNwWiBl0QF4UczhC0yU83zpeAqpG5hbIQtMFPxnaCmG32xcwTrY" +
       "Oxln8/NP7RDRBx0FnCokL1\njwHTFh/TBM5iA6si5oxXCvGTybsL3WGEgHiD" +
       "j5jTDO+4cDj1/o+2cpquCjQHWS5mxI8/091zafiP\njRGqRoOumTJNhTLLWV" +
       "THrZWhkg7ZvdHZkS7G7cUfT/z07vufxX8Jo4YkiomaUsirSdSIVSlhzeth\n" +
       "npJVzL8ezGZNTJKoTmGfYhp7B3dkZQVTd0Rhrgtkns1LOkKoHp4QPOcR/1tH" +
       "B4KuSwkmuUszFrER\nNxcIupFgk5hHTEM8os5p0vIRzZBkVTCWj5QRlujG65" +
       "ZCIbCp219fCiTjfk2RsJERn37vF0f33vn1\n4zxaNMMslQi6ngmI2wLirgAU" +
       "CrGd19NM5J4aNgxhmVZI6dilnsd/JnwP/A72m/IKZuaFluroCEyf\nrAkgCb" +
       "f8kjATIDsyYuf972/+zm+eeTWMIhVBJOV83KcZeUGheWBXTYclzr8C6dPnT+" +
       "JKsv/20Njz\nl3/5Tr+bzgT1BaosyEmrZLvf84YmYglQyN3+2//c//dHo599" +
       "IYzqoPQAfIgAKQOVvMUvo6xahmzk\nobZEUqg5GzC8iYCDljwG07GFDm08Oy" +
       "AWnT4FGWhdeSB281svNb/KLLbxrdUDhGlMeLW0u/GfNDCG\n7+88Nv7oqQ9W" +
       "vxyB+tR1HnOCYnphTpHFErB8orzAqHoSTZu/nhtq++Zu8zwLcaOczxeIMKdg" +
       "AGRB\nUbQlLGUIQ6R2D/ox0AFPtMwBeAEOZhTYiNuqh4qQnhXgIb6p8+S3Br" +
       "77FgUQnTlmIy00pikqsQ99\nITr2Bxbpew/N4E7XbCj5RW5Ay0D6ntHZ49uZ" +
       "5d7tdlkvJWfDCPsSgZ121ayFfbTRuKkiH/3HsXO/\nOtUSRuEZVC+b+6AsFe" +
       "os8wBP/goQ69ti5eLhJ668Qd5loXWzjSrWXQoixZTgKYRbLxfbYz84nQ+j\n" +
       "+hnUxtqkoJIpQSnQwM9AozMT1scUuq5svbxpcYQecqqp25/pHrH+PHcRCuaU" +
       "ms4beGozmlbwLPXx\nIDxtFpSy/3SxnQ4dJYZdPHepQvEkdOgcNjr+cOapj4" +
       "6t3hqmyBUtUsXBJ20u3YECPWc8ePZUT/PJ\n3z/MMgih1jN00z1M+BY2buPh" +
       "jxBQnYaIoHrdkIsCAT/ETHZ2KQGwjw1PZ8aHJyaTidTetBkM3bgh\n56H5FK" +
       "3ueGLLU396/r2JTo5D/AjRG+jiXh5+jGC+adZp7W2rJYFRv3LTtrP3Tbw7x9" +
       "trR3mt7lUL\n+T2n38YDt7eIFdpFBA46DFcYyn967cwGNCQa9FI3xWYffvvQ" +
       "2PRdg1z8LTW3OACyJV96n0qqt13c\ncFkNU/yLmQueZAmbhKD+lL2l5S/6ym" +
       "fp0TRf4iccynWzDpmi09loMLphOv88Hb4AwWzQzQzrloxk\nPUFdju5GQSVy" +
       "HtOzsWUvc1KIgcwYeGqnz0xHJ2BJj+CcrPIEsJI5xJ1zYw0uD9OONvHZXf1n" +
       "VzhT\nfy1RrvleWbQFiPOyIlF1k7BHb82ocPY3v/+E1rjjXy+ELdTk6bejpn" +
       "RVqmTmnho8YzCHI2tCg2ah\nyiI76vM9nhl5OZRqvvg7pn5zntNNlqHFBFOp" +
       "lkOS6hLYjStpVcuSlKbpnCdyx2tPPjbw2/O8Vmh2\ncB9a4nn3mdZZJ62lyA" +
       "QWsQMDXkUo/xTn95/H2XGMc5yL9H0Y/uHGPnbCqJsTTO4F/0UmeE8pu34w\n" +
       "YU0OxN4Ez6fgOWHpc8IHsXYdrONnSLjSAeop2GmB9nGQvt9Ch9lSCLFak2rV" +
       "Wi/UWkzBao6fnEfo\nkHEba5iT28LXu9CdUDQV0wOFvcZ7uKzFnZsiLJYC+h" +
       "loq8+zY8wpLua0F7sORebln4dZe+IdLXC1\nK2caKu9jTQaGm6lanp9d3CnM" +
       "wKBHQtwZNY8ra55lALOjIvWL7RNPq+M9mpGNsOUvOWC4shYY1uti\nhl5L6f" +
       "sBD9h9dQ2wS1QBO8p7SOf2HIZ050Gn473cRuTaaB+2QFRPtSsq63Sr0x+2PC" +
       "i8co8t4A6C\nGomm71ZwESsVTmq7a8KePyki6dsGdu5q/jPUXJULS7v1caI8" +
       "9uwmI1zjTYaOqlOaDfBMw9Nt+bDb\nV5osIh7v+TIkykyOsvfbLa8nIKhzmq" +
       "ZgQXUzojxh+C8RTlGOrJ1+x+HIAM3RL6iuqMkSYzvpiWiU\nTr/hbP+IX9DV" +
       "Ua06TqLPTniOWk46WslJVRK9lw5frGygF9e+4ki7Hp6ta0h7pDo2nrGx8cna" +
       "2EhH\nNwSnA7hIX2U6LAaBjuUQF8aYqyfIVePL03RYokOptDb14xD6PNxGWO" +
       "QD8Q95LAp+cePaCM+hGn2p\nSlxDHLsqKmlhgJNaGV9wh+EZvYpW2FreCqeq" +
       "x/tFO94vXUu8L/xv8X6RbXPh/xDvn1xTvJ+DK5Cs\nyqTsaBAMvMfvHiOrrE" +
       "HzaXJ/paLnok2B35b5L6Di9kuz/S/r7a/xU5H9K2V9CjVkC4rivWV65jHd\n" +
       "wFmZqV/P75w6+/eGc9CxfyyDK4E9ZQq/zgl/DS1XtU+Cb+rcV6H/AlJT+qRa" + "FwAA");
}
