package nbody.ordinary;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.sharedmem.*;

public class LocalRun {
    
    private static void configureTransports(String transports) {
        List ss = new LinkedList();
        List ts = new LinkedList();
        if (transports.contains("f")) {
            ss.add(new SJFifoPair());
            ts.add(new SJFifoPair());
        }
        if (transports.contains("s")) {
            ss.add(new SJStreamTCP());
            ts.add(new SJStreamTCP());
        }
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    public static void main(final String[] args) throws Exception {
        final String transports = args[0];
        LocalRun.configureTransports(transports);
        final String debug = args[1];
        final String numParticlesLast = args[2];
        final String numParticlesFirst = args[3];
        final String reps = args[4];
        new Thread() {
            
            public void run() {
                try {
                    LastWorker.main(new String[] { debug, "4444", "localhost",
                                    "4442", numParticlesLast });
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
        Thread.sleep(500);
        new Thread() {
            
            public void run() {
                try {
                    FirstWorker.main(new String[] { debug, "4442", "localhost",
                                     "4444", numParticlesFirst, reps });
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
    }
    
    public LocalRun() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238690296025L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVXW2wUVRg+e+n2ttJuWwqhNy4l0Ei3RqNBq8Gmcikstm4L" +
       "kbaknJ05u50yOzPO\nObudoiHgDfTBxIDXKLyYGA0PClEfNGoCePcFE/AFXj" +
       "BKohh5MBKDxv+cmdnLzLbgJnP2zDn/+c9/\n+/7/nxNXURU1UZwSShVdm4mz" +
       "OYNQMeqpGSIxGh/dOoJNSuRBFVM6BhtT0p5/lZ3vx57cEkSBcdSk\n6QOqgu" +
       "nYtKnnMtNj0wq1TLTc0NW5jKozh6OPx32rbsx+d2hrWwg1jKMGRRtlmCnSoK" +
       "4xYrFxFM2S\nbIqYdECWiTyOYhoh8igxFawq+4BQ1+BiqmQ0zHImoUlCdTXP" +
       "CZtoziCmuNNdTKCopGuUmTmJ6SZl\nqDExg/O4L8cUtS+hUNafQJG0QlSZPo" +
       "b2o2ACVaVVnAHC1oSrRZ/g2LeJrwN5nQJimmksEfdIeK+i\nyQx1eU8UNO7e" +
       "BgRwtDpL2LReuCqsYVhATbZIKtYyfaPMVLQMkFbpObiFoWXzMgWiGgNLe3GG" +
       "TDG0\n1Es3Ym8BVa0wCz/C0GIvmeAEPlvm8VmJt4Yj0X+eH/lrOXgcZJaJpH" +
       "L5I3Co03MoSdLEJJpE7IPX\nc/GjQ7ty7UGEgHixh9imGVj90Y7Elc+6bJq2" +
       "CjTDIhanpBv3tHecG/ipNsTFqDF0qvBQKNNceHXE\n2em3DIju1gJHvhl3Nz" +
       "9PfrHrwLvk1yCqGUIRSVdzWW0I1RJNHnTm1TBPKBqxV4fTaUrYEAqrYimi\n" +
       "i3cwR1pRCTdHFcwNzKbF3DIQQtXwBOBJIvu3iA8M1Sd0CavJnBanMwx1M0IZ" +
       "naSmNKmldHluUjdl\nRcPm3GQJmcWZLpoNBECfdi+2VAjELboqE3NKevvyN0" +
       "9s3PbcYdtTPLoccRhaItjHXfZxlz0KBATf\nZh6Dto0GTBPPcWxYB891vPYl" +
       "fhMsDppTZR8RigVmw3yEQ3cumDoGi8AbghmGuJiSWg5cWfb6D++c\nDaJQxf" +
       "SRKCxu0s0sVnkEuHhpcq7z7kDgdHvDt9Ldvz+//dT5by+uLQYyOMCHL/9Jjo" +
       "+VXrubukRk\nyD9F9q/8veWPI1X3fhBEYQAdpB2GIVgAw53eO8pw0u/mHK5L" +
       "KIHq0z7F6xgYaLZEYT5G+dBoxwb4\nosUjoEhX15+K3HHhk/qzQmM3szWUpM" +
       "BRwmycxIr+HzMJgfWLr44ceenqoYkQINMwbJ8zFDFyKVWR\nLDiypBxaXDyZ" +
       "h81vJ/sbX+ilHwoX1yrZbI7hlEogFWNV1WeJPMVELoqV5D2RbsAS0RSkLciA" +
       "Uyow\nsnU1AnkIzwqJIb605ejLPW9c4KnDEIZp5RATkiJLLHQH+LjWt8nfO3" +
       "gEtxTVBrDvtRWI9ozu3rrn\n8EqheSm7dc6Lwxzl/XjcxGuJGxPZ1ON/nj5W" +
       "t7wo4bpSdp1iXOHYls9XuZyLYhdOmKhjvhwt6suh\nR69Fn8VndtuZtKncOR" +
       "u1XPbu4z+SngejUoXsUMt0o1cleaIWTBUU9wbh2t4FUb5dlLQiCkKjG3rW\n" +
       "rKv/BVAwD8BjzmKSQP3WuPz8zhqBfPy/kd/lMYpXnli+7ZHQtPJVkGPLAb2v" +
       "Upcf6i81D6DPLBdU\nRE+bEKABTNQIT7/zj9x/vhnjQ5MDUJ+/gwxVG6aSxw" +
       "ygEKGiA6octG6+5e/N0MGIkOWoidvdws1D\nfQNDzZCP0koGEtaYiTVq6Caj" +
       "1F/BR0wlCwUy71TwFzvf+vnU5WSLHTJ2m7PK12mUnrFbHXFrvcGD\ndsVCNw" +
       "jqM7evOLE/eSkVdKRdz1A4ryuyUOjhEhCIhc3WPCv3FzzCn1541jgeWXOLHh" +
       "EI5MNDCzvC\n3y2Jkmmb7GSo+1rw49ZuUQXCKUzd6C5vM/1dZFlzKGSsK2jU" +
       "Bc/qm2i0uYKcXveWZacpad+nO45d\n/55dEu4tVizOp93y57aduKSYrj+fj0" +
       "XeO54Noupx1CiabKyxnVjN8eIxDgrSQWcxgW4r2y9vee3+\nrr8AznZvfJVc" +
       "662VpTANszKAivI4aQWQwSepigCsSkMzpNqJF0CoEi3DpgVNwrBDYJihEHiK" +
       "Tycs\nX250ENlcROSgqmuEVzt3zy4wih4vfMDAplUR2w/YEou7+HDXgri+Ke" +
       "ghrVdJXJwKicO2uXVL+aZE\nu42WRAzePosLxgCnWQgYAdPKYJ3wgXXCAkvX" +
       "uN0n7zyW+r4W7W8aaeW5PWtPG7GvbSS53x3V0Pyn\nc6pa6vmSecQwSVoR8l" +
       "XbcWCIv4MMLSpvgUEMdyqEPGATPg1mE4T85RkRPHkr8B8q4OcwLA8AAA==");
}
