package nbody.ordinary;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import nbody.Particle;
import nbody.ParticleV;

public class Worker {
    final private static int MAX_PARTICLES = 4000;
    final private static double G = 1.0;
    final private SJProtocol ps_nbody =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1WXWhcRRSe3U023STVpKYx2m1C06RNqO6KUFH2pena2rW3" +
       "NG7aSmNgmb07uzvp\n7J3r3NlkE6QoPqgvBWnVCtpCEcQSUCrVB6UK/gs+2A" +
       "crgvWhIoIW9C2oD56Z2d+bZQO5mZkz5/f7\nzpms3UbdnkC7PeJ5lDuLMbni" +
       "Ei+mtmY19/jcflKgzjHYZWxkfgJBhCoC7eqg1aQ0OWBfvm9qbdUo\nTXVyZU" +
       "R+XwELddtFynISTVk19bhWitfV4y3qCfC00+dJfXl2kdhS+TJOvn/3Ao9M/n" +
       "vVxLbV5Wyl\nwLisapg7M5MfHrd+/2TM3NnW5s5RbTVj//dQdPv1mV8jIRXy" +
       "Jpd7VIJ/iUasmlK8LCmLz1YliYrr\nVqD8kx1r4uTaFX9vB50jsMYFkuSlUt" +
       "mhNpb1or6z/7OA1XftF13UvpK5p0QSbW0EaQpq6vg0Oo2C\nOspOyKWcZQCI" +
       "tAu0U3IW567RCT36zaXz0z99oAPryvLcinIcqrl3PbXYrBadA0kTm9ClNoEo" +
       "/V6j\nf68Pwhkh8IrRuBKa+Dv40fBEEHWpMLBHlF6fhcJ5SljOk2jAWsRL2O" +
       "BoUU8mLNRLHUlEHttERzlk\noZ4SkUWeM1uowajPY5rkiSCOXY1zvRw7lzpZ" +
       "jtbiVC05XFdRrmI1ynya/vLks5fJH0G0KYXCNmfl\nkpNCESBJsrrugbVFHW" +
       "JOj+bzHpEp1MX0UZjrPeSWB7gk2mKyYdgpxOekoE4B8ulysSyqOEYqLpQv\n" +
       "Cr8T8HumWk79V6LIk1ycIiLmLUo0LoknvQVP2AuOwm6Bixx1sFhZqF9SDIr6" +
       "yjDLoGaHOMsRkbHf\nvvXtMwcOv/SiYYCDS6QagkR3aKOxWSwktRkBS3epsE" +
       "1lNHoKicpz17e//hV+E7oP8vXoKtHhB5a7\n1NfbiMJBBWnK8SQGJDL26rXj" +
       "F9a/kzd1ABEbGhdDzYREo/7OaIFPjRp/YiewaNh9+IelwfB7F0tB\n1DOPBs" +
       "CuEsgTmJXJHJHzQB8vWT200OYWeStAZswogHLEZhJF/XE1uYVb3XmGC8DYYf" +
       "+1g+o80Vxk\nWCuR5rpmYFh97qkEkKsWu6F4Q/7iKSPrz4cfuPFx3xdmRlf9" +
       "3dnUIZBgQvfcYAOwY4KoxH8+P3v2\nldsvPBUC0ruuBikowQjwBnILu+Uso3" +
       "YFVow4BVlsg9+soCVoilq3vzz61m/v30oPGQKdog68Fzv9\nubfoTByGS2bE" +
       "desRt6OTB3378z071k6nb2bNbNvS2qQHnHJp78UfyfS+frsNjUMwJ9RmuKIH" +
       "w5jK\n2OSt91FZpbUCO5Zk3CE4y0hNNqRllMfmiKCY0VUlbFhq0HzMl8QRPY" +
       "safBxc2vZEqEi/DqJQnUpj\n/jq1KvnI0iuILAv9pBjKCDS+oXLcJrmyIA2/" +
       "r/1z6K+z3Y9c1bO10V/KwniNPWqzC16mPBclzJSD\n2kjtlUXBlxsnzTTVRd" +
       "XHU/q7x9ApoNYxhevdrTgpKzk1Mv68khg4c78Hr05oHkUoPJdSVdVC/Zgx\n" +
       "vkxyGanfxsGmLkwy7Knu6c9iG0hWyDAwZEJyA0swmtr8gxAbGTr36vQbNxRr" +
       "3DpkSEeJDIZJHe1j\nG4Rqvw/6wlZ8qHFhoMETMxT0tQf/B8KII7fOCQAA"));
    final private SJProtocol pc_nbody =
      new SJProtocol(
      ("H4sIAAAAAAAAAH1WXWhcRRSe3U023STVpKYx2m1C06RNqO6KUFH2pena2thb" +
       "ErNtpTGwzN47uzvp\n7L3XuXOTTZCi+KC+FKRVK2gLRRBLwNJSfVCq4L/gg3" +
       "2wIlgfKiJoQd+C+uCcmf29WTaQm5k5c36/\n75zJ2h3U6XG02yOeRx17MSFW" +
       "XOIlYKtXmSfT+0mB2kflLmsi/RMKI1TmaFcbrQal8T7z0gMTa6ta\naaKNUk" +
       "aLgr5CBuo0i5RZAk0YVfWkUkrW1JNN6inpaWfAE3yd3CIxBfjSTr5//7wTG/" +
       "/3mo5tq+uw\nlQJzREVD35ka//CY8fsnI/rOthZ3ZpTVrPnfI/HtN6Z+jUUg" +
       "5E2u41Eh/Qs0ZFSVkr6gLDlbkaTK\nrlv22tdkjpiELpFW9d/bRu2IXOMCST" +
       "ulkm9TE4taXd/b/1nI6Ln+i6prT0nfA5FAW+tx6prqUj6L\nTqGwCnSyjccZ" +
       "XyxLkFpGOt5Gz3AcV+tEHv/m4rnJnz5QkXXkHGsFPEeq/l0PFpth0d5ihtjW" +
       "xihA\nuVsr3x/AcIpzvKI1rkTG/g5/NDgWRh0QA/YI6PUYKJqnhFmeQH3GIl" +
       "7CGkiDeiJloG5qC8Lz2CQq\nxAEDdZWIKDqW3soCDAc8zpE84cQ2K9Va9xNn" +
       "p0/48Wqc0JODNRVwlahy5tO5L088f4n8EUabplHU\ndJhfsqdRTKacrqy75N" +
       "qgNtGnM/m8R8Q06mDqKOqovcwtL7ESaIvOhmG7kMwITu2CzKfDxaIIcQyV\n" +
       "XVm+uPwdk7+nK+VUfwWKPe3wk4QnvEWBRgXxhLfgcXPBBuAWHG5RG/OVhdol" +
       "4E88UIZZJmt2yGEW\n4Vnz3dvfPnfg8Csva/htXCKVEAS6SxlNzGIuqMmItH" +
       "QPhK0ro9ADJMov3Nj+5lf4bdl+Ml+PrhIV\nfmi5A77eRhQOAqTTtiewRCJr" +
       "rl4/dn79O3FLBRAzZediWTMu0HCwL5rgg1kTTOw45nW7j/6w1B+9\nfKEURl" +
       "3zqE/aBYE4jplPMkTMS/p46cqhgTY3yZsB0nMGALKIyQSKB+NqcCtvdeYZLk" +
       "jGDgavHYTz\nVGOR5RpEiuuKgVH43FcOIRcWu2XxBoLFAyPrL0Yfuvlxzxd6" +
       "SFf83d3QITLBlOq5/jpgRzmBxH8+\nN3vmtTsvPRORpHddBVJYSCOSNzK3qO" +
       "vnGDXLcsWIXRDFFvjNclqSTVGdjq8Ov/Pb1dtzA5pAJ6kt\nH4ydwdybdMYO" +
       "y0t6wHWqAbejnQd1+/M9O9ZOzd3K6cG2pblJD9h+ae+FH8nkvl6zBY0jck7A" +
       "ZrCs\nBsMIZKzzVvu4qNAawE6kmWMTnGOkKhtQMuokMoRTzOgqCOuW6jQfCS" +
       "RxRM2iOh/7l7Y9FSnSr8Mo\nUqPSSLBOzUoBsnRzInyuHhRNGY5GN1TOMYnl" +
       "c1L3+8Y/h/460/nYNTVb6/0FFkar7IHNLvku5R1e\nwgwcVEdqtyhyZ7l+0k" +
       "hTVVR1PKG+ezSdQrBOAK73NuMEViwYGX9eSfWdftCTT05kHsWofCwFVNVA\n" +
       "vZgxZ5lYWaFexv6GLkwz7EH39OawKUlWyDJpSIfkhpbkaGrxH0JiaODs65Nv" +
       "3QTWuDXIkIoSaQzT\nKtonNghhv0/2hQl8qHKhr84TPRTUtYf/B9yczsvPCQ" + "AA"));
    
    public void run(boolean debug, int port_l, String host_r, int port_r,
                    int numParticles) {
        Particle[] particles = new Particle[numParticles];
        ParticleV[] pvs = new ParticleV[numParticles];
        SJServerSocket ss_l = null;
        final SJService c_r = SJService.create(pc_nbody, host_r, port_r);
        SJSocket s_r = null;
        try {
            ss_l = SJServerSocketImpl.create(ps_nbody, port_l);
            SJSocket s_l = null;
            try {
                s_l = ss_l.accept();
                s_r = c_r.request();
                SJRuntime.send(s_l, SJRuntime.receiveInt(s_r) + 1);
                this.initParticles(particles, pvs);
                int i = 0;
                while (SJRuntime.outsync(s_r, SJRuntime.insync(s_l))) {
                    if (debug) {
                        System.out.println("\nIteration: " + i);
                        System.out.println("Particles: " +
                                           Arrays.toString(particles));
                    }
                    Particle[] current = new Particle[numParticles];
                    System.arraycopy(particles, 0, current, 0, numParticles);
                    while (SJRuntime.outsync(s_r, SJRuntime.insync(s_l))) {
                        SJRuntime.send(s_r, current);
                        Worker.computeForces(particles, current, pvs);
                        current = (Particle[]) SJRuntime.receive(s_l);
                    }
                    Worker.computeForces(particles, current, pvs);
                    Worker.computeNewPos(particles, pvs, i);
                    i++;
                }
                if (debug) {
                    System.out.println("\nIteration: " + i);
                    System.out.println("Particles: " +
                                       Arrays.toString(particles));
                }
            }
            finally {
                SJRuntime.close(new SJSocket[] { s_l, s_r });
            }
        }
        catch (SJIncompatibleSessionException ise) {
            System.err.println("[Worker] Non-dual behavior: " + ise);
        }
        catch (SJIOException sioe) {
            System.err.println("[Worker] Communication error: " + sioe);
        }
        catch (ClassNotFoundException cnfe) {
            System.err.println("[Worker] Class error: " + cnfe);
        }
        finally {
            if (ss_l != null) ss_l.close();
        }
    }
    
    public static void main(String[] args) {
        boolean debug = Boolean.parseBoolean(args[0]);
        int port_l = Integer.parseInt(args[1]);
        String host_r = args[2];
        int port_r = Integer.parseInt(args[3]);
        int numParticles = Integer.parseInt(args[4]);
        if (numParticles <= MAX_PARTICLES) {
            Worker w = new Worker();
            w.run(debug, port_l, host_r, port_r, numParticles);
        } else {
            System.out.println("Too many particles: " + numParticles);
        }
    }
    
    private void initParticles(Particle[] particles, ParticleV[] pvs) {
        for (int i = 0; i < particles.length; i++) {
            Particle p = new Particle();
            p.x = 10.0 * Math.random();
            p.y = 10.0 * Math.random();
            p.m = 10.0 * Math.random();
            particles[i] = p;
            ParticleV pv = new ParticleV();
            pv.vi_old = 0;
            pv.vj_old = 0;
            pv.ai_old = 0;
            pv.aj_old = 0;
            pv.ai = 0;
            pv.aj = 0;
            pvs[i] = pv;
        }
    }
    
    public static void computeForces(Particle[] particles, Particle[] current,
                                     ParticleV[] pvs) {
        for (int ours = 0; ours < particles.length; ours++) {
            double x = particles[ours].x;
            double y = particles[ours].y;
            double ai = 0.0;
            double aj = 0.0;
            for (int theirs = 0; theirs < current.length; theirs++) {
                double ri = current[theirs].x - x;
                double rj = current[theirs].y - y;
                double m = current[theirs].m;
                if (ri != 0) { ai += (ri < 0 ? -1 : 1) * G * m / (ri * ri); }
                if (rj != 0) { aj += (rj < 0 ? -1 : 1) * G * m / (rj * rj); }
            }
            pvs[ours].ai += ai;
            pvs[ours].aj += aj;
        }
    }
    
    public static void computeNewPos(Particle[] particles, ParticleV[] pvs,
                                     int step) {
        double dt = 1.0;
        for (int i = 0; i < particles.length; i++) {
            Particle p = particles[i];
            ParticleV pv = pvs[i];
            double x = p.x;
            double y = p.y;
            double ai_old = pv.ai_old;
            double aj_old = pv.aj_old;
            double ai = pv.ai;
            double aj = pv.aj;
            double vi_old = pv.vi_old;
            double vj_old = pv.vj_old;
            double vi;
            double vj;
            if (step == 0) {
                vi = vi_old;
                vj = vj_old;
            } else {
                vi = vi_old + (ai + ai_old) * dt / 2;
                vj = vj_old + (aj + aj_old) * dt / 2;
            }
            p.x = x + vi * dt + ai * dt * dt / 2;
            p.y = y + vj * dt + aj * dt * dt / 2;
            pv.vi_old = vi;
            pv.vj_old = vj;
            pv.ai_old = ai;
            pv.aj_old = aj;
            pv.ai = 0.0;
            pv.aj = 0.0;
        }
    }
    
    public Worker() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238689142934L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVZfWwcxRWf+/DZjk38mTSN7ZjEdmOryRlQU6V1S7AvSWNz" +
       "ThyfSYIxOu/tzZ3X\n3ttddufOZxehhFYYiBSpIqYUEUAICQGhpYlC/2gVqk" +
       "LSQltQUynQStCqoBappUqktkQFqr6Z2d3b\n27tbJxWNNOO5mTdv5n393pvN" +
       "yQ9RlaGjsIENQ1KV2TBZ0LDBejUxi0VihGMjY4Ju4GREFgxjAhbi\n4vR/pA" +
       "M/bLp3jx/5JlGzog7KkmBMzOhqNj0zMSMZeR1dr6nyQlpWicmxhMdXuz6Z/9" +
       "XSSFsANUyi\nBkmJEYFIYkRVCM6TSVSfwZkE1o3BZBInJ1GTgnEyhnVJkKVF" +
       "IFQVONiQ0opAsjo2xrGhyjlK2Gxk\nNayzM63JKKoXVcUgelYkqm4Q1BidFX" +
       "JCf5ZIcn9UMshAFIVSEpaTxl3oHuSPoqqULKSBcG3UkqKf\ncezfTeeBfJUE" +
       "19RTgoitLcE5SUkS1OneYUvcfSsQwNbqDCYzqn1UUBFgAjXzK8mCku6PEV1S" +
       "0kBa\npWbhFILWV2QKRDWaIM4JaRwnaJ2bbowvAVUtUwvdQtAaNxnjBDZb77" +
       "KZw1r7QvWfPjj20fVgcbhz\nEosyvX8INm1wbRrHKaxjRcR845Vs+Pjw7dl2" +
       "P0JAvMZFzGkGe350W/SDlzs5TVsZmn3MF+PiJ19u\n77gw+H5tgF6jRlMNib" +
       "pCkeTMqmPmykBeA+9ea3Oki2Fr8afj528//Bz+qx/VDKOQqMrZjDKMarGS\n" +
       "jJjjahhHJQXz2X2plIHJMArKbCqkst+gjpQkY6qOKhhrAplh47yGEKqG5oP2" +
       "KeL/VtOOoNqDqj6H\n9bAxS9Amgg1iTBm6OKUk1OTClKonJUXQF6ZsojxluH" +
       "re5wNZ2t1xJYMT7lHlJNbj4jPvvX73rlsf\nuJ9biXqWeRUwOmMetpiHOXPk" +
       "8zGuLdT7uHYGdV1YoFGRP3Kh43s/F06ArkFmQ1rETCTffJD2sOkm\nT9CIFE" +
       "JuGEYCeERcbD38wfpHf/vsOT8KlAWOqD25W9Uzgkxtb0VKs3mcewVcptvtuO" +
       "XO/vuDo6cv\n/vKd3oILE9RdElmlO2lkbHJrXVdFnATkKbD/7r/3XHqo6itn" +
       "/CgI4QaAQwRwE4jeDe4ziiJkwEIb\nKksgiupSJYKvIqCgeYfAtK+nXSP3DL" +
       "BFq+uCDKiufCt0w1s/qTvHJLYwrcEBfjFMeIQ0Few/oWMM\n8+88MvbQ8odL" +
       "dwQgJjWN25ygkJZNyJKYhy2fKw4qer0kdZu/nRpoPLbVeImZuFbKZLJESMgY" +
       "QFiQ\nZXUeJ+OEoVCTA/EY0IAm6hMAWIB9cRkYcVk1Xw7cswwkhNe1Hn+477" +
       "G3KGhoTDFraXCxm6I8m+j2\n0b63ZJH+7qAe3FoQG8J8jgtQ3xe7c2T6/k1M" +
       "cie7LeaPvM0wyGaCwGmLZyzspsml4CrS3f86curN\n5Xo/8k+iasnYDSEpU2" +
       "UZe7nzl4FVF4vFs7c9fuXX5F1m2oK30Yu150tR4oDgCITtF3NNoRefyPhR\n" +
       "9SRqZKlRUMgBQc5Sw09CcjMi5mQUXVe0XpyoOCoP2NHU7vZ0x7FuPy+gE4wp" +
       "NR3XcNdmNA2gWarj\nfmiNJnyyv3SxiXbNeYZd3HfphcLDkJXTWG/+05NPf3" +
       "RkabufIldVjl4cdNJYoNubpbXFfSeXO+qO\n//Eo8yCEGp6kTLexwzewfiM3" +
       "f4DA1amJCKrWdCknENBDyGD1Sp6g60YHD8XHBscnhiPRXTGj1HRj\nupSBhJ" +
       "MzM+J3Njz959PvjbdyHOJlQ1dJ5nbu4aUD002dRmNvo9cJjPrVL248ec/4uw" +
       "meUpuLY3WX\nks1se+Jt3HdLvVgmVQSguGG4AihP/95QZI8eaC2mPVrK2cOh" +
       "550qwAU+fPpnI31zHwfhqJ2WOSj9\n9h2XOBv64xtl9E7HX6Pd12l3M+jax8" +
       "lu0XgMRsAOSXaGdV8dfWnlSAT0Jirk+0JITB99e//ooYP9\nXF03erLYC7pK" +
       "usJxeVjZcXbNRcVP8TpkzDqc228QgnqjFkvTvvQnH8VGYnyJV2FM4RpoUqOj" +
       "iVKt\n+AtaAYXUaEacZXZG0kJQm313PasQKYNp/W7Ky5TkY6B4EDS12SWmfS" +
       "fYEhvCaUnhDmsa28eV8wWP\nXY5NPY3ic1t6Ty7yTb1eRxXEd55FU5Y4I8lJ" +
       "et0Y8OjytArf/psfPK7W9nx8xm+iPA+XHs/TlWQ5\nMbd57BmFMZTVERWSmy" +
       "KJ7DnCeTw79IovWnf2D+z6dRlON1GEblPsSl4KGVbmQW5c7lZekkRVVeN7\n" +
       "Ajtfe+qRvt+/xGObegfXoXk8z5YJjWV+r4uMYxHbsOW8CN0/zfe73wysfOQ7" +
       "TgW6L/t/vLabVUTB\nhGBwLbgfW6VvqaInEjtslQ1B7dC6oR0z73PMBUFWHK" +
       "zm9S48OwGlZWynbKt8pb9vpN1s3odYrCle\nsdYFsRaSsZLm1f0Q7aRCIeDn" +
       "5NbhLQUIjMiqgmkBZK3xmkNSw/ZrFhbzJffTUadLs6NMKQXMacq1\n7Q/MSL" +
       "/ws3TKM3DJ87N400Bx3l2lY3g9K8X+2caVwgQs1YiPK8OzvFqx9lqEhCpSvV" +
       "g6caQMXlMw\nsiG2vN8Gw2+vDIYiB0M6cciBdksroF2kAtrRvXeYuSbF4rbP" +
       "g8u+LKkQuHS/aAXeUWsQhwFTMxOW\nEX2T6w4VdGcVnXB2R6XnOcv4S4cu19" +
       "8nvHqndd5OeGYSVdsq4xyWbTNUMXb0k89WTzh1O1sgtqNv\n85a6v0AsV3i4" +
       "NZmT48U+xV50wjW+6Gift0O+BtohaJ2mSjtdIc8M7dCey/MskV2FQ3VCVWUs" +
       "KAVP\nK3ZE/hXGDvahld36YSidIOm6DwrmVCnJtj3lsGgVHT5qsz/hPujqqJ" +
       "ZtJdG2GdqCqaSFckqqEEBd\ntLu5vIBOvJyxT/u8aQav005UxtzvW5j7ojfm" +
       "0v4uW+YXSvCW/mRz2VIAZT7ED2ObKzvIVePWGdod\nod29+ZWpnwHTZ+BVxi" +
       "xfYn+fQ6LSmYJda6ENeeS7Cnb1cUwse0mH8iSXXW+CNnAV2bWhOLseqGzq\n" +
       "85apX78WU5/730x9nvXnPgNTv3lNpn4ZXoGSIpGiaqPU5lzlDvkqTBdH9RS0" +
       "5017PP8ZRXWg8MCS\n3Kd7Cfo7Qj8IZLQswQDaYiVByzP2WisWeRzaG6bIb/" +
       "yfRGZechWo/n5B5L14fkxdUWQn4wprtJjk\nH2BpCb2u5L9K+Ad9cdOF6d5X" +
       "tKbXeAFtfXSvjqKaVFaWnR9QHOOQpuOUxK5ezT+naOzPZbsmtr4B\nQ8FkDd" +
       "llL3HCf0B1ZldR/9R4DPj+CwWYVnEpGgAA");
}
