package onedimjacobi;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.sharedmem.*;

public class Client {
    final private SJProtocol p_cm =
      new SJProtocol(
      ("H4sIAAAAAAAAAIVVS2wbRRgeP0seqE7qPqBuojYxpLSxAVFeFhJplKhptxDi" +
       "thLhYI13x/aE8e4y\nO3acCFVCHIALEmp5SdBeKiFQJFBR4QAqB0AgJA70QL" +
       "lQDkWIA5XgFgEH5p+xvfHaMjlMZvaf/zHf\n9/2/N26hmMfR3R7xPOrYKxmx" +
       "5hIvA0e9yx+fPUrK1D4lTwUT6b9QGKEGR3f18drilE6YHxye2ljX\nTlN9nP" +
       "LaFMwVMlDMrFBmCTRltNyzyinbds92uOdkpolAJlid4goxBeTSSX748IIzkP" +
       "7niq5tp+uw\ntTJzRNND35lJf3ra+P2LcX1nb487T6qoBfPfB1P7rs38OhCB" +
       "km9zHY8KmV+gPUbLKVsTlGUXm5Zc\nw3UbEv50X0xsqxf4R/r4nJR7XCazTr" +
       "Vas6mJRRvU949+GTKGrv6iQB2q6ntgEminX6QGVOP4HDqL\nwqrKfswtEZPQ" +
       "OukuFNwH3YYr/e8MIDfDOV7THpcjk3+FP9s1GUZRA0WL2CPgN2SgeIkSZnkC" +
       "JYwV\nXMcaPoN6ImegQWoLwkvYJB7cThhoW5WIimPpo8RoLJBxiZQIJ7bZrH" +
       "Ozljm/8HQt1aozJp8J/7er\n5wadFzmtStZaj3xt7NJvH99cSioko89SW6pz" +
       "Ighhh8/kCXkp187E0f5+GdTtrw7t3zi7dKOoKR9t\n3wcYMnN2rXrk4k/k4O" +
       "PDpq7CxhIANKqhYtguZ/OCU7ssdSZQ3HJqRUZk3h1g1zEUB4Bn44Vr+97+\n" +
       "Br8rpbuAoh5dJw0XOFyNwtoDjnkgZsH2BJZ4Fsz1q6cvbH4vbqhCBkypekxt" +
       "wgUaC2LSQQL0aSoQ\n+QzmftyHf6yPxD+6WA2jbcsoIeOCQZzBrEbyRCxLEX" +
       "izzY8Gur3D3omE7lEpm6hFTCZQKljXlrTy\nVqzEcFnqblfw2jx8zzXBBi7v" +
       "kHswKcUqduNuI4Rc2E1K4JJB4CDA5ovxe69/PvS1Hm7NXNu3aFw+\nLqe6Zs" +
       "Qn6xQn8Oif31o89/qtl56JSFG4riIoLGQQamP5rrgrWaZmQ+4YscuioiSdbE" +
       "p7t0AR2Taw\n3aG/pMBdB/G6uVhksr2OOcwivGC+d/O75+dOvPKyLzb1fhCX" +
       "lhQAnZlljk0wKA2s9wmUVDbqZPKE\nU8zoOhj95L7ExgPJT6pu9rUwUt/7VK" +
       "RCvw2jSJvG8SA/nU4BogY5ETWuZqGmi6MDXU3omMSqceLn\nffPvY3+eiz1y" +
       "RU0nX9sQYbzFHhwm5EgtObyKGSRoDaVBUeHOqv+lJRHFgfqUVuuUpjIE+0Mw" +
       "HnZ3\ntjtEsKBV/7icS7w67X0iYVhGA1TOeAGIGmgYM+asEqsg1EAf2aL+WY" +
       "Y9UO1wEZtyVpULTAbS5bih\nuhwJPX7VMnuS5984+M51GD5umy6kqkSav8dU" +
       "tTNdRjg/KjVpghZaOkj4GtHN2K0BOI+1u2ehG50w\n7O/REMF6GJZpWEa75A" +
       "zH+2F5oHeihzQHo7Dk+j7nf9/6BCxzsMyr8/R/bXeCAFgJAAA="));
    
    public void run(String host_m, int port_m, int size) {
        final SJService c_m = SJService.create(p_cm, host_m, port_m);
        SJSocket cm = null;
        long timeStarted = 0;
        long timeFinished = 0;
        try {
            cm = c_m.request();
            timeStarted = System.nanoTime();
            SJRuntime.send(cm, size);
            double[][] result = (double[][]) SJRuntime.receive(cm);
            this.printMatrix(result);
            timeFinished = System.nanoTime();
            System.out.println("time = " + (timeFinished - timeStarted) / 1000 +
                               " micros");
        }
        catch (SJIncompatibleSessionException ise) {
            System.err.println("[Client] Non-dual behavior: " + ise);
        }
        catch (SJIOException sioe) {
            System.err.println("[Client] Communication error: " + sioe);
        }
        catch (ClassNotFoundException cnfe) {
            System.err.println("[Client] Class error: " + cnfe);
        }
        finally {
            SJRuntime.close(cm);
        }
    }
    
    public static void main(String[] args) {
        String host_m = args[0];
        int port_m = Integer.parseInt(args[1]);
        String transports = args[2];
        Client.configureTransports(transports);
        int size = Integer.parseInt(args[3]);
        Client c = new Client();
        c.run(host_m, port_m, size);
    }
    
    private static void configureTransports(String transports) {
        List ss = new LinkedList();
        List ts = new LinkedList();
        if (transports.contains("f")) {
            ss.add(new SJFifoPair());
            ts.add(new SJFifoPair());
        }
        if (transports.contains("s")) {
            ss.add(new SJStreamTCP());
            ts.add(new SJStreamTCP());
        }
        if (transports.contains("m")) {
            ss.add(new SJManualTCP());
            ts.add(new SJManualTCP());
        }
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    private void printMatrix(double[][] u) {
        for (int i = 0; i < u.length; i++) {
            System.out.println(Arrays.toString(u[i]));
        }
    }
    
    public Client() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238688032653L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAK1YfWwcRxWfvTuf7fhofI4TQux82iGOmpyhalDBRcW2asX2" +
       "ubF9TohNosve7tx5\nnL3dZWfufImqkkJE+iFV6kdKqfrxD1LVKhKQqvAHKK" +
       "3Ulm+EGqS0/7T8UUQr9UP0H4igIN7M7N7t\n7Z7XRGBpx7Mz772Z9/F77+1d" +
       "+gi1UQdlKKaUWOZKhp2xMRWjVVjBGqOZ3NSs6lCsjxsqpQuwkddO\n/Zsc+3" +
       "H624djSFlCPaY1ahCVLiw7VqW0vLBMaM1Bu2zLOFMyLOZKDMn4ysCnq7+7MN" +
       "UXRxuX0EZi\n5pjKiDZumQzX2BJKlXG5gB06qutYX0JpE2M9hx2iGuQsEFom" +
       "HExJyVRZxcF0HlPLqHLCHlqxsSPO\n9BazKKVZJmVORWOWQxnqzq6oVXW4wo" +
       "gxnCWUjWRRskiwodNvontQLIvaioZaAsItWU+LYSFxeIKv\nA/kGAtd0iqqG" +
       "PZbEaWLqDO0MctQ1HpwGAmBtL2O2bNWPSpgqLKAeeSVDNUvDOeYQswSkbVYF" +
       "TmFo\n25pCgajDVrXTagnnGdoapJuVW0DVKczCWRjaHCQTksBn2wI+83nrSD" +
       "L1rwdm/74LPA531rFm8Psn\ngWlHgGkeF7GDTQ1LxuuVzGOTi5X+GEJAvDlA" +
       "LGlG9/70aPb9l3dKmr4WNEdELOa1T7/Uv/3q6J87\n4/waHbZFCQ+FJs2FV2" +
       "fdnZGaDdG9pS6Rb2a8zVfmf7F47gX8QQx1TKKkZhmVsjmJOrGpj7vzdphn\n" +
       "iYnl6pFikWI2iRKGWEpa4h3MUSQG5uZog7mtsmUxr9kIoXZ4FHgqSP7dxAeG" +
       "OscNgk2WoSsM7WKY\nMnqCOtoJy8Q6Ka+omlUgJ+okNS7uplVFAU36g6gyIA" +
       "QPW4aOnbz23Lu/ufvO6fvvkz7iceVehKFN\nftEZKRopipC5iUeetMyo46hn" +
       "OCJq917d/v1fqk+DnUFfSs5ioY6ymuAjMN0SmTDGG3CbhJkK0ZDX\nes+9v+" +
       "3JPz7/egzFWyaNbH1xwnLKqsH97qGkxz0uuAPhMhgM2lZnf/zAzIvXfvv2UC" +
       "N8GRoMoSrM\nyVGxJ2hzx9KwDlmnIf57/zj810fbvvxSDCUAapBsmAohAsjd" +
       "ETyjCR0jXqbhusSzqKsYUnwDAwOt\n+hTmY4oP3TIuwBe9gQuKJHX9O8kvvP" +
       "nzrteFxl4+2+hLfDnMJDrSDf8vOBjD+ttPzD568aML34gD\nHm1b+pyhpF0p" +
       "GESrActnmwHFr6fzsPnw8kj3QwfpT4SLO0m5XGFqwcCQgFXDsFaxnmciA6V9" +
       "2U4k\nGbBEqgDJCvJe3gBBUldbqUJ4tkgHma29jz2+/6k3ecKwhWG2cGCJm6" +
       "KaWBhU+DgU2uTv23kE9zbU\nBoiflgqk9udOTp26b4/Q3C/ugPtSqwtsYOHW" +
       "SCxM8MICMcMsyDCNkDn14FtzM8e/Pixz3hcjRdwF\nUNaFnAb/xUnzjiubr5" +
       "kxHiVJulKHexbFKGNoKOuJdCOPv8pZbiont7y8f2B9BRoHk7v/du/lP1xM\n" +
       "wcFLqJ3QCWKqBvc2vUuit0VNCIg4e+XoM9d/z94RsdmAC79+fy2c5I6pPiTf" +
       "dq2aTv7o2XIMtS+h\nblHXVZMdU40Kj9wlqMx03F3Mos807TdXWVlSRurpoD" +
       "8IVd+xQaAmfNZOcGo+75DYtGuKYvPZbYJ6\nhxh3y2CKMZDD7cVQu+2Qqsp7" +
       "HagZea0syDYx1Ff3hVMxGSlj3n+50SMAr4jA/irE3b6A2+oe5hl4\nDJeIKc" +
       "urW3sUGWqfj+DyMe3t1l44MHTprGQaimDyBZP/LJ52tGVi6Py6t4CMgcgok+" +
       "xv/PAZq3Pv\nP1+KuUjtsnm62Rt5uqm3UvNQBM8MzKEtGrcgQZlEE+2klPH8" +
       "2KtKtuvKn8T1u8qSbqHJwWPiSlEG\nmccaJlUcvhVnn7BF0g22WqLySo7L8c" +
       "FPYj/bMiiKSaKgUnl4sEcNt6BNnaU4bIMt89WUuHMQlbMO\nKUMj5N304R0/" +
       "+MuL7873yhop29mBUEfp55Etrc9Ru6NOENSv3bz70j3z7xSkk3qa68idZqV8" +
       "6Nm3\n8P6vpbQWTUxSt6AC4VAG5u+3AuyQgN3RFrDj8xE+DADckgY2S2xZEM" +
       "y4BpplKA725NNsI8XHJLcH\nTdko8eQBHRQ0VKp3GdiT1YRYmfo3Cmy2KhY7" +
       "AyaaET5r5Ld0tW8uvkx+FRN5Rqam0EdFM9NIc0La\n4GD4JjKbo7bPFv+yYe" +
       "Mo0i6RRXPdigqh0qZxm3j26G7YSibasC2a3WZFu42Px/mwyIfpkI/460k+\n" +
       "5FsfVJD6T/MB/2+6iig5zQdDvC/WfEJRg89rGcDp29f6sBKYuHD8k9R31ddO" +
       "eiliDj4QmGUfNHAV\nG/UrJIS4BEg7GJlIgwEVz92xf9+BrvcgnazRdqfdxf" +
       "nmuBH9uHqD/biwtZhvhNt2wHMInh43C4r/\nfDPNhx7Zwa7tkrhQOd4ipuQn" +
       "cj0eFtf32jlAOFTUIOoTVYvogu1+n9PifHo+KD5q71t1nfmzD54x\nV+exVj" +
       "qvEewDkJ2o+B2ktUL+iJ6qn/g5eHauc+L51vDjw+MeBJ+4EQhevHEIysME8/" +
       "8Bhk/7YLg+\n9UPg6jJ0mcLTIX8rPo3CKw3fdsMzAs+ca+m5G/Dt7Xx4JNKv" +
       "wlHr6/IclCJobIukBB+hC45qUtty\nGI1Q7XxItfNB1TrdsDVd1cz/TjUh7P" +
       "Z1tZpeX6vLDJoIQDWbUQHctQhtpkPaTNd4XZc/a/Duamvo\nx0f5E5m25+qp" +
       "oVft9K9lb+X9jNWeRR3FimH4u3rfPGk7uChv1O71+Pzfywyl/L+r8LVXbBmR" +
       "yn8A\ntduPxlkVAAA=");
}
