package onedimjacobi.noaliaz;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.sharedmem.*;

public class LocalRun {
    
    private static void configureTransports(String transports) {
        List ss = new LinkedList();
        List ts = new LinkedList();
        if (transports.contains("f")) {
            ss.add(new SJFifoPair());
            ts.add(new SJFifoPair());
        }
        if (transports.contains("s")) {
            ss.add(new SJStreamTCP());
            ts.add(new SJStreamTCP());
        }
        if (transports.contains("m")) {
            ss.add(new SJManualTCP());
            ts.add(new SJManualTCP());
        }
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    public static void main(final String[] args) throws Exception {
        String transports = args[0];
        LocalRun.configureTransports(transports);
        new Thread() {
            
            public void run() {
                try {
                    WorkerN.main(new String[] { "4442" });
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
        Thread.sleep(500);
        new Thread() {
            
            public void run() {
                try {
                    Master.main(new String[] { "4444", "localhost", "4442",
                                "localhost", "4443" });
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
        Thread.sleep(500);
        new Thread() {
            
            public void run() {
                try {
                    WorkerS.main(new String[] { "4443" });
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
    }
    
    public LocalRun() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238687911954L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVXW2wUVRg+e+n2ttJuWyqhNy4lUqVbo9Gg1WBTuRQWW9tC" +
       "pC1Zzs6e3U6ZnRnn\nnN0O1RDwBvJgYsBrFF5MjIYHhagPGjUBvPuCCfgCLx" +
       "glUYw8GIlB43/OzOzOzmwLbjJnzp7zn/Nf\nv///5/gVVEUNFKeEUllTZ+Js" +
       "j06oGLXUDJEYjY9tHsEGJelBBVM6DhtJade/8vb3Y09tCqLABGpS\ntQFFxn" +
       "R82tDy2enxaZmaBlqma8qerKIx+0bfHfevvD773YHNbSHUMIEaZHWMYSZLg5" +
       "rKiMkmUDRH\ncili0IF0mqQnUEwlJD1GDBkr8hwQaiowpnJWxSxvEDpKqKYU" +
       "OGETzevEEDydxQSKSppKmZGXmGZQ\nhhoTM7iA+/JMVvoSMmX9CRTJyERJ08" +
       "fRXhRMoKqMgrNA2JpwtOgTN/Zt4OtAXieDmEYGS8Q5Et4t\nq2mGurwnihp3" +
       "bwECOFqdI2xaK7IKqxgWUJMlkoLVbN8YM2Q1C6RVWh64MLR03kuBqEbH0m6c" +
       "JUmG\nlnjpRqwtoKoVZuFHGFrsJRM3gc+Wenzm8tZwJPrPoZG/loHHQeY0kR" +
       "QufwQOdXoOjZIMMYgqEevg\ntXz8yNCOfHsQISBe7CG2aAZWfbQtcfmzLoum" +
       "rQLNsIjFpHT93vaOswM/1Ya4GDW6RmUeCmWaC6+O\n2Dv9pg7R3Vq8kW/Gnc" +
       "3PR7/Yse9d8msQ1QyhiKQp+Zw6hGqJmh6059UwT8gqsVaHMxlK2BAKK2Ip\n" +
       "oon/YI6MrBBujiqY65hNi7mpI4Sq4QnAk0bWbxEfGKpPaBJWRvNqnM4wdDsj" +
       "lNEpakhTmkrScm4G\nS1pKnlI1CHY8N+UiNvnVi2YDAdCq3YswBcJxk6akiZ" +
       "GU3r70zZPrtzx/0PIXjzFbKIY63EziNpO4\nwwQFAuL2Zh6Plr0GDAPv4Tgx" +
       "95/teO1L/CZYH6xA5TkilAzMhvkIh+5aMI0MlkA4BDMMMZKUWvZd\nXvr6D+" +
       "+cCaJQxVSSKC5u0IwcVng0ONhpstl5dyCIur2hXIn374e2njz37YXVpaBmqN" +
       "uHNf9JjpUV\nXusbmkTSkItK17/y96Y/Dlfd90EQhQGAkIIYhsABPHd6eZRh" +
       "pt/JP1yXUALVZ3yK1zEw0KxLYT5G\n+dBoRQj4osUjoEhd156O3Hn+k/ozQm" +
       "MnyzW40uEYYRZmYiX/jxuEwPqFV0cOv3TlwGQIUKrrls8Z\niuj5lCJLJhy5" +
       "tRxmXLw0D5vfTvQ3vtBLPxQurpVzuTzDKYVAWsaKos2SdJKJvBRz5UCResAS" +
       "0RSk\nMMiGSQUusnTVAwUIzwpJIr6k5cjLPW+c52lEF4Zp5XATkiJTLHQH+L" +
       "jat8n/d/AIbimpDcDfbSkQ\n7RnbuXnXwRVCc/d1a+w/9uWo4EflBl5XnJjI" +
       "pZ7489TRumUlCde4r+sU43Lbtny+0rm5JHbxhIE6\n5svXotYceOxq9Dl8eq" +
       "eVVZvKnbNezefuOfYj6XkoKlXIEbVM03sVUiBK0VRBwTcIbHsXRPlWUd5K\n" +
       "KAiNreu5bU39L4CCeQAesxdHCdRylcvPedYI5OP/jfwuj1G88sQKbY+GpuWv" +
       "ghxbNuh9Vbv8UL/b\nPIA+o1xQET1tQoAGMFEjPP32GzlvvhnjQ5MNUJ+/gw" +
       "xV64ZcwAygEKGiG6octE6+5f+boZsRIctR\nE7c6hxuH+jqGmiEfZeQsJKxx" +
       "A6tU1wxGqb+ajxhyDoplwa7mL3a+9fPJS6MtVshYLc9KX9fhPmO1\nPYJrvc" +
       "6DdvlCHAT16TuWH987ejEVtKVdy1C4oMlpodAjLhCIhY3mPCsPFD3Cn177Qc" +
       "77JjwiEMiH\nhxd2hL9zEiXTMtmJUPfV4Met3aIKhFOYOtFd3nL6O8qyRlHI" +
       "WFfUqAueVTfQaGMFOb3uLctOSWnu\n021Hr33PLgr3lioWv6fd9Oe27dhVTN" +
       "eeK8Qi7x3LBVH1BGoUDTdW2Xas5HnxmAAF6aC9mEC3lO2X\nt79Wr9dfBGe7" +
       "N75cbL210g3TMCsDqCiPU2YA6XySqgjAqoysYsVKvABChahZNi1oEroVAsMM" +
       "hcBT\nfDpp+nKjjcjmEiIHFei2eLVz9qwCI2vx4scMbJoVsf2gJbHgxYe7F8" +
       "T1DUEPab1K4uJUSByWzc2b\nyjcu7dabEtF5Ky0YjANOcxAwAqaVwTrpA+uk" +
       "CZaucbpP3nks8X05Wt830oqzu1af0mNfW0hyvkGq\n4UMgk1cUt+dd84hukI" +
       "ws5Ku24kAXr/3gikqNMGRheyYk3WdRP8NQ1E3N154VgVQwA/8BhvGPbUQP\n" + "AAA=");
}
