package onedimjacobi.ordinary;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.sharedmem.*;

public class LocalRun {
    
    private static void configureTransports(String transports) {
        List ss = new LinkedList();
        List ts = new LinkedList();
        if (transports.contains("f")) {
            ss.add(new SJFifoPair());
            ts.add(new SJFifoPair());
        }
        if (transports.contains("s")) {
            ss.add(new SJStreamTCP());
            ts.add(new SJStreamTCP());
        }
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        sjtm.configureSetups(ss);
        sjtm.configureTransports(ts);
    }
    
    public static void main(final String[] args) throws Exception {
        String transports = args[0];
        LocalRun.configureTransports(transports);
        new Thread() {
            
            public void run() {
                try {
                    WorkerN.main(new String[] { "4442" });
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
        Thread.sleep(500);
        new Thread() {
            
            public void run() {
                try {
                    Master.main(new String[] { "4444", "localhost", "4442",
                                "localhost", "4443" });
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
        Thread.sleep(500);
        new Thread() {
            
            public void run() {
                try {
                    WorkerS.main(new String[] { "4443" });
                }
                catch (Exception x) { throw new RuntimeException(x); }
            }
        }.start();
    }
    
    public LocalRun() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238679870340L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVXW2wUVRg+e+n2ttpuWyqhNy4l0tBujUaDVoNN5VJYbG0L" +
       "kbZkOTt7djtldmac\nc3Y7RUPAG+iDiQGvUXgxMRoeFKI+aNQE8O4LJuALvG" +
       "CURDHyYCQGjf85M7M7O7MtuMmcPXPOf85/\n/f7/n+NXUBU1UJwSSmVNnY2z" +
       "eZ1QMWqpWSIxGh/fMooNStJDCqZ0AjaS0u5/5R3vx57cHESBSdSk\naoOKjO" +
       "nEjKHlszMTMzI1DbRc15T5rKIx+0bfHfetuj733cEtbSHUMIkaZHWcYSZLQ5" +
       "rKiMkmUTRH\ncili0MF0mqQnUUwlJD1ODBkr8l4g1FRgTOWsilneIHSMUE0p" +
       "cMImmteJIXg6iwkUlTSVMiMvMc2g\nDDUmZnEB9+eZrPQnZMoGEiiSkYmSpo" +
       "+hfSiYQFUZBWeBsDXhaNEvbuzfyNeBvE4GMY0MlohzJLxH\nVtMMdXlPFDXu" +
       "3goEcLQ6R9iMVmQVVjEsoCZLJAWr2f5xZshqFkirtDxwYWjZgpcCUY2OpT04" +
       "S5IM\nLfXSjVpbQFUrzMKPMLTESyZuAp8t8/jM5a2RSPSf50f/Wg4eB5nTRF" +
       "K4/BE41Ok5NEYyxCCqRKyD\n1/LxI8M78+1BhIB4iYfYohlc/dH2xOXPuiya" +
       "tgo0IyIWk9L1e9o7zg7+VBviYtToGpV5KJRpLrw6\nau8MmDpEd2vxRr4Zdz" +
       "Y/H/ti5/53ya9BVDOMIpKm5HPqMKolanrInlfDPCGrxFodyWQoYcMorIil\n" +
       "iCbewRwZWSHcHFUw1zGbEXNTRwhVwxOAR0LWr5kPDNUnNAkrY3k1TmcZWssI" +
       "ZXSaGtK0ppK0nJvF\nkpaSpzUjLavYmJ92UZv87lvnAgFQq90LMQXicbOmpI" +
       "mRlN6+9M0TG7Y+d8hyGA8yWyqGOt1c4g6X\nuMMFBQLi+mYekZbFBg0Dz3Ok" +
       "mAfOdrz2JX4T7A92oPJeItQMzIX5CIfuXDSRDJVgOAwzDFGSlFr2\nX172+g" +
       "/vnAmiUMVkkigubtSMHFZ4PDjoabLZeXcgjLq9wVyJ9+/Pbzt57tsLa0phzV" +
       "C3D23+kxwt\nK73mNzSJpCEbla5/5e/NfxyuuveDIAoDBCEJMQyhA4ju9PIo" +
       "Q82Ak4G4LqEEqs/4FK9jYKA5l8J8\njPKh0QoR8EWLR0CRvK49Fbnj/Cf1Z4" +
       "TGTp5rcCXEccIs1MRK/p8wCIH1C6+OHn7pysGpEOBU1y2f\nMxTR8ylFlkw4" +
       "cls50Lh4aR42v50YaHyhj34oXFwr53J5hlMKgcSMFUWbI+kkE5kp5sqCIvmA" +
       "JaIp\nSGKQD5MKXGTpqgcKEJ4V0kR8acuRl3veOM8TiS4M08oBJyRFpljoDv" +
       "BxjW+Tv3fwCG4pqQ3Q32Mp\nEO0Z37Vl96GVQnP3db32i305KvhhuZFXFicm" +
       "cqnH/zx1tG55ScJe93WdYlxh25bPVzk3l8QunjBQ\nx0IZW1Sbg49ejT6LT+" +
       "+y8mpTuXM2qPnc3cd+JD0PRqUKSaKWaXqfQgpEKZoqKPgGgW3foijfJgpc\n" +
       "CQWh8fU9t/fW/wIoWADgMXtxjEA1V7n8nGeNQD7+38jv8hjFK0+s0PZIaEb+" +
       "KsixZYPeV7fLDw24\nzQPoM8oFFdHTJgRoABM1wjMAzxI764t/vhnjQ5MNUJ" +
       "+/gwxV64ZcwAygEKGiH6octE6+5e/N0M+I\nkOWoiVu9w41DfT1DzZCPMnIW" +
       "EtaEgVWqawaj1F/PRw05B+WyYNfzFzvf+vnkpbEWK2SspmeVr+9w\nn7EaH8" +
       "G1XudBu2IxDoL69NoVx/eNXUwFbWnXMRQuaHJaKPSwCwRiYZO5wMr9RY/wpw" +
       "+eXtsjvTfp\nEYFAPjy0uCP8vZMomZbJToS6rwY/bu0WVSCcwtSJ7vKm099T" +
       "lrWKQsa6okZd8Ky+gUabKsjpdW9Z\ndkpKez/dfvTa9+yicG+pYvF72k1/bt" +
       "uBXcV03blCLPLesVwQVU+iRtFyY5XtwEqeF49JUJAO2YsJ\ndEvZfnkDbHV7" +
       "A0Vwtnvjy8XWWyvdMA2zMoCK8jhtBpDOJ6mKAKzKQDOkWIkXQKgQNctmBE1C" +
       "t0Jg\nhKEQeIpPp0xfbrQR2VxC5JAC7Ravds6eVWBkLV78nIFNsyK2H7AkFr" +
       "z4cNeiuL4h6CGtV0lcnAqJ\nw7K5eVP5xqXdBlMiOm+mBYMJwGkOAkbAtDJY" +
       "p3xgnTLB0jVO98k7j6W+b0frC0daeXb3mlN67GsL\nSc5XSDV8CmTyiuL2vG" +
       "se0Q2SkYV81VYc6OLvAHwJVeyEQRpnKmTdb9E/zVDUTc/XnhGhVDAD/wEM\n" +
       "is48SA8AAA==");
}
