package schat.client.gui;

import java.util.*;
import javax.swing.*;
import schat.common.*;

public class ChatMenuBar extends JMenuBar {
    final private static String FILE_MENU = "File";
    final private static String SESSION_MENU = "Session";
    final private static String WINDOW_MENU = "Window";
    final private static String FILE_CLOSE = "Close";
    
    public ChatMenuBar() {
        super();
        this.makeFileMenu();
        this.makeSessionMenu();
        this.makeWindowMenu();
    }
    
    private void makeFileMenu() {
        JMenu file = new JMenu(FILE_MENU);
        this.add(file);
    }
    
    private void makeSessionMenu() {
        JMenu file = new JMenu(SESSION_MENU);
        this.add(file);
    }
    
    private void makeWindowMenu() {
        JMenu file = new JMenu(WINDOW_MENU);
        this.add(file);
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238676054865L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVXW2xURRievXS3l6XtloJIb1Ag0thukShRi8FaW9myvdgt" +
       "RdaS5fTs7O5pz55z\nPDNndyGEAEa5PJgYwFtUXkyMhgeFqC9GTQTvxgQT8A" +
       "VeMEqiGH1RYtD4z5yzt7PbWjU2memcmX/m\nv8z3f/Pv6euoiugoQDAhkqrM" +
       "BugeDRPeqzOzWKQkEB4eF3SCYwOyQMgkLETF3X9KU2/6D211IkcE\nNSlqvy" +
       "wJZDKpq0YiOZmUSFZHqzRV3pOQVWqdWHbGvWtuZr44PNziQg0R1CApYSpQSR" +
       "xQFYqzNIJ8\nKZyawTrpj8VwLIL8CsaxMNYlQZb2gqCqgGIiJRSBGjomE5io" +
       "cpoJNhFDwzrXmZsMIZ+oKoTqhkhV\nnVDUGJoV0kKvQSW5NyQR2hdCnriE5R" +
       "h5DO1HzhCqistCAgSXh3Je9PITe4fYPIjXSmCmHhdEnNvi\nnpOUGEUd9h15" +
       "j9duAwHY6k1hmlTzqtyKABOoyTRJFpREb5jqkpIA0SrVAC0UrZz3UBCq1gRx" +
       "Tkjg\nKEUr7HLj5hJI1fCwsC0ULbOL8ZPgzlba7qzotsY8vj+Ojf+2Cm4cbI" +
       "5hUWb2e2BTu23TBI5jHSsi\nNjfeMAIngjuNVidCILzMJmzK9K97Z3vo2vsd" +
       "pkxLBZkxjsWoeHNTa9uF/m9rXMyMak0lEoNCief8\nVsetlb6sBuhenj+RLQ" +
       "Zyix9MfLTzwOv4ByeqDiKPqMpGSgmiGqzEBqyxF8YhScHm7Fg8TjANIrfM\n" +
       "pzwq/4ZwxCUZs3BUwVgTaJKPsxpCyAvNAW0LMv9qWUdR/UBSoCNYMR4Q9ACZ" +
       "paiLYkLJNNHFaSLC\n2rQoS1ih0wlDmi6VzbLD6zMOB/jVas8xGQC5VZVjWI" +
       "+Kr179bN/gtqNHzBtjKLPMoqiV6wiYOgKg\nI1CkAzkc/PClDJBmwPp1XdjD" +
       "EiV78ELb8x8LL0H4IQxE2ou5l46Mm/WwaeOCPDJQyMIgjAQASVRs\nPnBt5Q" +
       "tfv3beiVwVuSSUnxxS9ZQgMzjkkqfJUmdfARSttWO5ku6fjo2cvfj55fUFVF" +
       "O0tizZyney\nZOm0B19XRRwDMioc/+zvW38+XnXPW07khgwEDqICIAcSut2u" +
       "oyRp+nIExHxxhVBdvMzxWgoByhQ5\nzHofHzfAVVRDg2RCt1qwa2IdW/Szrs" +
       "nEEFxXs80HTm83HvdsuPRu3XkelBwTNhRRZhhTM6/8BYhM\n6hjD/OXnxo+f" +
       "vH74URdksqaZsKDIoxkzsiRmYcstpanIPIgxZP14pq/xqR7yNkdBjZRKGVSY" +
       "kTFQ\ntyDLagbHopRzl7+IJzk9QbB8M0BzwJhRGQ4yw6E50oDgCkQSWNF84p" +
       "muFy8xqtF4vJaz2HBLUZZP\nrHOwvqtskX23MZA3F9wGcpgzHfB1hXcN7z7S" +
       "yT0vPq7H+sjmD3TzGTec1L1gugyxJ6mAJmnfrwfP\nfHXS50TOCPJKZEhSBJ" +
       "kFi4ya+VGBjG1H7H1v+8s3vqRX+NUWAMkMa82W88mUUJQrd19M+z1vnEo5\n" +
       "kTeCGvmDKih0SpANdvEReBLJgDUZQktK1kufN5PL+/IJ12pPhiK19lQo8BiM" +
       "mTQbV9vQz2K8AZrP\nQr/Phn4HQNI9ZHH2Jr6tg/ed5sW5KChlwaXIq+lSWq" +
       "DggYfw+iRLUc1QMDQYHRkc3c43LYV6ggOC\nORcw326eXw7E1+8osWsTtCWW" +
       "XUsq2OUNm4hgM/0VTGPjPtZtZt19YI4vPBgOB8dGuUVscsv82u+E\nVm9pr6" +
       "+g3bMDahQ1wyYeWpTyuh3B0QfHdixG90ZojZbuxgq6qwZklfArGVmU6lp+DQ" +
       "OhsfBgsWaO\nhdVmIqNCIueyEJKubb4qh1dohx/5xfekcG6XWYs0ldLVoGKk" +
       "7jr1De663ydWeFdrqKr1yDiN5Xyu\nu0zzQW3Pgrk+wovCQra5wlu6buuu+x" +
       "6ejnleRb81OYGhAlYmc7nAn0vhHz+XHbag2O3xp1sediWl\nT5w8C83ELat1" +
       "Szf1laZrrV5qKL+oljxEaqC1QmuxINJS8ckqAwbn6s0LE/ffsvouyKKUMIcZ" +
       "J7Aq\niJQT6bgupaBoTFtV7dPtr3x39upEswkCs/RfU1Z9F+8xy3+urk5jMF" +
       "y9kAYufe721af3T1yZcVpm\nTgFtpVUpxj1JlsK67CNSEtkOaN1WZLsrRZZ1" +
       "0f8WRSjDG1gULQZjgeSG/gtz2y2mRLn//4O5GSjD\nmbkm5S3aWkZ6RdUyK4" +
       "NWlP3UNX+QiZ0Xdq//UPN/yuu//I8mL/xyiRuyXPyUFY09mo7jEjfRaz5s\n" +
       "Gv93CN4Ze91OkQt6bt9BU+oJgHKxFHC6OSgWOgJsy4XYx1Et94zxuiYbIBl4" +
       "wQLDloNZ9Bde9v4l\nIxAAAA==");
}
