package schat.client.gui;

import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import schat.common.*;
import schat.client.*;

public class UserList extends JList
  implements ListSelectionListener, MouseListener
{
    private DefaultListModel users;
    private ChatClient client;
    
    public UserList() {
        super(new DefaultListModel());
        this.users = (DefaultListModel) this.getModel();
    }
    
    public UserList(ChatClient client) {
        super(new DefaultListModel());
        this.users = (DefaultListModel) this.getModel();
        this.client = client;
        this.setLayoutOrientation(JList.VERTICAL);
        this.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
        this.setVisibleRowCount(-1);
        this.addListSelectionListener(this);
        this.addMouseListener(this);
    }
    
    public void valueChanged(ListSelectionEvent e) {
        if (e.getValueIsAdjusting() == false) {
            if (this.getSelectedIndex() == -1) {  } else {  }
        }
    }
    
    public void mouseClicked(MouseEvent e) {
        if (e.getClickCount() == 2) {
            synchronized (users)  {
                int index = this.getSelectedIndex();
                client.sendPrivateConversationRequest(
                  ((User) users.get(index)).getId());
            }
        }
    }
    
    public void addUser(User user) {
        synchronized (users)  {
            int i = 0;
            for (Enumeration e = users.elements(); e.hasMoreElements(); i++) {
                if (user.getName().compareTo(((User)
                                                e.nextElement()).getName()) <
                      0) {
                    break;
                }
            }
            users.insertElementAt(user, i);
        }
    }
    
    public User findUser(Integer key) {
        synchronized (users)  {
            for (Enumeration e = users.elements(); e.hasMoreElements(); ) {
                User user = (User) e.nextElement();
                if (user.getId().equals(key)) { return user; }
            }
        }
        return null;
    }
    
    public void removeUser(Integer key) {
        synchronized (users)  { users.removeElement(this.findUser(key)); }
    }
    
    public void removeAll() { synchronized (users)  { users.clear(); } }
    
    public void mousePressed(MouseEvent e) {  }
    
    public void mouseReleased(MouseEvent e) {  }
    
    public void mouseEntered(MouseEvent e) {  }
    
    public void mouseExited(MouseEvent e) {  }
    
    void saySomething(String eventDescription, MouseEvent e) {  }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238676054884L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVYa2wctRb2bpJN0mxJNw0lNGnThkAbQTaA4OpCftCQ26op" +
       "GxqyaUVDqtSZ8W6m\n9c4MY89mUxAq9yLKpRIqouVRAf0BAoGQeInHD8RDvF" +
       "8CFanlD/wBARIPwZ97KwSIY8/M7uzMNAmk\njWTHYx/b3zn+zvFZP/UjqmMW" +
       "SjPCmGbou9N81iRM1sbUbqJwls5uGcEWI+ogxYyNwcCksusPbfuz\nqX9vjq" +
       "PYOGrRjQGqYTY2bRl2fnpsWmMlC60xDTqbpwZ3VwytceV5v818tH9Lew1qHk" +
       "fNmp7lmGvK\noKFzUuLjKFkghSlisQFVJeo4SumEqFliaZhqe0HQ0GFjpuV1" +
       "zG2LsFHCDFoUgi3MNokl9/Q6Myip\nGDrjlq1ww2IcLcvsxkXcZ3ON9mU0xv" +
       "szKJHTCFXZjegWFM+guhzFeRBckfG06JMr9m0S/SC+RAOY\nVg4rxJtSu0fT" +
       "VY46gzPKGndfAwIwtb5A+LRR3qpWx9CBWhxIFOv5viy3ND0PonWGDbtwtPKU" +
       "i4JQ\ng4mVPThPJjlqC8qNOEMg1SjNIqZwdHZQTK4EZ7YycGa+09qaSP5+58" +
       "j/18CJA2aVKFTgT8Ck1YFJ\noyRHLKIrxJl40k4fGtphd8QRAuGzA8KOzMD5" +
       "L23LfPdapyPTHiGzVXJxUvntHx2rjg183VgjYDSY\nBtMEFao0l6c64o70l0" +
       "xg94ryimIw7Q2+PvrOjn1Pku/jqGEIJRSD2gV9CDUSXR102/XQzmg6cXq3\n" +
       "5nKM8CFUS2VXwpDfYI6cRokwRx20TcynZbtkIoTqocSgPIKcv6Wi4qhpGyOW" +
       "YF6a7eboAk4YZxPM\nUiaYMo35hEI1ovOJvK1N+ARLYtmzZmIx0Kgj6F0UqL" +
       "jZoCqxJpXHv/rg5o3X/PcO56wEv1xAHJ0r\nN0g7G6Rhg7S3AYrF5MrLBQ8d" +
       "Ow1YFp4VY6Vbj6164F38EFgdtGfaXiKVi8/UihomXTpn+BisON8Q\ntDBwY1" +
       "Jp3ffdyiOfPfF2HNVEhpBMuXOTYRUwFSzwfKbF3S44AuTpDlI4au+f7hx+/v" +
       "iHX6yvkJmj\n7pCPhWcKH+kKWt4yFKJCDKosf9+vm3++p+6KF+KoFhwPQg/H" +
       "QBjw49XBPap8pd+LO0KXmgxqyoUU\nX8LBQDM+hUWdlO1mOIoGcRxQOl22LR" +
       "eVGEyJqsUhEBxXa0AHGdVO/idx8YlXmt6WRvECYLMvUmYJ\nd9wpVaHImEUI" +
       "9H9x/8g9h3/cf0MNOLBpSlrEOEqY9hTVlBJMOafaA4UGqmDWD8/1L7url70o" +
       "WdCo\nFQo2x1OUQMTGlBozRJ3kMmSlfOFRRiUwVnIKohsEykkKCznmMGNFYH" +
       "BE/Ei3tR66t+fBEyLCmNJe\nK4RtJFJUkh3nx0TdExoU36uEZ7RW1IaYsMdR" +
       "INmT3bll1x1dUnP/cr3+j7bQEfW5R7Q26ohEtTYS\nVMyxrfxeztE5Ve48CO" +
       "1B2Zxfo4uRD6WUu6wU7imV51Z8/aI5fX2TuEYrrqDd/L9bn/vkcDKO4uOo\n" +
       "XmObNB1TcdLsWse5Iy6QwBJ7X9328MmP+ZeSlxVvEsA6SuFIuB37HP2fx4up" +
       "xDNHC3FUP46WySQA\n63w7prZg7Thc42zQ7cygpVXj1Veyc//0l6NFR9CTfd" +
       "sG/bgSgaEtpEW7IeC6jVDWQGl2edEc4EUs\nZorGBjmhU9ZdZUerNy2tiEXe" +
       "hOpsiOfM40eH0KCUZjPgJul/kRy2KResHTZUIi/ws5DDg/4qIO1Q\nUi6QVD" +
       "SQzaK6Gnzc4Z6ki7tgyUdfVGFgr8sgF9o6PzRSFPwVyLKEgqGBXuKDwDlXqZ" +
       "LGM9wVHjZA\nU09IhJhVp0peZOK1//pfkrfjt3Y6KUZLdTjaqNuFy49+Tno2" +
       "JJWIS7ORG2YvhW1p2R2apDJNsG3v\nnO4wLHO9CiFrslf1rLuo6Vu4Gk5x66" +
       "XczlECia0+5tFFXof4L1+HnQGjBPGkiu3X1Uxr78UlUR1u\nh1LY6kn91Yxe" +
       "YlUDlaffXhXvRKy7xKXTJYuKd93zkGZjcUHBbwdHyaJwcoiYep6oLByERiyt" +
       "AEli\n0c1i71796DfPfzXa6rDDSfXPC2Xb/jlOui+3azIFP9fOtYOUfuvCtU" +
       "/dMvrlVNyFOcpRbdHQVKmJ\nGozOO0Px2u3ZXmX8dVA2uMbfsCjjnxvlgQu0" +
       "OGS5yYKQh/tJgatTahStlx7SS4/SS+Q4w65ew4vS\nK+VeokahYOgyH55fHx" +
       "uCLlZVITyHKrMhVWajVOmCgl1V8OJUkUckbqz0EPxAzS9ElX0cNeSAfZ4u\n" +
       "sw7QIPLbQrrcFqVLNxTm6sL+li6+peeCfYCL0FMwimSeQ1gg8DYoN7nAb/pr" +
       "wBecRh6Cu8TBPEBp\nNOSo7DHs0AdcoAf+toX1+dE+5PnsiAX3y+nw2fVQDr" +
       "rQD55J6I9xtFRCH4WbAZ8W7MLsh13sh88k\n9qc9s28UT0ynA/oFUI640I+c" +
       "Segvc9TkQC9pfLHIxbPJFVCOusiPRiEPp8OncEPv94v4hkC5rBIo\nnde2BW" +
       "r4BhwOw7NZQzziudPCKsZF892Qnv5uSNUbvKcX8Zu6LfRc6jzqKV3Hdq1/00" +
       "y9Lx8Tyg9v\n9RkI2jal/p8WvnbCtEhOk4jrnR8apvz3KWgefAHiqAZqCfMT" +
       "R+ozoaRPqpzl+4WOw28NKSQ+TphV\nN5CXoW2Rj0foT83GMnlkFgAA");
}
