package schat.client.net;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import schat.common.*;
import schat.common.events.*;
import schat.client.*;

public class RequestorOutThread extends Thread {
    final private SJProtocol p_private_event_out_stream =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBszi1uDgzPy9Lr6SyILVYD8SFsIK9/EtLyjMy" +
       "c1JDgPz4ZAYIYGRi\nYKgoYlDFo88nP78AoofZ5eSiGZq3tjExMPowsCTlp1" +
       "SWMGj4wLTqgzXow7XqB3sFQ6RAuq2Btmjg\nsQVJKbLjgBaxJgNdnVLIUMfA" +
       "BDRDGc0MEJmflJWaXAIyBaL94vp5+Zyqv7dC/CZakJ9TmZ6TXwLV\nAVHjqL" +
       "o91OfFfnmIGmksavzBpsYn/zGTkb3k+ISTGeQYjoL84swSoP0lDBI+ME36pS" +
       "WZOfoBUBnr\nioKCioJi/IEanJqXgi0iTPHo8QWyE9NTnfNzc0vzMpMTS+Dh" +
       "tdLpMKMP97774PDizoWoA0mVMIgi\nXAmJFUhkgIKTGeJMGTS/B+QkJqd65O" +
       "ekpBbFJy9/fKrG1buzAxLleYm5QCOFfLISyxL1cxLz0vWD\nS4oy89KBXi5h" +
       "kC1Ozkgs0UsGOi8/Ty+1LDUPGCXOQCFXEBMAlpCSuaECAAA="));
    final private SJProtocol p_ra_private =
      new SJProtocol(
      ("H4sIAAAAAAAAAFvzloG1uIhBvTi1uDgzPy9Lr6SyILVYD8SFsIK9gp1S0zPz" +
       "QoC8+GQGCGBkYmCo\nKGJQw6MLSZOqQPIqHY01VRBNGvisgkih28Xow8CanJ" +
       "GZk1LCoOED064P1qQP166Pot0aaJMymk0g\nMj8pKzW5BGQXxJKL6+flc6r+" +
       "3gpxm2hBfk5lek5+CVQHRI2j6vZQnxf75SFqpLGo8QebGp/8x0xG\n9pLjE0" +
       "5mkJM5CvKLM0uA9pcwSPjANOmXlmTm6AdAZawrCgoqgMGviSdM/EtLyoF+T8" +
       "UWAap49Pnk\n5xdA9DC7nFw0Q/PWNnBAsiTlp1QWMtQxMFeASKaCioJi/AYF" +
       "p+alYLPcFI8eXyA7MT3VOT83tzQv\nMzmxBB6rK50OM/pw77sPdgx3LkQdSK" +
       "qEQRQRSpAYhUQkkjNl0MI+ICcxOdUjPycltSg+efnjUzWu\n3p0dEG/mJeYC" +
       "jRTyyUosS9TPScxL1w8uKcrMSwcGeQmDbHFyRmKJXjLQefl5eqllqXnAJOEM" +
       "FHIF\nMQF7eMU1FAMAAA=="));
    private ChatClient client;
    private RequestorInThread rit;
    private SJPort port_r_private_out;
    private List events = new LinkedList();
    private boolean run = true;
    
    public RequestorOutThread(ChatClient client, RequestorInThread rit,
                              SJPort port_r_private_out) {
        super();
        this.client = client;
        this.rit = rit;
        this.port_r_private_out = port_r_private_out;
    }
    
    public void run() {
        ChatClient.debugPrintln(
          "[RequestorOutThread] Requestor out thread started.");
        SJServerSocket ss_r_private_out = null;
        try {
            ss_r_private_out = SJServerSocketImpl.create(p_ra_private,
                                                         port_r_private_out);
            ChatClient.debugPrintln(
              "[RequestorOutThread] Waiting for Client to connect...");
            SJSocket s_ra_private_out = null;
            try {
                s_ra_private_out = ss_r_private_out.accept();
                ChatClient.debugPrintln(
                  "[RequestorOutThread] Client connected.");
                ss_r_private_out.getCloser().close();
                client.openPrivateConversation(rit.getTargetId(), this);
                while (SJRuntime.outsync(s_ra_private_out, run)) {
                    ChatEvent e = this.nextEvent();
                    ChatClient.debugPrintln(
                      "[RequestorOutThread] Sending event: " + e);
                    SJRuntime.send(s_ra_private_out, e);
                }
            }
            finally {
                rit.disconnect();
                ChatClient.debugPrintln(
                  "[RequestorOutThread] Requestor out thread stopped.");
                SJRuntime.close(s_ra_private_out);
            }
        }
        catch (SJIncompatibleSessionException ise) {
            System.err.println("[RequestorOutThread] Shouldn\'t get in here: " +
                               ise);
        }
        catch (SJIOException ioe) {
            ChatClient.debugPrintln("[RequestorOutThread] I/O error: " + ioe);
        }
        finally {
            if (ss_r_private_out != null) ss_r_private_out.close();
        }
    }
    
    public void disconnect() {
        if (run) {
            ChatClient.debugPrintln(
              "[RequestorOutThread] Told to disconnect...");
            this.run = false;
            synchronized (events)  { events.notify(); }
        }
    }
    
    private ChatEvent nextEvent() throws SJIOException {
        synchronized (events)  {
            while (events.isEmpty()) {
                try {
                    events.wait();
                }
                catch (InterruptedException ie) { throw new SJIOException(ie); }
                if (!run) {
                    ChatClient.debugPrintln(
                      "[RequestorOutThread] Creating quit event...");
                    return new QuitEvent(rit.getRequestorId());
                }
            }
            return (ChatEvent) events.remove(0);
        }
    }
    
    public void queueEvent(ChatEvent e) {
        synchronized (events)  {
            events.add(e);
            events.notify();
        }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238676054841L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVYfWwcRxWfu7Pv7PhIfK7z0firsePWVpNzoZQvo7aOcRSn" +
       "59r1uWljnFzGu3P2\nOHu7253Z88UqVQuItEFCom2gINpKCKm0RBRatfyDAl" +
       "JboHwIEaS0Qmr5owgqQRH8AxEUxJuZ3b29\nvfNF/oOTdm5u5n3Nm/d77+1d" +
       "eA+1MgdlGWGMWuZalp+xCZOjtbxGNM6y+aNz2GFEnzQwYwuwUdBO\n/Zce+3" +
       "7ms0fiKLaIukxrwqCYLaw6lruyurBKWcVB19mWcWbFsLgnsU7GJ4beX//l2a" +
       "M9CbRjEe2g\nZp5jTrVJy+SkwhdRukRKy8RhE7pO9EWUMQnR88Sh2KAbQGiZ" +
       "oJjRFRNz1yFsnjDLKAvCLubaxJE6\n/cUcSmuWybjjatxyGEeduTVcxmMup8" +
       "ZYjjI+nkPJIiWGzu5DD6B4DrUWDbwChLty/inGpMSxw2Id\nyLdRMNMpYo34" +
       "LC2nqalzNBDlCE68/w4gANZUifBVK1DVYmJYQF3KJAObK2N57lBzBUhbLRe0" +
       "cLR3\nU6FA1GZj7TReIQWO9kTp5tQWULVLtwgWjnZGyaQkuLO9kTsL3dZsMv" +
       "2fc3P/vA5uHGzWiWYI+5PA\n1B9hmidF4hBTI4rxipt9fPq42xtHCIh3RogV" +
       "zcTwD+7OvfujAUXT04BmVsZiQXv/I719lyb+0J4Q\nZrTZFqMiFGpOLm91zt" +
       "sZr9gQ3bsCiWIz62/+eP4nxx98jvw5jtqmUVKzDLdkTqN2YuqT3jwF8xw1\n" +
       "iVqdLRYZ4dOoxZBLSUv+BncUqUGEO1phbmO+KucVGyGUgicGz6NIfbaLAW5g" +
       "ntznEgbROOtywA3B\nepatcXQTh0W2xBxtiWmrmC9pBiUmXzIJX2rIUhGqtq" +
       "/HYnDK3ijiDAjPI5ahE6egPfPOz++fuuOR\nh9X9iZjzjORoSKrKKlVZUJWt" +
       "V4ViManjGhGlyosTjoPPCPRUHrrU97Wf4ifhTsA3jG4QefTYeosY\ngelDTZ" +
       "PLZBWa0zDDEDkFrfvBd/d+/bfPvhZHiYYJJhcsHracEjZEjPiI6vLURXcgtP" +
       "ZHA7yR7r+e\nm3nx8i/eGqmGOkf76xBYzykQNBi9A8fSiA4Zqir+q/868rfH" +
       "Wj/+Uhy1ACwhMXEM4QQo74/qqEHS\nuJ+VxFkSOdRRrDv4Ng4OWg8dWIxpOd" +
       "8BV9EGDyAMXe/F4j4xiM2MGLpUKMF1dUfOIHPelc8lb3rj\nhx2vSaf46XFH" +
       "KI/mCVdgy1RDZMEhBNbfemLusfPvnf10AuBt2yosOEra7rJBtQqw7K7FpziB" +
       "LiLr\nLy+Md37pIHtZRkE7LZVcjpcNAvkcG4a1TvQClwktE0qeMmeBs9LLkP" +
       "sgjRYMEKTcYcfKEMENskt2\nT/fjXxn9xhsi/9jSX7vAxoS0NCF/X8PR7hqY" +
       "TMJ8Uk79/cHNYTRtKhT5pD0BIBzX5LREJDnUWcvh\nFUk0HBPjaGALkrYgeU" +
       "d9AlPdVS9Dgjqt/JUezZ84eurhQeloZb1guFEMB8UwpqTf3HivEqhLSYIU\n" +
       "6DnQFLuHRdGshja9/x8PvfDr8+k4ii+iFGWHqYkNcXPsTgXWBuUiImLj4t1P" +
       "XfkVf1vGWRUdwrDe\nSn2OO4ZDwP3Y5XIm+b2nS3GUWkSdsuRjkx/DhiuicB" +
       "GKNpv0FnPoAzX7tQVYVZvxAP29UWSG1EZx\nWc2tMBfUYt4WgWI7PD3w7Pag" +
       "uDsCxVjMFpNPSoYBOQ4GwEnZDi1j0SVB0ZLRFlwklBdJ/NEaTQPw\nXOtpur" +
       "axpkNiuJWjhEN5EBGNpQ15tiP/u17alCety4aALjgFz+ACtDMy0jYXPgJPny" +
       "e8r7HwI57w\nJCkL9PmY2h4GhEJ8YxW9nkeQ/12vYibwhmuy+pCdc2gJGoiy" +
       "1+F8uf9bf3zxnfluVS9UGzhU14mF\neVQrKGOiwxYJcF8zDZL61Rv3XXhg/u" +
       "1l1SJ11SbMKdMt3fL0m2T09rTWoMCnli3LINhUPhHZ48NX\nRzVULm5BT1SF" +
       "16kvvnnXzL33jCkTPthUxJ2gX49A+/y0edvFnZfNuKhVSbYWAkqccY5Gcr5I" +
       "z2fi\np5rlj+bVlupU5aXa/m0t1qMkzgGUIvmItdsBKHvtIAhl2IhQLEABJ7" +
       "i0eVKGhOw5QXouJnPySXDf\naOTsgaHAAi3T+ir0gyo2vDiLKZ8NN+HLWZat" +
       "eBKfev2bT4z+7mV1k8uWfkboPQ78I034Qw4KqxXV\nWgN7dF/GUNN7U+y/ef" +
       "4pq3343y/FvYoDQSoqezPz89AfNzryLU14ZmAObyeTFhR2k2ryrU7JePbQ\n" +
       "K7Fcx8XfS/s7SopuoSaZarZXquHq+rzSC4IsM6vygqzQU2W/QN8ThMvpBuEi" +
       "5if8WEnbBQf74SIW\nC6HrF/nghmZ+OERWaN0tCE9c34QrxDTcqT13YOTChu" +
       "97OKc0FfvnLcJEfFO5vU+1C6jaLtzstQpg\naN9m73MypZy99+/pL+BXT/ia" +
       "Fjhq55Z90AAHGkEr0CLFtYC0g00jZ0a+1VbRnsjfNnrDgY4/QZu7\nSQef8R" +
       "bnCbzCm8HtytYeb7m1H4icNWpPptxzV2KV/iwui7Sq63Uv67VM47XVfJtTa6" +
       "h0Wk9Ne93l\nlTDkf0fb69CVbdLhXbX9+4xXl8R8zguOPEctZYvqUt/na8Og" +
       "7sdGjcmiITjpmXzy/2TyIxxt0ymD\njsuEaJE2xrZmqSjc/fCUPEtLm1l669" +
       "Yt9V9UvWTS36AOTM9OVTRiiwQlVT0KUDGhAZP5RYJRyqRb\n8vx+eM555zm3" +
       "Nc97Jqs0cFX3PwnuhzcRlwTm1rs/LKtmBRJiV/3/AaIc7Kn7h0/9D6UNXjo1" +
       "8oqd\neV2+4Qb/FaVyqK3oGka4Pw7Nk7ZDiiqnpVS3bMuvb3PUGX2zAgTAKG" +
       "19RlF9B9J2mCpojcNE34Wu\nQBKJH88H1aNTdo6i8c+qw1XQ/wCuatMuFhUA" + "AA==");
}
