package schat.common;

import java.io.Serializable;
import java.util.*;

public class User {
    private Integer id;
    private String name;
    
    public User(Integer id, String name) {
        super();
        this.id = id;
        this.name = name;
    }
    
    public Integer getId() { return id; }
    
    public String getName() { return name; }
    
    public String toString() {
        return this.getName() + " (" + this.getId().toString() + ")";
    }
    
    final public boolean equals(Object obj) {
        if (obj instanceof User) {
            return this.getId().equals(((User) obj).getId());
        } else {
            return false;
        }
    }
    
    final public int hashCode() { return this.getId().hashCode(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238676054789L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVXa2xURRSe3W13+1hoty1Q6QtKiTTQrZBglJpI09DQsoXa" +
       "lkZqSZnend295e69\nlztztwshBDQKovERwFdU/pgYDT8Uov4xaiL4NiaYgH" +
       "/gD0ZJFKN/lBg0npm5+7q7LWDCJjM7d+bM\nmTNnvvOdmVPXUDm1UJgSSlVD" +
       "nwmzvSahojamZ4jCaHh0cBhblET7NEzpGAxMKbv+VcffDT262Ys8\nE6hON3" +
       "o1FdOxhGXY8cRYQqVpCy0zDW1vXDOYo7FIx4YVN2a/OTzY5EM1E6hG1UcZZq" +
       "rSZ+iMpNkE\nCiZJcppYtDcaJdEJFNIJiY4SS8Waug8EDR0Wpmpcx8y2CB0h" +
       "1NBSXLCO2iaxxJqZzggKKoZOmWUr\nzLAoQ7WRGZzC3TZTte6ISllPBPljKt" +
       "GidA86gLwRVB7TcBwEF0cyu+gWGrv7eT+IV6lgphXDCslM\nKdut6lGG2twz" +
       "sjvu2AICMDWQJCxhZJcq0zF0oDppkob1ePcos1Q9DqLlhg2rMLR0TqUgVGFi" +
       "ZTeO\nkymGGt1yw3IIpCqFW/gUhha5xYQmOLOlrjPLO61t/uA/R4f/WgYnDj" +
       "ZHiaJx+/0wqdU1aYTEiEV0\nhciJ1+3w8YEddrMXIRBe5BKWMr0rP9geufpx" +
       "m5RpKiGzTWBxSrlxb3PL+d4fK33cjArToCqHQsHO\nxakOOyM9aRPQvTirkQ" +
       "+GM4OfjHy24+Db5BcvqhhAfsXQ7KQ+gCqJHu1z2gFoR1SdyN5tsRglbACV\n" +
       "aaLLb4hvcEdM1Qh3Rzm0TcwSop02EUIBKB4o65D8VfCKocB2SqwwnWGolRHK" +
       "6CS1lEmqJDCbVIxk\n0tAnHYE0V7Vw1uOBXTS7I0oD+G02tCixppQ3r3y1f9" +
       "OWJ4/I8+GYcoxgKCQUh6XiMFeMPB6hsZ5j\nTvqk17LwXh4L6UPnW17+HL8G" +
       "HoadUnUfERvxzJbxGiatm5cq+nKBNgAtDDiYUhoOXl36yvdvnfMi\nX0m6iG" +
       "Q7+w0riTV+4pn4qHOWc48AUDrccC219m9Hh85c+PrSqhxwGeooiqfimTwe2t" +
       "0etwyFRIFv\ncupf/Hvz78fK73/Pi8ogyIBmGAZwQMy2utcoiIueDMfwvfgi" +
       "qDpWtPEqBg6azdswr4OiXeMgCeIF\nhRxkLeAVHwzxqk4CB46rwbUHwWDXH/" +
       "Pfc/HD6nPCKRmyq8ljxVHCZOiEchAZswiB/ksvDR87ce3w\nIz4IVtOUsGDI" +
       "b9rTmqqkYcqSwmjjO4hyZP16uqf2mS76vkBBpZpM2gxPawTYGWuaMUuiU0zQ" +
       "UyiP\nCgUDgbOC08BkQIpTGiiS7jA9KUBwCa4INzYcf6Hz1YucTUzhr8XcV8" +
       "JSr/iuZ86++BrhAaDyOGQa\nZ6Q2NyKJOC1GVnp43ZnVh4Q+JPzcwuOiIecp" +
       "oIzdcs/BztGdg7uOtAtnSQv4hNW86pKK1xZ1p4uM\nttCaeaOunyevHCjV/X" +
       "8eOv3diaAXeSdQQKX9qo417nO6VYZZCdp2qdj30fbXr3/LLguE5HDNDWtO\n" +
       "F3PROM4LufsupEL+d04mvSgwgWpF6sU6G8eazfEzAcmT9jmdEbSgYLwwEUrW" +
       "78nGbbM7pvKWdUdU\njgOhzaV5u8IVRJVQGqBUOUFU5Qoij8fkjQ1iQpuo27" +
       "OQD5iWmsL8toK8ajR7fgsREoLrC1ZZBKXa\nWaW69CobefUAy1ne5agTRi+X" +
       "KEQ5FK51EAjoaJkrcYtLx+GH/wg+gc/ulOm1rjA8N+l2cv3JH0jn\nxqBSIn" +
       "lUMsPs0kiKaFlQlot1+a2xa15QDol7Tg4WvtEHO+9eU/0zUOUcWSDkdI4QuN" +
       "TpY5lDE+kB\n33Z6aHM5xW1PKNX0kC+hfuEVcJEIK7q+FU7qKcRVlVVoqDio" +
       "pgKKXgKl3jn3+lIUnXe2czDMTeln\niKHyOFxMJAaF4OpChBR9DBYY2egUlP" +
       "m/A0aOQ8CAkVsz2BaiXbdl5l1QWhwzW+6QmXCLrmCGJP7/\nYyeEK1oFpd2x" +
       "s71kWi6iEy8cYYyzNO/rKG1m5gpWnKckT958cwnI02SPjTVKixPAsKUm4Vqc" +
       "cu7t\nz7e+8dOZKyMNkhPk42ZF0fsif4584IiFqk3OSsvnW0FIn129/NSBkc" +
       "vTXsfAfgDJtGFoBOtiG6k8\nV4sOIz1HT+EJNEMJOycQvsUT4O353H/LENoP" +
       "EEpgmugzopKMmCknzTLkg3ejmPr43IiCfFLGb+n8\n+tVY9IqWbz2l/fyuVZ" +
       "+aoS/FvTP7HgvAoyhma1p+7str+02LxFRhZEBmQlP8Pc0gJ+Y9Ehh/DfGG\n" +
       "sOspKfQsQFQI8Y/nTOl79B9FMm8eQBAAAA==");
}
