package schat.common;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.httpservlet.*;

public class Utils {
    
    public static String makeTimeStamp() {
        Calendar c = new GregorianCalendar();
        String year = "" + c.get(Calendar.YEAR);
        String month = null;
        switch (c.get(Calendar.MONTH)) {
            case Calendar.JANUARY:
                month = "01";
                break;
            case Calendar.FEBRUARY:
                month = "02";
                break;
            case Calendar.MARCH:
                month = "03";
                break;
            case Calendar.APRIL:
                month = "04";
                break;
            case Calendar.MAY:
                month = "05";
                break;
            case Calendar.JUNE:
                month = "06";
                break;
            case Calendar.JULY:
                month = "07";
                break;
            case Calendar.AUGUST:
                month = "08";
                break;
            case Calendar.SEPTEMBER:
                month = "09";
                break;
            case Calendar.OCTOBER:
                month = "10";
                break;
            case Calendar.NOVEMBER:
                month = "11";
                break;
            case Calendar.DECEMBER:
                month = "12";
                break;
        }
        int d = c.get(Calendar.DAY_OF_MONTH);
        String day = (d < 10 ? "0" : "") + d;
        int h = c.get(Calendar.HOUR_OF_DAY);
        String hour = (h < 10 ? "0" : "") + h;
        int m = c.get(Calendar.MINUTE);
        String minute = (m < 10 ? "0" : "") + m;
        return "[" + year + month + day + "-" + hour + minute + "]";
    }
    
    public static SJSessionParameters createSJSessionParameters(
      String setups, String transports) {
        SJSessionParameters params;
        if (setups.equals("d") && transports.equals("d")) {
            params = new SJSessionParameters();
        } else {
            List ss = new LinkedList();
            List ts = new LinkedList();
            Utils.parseTransportFlags(ss, setups);
            Utils.parseTransportFlags(ts, transports);
            params = new SJSessionParameters(ss, ts);
        }
        return params;
    }
    
    private static void parseTransportFlags(List ts, String transports) {
        if (transports.equals("d")) {
            ts.add(new SJStreamTCP());
            return;
        }
        char[] cs = transports.toCharArray();
        for (int i = 0; i < cs.length; i++) {
            switch (cs[i]) {
                case 's':
                    {
                        ts.add(new SJStreamTCP());
                        break;
                    }
                case 'm':
                    {
                        ts.add(new SJManualTCP());
                        break;
                    }
                case 'h':
                    {
                        ts.add(new SJHTTPServlet());
                        break;
                    }
                default:
                    {
                        throw new RuntimeException(
                          "[Utils] Unknown transport flag: " + cs[i]);
                    }
            }
        }
    }
    
    public Utils() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238676054794L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVXXWxURRSe3e1uW7rQbimIlJa/EtsIWyPRqDXBpkLYsoTa" +
       "LURqcZm9d3b3tvfP\nmbnbBQ1BTQR5MDHib/x5MTEaXpSoLyaaAP4/YSK+4A" +
       "tGSRSjD0Zi0Hhm7t3du3e3BZrM7NyZc86c\nv+/M6akrKMooSjLCmGaZs0l+" +
       "yCZMzlZuliicJTPjE5gyoo7pmLEpOMgqB//T9r2feGpnGIWmUbdp\njeoaZl" +
       "NFajmF4lRRY2WK1tmWfqigW9yT2CDjvo3X5r89Nt4bQZ3TqFMzMxxzTRmzTE" +
       "7KfBrFDWLk\nCGWjqkrUaZQwCVEzhGpY1w4DoWXCxUwrmJg7lLBJwiy9JAi7" +
       "mWMTKu+sbKZRXLFMxqmjcIsyjrrS\ns7iEhx2u6cNpjfGRNIrlNaKr7DF0BI" +
       "XTKJrXcQEIV6YrVgxLicM7xD6QL9FATZrHCqmwtMxppsrR\n2iBH1eKBXUAA" +
       "rK0G4UWrelWLiWEDdbsq6dgsDGc41cwCkEYtB27haPWCQoGozcbKHC6QLEer" +
       "gnQT\n7hFQtUu3CBaOVgTJpCSI2epAzHzR2hOL/3ti4u91EHHQWSWKLvSPAV" +
       "N/gGmS5AklpkJcxqtO8mRq\nv7MmjBAQrwgQuzSjmz7em7786VqXprcJzR6Z" +
       "i1nl2t1r+s6P/tQeEWq02RbTRCrUWS6jOuGdjJRt\nyO6VVYniMFk5/Gzy8/" +
       "1H3yO/hlFbCsUUS3cMM4XaiamOeetWWKc1k7i7e/J5RngKtehyK2bJb3BH\n" +
       "XtOJcEcU1jbmRbku2wihVhghGGXk/i0VE0dte0EPlmSzkDCcMM5mGFVmmFLE" +
       "fEaxDMMyZyoUZSFs\n2XwoBHasCWJKhwTcaekqoVnlnUtfP7F917PH3QiJrP" +
       "LUgOSSkpOu5KSUjEIhKXK5SDvXLaOU4kMC\nDuUnz/e9+gV+A5wMxjLtMJG2" +
       "hOZbxAxMdy5aLcZqWEvBCkMqZJWeo5dXv/bdu+fCKNK0YqSrmzss\namBdBL" +
       "0CkW7vuuAJ5MpAMGOb3f37id2nv//m4mAtdzkaaIBUI6eAxIagy6mlEBVKTk" +
       "38y//s/OOF\n6L0fhlEL4AwqDceQHwDb/uAdddAYqZQZYUskjTryDYYv4eCg" +
       "eZ/BYo6LqctNC4hFT0BBWaGuPh27\n48InHeekxZVi1umrehnCXWgkavGfoo" +
       "TA/sVXJl548cqxRyKQtbbtxpyjmO3kdE0pA8st9WgS6qki\nbX77YKTruS3s" +
       "Ixnids0wHI5zOoHqi3Xdmidqlsvyk/CVOllhwBPxHFQqKHpZHQS5ttqhEqRn" +
       "k1qQ\nXNVz8qWh1y+IamFLx6wUqJKaorLcGAiJebDhUHz3iQzuqZkN+J5zDY" +
       "gPZQ6MHzy+QVruF7fZ+/CE\no1IjFHeI56OSE0bu8b/OvLlkXU3DzX5x/XJe" +
       "7/lWrDdWJNfUrnJQ1LdQWZZPyrGH/4w/g88ecItn\nd31wtpuOcddbP5ChB+" +
       "JKk8LQzi17i05KRK+6KiLvjcC1WxZF+W75itVQEMlsG7ptc8cvgIIFAJ7w\n" +
       "NicJPNmm0F/c2SaRj28a+WsDTgnqkyj1PhQpal+GBbY80Dc8zvVMI373APpo" +
       "vaIye3qlAp3gIjE2\neb+o8isOE2Lq9gDaEO+wjDcAisl+Z/F8vW4yb+NoqY" +
       "HnyJRmEGigDDfblkOLIxNcYCzpthNSSKox\nGes+7q+z7lEYWz3rtt6MdWIa" +
       "a658uEaWktP1bdzN0a0KJZiTzHjGzQdoJkXXBO1hxd7BarJSx+Tg\njaRJeL" +
       "IJg7xon8/0Bl0W2K75pgvGgzBSnm9SN+gbjlptqpXAkOs7qGLXMn+hckvjDb" +
       "hsmkPlFA33\nFMUmsy3K5bPAGru1CaoZ0AyVvG7t+f63fz59abLHrRVuS7ux" +
       "oav087htrby1wxbVav1iN0jqs7ev\nP3Vk8sdc2NP2Ho5aSpamSoOKwRjg5q" +
       "HxtsscRWVDIx6zVQ3/c7idsbLh/MHBM3biK/lEV7vXVmgh\n846u+zDvx3/M" +
       "piSvSQ1b3ZfXlj9QN+P+hoqL3lEspIqWSwTvbVQSiQ/eDJZuS1sO/Q8uFnHc" +
       "gg0A\nAA==");
}
