package schat.common.events;

import java.io.Serializable;
import java.util.*;

abstract public class ChatEvent implements Serializable {
    private Integer userId;
    private Date stamp;
    
    public ChatEvent(Integer userId) {
        super();
        this.stamp = new Date();
        this.userId = userId;
    }
    
    public Integer getUserId() { return userId; }
    
    public Date getTimeStamp() { return stamp; }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238676054816L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVXW2xURRie3W13e1lpdylQ6A1riVRhazQapInaVBoKi63d" +
       "QqSUlOnZ2e2U2XOO\nZ+a0CyEGNBHkwRcuXqLyaDQ+KEZ9MWqieDcmmIAv+K" +
       "KJJIrRFyUGjf/MnL2d3db4IMmZzs78t/nn\n+7/5ee0aqucOSnDCObXM+YQ4" +
       "ZBOuRmt2nhiCJ1I7xrHDSXqYYc4nYWPGOPA33fNG7PHtQRSYQnHT\nGmIU88" +
       "k5x3Kzc5NzlOcdtN622KEss4RnscrG1ltuLH55fEdHCLVMoRZqpgQW1Bi2TE" +
       "HyYgpFcyQ3\nSxw+lE6T9BSKmYSkU8ShmNHDIGiZ4JjTrImF6xA+QbjFFqRg" +
       "nLs2cZTPwmISRQ3L5MJxDWE5XKDW\n5DxewAOuoGwgSbkYTKJwhhKW5o+ix1" +
       "AwieozDGdBcHWycIoBZXFgRK6DeBOFMJ0MNkhBpe4gNdMC\n9fg1iifu2wkC" +
       "oBrJETFnFV3VmRgWUFyHxLCZHUgJh5pZEK23XPAi0LoljYJQg42NgzhLZgRq" +
       "98uN\n6y2QalRpkSoCrfKLKUtwZ+t8d1Z2W2Ph6F8nx/9YDzcOMaeJwWT8YV" +
       "Dq9ilNkAxxiGkQrXjdTZwe\n3et2BhEC4VU+YS0ztOGd3cmr7/domY4aMmMK" +
       "izPGjXs6uy4O/dAYkmE02BanEgoVJ1e3Ou7tDOZt\nQPfqokW5mShsfjDx8d" +
       "6jr5KfgqhhFIUNi7k5cxQ1EjM97M0jME9Sk+jVsUyGEzGK6phaClvqN6Qj\n" +
       "QxmR6aiHuY3FnJrnbYRQK3wB+HqR/tcgB4Giw3NYbFsgpkjweYFuE4QLPs0d" +
       "Y5obsDNtWLmcZU4T\nKcGny4Xz0vaKxUAAjtXpLzEGeNxusTRxZoyXv//8yL" +
       "adT53QFyZB5kUlUJdyktBOEtpJougEBQLK\n+koJSJ2wIcfBh2Sh5I9d7Hru" +
       "E/wipB/SwOlhok4ZWKyTIyjduSyPDJeqcBRmGEAyY7Qdvbru+W9e\nuRBEoZ" +
       "pckiwujlhODjMJh0LxxD13/h1AUZ8fy7V8/3Jy15uXvriysYRqgfqqiq1aUx" +
       "ZLrz/7jmWQ\nNJBRyfwzf27/9VT9vW8FUR1UIHCQwIAcKOhuv4+KohksEJA8" +
       "SyiJmjNVB28SkKDFsgPLMarmLR7M\noJjQGg92cTnIzZgc4hpEcF1tvjMoer" +
       "v+RPiOy+82X1BJKTBhSxllpojQdRUrQWTSIQTWrzw7furM\nteP7QlDJtq1h" +
       "IVDYdmcZNfKgsqayFOUJ0hJZP58fbH16M39boaCR5nKuwLOMAHVjxqxFkp4R" +
       "irti\nZTyp6AmSFZ0FmgPGnGFgSKfDDiwAgmsQSaK97fTZ/hcuS6qxVb5Wlw" +
       "FY/l4pvHNJH4lR4PkscfJq\na0NAjv1FNaTUkEpnl4R/WykhQBsH9dGi/an9" +
       "Ow6c6FU50Y6kwu3a5kD5Sr5oOqiWg2Bz07IlNSKf\nrRLi6JHfj53/+kw0iI" +
       "JTKEL5CDUxkwnlD+kaqkHYPhOH39v90vWvxHfq+kuglYF15qtJZw8uq6ct\n" +
       "lxZi4dfP5YIoMoVa1aOLTbEHM1eCYwqeTT7sLSbRTRX7lU+g5vvBYlF2+gum" +
       "zK2/XEpkB3MpLecN\nvgpphK8dviavQpp8FRII2HKyRSn0qLG3iOeI7dAFLP" +
       "sUFHY5cUbT6vpUVSGkhO+q8NQGX7Pnqbm2\np/vksFVANyZwzi4gcUUJUA+C" +
       "Q89DvjqqoEANeBZ4ChuqBPo8xKISYgcqQa6xSq1EsauCepMl2rVU\nF6A6mO" +
       "OP/BZ9En+0X7/V8cpy3ma6ubvPfUv6H4gaNR6eRmHZmxk8OKwGzjcvi/Ndqm" +
       "kqIS2Uur//\n1k3NPwK1LvFqxLzFCQIdojlZwIF6TvB/fk56fEnxxxNb6Hg4" +
       "NEc/DSoEatBW9YKVSoOVUG1yKgNV\ngO2ooPQO+NZ6MFpbi9LlcPOyVPWvPD" +
       "YB15QlYncJ1pqbyiCE8tU/xqoC7fYC7f6fAt0HbRQEOklz\nJCVLRq4NKfmh" +
       "pWOFim0sdjryCWuv+m+KbqaN3osHNn5oxz5Tb3ex4Y1A15lxGSunmLJ52HZI" +
       "hqrw\nIppwbPUnI9DKGk0X0IeeqBiJlqVwrnJZIVtTOSkXYpIopJD8UaKL1t" +
       "LDpRk0j/4B1gaffOENAAA=");
}
