package schat.common.events;

import java.util.*;

public class MessageEvent extends ChatEvent {
    private Integer targetId;
    private String msg;
    
    public MessageEvent(Integer userId, Integer targetId, String msg) {
        super(userId);
        this.targetId = targetId;
        this.msg = msg;
    }
    
    public Integer getSenderId() { return this.getUserId(); }
    
    public Integer getTargetId() { return targetId; }
    
    public String getMessage() { return msg; }
    
    public String toString() {
        return "<Message event: " + this.getUserId() + ", " +
        this.getTargetId() + ", " + msg + ">";
    }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1238676054821L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVXTWwbRRQe24mdH7eJ81NKfpoSUtGIxqFIRdAg0Shq1KQO" +
       "DXEaUZPKnazH9qbr\n3WVn1nGiCrUg0dIDl7YUENAjAnGAIuCCAAnKP0IqUs" +
       "ulXECiEhTBBSpUEG9m1vZ67RSKVEs7np15\nM+/NvO997+1rV1A9tVCUEkpV" +
       "Q1+MsmWTUNEaC4tEYTQan5zGFiWpMQ1TOgsTSeXA3+rcG5HHd/mR\nL4HadG" +
       "NUUzGdzVqGncnOZlVasNBG09CWM5rBnB2r9th++7WlL49OdgdQSwK1qHqcYa" +
       "YqY4bOSIEl\nUDhHcgvEoqOpFEklUEQnJBUnloo1dQUEDR0UUzWjY2ZbhM4Q" +
       "amh5LthGbZNYQmdxMIbCiqFTZtkK\nMyzKUGtsEefxsM1UbTimUjYSQ8G0Sr" +
       "QUfRQ9hvwxVJ/WcAYE18WKpxgWOw6P83EQb1LBTCuNFVJc\nUndQ1VMM9XlX" +
       "lE48sBsEYGkoR1jWKKmq0zEMoDZpkob1zHCcWaqeAdF6wwYtDHWtuikINZhY" +
       "OYgz\nJMnQeq/ctJwCqUZxLXwJQ51eMbET+KzL4zOXt/YEw38dn/5jI3gcbE" +
       "4RReP2B2HRBs+iGZImFtEV\nIhdetaMnJ/bZPX6EQLjTIyxlRje9szd2+f0+" +
       "KdNdQ2aPwGJSuXZPT+/50R8aA9yMBtOgKodCxcmF\nV6edmZGCCeheV9qRT0" +
       "aLkx/MfLzv8KvkJz9qmEBBxdDsnD6BGomeGnP6IejHVJ3I0T3pNCVsAtVp\n" +
       "YihoiHe4jrSqEX4d9dA3McuKfsFECIXg8cGzGckff0cMtUxBuIFjduaJzqJ0" +
       "kaEhRiij89RS5qmS\nxWxeMXI5Q58nXILOe+QLXMPaJZ8PDtfjDTQNULnL0F" +
       "LESiovf//5oZ27nzom3cah5tjG0EahJyr1\nRKWeqFsP8vmEgnaOTHlzo5aF" +
       "l3nEFI6c733uE/wi+AHug6orRBzXt1THW1h093UJZawcjhPQw4CW\npNJx+H" +
       "LX89+8cs6PAjVJJVYaHDesHNY4LopR1Oao884AnAa8oK6l+5fjU29e+OLS5j" +
       "K8GRqoirrq\nlTxq+r0OsAyFpICVytuf/nPXryfq73vLj+ogFIGMGAYIQWRv" +
       "8OqoiJ6RIhPxswRiqDlddfAmBhe0\n5Dowb8Oi3wKuaIAHogq1O/hbwxs+Ge" +
       "FNm8QRuKvDcwbBc1efCN518d3mc+JSipTY4uLOOGEywCJl\niMxahMD4pWen" +
       "T5y6cvSRAIS0aUpYMBQ07QVNVQqw5JbKmOQnSHFk/Xx2pPXpIfq2QEGjmsvZ" +
       "DC9o\nBDgca5qxRFJJJkgs4iJMwVNwWeEF4DugzqQGG8nrMH15QHANRomu7z" +
       "j5zOALFznnmOK+1oGNAWFp\nQLy3M+dcXEd0Agg/Qyw+cWdxurU8LTm7IGY2" +
       "+Xg7WNoUiU2RuOxeHhwd5esCdjkoDx4ejO+fPHCs\nX9yYNEMoKzVDcvette" +
       "cKJXV+IeAHPVuuG4TjPOOVMaoe+v3I2a9Phf3In0AhlY6rOta4C+iDMupq\n" +
       "cL1ni5X39r509Sv2nQBMGebcsJ5CNVPNYVcE3nshHwm+fibnR6EEahX5Guts" +
       "Dms2h1MCMi4dcwZj\naE3FfGX2lKlipBTGPd4Qc6n1BliZIaHPpXm/wRNTjf" +
       "B0Of+o+O+KKZ/P5J3tYkGfaPtLERAyLTWP\neYmDGhi2MpBPUiUvrkVIiG+r" +
       "0NUBT7Ojq7m2rh28uZ+hQI5mBByc3YTlt0lQojIotzqABIj0rpby\nRbly9O" +
       "Hfwk/ij/bLxNxWGbI7dTu37cy3ZHBHWKmRXxqZYQ5pkFe0EjLrhN46UDt0XW" +
       "ROiQqpjI1A\n/IHBO7Y0/wj0uUpmiDiDMwTKQX226DmRMvANp4w+z6V47Ynk" +
       "ux8KZNVP/QIzEmZVhV/lopFKcDVZ\nlYYKR3VX0HYvPJ2O2ztr0bbLt6sQzr" +
       "+y0RRDzQDBOBQ3xHKA6CtT3Fb3PhUvk1Wmdjmmdt0kU+ek\nqbPumPkfpnbD" +
       "0+eY2neTTIVKvAmMdGopEY9CeuiGLL0VngHH0oGbZGmWs5Ahc9d/shNoK+yu" +
       "EXny\nX1/1pSe/R5T+8wc2f2hGPhNVT+mbIQSFe9rWNDfVuvpB0yJpVVgXks" +
       "Rrij8oPdprVKxQU8iOMNOS\nsnmw0i3LeHXPO26hZQZfvlyIv6yYxZzeW6ss" +
       "HoMhcd4C+gd/RpJTMQ8AAA==");
}
