package util;

import java.util.*;
import sessionj.runtime.*;
import sessionj.runtime.net.*;
import sessionj.runtime.transport.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.sharedmem.*;
import sessionj.runtime.transport.tcp.*;
import sessionj.runtime.transport.httpservlet.*;

public class TransportUtils {
    
    public static SJSessionParameters createSJSessionParameters(
      String setups, String transports) {
        SJSessionParameters params;
        if (setups.contains("d") && transports.contains("d")) {
            params = new SJSessionParameters();
        } else {
            List ss = new LinkedList();
            List ts = new LinkedList();
            TransportUtils.parseTransportFlags(ss, setups);
            TransportUtils.parseTransportFlags(ts, transports);
            params = new SJSessionParameters(ss, ts);
        }
        return params;
    }
    
    public static void parseTransportFlags(List ts, String transports) {
        if (transports.contains("d")) {
            ts.add(new SJStreamTCP());
            return;
        }
        char[] cs = transports.toCharArray();
        for (int i = 0; i < cs.length; i++) {
            switch (cs[i]) {
                case 's':
                    {
                        ts.add(new SJStreamTCP());
                        break;
                    }
                case 'm':
                    {
                        ts.add(new SJManualTCP());
                        break;
                    }
                case 'h':
                    {
                        ts.add(new SJHTTPServlet());
                        break;
                    }
            }
        }
    }
    
    private static void configureTransports(String setups, String transports) {
        SJTransportManager sjtm = SJRuntime.getTransportManager();
        if (!setups.contains("d")) {
            List ss = new LinkedList();
            TransportUtils.parseTransportFlags(ss, setups);
            sjtm.configureSetups(ss);
        }
        if (!transports.contains("d")) {
            List ts = new LinkedList();
            TransportUtils.parseTransportFlags(ts, transports);
            sjtm.configureTransports(ts);
        }
    }
    
    public TransportUtils() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.3.0";
    final public static long jlc$SourceLastModified$jl = 1236555156335L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAJVXXWxURRSe/em2pRvabQsipaVADW2ErTHRqDXBpqGh7ZLW" +
       "bmukFpe7985up8ze\ne5mZu13QENREkAcTA/7GnxcTo+FFifpiogng/1NNxB" +
       "d8wSiJYvTBSAwaz8y9+3d3W6DJzM6dOefM\n+fvOnJ65iho4Q3GOOSeWuRgX" +
       "h23M1WylF7EueDw5PqUxjo0RqnE+Awcp/cB/5JH3Y0/vCaLAHGo3\nrWFKND" +
       "6zwCwnuzCzQHiBoV7booez1BKexBoZD2y7vvTt8fGuEGqdQ63ETApNEH3EMg" +
       "UuiDkUzeFc\nGjM+bBjYmEMxE2MjiRnRKDkChJYJF3OSNTXhMMynMbdoXhK2" +
       "c8fGTN1Z3EygqG6ZXDBHFxbjArUl\nFrW8NugIQgcThIuhBIpkCKYGP4SOom" +
       "ACNWSolgXC9YmiFYNK4uCo3AfyNQTUZBlNx0WW8EFiGgJt\n9nOULO6bAAJg" +
       "bcxhsWCVrgqbGmygdlclqpnZwaRgxMwCaYPlwC0CbVxRKBA12Zp+UMvilEAb" +
       "/HRT\n7hFQNSu3SBaB1vnJlCSI2UZfzCqiNRmJ/nty6u9eiDjobGCdSv0jwN" +
       "TjY5rGGcywqWOX8ZoTPz22\nz9kURAiI1/mIXZrhOz6eTVz5dLNL01WHZlLl" +
       "Ykq/fu+m7uXhn5pDUo0m2+JEpkKV5SqqU97JUMGG\n7F5fkigP48XDz6Y/33" +
       "fsPfxrEDWNoYhuUSdnjqFmbBoj3roR1gliYnd3MpPhWIyhMFVbEUt9gzsy\n" +
       "hGLpjgZY25pYUOuCjRBqhBGAQZD71yongWIzTDO5bTExCwrxOF8UqFdgLvg8" +
       "Z/q81HK+hqQgxa5d\nCgTAok1+dFFIxT0WNTBL6e9c/vrJ3RPPnXBjJfPLU0" +
       "igDuWAatEoEFAyO2QGuh4aZkw7LJFReGq5\n+9UvtDfA32A3J0ewMiuwFJYz" +
       "MN29auEYKcNuDFYaZEVK7zx2ZeNr3717IYhCdYtHorQ5arGcRmX8\ni2hp96" +
       "7zn0Da9PmTt97dv5/ce/b7by71l9NYoL4adNVySnRs9fucWTo2oPqUxb/8z5" +
       "4/TjXc/2EQ\nhQFyUHSEBqkCCO7x31GFkqFixZG2hBKoJVNj+BoBDlqqMFjO" +
       "UTm1uXkBsej0KaiK1bVnIndd/KTl\ngrK4WNdaKwpgEgsXJbFy/GcYxrB/6Z" +
       "WpUy9ePf5YCHBp227MBYrYTpoSvQAst1UDS6pnyLT57YOh\ntud38o9UiJtJ" +
       "LucILU0xFGKNUmsJGymhKlGsouqpYgOeiKahaEH9S1EQ5NpqB/KQnnXKQnxD" +
       "5+mX\nBl6/KAuHrRyzXgJMaYoKaqMvIOf+mkP53S0zuLNsNkD9oGtAdCC5f/" +
       "zAia3K8kpxO7wPTzjK12Jx\nVL4kxZzIpZ/469yba3rLGu6oFNej5i2eb+V6" +
       "W1FyWe0SB0PdK1Vo9bocf/TP6LPa+f1uHW2vDs5u\n08nd89YPeOChqF6nMj" +
       "QLy95JcR7TkqtC6t4QXLtzVZTvVQ9aGQWh5K6B7TtafgEUrADwmLc5jeH1\n" +
       "NqX+8s4mhXztlpG/2ecUvz6xfNfDoQXyZVBiywN9zTtdzTRU6R5AH6tWVGVP" +
       "l1Kg1avqj8OIeVVe\n/crDmJzaPYDWxDuo4g2A4qr1qZ+vQZdUfXdA66KyVQ" +
       "Im7rYJcn/0xqm+S6DbdYY1gZPjSdeT0JHJ\n1gN6rKLw/lKYmWMKksNxE4t4" +
       "HQZ10URFcipTRit0WWH7wSqfjcDY7vls+634TE4jN+WvtZXoduvJ\nTXhrEl" +
       "5KWzaspZdS1VJe2+1MMZKDZiLvdTsv9Lz989nL050uwNyWcFtNV1bJ47aF6t" +
       "YWW0J8y2o3\nKOrzd245c3T6x3TQ0/Y+gcJ5ixjKoHm/+2frR2W2blTaYIzD" +
       "SHpRSd5kVARqtBnJQ3rdODT+nFgt\nEGkIBDyjGZKFd7YUDEU6X9/c1ZOwAB" +
       "lR3f3Il29Dzf8qbketb10+0H/Ojn2l3vNS19sIrWfGobSi\nQFQWi4jNcIYo" +
       "9RvdZ9pWP1BkwzIR5fqQXQfQbpNbCPwP9yt+dZQNAAA=");
}
