package benchmarks.benchmark1.b;

import java.io.*;
import java.net.*;
import java.util.Arrays;
import sj.runtime.*;
import sj.runtime.net.*;
import benchmarks.BinaryTree;

public class Client {
    final private java.lang.String _sjprotocol_p =
      ("H4sIAAAAAAAAAIWQMUvDQBiGv1YrVRcRCoIVJ+mg5DaXTi0IooEWW+dyvRzp" +
       "xfTuvLvWBsRZf4mL\nu6O7o39BBxf/gYOXXKu1FJLhgyTf+z7f+z59QUkrON" +
       "KRZxJJdTZFP6LEaE9Trd3XzlmThox37UuP\ngHsKRYCJglqudFFV9KFEBiwO" +
       "DNR8HaFsD82p0a8aOXXdhzWJFeXmGu6gaKkVKeIkjIWZsh2jcfB8\n6X++7L" +
       "vLdpfstDJCj3wfV/feGh/rK1DwoSyFZoYJbmDHn4nQyLAYtad/6hMpJ7YolJ" +
       "u2NTI3Nhxd\nTG05q30RJC5BOgvSmlrPw1zPDuXBEr/Nod3BYYYyUPk73XWX" +
       "NTcjWY6Xy7mghLLxstPnUanjxr8E\n1YWm2zEm9FTEAVU98vj+enty/nDvKu" +
       "B4aG/d9iM8xijGPEQdoxgPbcE2Qp9yMhhidaW9JuNYJV1F\nM145HVvyBzWo" +
       "im2vAgAA");
    final private SJProtocol p = new sj.runtime.SJProtocol(this._sjprotocol_p);
    
    private void run(boolean debug, String server, int port, int depth, int len,
                     int num)
          throws Exception {
        SJServerAddress c = SJServerAddress.create(p, server, port);
        long totalRunTime = 0;
        for (int i = 0; i < num; i++) {
            BinaryTree bt = BinaryTree.createDepth(depth);
            SJSocket ds = SJFSocket.create(c);
            {
                sj.runtime.net.SJSocket _sjtryreturned_1 = null;
                int _sjspawncount_ds = -1;
                try {
                    ds.request();
                    int k = 0;
                    while (ds.outsync(k < 1)) {
                        ds.send(bt);
                        bt = (BinaryTree) ds.receive();
                        k++;
                    }
                    bt = BinaryTree.createDepth(depth);
                    long runTime = 0;
                    long timeStarted = 0;
                    long timeFinished = 0;
                    SJSocket s = SJFSocket.create(c);
                    {
                        sj.runtime.net.SJSocket _sjtryreturned_0 = null;
                        int _sjspawncount_s = -1;
                        try {
                            s.request();
                            timeStarted = System.nanoTime();
                            int j = 0;
                            while (s.outsync(j < len)) {
                                s.send(bt);
                                bt = (BinaryTree) s.receive();
                                if (debug) { bt.println(); }
                                j++;
                            }
                            timeFinished = System.nanoTime();
                        }
                        finally {
                            if (s != null && s != _sjtryreturned_0)
                                s.close(_sjspawncount_s);
                        }
                    }
                    runTime = (timeFinished - timeStarted) / 1000;
                    totalRunTime += runTime;
                }
                finally {
                    if (ds != null && ds != _sjtryreturned_1)
                        ds.close(_sjspawncount_ds);
                }
            }
        }
        System.out.println(totalRunTime);
    }
    
    public static void main(String[] args) throws Exception {
        boolean debug = Boolean.parseBoolean(args[0]);
        String server = args[1];
        int port = Integer.parseInt(args[2]);
        int depth = Integer.parseInt(args[3]);
        int len = Integer.parseInt(args[4]);
        int num = Integer.parseInt(args[5]);
        new Client().run(debug, server, port, depth, len, num);
    }
    
    public Client() { super(); }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1238690428952L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAI1XXWwURRyf27teuVJsr+XLUtoCVamEqz5IlL7YNBBajnC2" +
       "gHCWHLN7c+22e7vr\n7OzdUZRoTAR5MDHgV6LwYkJieDAQ9UGjJuC3JqYP4A" +
       "skBmNMFCIPxsZg9D8zt7d3e0exye7Nzvy/\n5v///T967gZqcijqsy3j8JRh" +
       "sQQ7bBMnkcLUIdkRAzvOHtjIaFs33C5+d2xsTRi1pVGbbk4wzHRt\nxDIZKb" +
       "E0as2TvEqoM5zNkmwaxU1CshOE6tjQ54DQMtOow9GnTMxcSpxx4lhGgRN2OK" +
       "5NqNDpbSZR\nq2aZDqOuxizqMNSenMEFPOgy3RhM6g4bSqJoTidG1nkaHUWh" +
       "JGrKGXgKCFcmvVsMComD2/k+kLfo\nYCbNYY14LJFZ3cwy1BvkqNy4fycQAG" +
       "tznrBpq6IqYmLYQB3SJAObU4MTjOrmFJA2WS5oYajrjkKB\naImNtVk8RTIM" +
       "rQ7SpeQRUMWEWzgLQyuCZEJSiaKuQMyqorU72vrPidRffYqwOUs0g9vfBEw9" +
       "AaZx\nkiOUmBqRjAtu4tToAbdbQQiIVwSIJc3wfR/uTf76aa+kWdOAZrc6Qz" +
       "SW0W5v6V47P/xzLMzNWGJb\njs6hUHNzEdVU+WSoZAMWV1Yk8sOEd/jZ+BcH" +
       "nnuX/KagJaMoqlmGmzdHUYyY2ZHyuhnWSd0kcnd3\nLucQNooihtiKWuIb3J" +
       "HTDcLdEYG1jdm0WJdshFAzPCF4XCT/OvmLodiIoROTJZwZhjYx4jBn0qHa\n" +
       "pApum85jOuv4y4cn1ckKdYlLXlYMheBS3cEEMwCNOywjS2hGO3v9m2e27Xzp" +
       "uFKBWNkmhnp8LQlf\nS0JNSC0oFBLiV9X6jAchy3Pl9/ND7S9vdj5QUDiNYn" +
       "o+7zKsGgRyDBuGVSTZDBMgi1cBWuAIQNiq\nAh4B2hkDBAn8g5MKFK0P4s7P" +
       "1lFYYQDT/NF/f7iZKV7gEOEhXc6lS9MgQLPSttaBiYNjh46vD3Oi\nYoT7Hk" +
       "j77y49o908sevC5W+vbvTxzVB/XdrVc/K0CZqfopZGslCWfPGv/73jj5NNj7" +
       "2vcIzEoBox\nDBiC1O4J6qhJnyGvFHFnKUm0NGfRPDb4kVc/Wtg0tYr+joDI" +
       "Uv5qk2jhzgoYKKrYwgvRh658vPRz\npbrgtVVVxgnCZPrEfV/voYTA/tU3Ui" +
       "dfvXHsKeHosqcZitquauhaSRiyIgSB7WyQyonVy0+9NvDW\nFS+Snb70YUrx" +
       "YR7I0vPza9/8Er8NaQ7p5uhzRGQTEpqQp4C/B8T6wapD/t1XJuHgCubJdl7o" +
       "vcjk\n1SN/Xjzd0ieN4TxdFdwEC1sNY0ab+2Tv6YXv2TXhPz+kXEZvqV7tPl" +
       "yFtkcvF+LR987kFdScRu2i\nOWGT7cOGy72bhvbijJQ3k2hZzXltq5B1cagC" +
       "2e4gnKrUBsHklwVYc2q+bpb4sUuhkM1XWwT1OvHu\nl5FWGMjRTQzqmm2qFz" +
       "Bv2Cgk3dcB7cWZSVDXZHqeJCbGIBmYBbVVYLFUL01E8X4vXn5Iu7xYU7T2\n" +
       "Tm1JtNRj+2+1vogvHZTNo6O2bG0z3fwjZ34kA4+3ag1qYYxZ9maDFIjh4yWo" +
       "bZdo154T257s/Wn7\nlrPPBgGjgJ29i3JmtHhhzRPhaf0rKJ2VgNXNC7VMQ7" +
       "VhaqEExh1zT02weoQZ94ARMXj2wdNV7jbi\nlx+281e8XA8ah2Br46yKCopo" +
       "g3RIUT0PbbRQ7vOv9Lzzy4Xr48uVqmFoQ908Us0jByJhVIvN47xu\nMQ2C+t" +
       "KmdeeOjl9TlXKejwAEVcsyCDY99LWLcsKTIyHnKHEwbsvr7WUoDKMbX6b9V+" +
       "Orh8qVoCy4\n0xe8raQRm08QwogkyAS8B/VECpYup7yxSoDa4HkAnplygGb+" +
       "X4AUkSNQYB0xIy9ubv0YJ8qqjNL5\ncP8t5aOV/aIPRVTsSBwF59/68bZmah" +
       "V2xiq3uhee3rvcar9t24vazT8zghRKXCQPtZSvVagsUTmY\n8F6xuu6fCjn6" +
       "auvnD228aMe/lvfyxtMozIg51zCqC13VOmpTktOFzqhX9vgPY2jVHYYkqHOq" +
       "sNyR\npEUodw1JGWrxP6o55qpPxMERuwF2ZWEv/QdWpTUsTQ0AAA==");
}
